// @license magnet:?xt=urn:btih:87f119ba0b429ba17a44b4bffcab33165ebdacc0&dn=freebsd.txt BSD-2-Clause
(function(_) {
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function t(e) {
        return e.split("");
    }
    function Bn(e, n) {
        return n.indexOf(e) >= 0;
    }
    function Ln(e, n) {
        for (var t = n.length; --t >= 0; ) if (e(n[t])) return n[t];
    }
    function r(e) {
        Object.defineProperty(e.prototype, "stack", {
            get: function() {
                var e = new Error(this.message);
                e.name = this.name;
                try {
                    throw e;
                } catch (e) {
                    return e.stack;
                }
            }
        });
    }
    function i(e, n) {
        this.message = e;
        this.defs = n;
    }
    i.prototype = Object.create(Error.prototype);
    i.prototype.constructor = i;
    i.prototype.name = "DefaultsError";
    r(i);
    function be(e, n, t) {
        if (t) for (var r in e) {
            if (Qn(e, r) && !Qn(n, r)) throw new i("`" + r + "` is not a supported option", n);
        }
        for (var r in e) {
            if (Qn(e, r)) n[r] = e[r];
        }
        return n;
    }
    function Un() {}
    function un() {
        return false;
    }
    function cn() {
        return true;
    }
    function Vn() {
        return this;
    }
    function Wn() {
        return null;
    }
    var Gn = function() {
        function e(e, n) {
            var t = [];
            for (var r = 0; r < e.length; r++) {
                var i = n(e[r], r);
                if (i === a) continue;
                if (i instanceof o) {
                    t.push.apply(t, i.v);
                } else {
                    t.push(i);
                }
            }
            return t;
        }
        e.is_op = function(e) {
            return e === a || e instanceof o;
        };
        e.splice = function(e) {
            return new o(e);
        };
        var a = e.skip = {};
        function o(e) {
            this.v = e;
        }
        return e;
    }();
    function Jn(e, n) {
        if (e.indexOf(n) < 0) return e.push(n);
    }
    function Xn(e, r) {
        return e.replace(/\{([^{}]+)\}/g, function(e, n) {
            var t = r[n];
            return t instanceof vn ? t.print_to_string() : t;
        });
    }
    function Kn(e, n) {
        var t = e.indexOf(n);
        if (t >= 0) e.splice(t, 1);
    }
    function ln(e) {
        if (!Array.isArray(e)) e = e.split(" ");
        var n = Object.create(null);
        e.forEach(function(e) {
            n[e] = true;
        });
        return n;
    }
    function pn(e, n) {
        for (var t = e.length; --t >= 0; ) if (!n(e[t], t)) return false;
        return true;
    }
    function dn() {
        this.values = Object.create(null);
    }
    dn.prototype = {
        set: function(e, n) {
            if (e == "__proto__") {
                this.proto_value = n;
            } else {
                this.values[e] = n;
            }
            return this;
        },
        add: function(e, n) {
            var t = this.get(e);
            if (t) {
                t.push(n);
            } else {
                this.set(e, [ n ]);
            }
            return this;
        },
        get: function(e) {
            return e == "__proto__" ? this.proto_value : this.values[e];
        },
        del: function(e) {
            if (e == "__proto__") {
                delete this.proto_value;
            } else {
                delete this.values[e];
            }
            return this;
        },
        has: function(e) {
            return e == "__proto__" ? "proto_value" in this : e in this.values;
        },
        all: function(e) {
            for (var n in this.values) if (!e(this.values[n], n)) return false;
            if ("proto_value" in this && !e(this.proto_value, "__proto__")) return false;
            return true;
        },
        each: function(e) {
            for (var n in this.values) e(this.values[n], n);
            if ("proto_value" in this) e(this.proto_value, "__proto__");
        },
        size: function() {
            return Object.keys(this.values).length + ("proto_value" in this);
        },
        map: function(e) {
            var n = [];
            for (var t in this.values) n.push(e(this.values[t], t));
            if ("proto_value" in this) n.push(e(this.proto_value, "__proto__"));
            return n;
        },
        clone: function() {
            var t = new dn();
            this.each(function(e, n) {
                t.set(n, e);
            });
            return t;
        },
        toObject: function() {
            var t = {};
            this.each(function(e, n) {
                t["$" + n] = e;
            });
            return t;
        }
    };
    dn.fromObject = function(e) {
        var n = new dn();
        for (var t in e) if (Qn(e, t)) n.set(t.slice(1), e[t]);
        return n;
    };
    function Qn(e, n) {
        return Object.prototype.hasOwnProperty.call(e, n);
    }
    function Zn(e, n, t) {
        var r = e.parent(-1);
        for (var i = 0, a; a = e.parent(i++); r = a) {
            if (wt(a)) {
                return n && a.value === r;
            } else if (a instanceof zn) {
                if (a.left === r) continue;
            } else if (a.TYPE == "Call") {
                if (a.expression === r) continue;
            } else if (a instanceof qn) {
                if (a.condition === r) continue;
            } else if (a instanceof sr) {
                return t;
            } else if (a instanceof Tn) {
                if (a.expression === r) continue;
            } else if (a instanceof Sn) {
                if (a.expressions[0] === r) continue;
            } else if (a instanceof mn) {
                return true;
            } else if (a instanceof Ir) {
                if (a.tag === r) continue;
            } else if (a instanceof dr) {
                if (a.expression === r) continue;
            }
            return false;
        }
    }
    function a(r, e) {
        if (e.length > 31) throw new Error("Too many properties: " + e.length + "\n" + e.join(", "));
        e.forEach(function(e, n) {
            var t = 1 << n;
            Object.defineProperty(r.prototype, e, {
                get: function() {
                    return !!(this._bits & t);
                },
                set: function(e) {
                    if (e) this._bits |= t; else this._bits &= ~t;
                }
            });
        });
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function e(e, n, t, r) {
        if (typeof r === "undefined") r = vn;
        n = n ? n.split(/\s+/) : [];
        var i = n;
        if (r && r.PROPS) n = n.concat(r.PROPS);
        var a = [ "return function AST_", e, "(props){", "this._bits=0;", "if(props){" ];
        n.forEach(function(e) {
            a.push("this.", e, "=props.", e, ";");
        });
        a.push("}");
        var o = Object.create(r && r.prototype);
        if (t.initialize || o.initialize) a.push("this.initialize();");
        a.push("};");
        var s = new Function(a.join(""))();
        s.prototype = o;
        s.prototype.CTOR = s;
        s.prototype.TYPE = s.TYPE = e;
        if (r) {
            s.BASE = r;
            r.SUBCLASSES.push(s);
        }
        s.DEFMETHOD = function(e, n) {
            this.prototype[e] = n;
        };
        s.PROPS = n;
        s.SELF_PROPS = i;
        s.SUBCLASSES = [];
        for (var f in t) if (Qn(t, f)) {
            if (/^\$/.test(f)) {
                s[f.substr(1)] = t[f];
            } else {
                s.DEFMETHOD(f, t[f]);
            }
        }
        if (typeof _ !== "undefined") _["AST_" + e] = s;
        return s;
    }
    var te = e("Token", "type value line col pos endline endcol endpos nlb comments_before comments_after file raw", {}, null);
    var vn = e("Node", "start end", {
        _clone: function(e) {
            if (e) {
                var n = this.clone();
                return n.transform(new Xr(function(e) {
                    if (e !== n) {
                        return e.clone(true);
                    }
                }));
            }
            return new this.CTOR(this);
        },
        clone: function(e) {
            return this._clone(e);
        },
        $documentation: "Base class of all AST nodes",
        $propdoc: {
            start: "[AST_Token] The first token of this node",
            end: "[AST_Token] The last token of this node"
        },
        walk: function(e) {
            e.visit(this);
        },
        _validate: function() {
            if (this.TYPE == "Node") throw new Error("should not instantiate AST_Node");
        },
        validate: function() {
            var e = this.CTOR;
            do {
                e.prototype._validate.call(this);
            } while (e = e.BASE);
        },
        validate_ast: function() {
            var n = {};
            this.walk(new Rn(function(e) {
                if (e.validate_visited === n) {
                    throw new Error(Xn("cannot reuse {type} from [{file}:{line},{col}]", {
                        type: "AST_" + e.TYPE,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    }));
                }
                e.validate_visited = n;
            }));
        }
    }, null);
    a(vn, [ "_optimized", "_squeezed", "call_only", "collapse_scanning", "defined", "evaluating", "falsy", "in_arg", "in_bool", "is_undefined", "inlined", "length_read", "nested", "new", "optional", "private", "pure", "redundant", "static", "terminal", "truthy", "uses_eval", "uses_with" ]);
    (vn.log_function = function(n, e) {
        if (typeof n != "function") {
            vn.info = vn.warn = Un;
            return;
        }
        var t = Object.create(null);
        vn.info = e ? function(e, n) {
            r("INFO: " + Xn(e, n));
        } : Un;
        vn.warn = function(e, n) {
            r("WARN: " + Xn(e, n));
        };
        function r(e) {
            if (t[e]) return;
            t[e] = true;
            n(e);
        }
    })();
    var o = [];
    vn.enable_validation = function() {
        vn.disable_validation();
        (function e(n) {
            n.SUBCLASSES.forEach(e);
            if (!Qn(n.prototype, "transform")) return;
            var r = n.prototype.transform;
            n.prototype.transform = function(e, n) {
                var t = r.call(this, e, n);
                if (t instanceof vn) {
                    t.validate();
                } else if (!(t === null || n && Gn.is_op(t))) {
                    throw new Error("invalid transformed value: " + t);
                }
                return t;
            };
            o.push(function() {
                n.prototype.transform = r;
            });
        })(this);
    };
    vn.disable_validation = function() {
        var e;
        while (e = o.pop()) e();
    };
    var et = e("Statement", null, {
        $documentation: "Base class of all statements",
        _validate: function() {
            if (this.TYPE == "Statement") throw new Error("should not instantiate AST_Statement");
        }
    });
    var nt = e("Debugger", null, {
        $documentation: "Represents a debugger statement"
    }, et);
    var tt = e("Directive", "quote value", {
        $documentation: 'Represents a directive, like "use strict";',
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] The value of this directive as a plain string (it's not an AST_String!)"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, et);
    var hn = e("EmptyStatement", null, {
        $documentation: "The empty statement (empty block or simply a semicolon)"
    }, et);
    function rt(e) {
        return e instanceof et && !(e instanceof Nt) && !(e instanceof yt);
    }
    function s(e, n, t, r, i) {
        t = t ? "contain" : "be";
        if (!(e instanceof vn)) throw new Error(n + " must " + t + " AST_Node");
        if (e instanceof kn) throw new Error(n + " cannot " + t + " AST_DefaultValue");
        if (e instanceof Fn) throw new Error(n + " cannot " + t + " AST_Destructured");
        if (e instanceof Ur && !i) throw new Error(n + " cannot " + t + " AST_Hole");
        if (e instanceof Dn && !r) throw new Error(n + " cannot " + t + " AST_Spread");
        if (rt(e)) throw new Error(n + " cannot " + t + " AST_Statement");
        if (e instanceof Sr) {
            throw new Error(n + " cannot " + t + " AST_SymbolDeclaration");
        }
    }
    function n(e, n) {
        s(e[n], n);
    }
    var mn = e("SimpleStatement", "body", {
        $documentation: "A statement consisting of an expression, i.e. a = 1 + 2",
        $propdoc: {
            body: "[AST_Node] an expression node (should not be instanceof AST_Statement)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            n(this, "body");
        }
    }, et);
    var it = e("BlockScope", "_var_names enclosed functions make_def parent_scope variables", {
        $documentation: "Base class for all statements introducing a lexical scope",
        $propdoc: {
            enclosed: "[SymbolDef*/S] a list of all symbol definitions that are accessed from this scope or any subscopes",
            functions: "[Dictionary/S] like `variables`, but only lists function declarations",
            parent_scope: "[AST_Scope?/S] link to the parent scope",
            variables: "[Dictionary/S] a map of name ---\x3e SymbolDef for all variables/functions defined in this scope"
        },
        clone: function(e) {
            var n = this._clone(e);
            if (this.enclosed) n.enclosed = this.enclosed.slice();
            if (this.functions) n.functions = this.functions.clone();
            if (this.variables) n.variables = this.variables.clone();
            return n;
        },
        pinned: function() {
            return this.resolve().pinned();
        },
        resolve: function() {
            return this.parent_scope.resolve();
        },
        _validate: function() {
            if (this.TYPE == "BlockScope") throw new Error("should not instantiate AST_BlockScope");
            if (this.parent_scope == null) return;
            if (!(this.parent_scope instanceof it)) throw new Error("parent_scope must be AST_BlockScope");
            if (!(this.resolve() instanceof gn)) throw new Error("must be contained within AST_Scope");
        }
    }, et);
    function at(e, n) {
        e.body.forEach(function(e) {
            e.walk(n);
        });
    }
    var ot = e("Block", "body", {
        $documentation: "A body of statements (usually braced)",
        $propdoc: {
            body: "[AST_Statement*] an array of statements"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                at(n, e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Block") throw new Error("should not instantiate AST_Block");
            this.body.forEach(function(e) {
                if (!rt(e)) throw new Error("body must contain AST_Statement");
            });
        }
    }, it);
    var _n = e("BlockStatement", null, {
        $documentation: "A block statement"
    }, ot);
    var j = e("StatementWithBody", "body", {
        $documentation: "Base class for all statements that contain one nested body: `For`, `ForIn`, `Do`, `While`, `With`",
        $propdoc: {
            body: "[AST_Statement] the body; this should always be present, even if it's an AST_EmptyStatement"
        },
        _validate: function() {
            if (this.TYPE == "StatementWithBody") throw new Error("should not instantiate AST_StatementWithBody");
            if (!rt(this.body)) throw new Error("body must be AST_Statement");
        }
    }, it);
    var st = e("LabeledStatement", "label", {
        $documentation: "Statement with a label",
        $propdoc: {
            label: "[AST_Label] a label definition"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.label.walk(e);
                n.body.walk(e);
            });
        },
        clone: function(e) {
            var n = this._clone(e);
            if (e) {
                var t = n.label;
                var r = this.label;
                n.walk(new Rn(function(e) {
                    if (e instanceof Vt) {
                        if (!e.label || e.label.thedef !== r) return;
                        e.label.thedef = t;
                        t.references.push(e);
                        return true;
                    }
                    if (e instanceof gn) return true;
                }));
            }
            return n;
        },
        _validate: function() {
            if (!(this.label instanceof Se)) throw new Error("label must be AST_Label");
        }
    }, j);
    var ft = e("IterationStatement", null, {
        $documentation: "Internal class.  All loops inherit from it.",
        _validate: function() {
            if (this.TYPE == "IterationStatement") throw new Error("should not instantiate AST_IterationStatement");
        }
    }, j);
    var ut = e("DWLoop", "condition", {
        $documentation: "Base class for do/while statements",
        $propdoc: {
            condition: "[AST_Node] the loop condition.  Should not be instanceof AST_Statement"
        },
        _validate: function() {
            if (this.TYPE == "DWLoop") throw new Error("should not instantiate AST_DWLoop");
            n(this, "condition");
        }
    }, ft);
    var ct = e("Do", null, {
        $documentation: "A `do` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
                n.condition.walk(e);
            });
        }
    }, ut);
    var lt = e("While", null, {
        $documentation: "A `while` statement",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
            });
        }
    }, ut);
    var pt = e("For", "init condition step", {
        $documentation: "A `for` statement",
        $propdoc: {
            init: "[AST_Node?] the `for` initialization code, or null if empty",
            condition: "[AST_Node?] the `for` termination clause, or null if empty",
            step: "[AST_Node?] the `for` update clause, or null if empty"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.init) n.init.walk(e);
                if (n.condition) n.condition.walk(e);
                if (n.step) n.step.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.init != null) {
                if (!(this.init instanceof vn)) throw new Error("init must be AST_Node");
                if (rt(this.init) && !(this.init instanceof tr)) {
                    throw new Error("init cannot be AST_Statement");
                }
            }
            if (this.condition != null) n(this, "condition");
            if (this.step != null) n(this, "step");
        }
    }, ft);
    var dt = e("ForEnumeration", "init object", {
        $documentation: "Base class for enumeration loops, i.e. `for ... in`, `for ... of` & `for await ... of`",
        $propdoc: {
            init: "[AST_Node] the assignment target during iteration",
            object: "[AST_Node] the object to iterate over"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.init.walk(e);
                n.object.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ForEnumeration") throw new Error("should not instantiate AST_ForEnumeration");
            if (this.init instanceof tr) {
                if (this.init.definitions.length != 1) throw new Error("init must have single declaration");
            } else {
                u(this.init, function(e) {
                    if (!(e instanceof Tn || e instanceof Nn)) {
                        throw new Error("init must be assignable: " + e.TYPE);
                    }
                });
            }
            n(this, "object");
        }
    }, ft);
    var vt = e("ForIn", null, {
        $documentation: "A `for ... in` statement"
    }, dt);
    var ye = e("ForOf", null, {
        $documentation: "A `for ... of` statement"
    }, dt);
    var ht = e("ForAwaitOf", null, {
        $documentation: "A `for await ... of` statement"
    }, ye);
    var mt = e("With", "expression", {
        $documentation: "A `with` statement",
        $propdoc: {
            expression: "[AST_Node] the `with` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.body.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    }, j);
    var gn = e("Scope", "fn_defs may_call_this uses_eval uses_with", {
        $documentation: "Base class for all statements introducing a lambda scope",
        $propdoc: {
            uses_eval: "[boolean/S] tells whether this scope contains a direct call to the global `eval`",
            uses_with: "[boolean/S] tells whether this scope uses the `with` statement"
        },
        pinned: function() {
            return this.uses_eval || this.uses_with;
        },
        resolve: Vn,
        _validate: function() {
            if (this.TYPE == "Scope") throw new Error("should not instantiate AST_Scope");
        }
    }, ot);
    var _t = e("Toplevel", "globals", {
        $documentation: "The toplevel scope",
        $propdoc: {
            globals: "[Dictionary/S] a map of name ---\x3e SymbolDef for all undeclared names"
        },
        wrap: function(e) {
            var n = this.body;
            return ti([ "(function(exports){'$ORIG';})(typeof ", e, "=='undefined'?(", e, "={}):", e, ");" ].join(""), {
                filename: "wrap=" + JSON.stringify(e)
            }).transform(new Xr(function(e) {
                if (e instanceof tt && e.value == "$ORIG") {
                    return Gn.splice(n);
                }
            }));
        },
        enclose: function(e) {
            if (typeof e != "string") e = "";
            var n = e.indexOf(":");
            if (n < 0) n = e.length;
            var t = this.body;
            return ti([ "(function(", e.slice(0, n), '){"$ORIG"})(', e.slice(n + 1), ")" ].join(""), {
                filename: "enclose=" + JSON.stringify(e)
            }).transform(new Xr(function(e) {
                if (e instanceof tt && e.value == "$ORIG") {
                    return Gn.splice(t);
                }
            }));
        }
    }, gn);
    var gt = e("ClassInitBlock", null, {
        $documentation: "Value for `class` static initialization blocks"
    }, gn);
    var bn = e("Lambda", "argnames length_read rest safe_ids uses_arguments", {
        $documentation: "Base class for functions",
        $propdoc: {
            argnames: "[(AST_DefaultValue|AST_Destructured|AST_SymbolFunarg)*] array of function arguments and/or destructured literals",
            length_read: "[boolean/S] whether length property of this function is accessed",
            rest: "[(AST_Destructured|AST_SymbolFunarg)?] rest parameter, or null if absent",
            uses_arguments: "[boolean|number/S] whether this function accesses the arguments array"
        },
        each_argname: function(n) {
            var t = new Rn(function(e) {
                if (e instanceof kn) {
                    e.name.walk(t);
                    return true;
                }
                if (e instanceof _r) {
                    e.value.walk(t);
                    return true;
                }
                if (e instanceof jn) n(e);
            });
            this.argnames.forEach(function(e) {
                e.walk(t);
            });
            if (this.rest) this.rest.walk(t);
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                at(e, n);
            });
        },
        _validate: function() {
            if (this.TYPE == "Lambda") throw new Error("should not instantiate AST_Lambda");
            this.argnames.forEach(function(e) {
                u(e, function(e) {
                    if (!(e instanceof jn)) throw new Error("argnames must be AST_SymbolFunarg[]");
                }, true);
            });
            if (this.rest != null) u(this.rest, function(e) {
                if (!(e instanceof jn)) throw new Error("rest must be AST_SymbolFunarg");
            });
        }
    }, gn);
    var bt = e("Accessor", null, {
        $documentation: "A getter/setter function",
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
        }
    }, bn);
    var yt = e("LambdaExpression", "inlined", {
        $documentation: "Base class for function expressions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined"
        },
        _validate: function() {
            if (this.TYPE == "LambdaExpression") throw new Error("should not instantiate AST_LambdaExpression");
        }
    }, bn);
    function wt(e) {
        return e instanceof St || e instanceof Tt;
    }
    function xt(e) {
        return e instanceof Tt || e instanceof qt || e instanceof At || e instanceof Ct || e instanceof Dt;
    }
    function kt(e) {
        return e instanceof Ct || e instanceof Dt || e instanceof Ft || e instanceof $t;
    }
    function Et(e, n) {
        if (wt(e) && e.value) {
            e.value.walk(n);
        } else {
            at(e, n);
        }
    }
    var St = e("Arrow", "value", {
        $documentation: "An arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    at(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                n(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, yt);
    var Tt = e("AsyncArrow", "value", {
        $documentation: "An asynchronous arrow function expression",
        $propdoc: {
            value: "[AST_Node?] simple return expression, or null if using function body."
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.argnames.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
                if (e.value) {
                    e.value.walk(n);
                } else {
                    at(e, n);
                }
            });
        },
        _validate: function() {
            if (this.name != null) throw new Error("name must be null");
            if (this.uses_arguments) throw new Error("uses_arguments must be false");
            if (this.value != null) {
                n(this, "value");
                if (this.body.length) throw new Error("body must be empty if value exists");
            }
        }
    }, yt);
    var At = e("AsyncFunction", "name", {
        $documentation: "An asynchronous function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof zr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, yt);
    var Dt = e("AsyncGeneratorFunction", "name", {
        $documentation: "An asynchronous generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof zr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, yt);
    var Ot = e("Function", "name", {
        $documentation: "A function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof zr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, yt);
    var $t = e("GeneratorFunction", "name", {
        $documentation: "A generator function expression",
        $propdoc: {
            name: "[AST_SymbolLambda?] the name of this function, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof zr)) throw new Error("name must be AST_SymbolLambda");
            }
        }
    }, yt);
    var zt = e("LambdaDefinition", "inlined name", {
        $documentation: "Base class for function definitions",
        $propdoc: {
            inlined: "[boolean/S] whether this function has been inlined",
            name: "[AST_SymbolDefun] the name of this function"
        },
        _validate: function() {
            if (this.TYPE == "LambdaDefinition") throw new Error("should not instantiate AST_LambdaDefinition");
            if (!(this.name instanceof $r)) throw new Error("name must be AST_SymbolDefun");
        }
    }, bn);
    var qt = e("AsyncDefun", null, {
        $documentation: "An asynchronous function definition"
    }, zt);
    var Ct = e("AsyncGeneratorDefun", null, {
        $documentation: "An asynchronous generator function definition"
    }, zt);
    var Mt = e("Defun", null, {
        $documentation: "A function definition"
    }, zt);
    var Ft = e("GeneratorDefun", null, {
        $documentation: "A generator function definition"
    }, zt);
    var Pt = e("Class", "extends name properties", {
        $documentation: "Base class for class literals",
        $propdoc: {
            extends: "[AST_Node?] the super class, or null if not specified",
            properties: "[AST_ClassProperty*] array of class properties"
        },
        resolve: function(e) {
            return e ? this : this.parent_scope.resolve();
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.name) e.name.walk(n);
                if (e.extends) e.extends.walk(n);
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Class") throw new Error("should not instantiate AST_Class");
            if (this.extends != null) n(this, "extends");
            this.properties.forEach(function(e) {
                if (!(e instanceof It)) throw new Error("properties must contain AST_ClassProperty");
            });
        }
    }, it);
    var jt = e("DefClass", null, {
        $documentation: "A class definition",
        $propdoc: {
            name: "[AST_SymbolDefClass] the name of this class"
        },
        _validate: function() {
            if (!(this.name instanceof Ee)) throw new Error("name must be AST_SymbolDefClass");
        }
    }, Pt);
    var Nt = e("ClassExpression", null, {
        $documentation: "A class expression",
        $propdoc: {
            name: "[AST_SymbolClass?] the name of this class, or null if not specified"
        },
        _validate: function() {
            if (this.name != null) {
                if (!(this.name instanceof qr)) throw new Error("name must be AST_SymbolClass");
            }
        }
    }, Pt);
    var It = e("ClassProperty", "key private static value", {
        $documentation: "Base class for `class` properties",
        $propdoc: {
            key: "[string|AST_Node?] property name (AST_Node for computed property, null for initialization block)",
            private: "[boolean] whether this is a private property",
            static: "[boolean] whether this is a static property",
            value: "[AST_Node?] property value (AST_Accessor for getters/setters, AST_LambdaExpression for methods, null if not specified for fields)"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ClassProperty") throw new Error("should not instantiate AST_ClassProperty");
            if (this instanceof Rt) {
                if (this.key != null) throw new Error("key must be null");
            } else if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (this.value != null) {
                if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
            }
        }
    });
    var Ht = e("ClassField", null, {
        $documentation: "A `class` field",
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    }, It);
    var we = e("ClassGetter", null, {
        $documentation: "A `class` getter",
        _validate: function() {
            if (!(this.value instanceof bt)) throw new Error("value must be AST_Accessor");
        }
    }, It);
    var xe = e("ClassSetter", null, {
        $documentation: "A `class` setter",
        _validate: function() {
            if (!(this.value instanceof bt)) throw new Error("value must be AST_Accessor");
        }
    }, It);
    var Yt = e("ClassMethod", null, {
        $documentation: "A `class` method",
        _validate: function() {
            if (!(this.value instanceof yt)) throw new Error("value must be AST_LambdaExpression");
            if (wt(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of class method's lambda must be null");
        }
    }, It);
    var Rt = e("ClassInit", null, {
        $documentation: "A `class` static initialization block",
        _validate: function() {
            if (!this.static) throw new Error("static must be true");
            if (!(this.value instanceof gt)) throw new Error("value must be AST_ClassInitBlock");
        },
        initialize: function() {
            this.static = true;
        }
    }, It);
    var Bt = e("Jump", null, {
        $documentation: "Base class for “jumps” (for now that's `return`, `throw`, `break` and `continue`)",
        _validate: function() {
            if (this.TYPE == "Jump") throw new Error("should not instantiate AST_Jump");
        }
    }, et);
    var Lt = e("Exit", "value", {
        $documentation: "Base class for “exits” (`return` and `throw`)",
        $propdoc: {
            value: "[AST_Node?] the value returned or thrown by this statement; could be null for AST_Return"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Exit") throw new Error("should not instantiate AST_Exit");
        }
    }, Bt);
    var yn = e("Return", null, {
        $documentation: "A `return` statement",
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    }, Lt);
    var Ut = e("Throw", null, {
        $documentation: "A `throw` statement",
        _validate: function() {
            n(this, "value");
        }
    }, Lt);
    var Vt = e("LoopControl", "label", {
        $documentation: "Base class for loop control statements (`break` and `continue`)",
        $propdoc: {
            label: "[AST_LabelRef?] the label, or null if none"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.label) n.label.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "LoopControl") throw new Error("should not instantiate AST_LoopControl");
            if (this.label != null) {
                if (!(this.label instanceof Te)) throw new Error("label must be AST_LabelRef");
            }
        }
    }, Bt);
    var Wt = e("Break", null, {
        $documentation: "A `break` statement"
    }, Vt);
    var Gt = e("Continue", null, {
        $documentation: "A `continue` statement"
    }, Vt);
    var wn = e("If", "condition alternative", {
        $documentation: "A `if` statement",
        $propdoc: {
            condition: "[AST_Node] the `if` condition",
            alternative: "[AST_Statement?] the `else` part, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.body.walk(e);
                if (n.alternative) n.alternative.walk(e);
            });
        },
        _validate: function() {
            n(this, "condition");
            if (this.alternative != null) {
                if (!rt(this.alternative)) throw new Error("alternative must be AST_Statement");
            }
        }
    }, j);
    var Jt = e("Switch", "expression", {
        $documentation: "A `switch` statement",
        $propdoc: {
            expression: "[AST_Node] the `switch` “discriminant”"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                at(n, e);
            });
        },
        _validate: function() {
            n(this, "expression");
            this.body.forEach(function(e) {
                if (!(e instanceof Xt)) throw new Error("body must be AST_SwitchBranch[]");
            });
        }
    }, ot);
    var Xt = e("SwitchBranch", null, {
        $documentation: "Base class for `switch` branches",
        _validate: function() {
            if (this.TYPE == "SwitchBranch") throw new Error("should not instantiate AST_SwitchBranch");
        }
    }, ot);
    var Kt = e("Default", null, {
        $documentation: "A `default` switch branch"
    }, Xt);
    var Qt = e("Case", "expression", {
        $documentation: "A `case` switch branch",
        $propdoc: {
            expression: "[AST_Node] the `case` expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                at(n, e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    }, Xt);
    var Zt = e("Try", "bcatch bfinally", {
        $documentation: "A `try` statement",
        $propdoc: {
            bcatch: "[AST_Catch?] the catch block, or null if not present",
            bfinally: "[AST_Finally?] the finally block, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                at(n, e);
                if (n.bcatch) n.bcatch.walk(e);
                if (n.bfinally) n.bfinally.walk(e);
            });
        },
        _validate: function() {
            if (this.bcatch != null) {
                if (!(this.bcatch instanceof er)) throw new Error("bcatch must be AST_Catch");
            }
            if (this.bfinally != null) {
                if (!(this.bfinally instanceof nr)) throw new Error("bfinally must be AST_Finally");
            }
        }
    }, ot);
    var er = e("Catch", "argname", {
        $documentation: "A `catch` node; only makes sense as part of a `try` statement",
        $propdoc: {
            argname: "[(AST_Destructured|AST_SymbolCatch)?] symbol for the exception, or null if not present"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.argname) n.argname.walk(e);
                at(n, e);
            });
        },
        _validate: function() {
            if (this.argname != null) u(this.argname, function(e) {
                if (!(e instanceof Cr)) throw new Error("argname must be AST_SymbolCatch");
            });
        }
    }, ot);
    var nr = e("Finally", null, {
        $documentation: "A `finally` node; only makes sense as part of a `try` statement"
    }, ot);
    var tr = e("Definitions", "definitions", {
        $documentation: "Base class for `var` nodes (variable declarations/initializations)",
        $propdoc: {
            definitions: "[AST_VarDef*] array of variable definitions"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.definitions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.TYPE == "Definitions") throw new Error("should not instantiate AST_Definitions");
            if (this.definitions.length < 1) throw new Error("must have at least one definition");
        }
    }, et);
    var rr = e("Const", null, {
        $documentation: "A `const` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Tr)) throw new Error("name must be AST_SymbolConst");
                });
            });
        }
    }, tr);
    var ir = e("Let", null, {
        $documentation: "A `let` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Dr)) throw new Error("name must be AST_SymbolLet");
                });
            });
        }
    }, tr);
    var ar = e("Var", null, {
        $documentation: "A `var` statement",
        _validate: function() {
            this.definitions.forEach(function(e) {
                if (!(e instanceof xn)) throw new Error("definitions must be AST_VarDef[]");
                u(e.name, function(e) {
                    if (!(e instanceof Or)) throw new Error("name must be AST_SymbolVar");
                });
            });
        }
    }, tr);
    var xn = e("VarDef", "name value", {
        $documentation: "A variable declaration; only appears in a AST_Definitions node",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolVar] name of the variable",
            value: "[AST_Node?] initializer, or null of there's no initializer"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                if (n.value) n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.value != null) n(this, "value");
        }
    });
    var or = e("ExportDeclaration", "body", {
        $documentation: "An `export` statement",
        $propdoc: {
            body: "[AST_DefClass|AST_Definitions|AST_LambdaDefinition] the statement to export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof jt || this.body instanceof tr || this.body instanceof zt)) {
                throw new Error("body must be AST_DefClass, AST_Definitions or AST_LambdaDefinition");
            }
        }
    }, et);
    var sr = e("ExportDefault", "body", {
        $documentation: "An `export default` statement",
        $propdoc: {
            body: "[AST_Node] the default export"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.body.walk(e);
            });
        },
        _validate: function() {
            if (!(this.body instanceof jt || this.body instanceof zt)) {
                n(this, "body");
            }
        }
    }, et);
    var ke = e("ExportForeign", "aliases keys path quote", {
        $documentation: "An `export ... from '...'` statement",
        $propdoc: {
            aliases: "[string*] array of aliases to export",
            keys: "[string*] array of keys to import",
            path: "[string] the path to import module",
            quote: "[string?] the original quote character"
        },
        _validate: function() {
            if (this.aliases.length != this.keys.length) {
                throw new Error("aliases:key length mismatch: " + this.aliases.length + " != " + this.keys.length);
            }
            this.aliases.forEach(function(e) {
                if (typeof e != "string") throw new Error("aliases must contain string");
            });
            this.keys.forEach(function(e) {
                if (typeof e != "string") throw new Error("keys must contain string");
            });
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, et);
    var fr = e("ExportReferences", "properties", {
        $documentation: "An `export { ... }` statement",
        $propdoc: {
            properties: "[AST_SymbolExport*] array of aliases to export"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof Mr)) throw new Error("properties must contain AST_SymbolExport");
            });
        }
    }, et);
    var ur = e("Import", "all default path properties quote", {
        $documentation: "An `import` statement",
        $propdoc: {
            all: "[AST_SymbolImport?] the imported namespace, or null if not specified",
            default: "[AST_SymbolImport?] the alias for default `export`, or null if not specified",
            path: "[string] the path to import module",
            properties: "[(AST_SymbolImport*)?] array of aliases, or null if not specified",
            quote: "[string?] the original quote character"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.all) e.all.walk(n);
                if (e.default) e.default.walk(n);
                if (e.properties) e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.all != null) {
                if (!(this.all instanceof Ar)) throw new Error("all must be AST_SymbolImport");
                if (this.properties != null) throw new Error("cannot import both * and {} in the same statement");
            }
            if (this.default != null) {
                if (!(this.default instanceof Ar)) throw new Error("default must be AST_SymbolImport");
                if (this.default.key !== "") throw new Error("invalid default key: " + this.default.key);
            }
            if (typeof this.path != "string") throw new Error("path must be string");
            if (this.properties != null) this.properties.forEach(function(e) {
                if (!(e instanceof Ar)) throw new Error("properties must contain AST_SymbolImport");
            });
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
        }
    }, et);
    var kn = e("DefaultValue", "name value", {
        $documentation: "A default value declaration",
        $propdoc: {
            name: "[AST_Destructured|AST_SymbolDeclaration] name of the variable",
            value: "[AST_Node] value to assign if variable is `undefined`"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.name.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            n(this, "value");
        }
    });
    function f(e, n, t, r) {
        e[n].forEach(function(e) {
            s(e, n, true, t, r);
        });
    }
    var En = e("Call", "args expression optional pure terminal", {
        $documentation: "A function call expression",
        $propdoc: {
            args: "[AST_Node*] array of arguments",
            expression: "[AST_Node] expression to invoke as function",
            optional: "[boolean] whether the expression is optional chaining",
            pure: "[boolean/S] marker for side-effect-free call expression",
            terminal: "[boolean] whether the chain has ended"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expression.walk(n);
                e.args.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            n(this, "expression");
            f(this, "args", true);
        }
    });
    var cr = e("New", null, {
        $documentation: "An object instantiation.  Derives from a function call since it has exactly the same properties",
        _validate: function() {
            if (this.optional) throw new Error("optional must be false");
            if (this.terminal) throw new Error("terminal must be false");
        }
    }, En);
    var Sn = e("Sequence", "expressions", {
        $documentation: "A sequence expression (comma-separated expressions)",
        $propdoc: {
            expressions: "[AST_Node*] array of expressions (at least two)"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length < 2) throw new Error("expressions must contain multiple elements");
            f(this, "expressions");
        }
    });
    function lr(e) {
        while (e instanceof Tn) e = e.expression;
        return e;
    }
    var Tn = e("PropAccess", "expression optional property terminal", {
        $documentation: 'Base class for property access expressions, i.e. `a.foo` or `a["foo"]`',
        $propdoc: {
            expression: "[AST_Node] the “container” expression",
            optional: "[boolean] whether the expression is optional chaining",
            property: "[AST_Node|string] the property to access.  For AST_Dot this is always a plain string, while for AST_Sub it's an arbitrary AST_Node",
            terminal: "[boolean] whether the chain has ended"
        },
        get_property: function() {
            var e = this.property;
            if (e instanceof In) return e.value;
            if (e instanceof $n && e.operator == "void" && e.expression instanceof In) return;
            return e;
        },
        _validate: function() {
            if (this.TYPE == "PropAccess") throw new Error("should not instantiate AST_PropAccess");
            n(this, "expression");
        }
    });
    var An = e("Dot", null, {
        $documentation: "A dotted property access expression",
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.property != "string") throw new Error("property must be string");
        }
    }, Tn);
    var pr = e("Sub", null, {
        $documentation: 'Index-style property access, i.e. `a["foo"]`',
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
                n.property.walk(e);
            });
        },
        _validate: function() {
            n(this, "property");
        }
    }, Tn);
    var Dn = e("Spread", "expression", {
        $documentation: "Spread expression in array/object literals or function calls",
        $propdoc: {
            expression: "[AST_Node] expression to be expanded"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    });
    var On = e("Unary", "operator expression", {
        $documentation: "Base class for unary expressions",
        $propdoc: {
            operator: "[string] the operator",
            expression: "[AST_Node] expression that this unary operator applies to"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "Unary") throw new Error("should not instantiate AST_Unary");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            n(this, "expression");
        }
    });
    var $n = e("UnaryPrefix", null, {
        $documentation: "Unary prefix expression, i.e. `typeof i` or `++i`"
    }, On);
    var dr = e("UnaryPostfix", null, {
        $documentation: "Unary postfix expression, i.e. `i++`"
    }, On);
    var zn = e("Binary", "operator left right", {
        $documentation: "Binary expression, i.e. `a + b`",
        $propdoc: {
            left: "[AST_Node] left-hand side expression",
            operator: "[string] the operator",
            right: "[AST_Node] right-hand side expression"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.left.walk(e);
                n.right.walk(e);
            });
        },
        _validate: function() {
            if (!(this instanceof Cn)) n(this, "left");
            if (typeof this.operator != "string") throw new Error("operator must be string");
            n(this, "right");
        }
    });
    var qn = e("Conditional", "condition consequent alternative", {
        $documentation: "Conditional expression using the ternary operator, i.e. `a ? b : c`",
        $propdoc: {
            condition: "[AST_Node]",
            consequent: "[AST_Node]",
            alternative: "[AST_Node]"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.condition.walk(e);
                n.consequent.walk(e);
                n.alternative.walk(e);
            });
        },
        _validate: function() {
            n(this, "condition");
            n(this, "consequent");
            n(this, "alternative");
        }
    });
    var Cn = e("Assign", null, {
        $documentation: "An assignment expression — `a = b + 5`",
        _validate: function() {
            if (this.operator.indexOf("=") < 0) throw new Error('operator must contain "="');
            if (this.left instanceof Fn) {
                if (this.operator != "=") throw new Error("invalid destructuring operator: " + this.operator);
                u(this.left, function(e) {
                    if (!(e instanceof Tn || e instanceof Nn)) {
                        throw new Error("left must be assignable: " + e.TYPE);
                    }
                });
            } else if (!(this.left instanceof Vr || this.left instanceof Br || this.left instanceof Tn && !this.left.optional || this.left instanceof Nn || this.left instanceof Lr)) {
                throw new Error("left must be assignable");
            }
        }
    }, zn);
    var vr = e("Await", "expression", {
        $documentation: "An await expression",
        $propdoc: {
            expression: "[AST_Node] expression with Promise to resolve on"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                n.expression.walk(e);
            });
        },
        _validate: function() {
            n(this, "expression");
        }
    });
    var hr = e("Yield", "expression nested", {
        $documentation: "A yield expression",
        $propdoc: {
            expression: "[AST_Node?] return value for iterator, or null if undefined",
            nested: "[boolean] whether to iterate over expression as generator"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.expression) n.expression.walk(e);
            });
        },
        _validate: function() {
            if (this.expression != null) {
                n(this, "expression");
            } else if (this.nested) {
                throw new Error("yield* must contain expression");
            }
        }
    });
    var Mn = e("Array", "elements", {
        $documentation: "An array literal",
        $propdoc: {
            elements: "[AST_Node*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            f(this, "elements", true, true);
        }
    });
    var Fn = e("Destructured", "rest", {
        $documentation: "Base class for destructured literal",
        $propdoc: {
            rest: "[(AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)?] rest parameter, or null if absent"
        },
        _validate: function() {
            if (this.TYPE == "Destructured") throw new Error("should not instantiate AST_Destructured");
        }
    });
    function u(e, n, t) {
        if (e instanceof kn && t) return u(e.name, n);
        if (e instanceof Fn) {
            if (e.rest != null) u(e.rest, n);
            if (e instanceof mr) return e.elements.forEach(function(e) {
                if (!(e instanceof Ur)) u(e, n, true);
            });
            if (e instanceof gr) return e.properties.forEach(function(e) {
                u(e.value, n, true);
            });
        }
        n(e);
    }
    var mr = e("DestructuredArray", "elements", {
        $documentation: "A destructured array literal",
        $propdoc: {
            elements: "[(AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef)*] array of elements"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.elements.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        }
    }, Fn);
    var _r = e("DestructuredKeyVal", "key value", {
        $documentation: "A key: value destructured property",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_DefaultValue|AST_Destructured|AST_SymbolDeclaration|AST_SymbolRef] property value"
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
        }
    });
    var gr = e("DestructuredObject", "properties", {
        $documentation: "A destructured object literal",
        $propdoc: {
            properties: "[AST_DestructuredKeyVal*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
                if (e.rest) e.rest.walk(n);
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof _r)) throw new Error("properties must be AST_DestructuredKeyVal[]");
            });
        }
    }, Fn);
    var Pn = e("Object", "properties", {
        $documentation: "An object literal",
        $propdoc: {
            properties: "[(AST_ObjectProperty|AST_Spread)*] array of properties"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                e.properties.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            this.properties.forEach(function(e) {
                if (!(e instanceof br || e instanceof Dn)) {
                    throw new Error("properties must contain AST_ObjectProperty and/or AST_Spread only");
                }
            });
        }
    });
    var br = e("ObjectProperty", "key value", {
        $documentation: "Base class for literal object properties",
        $propdoc: {
            key: "[string|AST_Node] property name.  For computed property this is an AST_Node.",
            value: "[AST_Node] property value.  For getters and setters this is an AST_Accessor."
        },
        walk: function(e) {
            var n = this;
            e.visit(n, function() {
                if (n.key instanceof vn) n.key.walk(e);
                n.value.walk(e);
            });
        },
        _validate: function() {
            if (this.TYPE == "ObjectProperty") throw new Error("should not instantiate AST_ObjectProperty");
            if (typeof this.key != "string") {
                if (!(this.key instanceof vn)) throw new Error("key must be string or AST_Node");
                n(this, "key");
            }
            if (!(this.value instanceof vn)) throw new Error("value must be AST_Node");
        }
    });
    var yr = e("ObjectKeyVal", null, {
        $documentation: "A key: value object property",
        _validate: function() {
            n(this, "value");
        }
    }, br);
    var wr = e("ObjectMethod", null, {
        $documentation: "A key(){} object property",
        _validate: function() {
            if (!(this.value instanceof yt)) throw new Error("value must be AST_LambdaExpression");
            if (wt(this.value)) throw new Error("value cannot be AST_Arrow or AST_AsyncArrow");
            if (this.value.name != null) throw new Error("name of object method's lambda must be null");
        }
    }, yr);
    var xr = e("ObjectSetter", null, {
        $documentation: "An object setter property",
        _validate: function() {
            if (!(this.value instanceof bt)) throw new Error("value must be AST_Accessor");
        }
    }, br);
    var kr = e("ObjectGetter", null, {
        $documentation: "An object getter property",
        _validate: function() {
            if (!(this.value instanceof bt)) throw new Error("value must be AST_Accessor");
        }
    }, br);
    var Er = e("Symbol", "scope name thedef", {
        $documentation: "Base class for all symbols",
        $propdoc: {
            name: "[string] name of this symbol",
            scope: "[AST_Scope/S] the current scope (not necessarily the definition scope)",
            thedef: "[SymbolDef/S] the definition of this symbol"
        },
        _validate: function() {
            if (this.TYPE == "Symbol") throw new Error("should not instantiate AST_Symbol");
            if (typeof this.name != "string") throw new Error("name must be string");
        }
    });
    var Sr = e("SymbolDeclaration", "init", {
        $documentation: "A declaration symbol (symbol in var, function name or argument, symbol in catch)"
    }, Er);
    var Tr = e("SymbolConst", null, {
        $documentation: "Symbol defining a constant"
    }, Sr);
    var Ar = e("SymbolImport", "key", {
        $documentation: "Symbol defined by an `import` statement",
        $propdoc: {
            key: "[string] the original `export` name"
        },
        _validate: function() {
            if (typeof this.key != "string") throw new Error("key must be string");
        }
    }, Tr);
    var Dr = e("SymbolLet", null, {
        $documentation: "Symbol defining a lexical-scoped variable"
    }, Sr);
    var Or = e("SymbolVar", null, {
        $documentation: "Symbol defining a variable"
    }, Sr);
    var jn = e("SymbolFunarg", "unused", {
        $documentation: "Symbol naming a function argument"
    }, Or);
    var $r = e("SymbolDefun", null, {
        $documentation: "Symbol defining a function"
    }, Sr);
    var zr = e("SymbolLambda", null, {
        $documentation: "Symbol naming a function expression"
    }, Sr);
    var Ee = e("SymbolDefClass", null, {
        $documentation: "Symbol defining a class"
    }, Tr);
    var qr = e("SymbolClass", null, {
        $documentation: "Symbol naming a class expression"
    }, Tr);
    var Cr = e("SymbolCatch", null, {
        $documentation: "Symbol naming the exception in catch"
    }, Sr);
    var Se = e("Label", "references", {
        $documentation: "Symbol naming a label (declaration)",
        $propdoc: {
            references: "[AST_LoopControl*] a list of nodes referring to this label"
        },
        initialize: function() {
            this.references = [];
            this.thedef = this;
        }
    }, Er);
    var Nn = e("SymbolRef", "fixed in_arg redef", {
        $documentation: "Reference to some symbol (not definition/declaration)"
    }, Er);
    var Mr = e("SymbolExport", "alias", {
        $documentation: "Reference in an `export` statement",
        $propdoc: {
            alias: "[string] the `export` alias"
        },
        _validate: function() {
            if (typeof this.alias != "string") throw new Error("alias must be string");
        }
    }, Nn);
    var Te = e("LabelRef", null, {
        $documentation: "Reference to a label symbol"
    }, Er);
    var Fr = e("ObjectIdentity", null, {
        $documentation: "Base class for `super` & `this`",
        _validate: function() {
            if (this.TYPE == "ObjectIdentity") throw new Error("should not instantiate AST_ObjectIdentity");
        }
    }, Er);
    var Pr = e("Super", null, {
        $documentation: "The `super` symbol",
        _validate: function() {
            if (this.name !== "super") throw new Error('name must be "super"');
        }
    }, Fr);
    var jr = e("This", null, {
        $documentation: "The `this` symbol",
        _validate: function() {
            if (this.TYPE == "This" && this.name !== "this") throw new Error('name must be "this"');
        }
    }, Fr);
    var Nr = e("NewTarget", null, {
        $documentation: "The `new.target` symbol",
        initialize: function() {
            this.name = "new.target";
        },
        _validate: function() {
            if (this.name !== "new.target") throw new Error('name must be "new.target": ' + this.name);
        }
    }, jr);
    var Ir = e("Template", "expressions strings tag", {
        $documentation: "A template literal, i.e. tag`str1${expr1}...strN${exprN}strN+1`",
        $propdoc: {
            expressions: "[AST_Node*] the placeholder expressions",
            strings: "[string*] the raw text segments",
            tag: "[AST_Node] tag function, or null if absent"
        },
        walk: function(n) {
            var e = this;
            n.visit(e, function() {
                if (e.tag) e.tag.walk(n);
                e.expressions.forEach(function(e) {
                    e.walk(n);
                });
            });
        },
        _validate: function() {
            if (this.expressions.length + 1 != this.strings.length) {
                throw new Error("malformed template with " + this.expressions.length + " placeholder(s) but " + this.strings.length + " text segment(s)");
            }
            f(this, "expressions");
            this.strings.forEach(function(e) {
                if (typeof e != "string") throw new Error("strings must contain string");
            });
            if (this.tag != null) n(this, "tag");
        }
    });
    var In = e("Constant", null, {
        $documentation: "Base class for all constants",
        _validate: function() {
            if (this.TYPE == "Constant") throw new Error("should not instantiate AST_Constant");
        }
    });
    var Hn = e("String", "quote value", {
        $documentation: "A string literal",
        $propdoc: {
            quote: "[string?] the original quote character",
            value: "[string] the contents of this string"
        },
        _validate: function() {
            if (this.quote != null) {
                if (typeof this.quote != "string") throw new Error("quote must be string");
                if (!/^["']$/.test(this.quote)) throw new Error("invalid quote: " + this.quote);
            }
            if (typeof this.value != "string") throw new Error("value must be string");
        }
    }, In);
    var Yn = e("Number", "value", {
        $documentation: "A number literal",
        $propdoc: {
            value: "[number] the numeric value"
        },
        _validate: function() {
            if (typeof this.value != "number") throw new Error("value must be number");
            if (!isFinite(this.value)) throw new Error("value must be finite");
            if (this.value < 0) throw new Error("value cannot be negative");
        }
    }, In);
    var Hr = e("BigInt", "value", {
        $documentation: "A BigInt literal",
        $propdoc: {
            value: "[string] the numeric representation"
        },
        _validate: function() {
            if (typeof this.value != "string") throw new Error("value must be string");
            if (this.value[0] == "-") throw new Error("value cannot be negative");
        }
    }, In);
    var Yr = e("RegExp", "value", {
        $documentation: "A regexp literal",
        $propdoc: {
            value: "[RegExp] the actual regexp"
        },
        _validate: function() {
            if (!(this.value instanceof RegExp)) throw new Error("value must be RegExp");
        }
    }, In);
    var g = e("Atom", null, {
        $documentation: "Base class for atoms",
        _validate: function() {
            if (this.TYPE == "Atom") throw new Error("should not instantiate AST_Atom");
        }
    }, In);
    var Rr = e("Null", null, {
        $documentation: "The `null` atom",
        value: null
    }, g);
    var Br = e("NaN", null, {
        $documentation: "The impossible value",
        value: 0 / 0
    }, g);
    var Lr = e("Undefined", null, {
        $documentation: "The `undefined` value",
        value: function() {}()
    }, g);
    var Ur = e("Hole", null, {
        $documentation: "A hole in an array",
        value: function() {}()
    }, g);
    var Vr = e("Infinity", null, {
        $documentation: "The `Infinity` value",
        value: 1 / 0
    }, g);
    var Wr = e("Boolean", null, {
        $documentation: "Base class for booleans",
        _validate: function() {
            if (this.TYPE == "Boolean") throw new Error("should not instantiate AST_Boolean");
        }
    }, g);
    var Gr = e("False", null, {
        $documentation: "The `false` atom",
        value: false
    }, Wr);
    var Jr = e("True", null, {
        $documentation: "The `true` atom",
        value: true
    }, Wr);
    function Rn(e) {
        this.callback = e;
        this.directives = Object.create(null);
        this.stack = [];
    }
    Rn.prototype = {
        visit: function(e, n) {
            this.push(e);
            var t = this.callback(e, n || Un);
            if (!t && n) n();
            this.pop();
        },
        parent: function(e) {
            return this.stack[this.stack.length - 2 - (e || 0)];
        },
        push: function(e) {
            var n;
            if (e instanceof Pt) {
                this.directives = Object.create(this.directives);
                n = "use strict";
            } else if (e instanceof tt) {
                n = e.value;
            } else if (e instanceof bn) {
                this.directives = Object.create(this.directives);
            }
            if (n && !this.directives[n]) this.directives[n] = e;
            this.stack.push(e);
        },
        pop: function() {
            var e = this.stack.pop();
            if (e instanceof Pt || e instanceof bn) {
                this.directives = Object.getPrototypeOf(this.directives);
            }
        },
        self: function() {
            return this.stack[this.stack.length - 1];
        },
        find_parent: function(e) {
            var n = this.stack;
            for (var t = n.length - 1; --t >= 0; ) {
                var r = n[t];
                if (r instanceof e) return r;
            }
        },
        has_directive: function(e) {
            var n = this.directives[e];
            if (n) return n;
            var t = this.stack[this.stack.length - 1];
            if (t instanceof gn) {
                for (var r = 0; r < t.body.length; ++r) {
                    var i = t.body[r];
                    if (!(i instanceof tt)) break;
                    if (i.value == e) return i;
                }
            }
        },
        loopcontrol_target: function(e) {
            var n = this.stack;
            if (e.label) for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof st && r.label.name == e.label.name) return r.body;
            } else for (var t = n.length; --t >= 0; ) {
                var r = n[t];
                if (r instanceof ft || e instanceof Wt && r instanceof Jt) return r;
            }
        },
        in_boolean_context: function() {
            for (var e = true, n = 0, t, r = this.self(); t = this.parent(n++); r = t) {
                if (t instanceof zn) switch (t.operator) {
                  case "&&":
                  case "||":
                    if (t.left === r) e = false;
                    continue;

                  default:
                    return false;
                }
                if (t instanceof qn) {
                    if (t.condition === r) return true;
                    continue;
                }
                if (t instanceof ut) return t.condition === r;
                if (t instanceof pt) return t.condition === r;
                if (t instanceof wn) return t.condition === r;
                if (t instanceof yn) {
                    if (t.in_bool) return true;
                    while (t = this.parent(n++)) {
                        if (t instanceof bn) {
                            if (t.name) return false;
                            t = this.parent(n++);
                            if (t.TYPE != "Call") return false;
                            break;
                        }
                    }
                }
                if (t instanceof Sn) {
                    if (t.tail_node() === r) continue;
                    return e ? "d" : true;
                }
                if (t instanceof mn) return e ? "d" : true;
                if (t instanceof $n) return t.operator == "!";
                return false;
            }
        }
    };
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function Xr(e, n) {
        Rn.call(this);
        this.before = e;
        this.after = n;
    }
    Xr.prototype = new Rn();
    (function(e) {
        function t(e, n) {
            return Gn(e, function(e) {
                return e.transform(n, true);
            });
        }
        e(vn, Un);
        e(st, function(e, n) {
            e.label = e.label.transform(n);
            e.body = e.body.transform(n);
        });
        e(mn, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(ot, function(e, n) {
            e.body = t(e.body, n);
        });
        e(ct, function(e, n) {
            e.body = e.body.transform(n);
            e.condition = e.condition.transform(n);
        });
        e(lt, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
        });
        e(pt, function(e, n) {
            if (e.init) e.init = e.init.transform(n);
            if (e.condition) e.condition = e.condition.transform(n);
            if (e.step) e.step = e.step.transform(n);
            e.body = e.body.transform(n);
        });
        e(dt, function(e, n) {
            e.init = e.init.transform(n);
            e.object = e.object.transform(n);
            e.body = e.body.transform(n);
        });
        e(mt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = e.body.transform(n);
        });
        e(Lt, function(e, n) {
            if (e.value) e.value = e.value.transform(n);
        });
        e(Vt, function(e, n) {
            if (e.label) e.label = e.label.transform(n);
        });
        e(wn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.body = e.body.transform(n);
            if (e.alternative) e.alternative = e.alternative.transform(n);
        });
        e(Jt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Qt, function(e, n) {
            e.expression = e.expression.transform(n);
            e.body = t(e.body, n);
        });
        e(Zt, function(e, n) {
            e.body = t(e.body, n);
            if (e.bcatch) e.bcatch = e.bcatch.transform(n);
            if (e.bfinally) e.bfinally = e.bfinally.transform(n);
        });
        e(er, function(e, n) {
            if (e.argname) e.argname = e.argname.transform(n);
            e.body = t(e.body, n);
        });
        e(tr, function(e, n) {
            e.definitions = t(e.definitions, n);
        });
        e(xn, function(e, n) {
            e.name = e.name.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(kn, function(e, n) {
            e.name = e.name.transform(n);
            e.value = e.value.transform(n);
        });
        e(bn, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            e.body = t(e.body, n);
        });
        function n(e, n) {
            e.argnames = t(e.argnames, n);
            if (e.rest) e.rest = e.rest.transform(n);
            if (e.value) {
                e.value = e.value.transform(n);
            } else {
                e.body = t(e.body, n);
            }
        }
        e(St, n);
        e(Tt, n);
        e(Pt, function(e, n) {
            if (e.name) e.name = e.name.transform(n);
            if (e.extends) e.extends = e.extends.transform(n);
            e.properties = t(e.properties, n);
        });
        e(It, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            if (e.value) e.value = e.value.transform(n);
        });
        e(En, function(e, n) {
            e.expression = e.expression.transform(n);
            e.args = t(e.args, n);
        });
        e(Sn, function(e, n) {
            e.expressions = t(e.expressions, n);
        });
        e(vr, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(hr, function(e, n) {
            if (e.expression) e.expression = e.expression.transform(n);
        });
        e(An, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(pr, function(e, n) {
            e.expression = e.expression.transform(n);
            e.property = e.property.transform(n);
        });
        e(Dn, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(On, function(e, n) {
            e.expression = e.expression.transform(n);
        });
        e(zn, function(e, n) {
            e.left = e.left.transform(n);
            e.right = e.right.transform(n);
        });
        e(qn, function(e, n) {
            e.condition = e.condition.transform(n);
            e.consequent = e.consequent.transform(n);
            e.alternative = e.alternative.transform(n);
        });
        e(Mn, function(e, n) {
            e.elements = t(e.elements, n);
        });
        e(mr, function(e, n) {
            e.elements = t(e.elements, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(_r, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(gr, function(e, n) {
            e.properties = t(e.properties, n);
            if (e.rest) e.rest = e.rest.transform(n);
        });
        e(Pn, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(br, function(e, n) {
            if (e.key instanceof vn) e.key = e.key.transform(n);
            e.value = e.value.transform(n);
        });
        e(or, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(sr, function(e, n) {
            e.body = e.body.transform(n);
        });
        e(fr, function(e, n) {
            e.properties = t(e.properties, n);
        });
        e(ur, function(e, n) {
            if (e.all) e.all = e.all.transform(n);
            if (e.default) e.default = e.default.transform(n);
            if (e.properties) e.properties = t(e.properties, n);
        });
        e(Ir, function(e, n) {
            if (e.tag) e.tag = e.tag.transform(n);
            e.expressions = t(e.expressions, n);
        });
    })(function(e, i) {
        e.DEFMETHOD("transform", function(e, n) {
            var t, r;
            e.push(this);
            if (e.before) t = e.before(this, i, n);
            if (typeof t === "undefined") {
                t = this;
                i(t, e);
                if (e.after) {
                    r = e.after(t, n);
                    if (typeof r !== "undefined") t = r;
                }
            }
            e.pop();
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>
    Parser based on parse-js (http://marijn.haverbeke.nl/parse-js/).

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var Ae = "break case catch class const continue debugger default delete do else extends finally for function if in instanceof new return switch throw try typeof var void while with";
    var C = "false null true";
    var N = [ "abstract async await boolean byte char double enum export final float goto implements import int interface let long native package private protected public short static super synchronized this throws transient volatile yield", C, Ae ].join(" ");
    var M = "return new delete throw else case";
    Ae = ln(Ae);
    N = ln(N);
    M = ln(M);
    C = ln(C);
    var c = /^0b([01]+)$/i;
    var l = /^0x([0-9a-f]+)$/i;
    var p = /^0o?([0-7]+)$/i;
    var F = ln([ "in", "instanceof", "typeof", "new", "void", "delete", "++", "--", "+", "-", "!", "~", "&", "|", "^", "*", "/", "%", "**", ">>", "<<", ">>>", "<", ">", "<=", ">=", "==", "===", "!=", "!==", "?", "=", "+=", "-=", "/=", "*=", "%=", "**=", ">>=", "<<=", ">>>=", "&=", "|=", "^=", "&&", "||", "??", "&&=", "||=", "??=" ]);
    var P = "\n\r\u2028\u2029";
    var I = "+-*&%=<>!?|~^";
    var d = "[{(";
    var v = ",;:";
    var h = ")}]";
    var De = v + h;
    var H = d + v;
    var Y = H + "`" + h;
    var R = P + "  \t\f\v​             　\ufeff";
    var B = ln(t("./'\"#" + I + Y + R));
    P = ln(t(P));
    I = ln(t(I));
    De = ln(t(De));
    H = ln(t(H));
    Y = ln(t(Y));
    R = ln(t(R));
    function re(e) {
        return e >= 55296 && e <= 56319;
    }
    function ie(e) {
        return e >= 56320 && e <= 57343;
    }
    function L(e) {
        return e >= 48 && e <= 57;
    }
    function ae(e) {
        return !B[e];
    }
    function Kr(e) {
        return /^[a-z_$][a-z0-9_$]*$/i.test(e);
    }
    function Qr(e) {
        switch (e[0]) {
          case "b":
            return "\b";

          case "f":
            return "\f";

          case "n":
            return "\n";

          case "r":
            return "\r";

          case "t":
            return "\t";

          case "u":
            var n;
            if (e[1] == "{" && e.slice(-1) == "}") {
                n = e.slice(2, -1);
            } else if (e.length == 5) {
                n = e.slice(1);
            } else {
                return;
            }
            var t = parseInt(n, 16);
            if (t < 0 || isNaN(t)) return;
            if (t < 65536) return String.fromCharCode(t);
            if (t > 1114111) return;
            return String.fromCharCode((t >> 10) + 55232) + String.fromCharCode((t & 1023) + 56320);

          case "v":
            return "\v";

          case "x":
            if (e.length != 3) return;
            var t = parseInt(e.slice(1), 16);
            if (t < 0 || isNaN(t)) return;
            return String.fromCharCode(t);

          case "\r":
          case "\n":
            return "";

          default:
            if (e == "0") return "\0";
            if (e[0] >= "0" && e[0] <= "9") return;
            return e;
        }
    }
    function U(e) {
        var n;
        if (n = c.exec(e)) return parseInt(n[1], 2);
        if (n = l.exec(e)) return parseInt(n[1], 16);
        if (n = p.exec(e)) return parseInt(n[1], 8);
        var t = parseFloat(e);
        if (t == e) return t;
    }
    function Zr(e, n, t, r, i) {
        this.message = e;
        this.filename = n;
        this.line = t;
        this.col = r;
        this.pos = i;
    }
    Zr.prototype = Object.create(Error.prototype);
    Zr.prototype.constructor = Zr;
    Zr.prototype.name = "SyntaxError";
    r(Zr);
    function Oe(e, n, t, r, i) {
        throw new Zr(e, n, t, r, i);
    }
    function $e(e, n, t) {
        return e.type == n && (t == null || e.value == t);
    }
    var V = {};
    function ze(i, a, o, s) {
        var f = {
            text: i,
            filename: a,
            pos: 0,
            tokpos: 0,
            line: 1,
            tokline: 0,
            col: 0,
            tokcol: 0,
            newline_before: false,
            regex_allowed: false,
            comments_before: [],
            directives: Object.create(null),
            read_template: n("Unterminated template literal", function(e) {
                var n = "";
                for (;;) {
                    var t = r();
                    switch (t) {
                      case "\\":
                        t += r();
                        break;

                      case "`":
                        e.push(n);
                        return;

                      case "$":
                        if (c() == "{") {
                            l();
                            e.push(n);
                            f.regex_allowed = true;
                            return true;
                        }
                    }
                    n += t;
                }
                function r() {
                    var e = l(true, true);
                    return e == "\r" ? "\n" : e;
                }
            })
        };
        var u = false;
        function c() {
            return f.text.charAt(f.pos);
        }
        function l(e, n) {
            var t = f.text.charAt(f.pos++);
            if (e && !t) throw V;
            if (P[t]) {
                f.col = 0;
                f.line++;
                if (!n) f.newline_before = true;
                if (t == "\r" && c() == "\n") {
                    f.pos++;
                    t = "\n";
                }
            } else {
                f.col++;
            }
            return t;
        }
        function p(e) {
            while (e-- > 0) l();
        }
        function d(e) {
            return f.text.substr(f.pos, e.length) == e;
        }
        function v() {
            var e = f.text;
            for (var n = f.pos; n < f.text.length; ++n) {
                if (P[e[n]]) return n;
            }
            return -1;
        }
        function r(e, n) {
            var t = f.text.indexOf(e, f.pos);
            if (n && t == -1) throw V;
            return t;
        }
        function h() {
            f.tokline = f.line;
            f.tokcol = f.col;
            f.tokpos = f.pos;
        }
        function m(e, n, t) {
            f.regex_allowed = e == "operator" && !ei[n] || e == "keyword" && M[n] || e == "punc" && H[n];
            if (e == "punc" && n == ".") u = true; else if (!t) u = false;
            var r = {
                type: e,
                value: n,
                line: f.tokline,
                col: f.tokcol,
                pos: f.tokpos,
                endline: f.line,
                endcol: f.col,
                endpos: f.pos,
                nlb: f.newline_before,
                file: a
            };
            if (/^(?:num|string|regexp)$/i.test(e)) {
                r.raw = i.substring(r.pos, r.endpos);
            }
            if (!t) {
                r.comments_before = f.comments_before;
                r.comments_after = f.comments_before = [];
            }
            f.newline_before = false;
            return new te(r);
        }
        function _() {
            while (R[c()]) l();
        }
        function g(e) {
            var n = "", t;
            while ((t = c()) && e(t, n)) n += l();
            return n;
        }
        function b(e) {
            Oe(e, a, f.tokline, f.tokcol, f.tokpos);
        }
        function y(e) {
            return /^0[0-7_]+$/.test(e);
        }
        function w(e) {
            var t = false, r = false, i = false, a = e == ".";
            var n = g(function(e, n) {
                switch (e) {
                  case "x":
                  case "X":
                    return i ? false : i = true;

                  case "e":
                  case "E":
                    return i ? true : t ? false : t = r = true;

                  case "+":
                  case "-":
                    return r;

                  case r = false, ".":
                    return a || t || i || y(n) ? false : a = true;
                }
                return /[_0-9a-dfo]/i.test(e);
            });
            if (e) n = e + n;
            if (y(n)) {
                if (q.has_directive("use strict")) b("Legacy octal literals are not allowed in strict mode");
            } else {
                n = n.replace(i ? /([1-9a-f]|.0)_(?=[0-9a-f])/gi : /([1-9]|.0)_(?=[0-9])/gi, "$1");
            }
            var o = U(n);
            if (isNaN(o)) b("Invalid syntax: " + n);
            if (a || t || c() != "n") return m("num", o);
            return m("bigint", n.toLowerCase() + l());
        }
        function x(e) {
            var n = l(true, e);
            if (n >= "0" && n <= "7") return k(n);
            if (n == "u") {
                var t = l(true, e);
                n += t;
                if (t != "{") {
                    n += l(true, e) + l(true, e) + l(true, e);
                } else do {
                    t = l(true, e);
                    n += t;
                } while (t != "}");
            } else if (n == "x") {
                n += l(true, e) + l(true, e);
            }
            var r = Qr(n);
            if (typeof r != "string") b("Invalid escape sequence: \\" + n);
            return r;
        }
        function k(e) {
            var n = c();
            if (n >= "0" && n <= "7") {
                e += l(true);
                if (e[0] <= "3" && (n = c()) >= "0" && n <= "7") e += l(true);
            }
            if (e === "0") return "\0";
            if (e.length > 0 && q.has_directive("use strict")) b("Legacy octal escape sequences are not allowed in strict mode");
            return String.fromCharCode(parseInt(e, 8));
        }
        var E = n("Unterminated string constant", function(e) {
            var n = l(), t = "";
            for (;;) {
                var r = l(true, true);
                if (r == "\\") r = x(true); else if (P[r]) b("Unterminated string constant"); else if (r == n) break;
                t += r;
            }
            var i = m("string", t);
            i.quote = e;
            return i;
        });
        function S(e) {
            var n = f.regex_allowed;
            var t = v(), r;
            if (t == -1) {
                r = f.text.substr(f.pos);
                f.pos = f.text.length;
            } else {
                r = f.text.substring(f.pos, t);
                f.pos = t;
            }
            f.col = f.tokcol + (f.pos - f.tokpos);
            f.comments_before.push(m(e, r, true));
            f.regex_allowed = n;
            return q;
        }
        var e = n("Unterminated multiline comment", function() {
            var e = f.regex_allowed;
            var n = r("*/", true);
            var t = f.text.substring(f.pos, n).replace(/\r\n|\r|\u2028|\u2029/g, "\n");
            p(t.length + 2);
            f.comments_before.push(m("comment2", t, true));
            f.regex_allowed = e;
            return q;
        });
        function T() {
            var e = false, n, t = false, r = c() == "#" ? l() : "";
            while (n = c()) {
                if (!e) {
                    if (n == "\\") t = e = true, l(); else if (ae(n)) r += l(); else break;
                } else {
                    if (n != "u") b("Expecting UnicodeEscapeSequence -- uXXXX");
                    n = x();
                    if (!ae(n)) b("Unicode char: " + n.charCodeAt(0) + " is not valid in identifier");
                    r += n;
                    e = false;
                }
            }
            if (Ae[r] && t) {
                var i = r.charCodeAt(0).toString(16).toUpperCase();
                r = "\\u" + "0000".substr(i.length) + i + r.slice(1);
            }
            return r;
        }
        var A = n("Unterminated regular expression", function(e) {
            var n = false, t, r = false;
            while (t = l(true)) if (P[t]) {
                b("Unexpected line terminator");
            } else if (n) {
                e += "\\" + t;
                n = false;
            } else if (t == "[") {
                r = true;
                e += t;
            } else if (t == "]" && r) {
                r = false;
                e += t;
            } else if (t == "/" && !r) {
                break;
            } else if (t == "\\") {
                n = true;
            } else {
                e += t;
            }
            var i = T();
            try {
                var a = new RegExp(e, i);
                a.raw_source = e;
                return m("regexp", a);
            } catch (e) {
                b(e.message);
            }
        });
        function D(e) {
            function t(e) {
                if (!c()) return e;
                var n = e + c();
                if (F[n]) {
                    l();
                    return t(n);
                } else {
                    return e;
                }
            }
            return m("operator", t(e || l()));
        }
        function O() {
            l();
            switch (c()) {
              case "/":
                l();
                return S("comment1");

              case "*":
                l();
                return e();
            }
            return f.regex_allowed ? A("") : D("/");
        }
        function $() {
            l();
            var e = c();
            if (e == ".") {
                var n = ".";
                do {
                    n += ".";
                    l();
                } while (c() == ".");
                return m("operator", n);
            }
            return L(e.charCodeAt(0)) ? w(".") : m("punc", ".");
        }
        function z() {
            var e = T();
            if (u) return m("name", e);
            return C[e] ? m("atom", e) : !Ae[e] ? m("name", e) : F[e] ? m("operator", e) : m("keyword", e);
        }
        function n(n, t) {
            return function(e) {
                try {
                    return t(e);
                } catch (e) {
                    if (e === V) b(n); else throw e;
                }
            };
        }
        function q(e) {
            if (e != null) return A(e);
            if (s && f.pos == 0 && d("#!")) {
                h();
                p(2);
                S("comment5");
            }
            for (;;) {
                _();
                h();
                if (o) {
                    if (d("\x3c!--")) {
                        p(4);
                        S("comment3");
                        continue;
                    }
                    if (d("--\x3e") && f.newline_before) {
                        p(3);
                        S("comment4");
                        continue;
                    }
                }
                var n = c();
                if (!n) return m("eof");
                var t = n.charCodeAt(0);
                switch (t) {
                  case 34:
                  case 39:
                    return E(n);

                  case 46:
                    return $();

                  case 47:
                    var r = O();
                    if (r === q) continue;
                    return r;
                }
                if (L(t)) return w();
                if (Y[n]) return m("punc", l());
                if (d("=>")) return m("punc", l() + l());
                if (I[n]) return D();
                if (t == 35 || t == 92 || !B[n]) return z();
                break;
            }
            b("Unexpected character '" + n + "'");
        }
        q.context = function(e) {
            if (e) f = e;
            return f;
        };
        q.add_directive = function(e) {
            f.directives[e] = true;
        };
        q.push_directives_stack = function() {
            f.directives = Object.create(f.directives);
        };
        q.pop_directives_stack = function() {
            f.directives = Object.getPrototypeOf(f.directives);
        };
        q.has_directive = function(e) {
            return !!f.directives[e];
        };
        return q;
    }
    var qe = ln("typeof void delete -- ++ ! ~ - +");
    var ei = ln("-- ++");
    var Ce = ln("= += -= /= *= %= **= >>= <<= >>>= &= |= ^= &&= ||= ??=");
    var ni = function(e, n) {
        for (var t = 0; t < e.length; ) {
            var r = e[t++];
            for (var i = 0; i < r.length; i++) {
                n[r[i]] = t;
            }
        }
        return n;
    }([ [ "??" ], [ "||" ], [ "&&" ], [ "|" ], [ "^" ], [ "&" ], [ "==", "===", "!=", "!==" ], [ "<", ">", "<=", ">=", "in", "instanceof" ], [ ">>", "<<", ">>>" ], [ "+", "-" ], [ "*", "/", "%" ], [ "**" ] ], {});
    var Me = ln("atom bigint num regexp string");
    function ti(t, l) {
        l = be(l, {
            bare_returns: false,
            expression: false,
            filename: null,
            html5_comments: true,
            module: false,
            shebang: true,
            strict: false,
            toplevel: null
        }, true);
        var _ = {
            input: typeof t == "string" ? ze(t, l.filename, l.html5_comments, l.shebang) : t,
            in_async: false,
            in_directives: true,
            in_funarg: -1,
            in_function: 0,
            in_generator: false,
            in_loop: 0,
            labels: [],
            peeked: null,
            prev: null,
            token: null
        };
        _.token = b();
        function g(e, n) {
            return $e(_.token, e, n);
        }
        function p() {
            return _.peeked || (_.peeked = _.input());
        }
        function b() {
            _.prev = _.token;
            if (_.peeked) {
                _.token = _.peeked;
                _.peeked = null;
            } else {
                _.token = _.input();
            }
            _.in_directives = _.in_directives && (_.token.type == "string" || g("punc", ";"));
            return _.token;
        }
        function y() {
            return _.prev;
        }
        function s(e, n, t, r) {
            var i = _.input.context();
            Oe(e, i.filename, n != null ? n : i.tokline, t != null ? t : i.tokcol, r != null ? r : i.tokpos);
        }
        function f(e, n) {
            s(n, e.line, e.col);
        }
        function r(e, n) {
            return e + (n === undefined ? "" : " «" + n + "»");
        }
        function w(e) {
            if (e == null) e = _.token;
            f(e, "Unexpected token: " + r(e.type, e.value));
        }
        function u(e, n) {
            if (g(e, n)) return b();
            f(_.token, "Unexpected token: " + r(_.token.type, _.token.value) + ", expected: " + r(e, n));
        }
        function x(e) {
            return u("punc", e);
        }
        function o(e) {
            return e.nlb || !pn(e.comments_before, function(e) {
                return !e.nlb;
            });
        }
        function c() {
            return !l.strict && (g("eof") || g("punc", "}") || o(_.token));
        }
        function k(e) {
            if (g("punc", ";")) b(); else if (!e && !c()) x(";");
        }
        function d() {
            x("(");
            var e = N();
            x(")");
            return e;
        }
        function e(r) {
            return function() {
                var e = _.token;
                var n = r.apply(null, arguments);
                var t = y();
                n.start = e;
                n.end = t;
                return n;
            };
        }
        function E() {
            if (g("operator", "/") || g("operator", "/=")) {
                _.peeked = null;
                _.token = _.input(_.token.value.substr(1));
            }
        }
        var v = e(function() {
            E();
            switch (_.token.type) {
              case "string":
                var e = _.in_directives;
                var n = N();
                if (e) {
                    if (n instanceof Hn) {
                        var t = n.start.raw.slice(1, -1);
                        _.input.add_directive(t);
                        n.value = t;
                    } else {
                        _.in_directives = e = false;
                    }
                }
                k();
                return e ? new tt(n) : new mn({
                    body: n
                });

              case "num":
              case "bigint":
              case "regexp":
              case "operator":
              case "atom":
                return h();

              case "name":
                switch (_.token.value) {
                  case "async":
                    if ($e(p(), "keyword", "function")) {
                        b();
                        b();
                        if (!g("operator", "*")) return A(qt);
                        b();
                        return A(Ct);
                    }
                    break;

                  case "await":
                    if (_.in_async) return h();
                    break;

                  case "export":
                    b();
                    return U();

                  case "import":
                    var r = p();
                    if (!(r.type == "punc" && /^[(.]$/.test(r.value))) {
                        b();
                        return G();
                    }
                    break;

                  case "let":
                    if (Q()) {
                        b();
                        var i = ee();
                        k();
                        return i;
                    }
                    break;

                  case "yield":
                    if (_.in_generator) return h();
                    break;
                }
                return $e(p(), "punc", ":") ? H() : h();

              case "punc":
                switch (_.token.value) {
                  case "{":
                    return new _n({
                        start: _.token,
                        body: O(),
                        end: y()
                    });

                  case "[":
                  case "(":
                  case "`":
                    return h();

                  case ";":
                    _.in_directives = false;
                    b();
                    return new hn();

                  default:
                    w();
                }

              case "keyword":
                switch (_.token.value) {
                  case "break":
                    b();
                    return Y(Wt);

                  case "class":
                    b();
                    return m(jt);

                  case "const":
                    b();
                    var i = Z();
                    k();
                    return i;

                  case "continue":
                    b();
                    return Y(Gt);

                  case "debugger":
                    b();
                    k();
                    return new nt();

                  case "do":
                    b();
                    var n = I(v);
                    u("keyword", "while");
                    var a = d();
                    k(true);
                    return new ct({
                        body: n,
                        condition: a
                    });

                  case "while":
                    b();
                    return new lt({
                        condition: d(),
                        body: I(v)
                    });

                  case "for":
                    b();
                    return B();

                  case "function":
                    b();
                    if (!g("operator", "*")) return A(Mt);
                    b();
                    return A(Ft);

                  case "if":
                    b();
                    return L();

                  case "return":
                    if (_.in_function == 0 && !l.bare_returns) s("'return' outside of function");
                    b();
                    var t = null;
                    if (g("punc", ";")) {
                        b();
                    } else if (!c()) {
                        t = N();
                        k();
                    }
                    return new yn({
                        value: t
                    });

                  case "switch":
                    b();
                    return new Jt({
                        expression: d(),
                        body: I(J)
                    });

                  case "throw":
                    b();
                    if (o(_.token)) s("Illegal newline after 'throw'");
                    var t = N();
                    k();
                    return new Ut({
                        value: t
                    });

                  case "try":
                    b();
                    return X();

                  case "var":
                    b();
                    var i = ne();
                    k();
                    return i;

                  case "with":
                    if (_.input.has_directive("use strict")) {
                        s("Strict mode may not include a with statement");
                    }
                    b();
                    return new mt({
                        expression: d(),
                        body: v()
                    });
                }
            }
            w();
        });
        function H() {
            var n = q(Se);
            if (!pn(_.labels, function(e) {
                return e.name != n.name;
            })) {
                s("Label " + n.name + " defined twice");
            }
            x(":");
            _.labels.push(n);
            var e = v();
            _.labels.pop();
            if (!(e instanceof ft)) {
                n.references.forEach(function(e) {
                    if (e instanceof Gt) {
                        f(e.label.start, "Continue label `" + n.name + "` must refer to IterationStatement");
                    }
                });
            }
            return new st({
                body: e,
                label: n
            });
        }
        function h() {
            var e = N();
            k();
            return new mn({
                body: e
            });
        }
        function Y(e) {
            var n = null, t;
            if (!c()) {
                n = q(Te, true);
            }
            if (n != null) {
                t = Ln(function(e) {
                    return e.name == n.name;
                }, _.labels);
                if (!t) f(n.start, "Undefined label " + n.name);
                n.thedef = t;
            } else if (_.in_loop == 0) s(e.TYPE + " not inside a loop or switch");
            k();
            var r = new e({
                label: n
            });
            if (t) t.references.push(r);
            return r;
        }
        function R(e) {
            if (!g("name", e)) return;
            var n = p();
            if (!n) return;
            if ($e(n, "operator", "=")) return;
            if (n.type == "punc" && /^[(;}]$/.test(n.value)) return;
            if (o(n)) return;
            return b();
        }
        function m(e) {
            var n = _.in_async;
            var t = _.in_generator;
            _.input.push_directives_stack();
            _.input.add_directive("use strict");
            var r;
            if (e === jt) {
                r = q(Ee);
            } else {
                r = q(qr, true);
            }
            var i = null;
            if (g("keyword", "extends")) {
                b();
                E();
                i = ie(true);
            }
            x("{");
            var a = [];
            while (!g("punc", "}")) {
                if (g("punc", ";")) {
                    b();
                    continue;
                }
                var o = _.token;
                var s = !!R("static");
                var f = R("async");
                if (g("operator", "*")) {
                    b();
                    var u = g("name") && /^#/.test(_.token.value);
                    var c = z();
                    var l = _.token;
                    var p = A(f ? Dt : $t);
                    p.start = l;
                    p.end = y();
                    a.push(new Yt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: p,
                        end: y()
                    }));
                    continue;
                }
                if (s && g("punc", "{")) {
                    a.push(new Rt({
                        start: o,
                        value: new gt({
                            start: o,
                            body: O(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                var u = g("name") && /^#/.test(_.token.value);
                var c = z();
                if (g("punc", "(")) {
                    var d = _.token;
                    var v = A(f ? At : Ot);
                    v.start = d;
                    v.end = y();
                    a.push(new Yt({
                        start: o,
                        static: s,
                        private: u,
                        key: c,
                        value: v,
                        end: y()
                    }));
                    continue;
                }
                if (f) w(f);
                var h = null;
                if (g("operator", "=")) {
                    b();
                    _.in_async = false;
                    _.in_generator = false;
                    h = j();
                    _.in_generator = t;
                    _.in_async = n;
                } else if (!(g("punc", ";") || g("punc", "}"))) {
                    var m = null;
                    switch (c) {
                      case "get":
                        m = we;
                        break;

                      case "set":
                        m = xe;
                        break;
                    }
                    if (m) {
                        a.push(new m({
                            start: o,
                            static: s,
                            private: g("name") && /^#/.test(_.token.value),
                            key: z(),
                            value: oe(),
                            end: y()
                        }));
                        continue;
                    }
                }
                k();
                a.push(new Ht({
                    start: o,
                    static: s,
                    private: u,
                    key: c,
                    value: h,
                    end: y()
                }));
            }
            b();
            _.input.pop_directives_stack();
            _.in_generator = t;
            _.in_async = n;
            return new e({
                extends: i,
                name: r,
                properties: a
            });
        }
        function B() {
            var e = g("name", "await") && b();
            x("(");
            var n = null;
            if (e || !g("punc", ";")) {
                n = g("keyword", "const") ? (b(), Z(true)) : g("name", "let") && Q() ? (b(), 
                ee(true)) : g("keyword", "var") ? (b(), ne(true)) : N(true);
                var t;
                if (e) {
                    u("name", "of");
                    t = ht;
                } else if (g("operator", "in")) {
                    b();
                    t = vt;
                } else if (g("name", "of")) {
                    b();
                    t = ye;
                }
                if (t) {
                    if (n instanceof tr) {
                        if (n.definitions.length > 1) {
                            f(n.start, "Only one variable declaration allowed in for..in/of loop");
                        }
                        if (t !== vt && n.definitions[0].value) {
                            f(n.definitions[0].value.start, "No initializers allowed in for..of loop");
                        }
                    } else if (!(F(n) || (n = P(n)) instanceof Fn)) {
                        f(n.start, "Invalid left-hand side in for..in/of loop");
                    }
                    return a(t, n);
                }
            }
            return i(n);
        }
        function i(e) {
            x(";");
            var n = g("punc", ";") ? null : N();
            x(";");
            var t = g("punc", ")") ? null : N();
            x(")");
            return new pt({
                init: e,
                condition: n,
                step: t,
                body: I(v)
            });
        }
        function a(e, n) {
            E();
            var t = N();
            x(")");
            return new e({
                init: n,
                object: t,
                body: I(v)
            });
        }
        function S(e) {
            if (e instanceof Mn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Dn) {
                    n = S(e.elements.pop().expression);
                }
                return new mr({
                    start: e.start,
                    elements: e.elements.map(S),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof Cn) return new kn({
                start: e.start,
                name: S(e.left),
                value: e.right,
                end: e.end
            });
            if (e instanceof kn) {
                e.name = S(e.name);
                return e;
            }
            if (e instanceof mr) {
                e.elements = e.elements.map(S);
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof gr) {
                e.properties.forEach(function(e) {
                    e.value = S(e.value);
                });
                if (e.rest) e.rest = S(e.rest);
                return e;
            }
            if (e instanceof Ur) return e;
            if (e instanceof Pn) {
                var n = null;
                if (e.properties[e.properties.length - 1] instanceof Dn) {
                    n = S(e.properties.pop().expression);
                }
                return new gr({
                    start: e.start,
                    properties: e.properties.map(function(e) {
                        if (!(e instanceof yr)) f(e.start, "Invalid destructuring assignment");
                        return new _r({
                            start: e.start,
                            key: e.key,
                            value: S(e.value),
                            end: e.end
                        });
                    }),
                    rest: n,
                    end: e.end
                });
            }
            if (e instanceof jn) return e;
            if (e instanceof Nn) return new jn(e);
            if (e instanceof hr) return new jn({
                start: e.start,
                name: "yield",
                end: e.end
            });
            f(e.start, "Invalid arrow parameter");
        }
        function T(e, n, t) {
            var r = _.in_async;
            var i = _.in_generator;
            _.in_async = t;
            _.in_generator = false;
            var a = _.in_funarg;
            _.in_funarg = _.in_function;
            var o = e.map(S);
            var s = e.rest || null;
            if (s) s = S(s);
            _.in_funarg = a;
            x("=>");
            var f, u;
            var c = _.in_loop;
            var l = _.labels;
            ++_.in_function;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            if (g("punc", "{")) {
                _.in_directives = true;
                f = O();
                u = null;
            } else {
                f = [];
                E();
                u = j();
            }
            var p = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = c;
            _.labels = l;
            _.in_generator = i;
            _.in_async = r;
            var d = new (t ? Tt : St)({
                start: n,
                argnames: o,
                rest: s,
                body: f,
                value: u,
                end: y()
            });
            if (p) d.each_argname(ce);
            return d;
        }
        var A = function(e) {
            var n = _.in_async;
            var t = _.in_generator;
            var r;
            if (/Defun$/.test(e.TYPE)) {
                r = q($r);
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
            } else {
                _.in_async = /^Async/.test(e.TYPE);
                _.in_generator = /Generator/.test(e.TYPE);
                r = q(zr, true);
            }
            if (r && e !== bt && !(r instanceof Sr)) w(y());
            x("(");
            var i = _.in_funarg;
            _.in_funarg = _.in_function;
            var a = $(")", !l.strict, false, function() {
                return le(jn);
            });
            _.in_funarg = i;
            var o = _.in_loop;
            var s = _.labels;
            ++_.in_function;
            _.in_directives = true;
            _.input.push_directives_stack();
            _.in_loop = 0;
            _.labels = [];
            var f = O();
            var u = _.input.has_directive("use strict");
            _.input.pop_directives_stack();
            --_.in_function;
            _.in_loop = o;
            _.labels = s;
            _.in_generator = t;
            _.in_async = n;
            var c = new e({
                name: r,
                argnames: a,
                rest: a.rest || null,
                body: f
            });
            if (u) {
                if (r) ce(r);
                c.each_argname(ce);
            }
            return c;
        };
        function L() {
            var e = d(), n = v(), t = null;
            if (g("keyword", "else")) {
                b();
                t = v();
            }
            return new wn({
                condition: e,
                body: n,
                alternative: t
            });
        }
        function D() {
            return g("name") || Kr(_.token.value);
        }
        function U() {
            if (g("operator", "*")) {
                b();
                var e = "*";
                if (g("name", "as")) {
                    b();
                    if (!D()) u("name");
                    e = _.token.value;
                    b();
                }
                u("name", "from");
                var n = _.token;
                u("string");
                k();
                return new ke({
                    aliases: [ e ],
                    keys: [ "*" ],
                    path: n.value,
                    quote: n.quote
                });
            }
            if (g("punc", "{")) {
                b();
                var r = [];
                var t = [];
                while (D()) {
                    var i = _.token;
                    b();
                    t.push(i);
                    if (g("name", "as")) {
                        b();
                        if (!D()) u("name");
                        r.push(_.token.value);
                        b();
                    } else {
                        r.push(i.value);
                    }
                    if (!g("punc", "}")) x(",");
                }
                x("}");
                if (g("name", "from")) {
                    b();
                    var n = _.token;
                    u("string");
                    k();
                    return new ke({
                        aliases: r,
                        keys: t.map(function(e) {
                            return e.value;
                        }),
                        path: n.value,
                        quote: n.quote
                    });
                }
                k();
                return new fr({
                    properties: t.map(function(e, n) {
                        if (!$e(e, "name")) f(e, "Name expected");
                        var t = ue(Mr, e);
                        t.alias = r[n];
                        return t;
                    })
                });
            }
            if (g("keyword", "default")) {
                b();
                var a = _.token;
                var o = V();
                if (o) {
                    o.start = a;
                    o.end = y();
                } else {
                    E();
                    o = N();
                    k();
                }
                return new sr({
                    body: o
                });
            }
            return new or({
                body: W()
            });
        }
        function n(e, n) {
            if (n.name) {
                n = new e(n);
                n.name = new (e === jt ? Ee : $r)(n.name);
            }
            return n;
        }
        function V() {
            if (g("name", "async")) {
                if (!$e(p(), "keyword", "function")) return;
                b();
                b();
                if (!g("operator", "*")) return n(qt, A(At));
                b();
                return n(Ct, A(Dt));
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return n(jt, m(Nt));

              case "function":
                b();
                if (!g("operator", "*")) return n(Mt, A(Ot));
                b();
                return n(Ft, A($t));
            }
        }
        var W = e(function() {
            if (g("name")) switch (_.token.value) {
              case "async":
                b();
                u("keyword", "function");
                if (!g("operator", "*")) return A(qt);
                b();
                return A(Ct);

              case "let":
                b();
                var e = ee();
                k();
                return e;
            } else if (g("keyword")) switch (_.token.value) {
              case "class":
                b();
                return m(jt);

              case "const":
                b();
                var e = Z();
                k();
                return e;

              case "function":
                b();
                if (!g("operator", "*")) return A(Mt);
                b();
                return A(Ft);

              case "var":
                b();
                var e = ne();
                k();
                return e;
            }
            w();
        });
        function G() {
            var e = null;
            var n = q(Ar, true);
            var t = null;
            if (n ? (n.key = "", g("punc", ",") && b()) : !g("string")) {
                if (g("operator", "*")) {
                    b();
                    u("name", "as");
                    e = q(Ar);
                    e.key = "*";
                } else {
                    x("{");
                    t = [];
                    while (D()) {
                        var r;
                        if ($e(p(), "name", "as")) {
                            var i = _.token.value;
                            b();
                            b();
                            r = q(Ar);
                            r.key = i;
                        } else {
                            r = q(Ar);
                            r.key = r.name;
                        }
                        t.push(r);
                        if (!g("punc", "}")) x(",");
                    }
                    x("}");
                }
            }
            if (e || n || t) u("name", "from");
            var a = _.token;
            u("string");
            k();
            return new ur({
                all: e,
                default: n,
                path: a.value,
                properties: t,
                quote: a.quote
            });
        }
        function O() {
            x("{");
            var e = [];
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                e.push(v());
            }
            b();
            return e;
        }
        function J() {
            x("{");
            var e = [], n, t, r, i;
            while (!g("punc", "}")) {
                if (g("eof")) x("}");
                if (g("keyword", "case")) {
                    if (n) n.end = y();
                    t = [];
                    n = new Qt({
                        start: (i = _.token, b(), i),
                        expression: N(),
                        body: t
                    });
                    e.push(n);
                    x(":");
                } else if (g("keyword", "default")) {
                    if (n) n.end = y();
                    if (r) s("More than one default clause in switch statement");
                    t = [];
                    n = new Kt({
                        start: (i = _.token, b(), x(":"), i),
                        body: t
                    });
                    e.push(n);
                    r = n;
                } else {
                    if (!t) w();
                    t.push(v());
                }
            }
            if (n) n.end = y();
            b();
            return e;
        }
        function X() {
            var e = O(), n = null, t = null;
            if (g("keyword", "catch")) {
                var r = _.token;
                b();
                var i = null;
                if (g("punc", "(")) {
                    b();
                    i = C(Cr);
                    x(")");
                }
                n = new er({
                    start: r,
                    argname: i,
                    body: O(),
                    end: y()
                });
            }
            if (g("keyword", "finally")) {
                var r = _.token;
                b();
                t = new nr({
                    start: r,
                    body: O(),
                    end: y()
                });
            }
            if (!n && !t) s("Missing catch/finally blocks");
            return new Zt({
                body: e,
                bcatch: n,
                bfinally: t
            });
        }
        function K(e, n) {
            var t = [];
            for (;;) {
                var r = _.token;
                var i = C(e);
                var a = null;
                if (g("operator", "=")) {
                    b();
                    a = j(n);
                } else if (!n && (e === Tr || i instanceof Fn)) {
                    s("Missing initializer in declaration");
                }
                t.push(new xn({
                    start: r,
                    name: i,
                    value: a,
                    end: y()
                }));
                if (!g("punc", ",")) break;
                b();
            }
            return t;
        }
        function Q() {
            var e = p();
            return $e(e, "name") || $e(e, "punc", "[") || $e(e, "punc", "{");
        }
        var Z = function(e) {
            return new rr({
                start: y(),
                definitions: K(Tr, e),
                end: y()
            });
        };
        var ee = function(e) {
            return new ir({
                start: y(),
                definitions: K(Dr, e),
                end: y()
            });
        };
        var ne = function(e) {
            return new ar({
                start: y(),
                definitions: K(Or, e),
                end: y()
            });
        };
        var te = function(e) {
            var n = _.token;
            u("operator", "new");
            var t;
            if (g("punc", ".") && $e(p(), "name", "target")) {
                b();
                b();
                t = new Nr();
            } else {
                var r = ie(false), i;
                if (g("punc", "(")) {
                    b();
                    i = $(")", !l.strict);
                } else {
                    i = [];
                }
                t = new cr({
                    expression: r,
                    args: i
                });
            }
            t.start = n;
            t.end = y();
            return M(t, e);
        };
        function re() {
            var e, n = _.token, t = n.value;
            switch (n.type) {
              case "num":
                if (isFinite(t)) {
                    e = new Yn({
                        value: t
                    });
                } else {
                    e = new Vr();
                    if (t < 0) e = new $n({
                        operator: "-",
                        expression: e
                    });
                }
                break;

              case "bigint":
                e = new Hr({
                    value: t
                });
                break;

              case "string":
                e = new Hn({
                    value: t,
                    quote: n.quote
                });
                break;

              case "regexp":
                e = new Yr({
                    value: t
                });
                break;

              case "atom":
                switch (t) {
                  case "false":
                    e = new Gr();
                    break;

                  case "true":
                    e = new Jr();
                    break;

                  case "null":
                    e = new Rr();
                    break;

                  default:
                    w();
                }
                break;

              default:
                w();
            }
            b();
            e.start = e.end = n;
            return e;
        }
        var ie = function(e) {
            if (g("operator", "new")) {
                return te(e);
            }
            var n = _.token;
            if (g("punc")) {
                switch (n.value) {
                  case "`":
                    return M(pe(null), e);

                  case "(":
                    b();
                    if (g("punc", ")")) {
                        b();
                        return T([], n);
                    }
                    var t = N(false, true);
                    var r = n.comments_before.length;
                    [].unshift.apply(t.start.comments_before, n.comments_before);
                    n.comments_before.length = 0;
                    n.comments_before = t.start.comments_before;
                    n.comments_before_length = r;
                    if (r == 0 && n.comments_before.length > 0) {
                        var i = n.comments_before[0];
                        if (!i.nlb) {
                            i.nlb = n.nlb;
                            n.nlb = false;
                        }
                    }
                    n.comments_after = t.start.comments_after;
                    t.start = n;
                    x(")");
                    var a = y();
                    a.comments_before = t.end.comments_before;
                    a.comments_after.forEach(function(e) {
                        t.end.comments_after.push(e);
                        if (e.nlb) _.token.nlb = true;
                    });
                    a.comments_after.length = 0;
                    a.comments_after = t.end.comments_after;
                    t.end = a;
                    if (g("punc", "=>")) return T(t instanceof Sn ? t.expressions : [ t ], n);
                    return M(t, e);

                  case "[":
                    return M(ae(), e);

                  case "{":
                    return M(se(), e);
                }
                w();
            }
            if (g("keyword")) switch (n.value) {
              case "class":
                b();
                var o = m(Nt);
                o.start = n;
                o.end = y();
                return M(o, e);

              case "function":
                b();
                var s;
                if (g("operator", "*")) {
                    b();
                    s = A($t);
                } else {
                    s = A(Ot);
                }
                s.start = n;
                s.end = y();
                return M(s, e);
            }
            if (g("name")) {
                var f = ue(Nn, n);
                b();
                if (f.name == "async") {
                    if (g("keyword", "function")) {
                        b();
                        var s;
                        if (g("operator", "*")) {
                            b();
                            s = A(Dt);
                        } else {
                            s = A(At);
                        }
                        s.start = n;
                        s.end = y();
                        return M(s, e);
                    }
                    if (g("name") && $e(p(), "punc", "=>")) {
                        n = _.token;
                        f = ue(Nn, n);
                        b();
                        return T([ f ], n, true);
                    }
                    if (g("punc", "(")) {
                        var u = M(f, e);
                        if (!g("punc", "=>")) return u;
                        var c = u.args;
                        if (c[c.length - 1] instanceof Dn) {
                            c.rest = c.pop().expression;
                        }
                        return T(c, n, true);
                    }
                }
                return g("punc", "=>") ? T([ f ], n) : M(f, e);
            }
            if (Me[_.token.type]) {
                return M(re(), e);
            }
            w();
        };
        function $(e, n, t, r) {
            if (!r) r = j;
            var i = true, a = [];
            while (!g("punc", e)) {
                if (i) i = false; else x(",");
                if (n && g("punc", e)) break;
                if (t && g("punc", ",")) {
                    a.push(new Ur({
                        start: _.token,
                        end: _.token
                    }));
                } else if (!g("operator", "...")) {
                    a.push(r());
                } else if (r === j) {
                    a.push(new Dn({
                        start: _.token,
                        expression: (b(), r()),
                        end: y()
                    }));
                } else {
                    b();
                    a.rest = r();
                    if (a.rest instanceof kn) f(a.rest.start, "Invalid rest parameter");
                    break;
                }
            }
            x(e);
            return a;
        }
        var ae = e(function() {
            x("[");
            return new Mn({
                elements: $("]", !l.strict, true)
            });
        });
        var oe = e(function() {
            return A(bt);
        });
        var se = e(function() {
            x("{");
            var e = true, n = [];
            while (!g("punc", "}")) {
                if (e) e = false; else x(",");
                if (!l.strict && g("punc", "}")) break;
                var t = _.token;
                if (g("operator", "*")) {
                    b();
                    var r = z();
                    var i = _.token;
                    var a = A($t);
                    a.start = i;
                    a.end = y();
                    n.push(new wr({
                        start: t,
                        key: r,
                        value: a,
                        end: y()
                    }));
                    continue;
                }
                if (g("operator", "...")) {
                    b();
                    n.push(new Dn({
                        start: t,
                        expression: j(),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "operator", "=")) {
                    var o = q(Nn);
                    b();
                    n.push(new yr({
                        start: t,
                        key: t.value,
                        value: new Cn({
                            start: t,
                            left: o,
                            operator: "=",
                            right: j(),
                            end: y()
                        }),
                        end: y()
                    }));
                    continue;
                }
                if ($e(p(), "punc", ",") || $e(p(), "punc", "}")) {
                    n.push(new yr({
                        start: t,
                        key: t.value,
                        value: q(Nn),
                        end: y()
                    }));
                    continue;
                }
                var r = z();
                if (g("punc", "(")) {
                    var s = _.token;
                    var f = A(Ot);
                    f.start = s;
                    f.end = y();
                    n.push(new wr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;
                }
                if (g("punc", ":")) {
                    b();
                    n.push(new yr({
                        start: t,
                        key: r,
                        value: j(),
                        end: y()
                    }));
                    continue;
                }
                if (t.type == "name") switch (r) {
                  case "async":
                    var u = g("operator", "*") && b();
                    r = z();
                    var s = _.token;
                    var f = A(u ? Dt : At);
                    f.start = s;
                    f.end = y();
                    n.push(new wr({
                        start: t,
                        key: r,
                        value: f,
                        end: y()
                    }));
                    continue;

                  case "get":
                    n.push(new kr({
                        start: t,
                        key: z(),
                        value: oe(),
                        end: y()
                    }));
                    continue;

                  case "set":
                    n.push(new xr({
                        start: t,
                        key: z(),
                        value: oe(),
                        end: y()
                    }));
                    continue;
                }
                w();
            }
            b();
            return new Pn({
                properties: n
            });
        });
        function z() {
            var e = _.token;
            switch (e.type) {
              case "operator":
                if (!Ae[e.value]) w();

              case "num":
              case "string":
              case "name":
              case "keyword":
              case "atom":
                b();
                return "" + e.value;

              case "punc":
                x("[");
                var n = j();
                x("]");
                return n;

              default:
                w();
            }
        }
        function fe() {
            var e = _.token.value;
            u("name");
            return e;
        }
        function ue(e, n) {
            var t = n.value;
            switch (t) {
              case "await":
                if (_.in_async) w(n);
                break;

              case "super":
                e = Pr;
                break;

              case "this":
                e = jr;
                break;

              case "yield":
                if (_.in_generator) w(n);
                break;
            }
            return new e({
                name: "" + t,
                start: n,
                end: n
            });
        }
        function ce(e) {
            if (e.name == "arguments" || e.name == "eval" || e.name == "let") f(e.start, "Unexpected " + e.name + " in strict mode");
        }
        function q(e, n) {
            if (!g("name")) {
                if (!n) s("Name expected");
                return null;
            }
            var t = ue(e, _.token);
            if (_.input.has_directive("use strict") && t instanceof Sr) {
                ce(t);
            }
            b();
            return t;
        }
        function C(e) {
            var n = _.token;
            if (g("punc", "[")) {
                b();
                var t = $("]", !l.strict, true, function() {
                    return le(e);
                });
                return new mr({
                    start: n,
                    elements: t,
                    rest: t.rest || null,
                    end: y()
                });
            }
            if (g("punc", "{")) {
                b();
                var r = true, i = [], a = null;
                while (!g("punc", "}")) {
                    if (r) r = false; else x(",");
                    if (!l.strict && g("punc", "}")) break;
                    var o = _.token;
                    if (g("punc", "[") || $e(p(), "punc", ":")) {
                        var s = z();
                        x(":");
                        i.push(new _r({
                            start: o,
                            key: s,
                            value: le(e),
                            end: y()
                        }));
                        continue;
                    }
                    if (g("operator", "...")) {
                        b();
                        a = C(e);
                        break;
                    }
                    var f = q(e);
                    if (g("operator", "=")) {
                        b();
                        f = new kn({
                            start: f.start,
                            name: f,
                            value: j(),
                            end: y()
                        });
                    }
                    i.push(new _r({
                        start: o,
                        key: o.value,
                        value: f,
                        end: y()
                    }));
                }
                x("}");
                return new gr({
                    start: n,
                    properties: i,
                    rest: a,
                    end: y()
                });
            }
            return q(e);
        }
        function le(e) {
            var n = _.token;
            var t = C(e);
            if (!g("operator", "=")) return t;
            b();
            return new kn({
                start: n,
                name: t,
                value: j(),
                end: y()
            });
        }
        function pe(e) {
            var n = e ? e.start : _.token;
            var t = _.input.context().read_template;
            var r = [];
            var i = [];
            while (t(r)) {
                b();
                i.push(N());
                if (!g("punc", "}")) w();
            }
            b();
            return new Ir({
                start: n,
                expressions: i,
                strings: r,
                tag: e,
                end: y()
            });
        }
        function M(e, n) {
            var t = e.start;
            var r = null;
            while (true) {
                if (g("operator", "?") && $e(p(), "punc", ".")) {
                    b();
                    b();
                    r = e;
                }
                if (g("punc", "[")) {
                    b();
                    var i = N();
                    x("]");
                    e = new pr({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: i,
                        end: y()
                    });
                } else if (n && g("punc", "(")) {
                    b();
                    e = new En({
                        start: t,
                        optional: r === e,
                        expression: e,
                        args: $(")", !l.strict),
                        end: y()
                    });
                } else if (r === e || g("punc", ".")) {
                    if (r !== e) b();
                    e = new An({
                        start: t,
                        optional: r === e,
                        expression: e,
                        property: fe(),
                        end: y()
                    });
                } else if (g("punc", "`")) {
                    if (r) s("Invalid template on optional chain");
                    e = pe(e);
                } else {
                    break;
                }
            }
            if (r) e.terminal = true;
            if (e instanceof En && !e.pure) {
                var t = e.start;
                var a = t.comments_before;
                var o = Qn(t, "comments_before_length") ? t.comments_before_length : a.length;
                while (--o >= 0) {
                    if (/[@#]__PURE__/.test(a[o].value)) {
                        e.pure = true;
                        break;
                    }
                }
            }
            return e;
        }
        function de(e) {
            var n = _.token;
            if (_.in_async && g("name", "await")) {
                if (_.in_funarg === _.in_function) s("Invalid use of await in function argument");
                _.input.context().regex_allowed = true;
                b();
                return new vr({
                    start: n,
                    expression: de(e),
                    end: y()
                });
            }
            if (_.in_generator && g("name", "yield")) {
                if (_.in_funarg === _.in_function) s("Invalid use of yield in function argument");
                _.input.context().regex_allowed = true;
                b();
                var t = null;
                var r = false;
                if (g("operator", "*")) {
                    b();
                    t = j(e);
                    r = true;
                } else if (g("punc") ? !De[_.token.value] : !c()) {
                    t = j(e);
                }
                return new hr({
                    start: n,
                    expression: t,
                    nested: r,
                    end: y()
                });
            }
            if (g("operator") && qe[n.value]) {
                b();
                E();
                var i = ve($n, n, de(e));
                i.start = n;
                i.end = y();
                return i;
            }
            var a = ie(true);
            while (g("operator") && ei[_.token.value] && !o(_.token)) {
                a = ve(dr, _.token, a);
                a.start = n;
                a.end = _.token;
                b();
            }
            return a;
        }
        function ve(e, n, t) {
            var r = n.value;
            switch (r) {
              case "++":
              case "--":
                if (!F(t)) f(n, "Invalid use of " + r + " operator");
                break;

              case "delete":
                if (t instanceof Nn && _.input.has_directive("use strict")) f(t.start, "Calling delete on expression not allowed in strict mode");
                break;
            }
            return new e({
                operator: r,
                expression: t
            });
        }
        var he = function(e, n, t) {
            var r = g("operator") ? _.token.value : null;
            if (r == "in" && t) r = null;
            var i = r != null ? ni[r] : null;
            if (i != null && i > n) {
                b();
                var a = he(de(t), r == "**" ? i - 1 : i, t);
                return he(new zn({
                    start: e.start,
                    left: e,
                    operator: r,
                    right: a,
                    end: a.end
                }), n, t);
            }
            return e;
        };
        function me(e) {
            return he(de(e), 0, e);
        }
        var _e = function(e) {
            var n = _.token;
            var t = me(e);
            if (g("operator", "?")) {
                b();
                var r = j();
                x(":");
                return new qn({
                    start: n,
                    condition: t,
                    consequent: r,
                    alternative: j(e),
                    end: y()
                });
            }
            return t;
        };
        function F(e) {
            return e instanceof Tn && !e.optional || e instanceof Nn;
        }
        function P(e) {
            if (e instanceof Mn) {
                var n = null;
                if (e.elements[e.elements.length - 1] instanceof Dn) {
                    n = P(e.elements.pop().expression);
                    if (!(n instanceof Fn || F(n))) return e;
                }
                var t = e.elements.map(P);
                return pn(t, function(e) {
                    return e instanceof kn || e instanceof Fn || e instanceof Ur || F(e);
                }) ? new mr({
                    start: e.start,
                    elements: t,
                    rest: n,
                    end: e.end
                }) : e;
            }
            if (e instanceof Cn) {
                var r = P(e.left);
                return r instanceof Fn || F(r) ? new kn({
                    start: e.start,
                    name: r,
                    value: e.right,
                    end: e.end
                }) : e;
            }
            if (!(e instanceof Pn)) return e;
            var n = null;
            if (e.properties[e.properties.length - 1] instanceof Dn) {
                n = P(e.properties.pop().expression);
                if (!(n instanceof Fn || F(n))) return e;
            }
            var i = [];
            for (var a = 0; a < e.properties.length; a++) {
                var o = e.properties[a];
                if (!(o instanceof yr)) return e;
                var s = P(o.value);
                if (!(s instanceof kn || s instanceof Fn || F(s))) {
                    return e;
                }
                i.push(new _r({
                    start: o.start,
                    key: o.key,
                    value: s,
                    end: o.end
                }));
            }
            return new gr({
                start: e.start,
                properties: i,
                rest: n,
                end: e.end
            });
        }
        function j(e) {
            var n = _.token;
            var t = _e(e), r = _.token.value;
            if (g("operator") && Ce[r]) {
                if (F(t) || r == "=" && (t = P(t)) instanceof Fn) {
                    b();
                    return new Cn({
                        start: n,
                        left: t,
                        operator: r,
                        right: j(e),
                        end: y()
                    });
                }
                s("Invalid assignment");
            }
            return t;
        }
        function N(e, n) {
            var t = _.token;
            var r = [];
            while (true) {
                if (n && g("operator", "...")) {
                    b();
                    r.rest = C(jn);
                    break;
                }
                r.push(j(e));
                if (!g("punc", ",")) break;
                b();
                if (n && g("punc", ")") && $e(p(), "punc", "=>")) break;
            }
            return r.length == 1 && !r.rest ? r[0] : new Sn({
                start: t,
                expressions: r,
                end: y()
            });
        }
        function I(e) {
            ++_.in_loop;
            var n = e();
            --_.in_loop;
            return n;
        }
        if (l.expression) {
            E();
            var ge = N();
            u("eof");
            return ge;
        }
        return function() {
            var e = _.token;
            var n = [];
            if (l.module) {
                _.in_async = true;
                _.input.add_directive("use strict");
            }
            _.input.push_directives_stack();
            while (!g("eof")) n.push(v());
            _.input.pop_directives_stack();
            var t = y() || e;
            var r = l.toplevel;
            if (r) {
                r.body = r.body.concat(n);
                r.end = t;
            } else {
                r = new _t({
                    start: e,
                    body: n,
                    end: t
                });
            }
            return r;
        }();
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function m(e, n, t, r) {
        this._bits = 0;
        this.defun = undefined;
        this.eliminated = 0;
        this.id = e;
        this.init = r;
        this.mangled_name = null;
        this.name = t.name;
        this.orig = [ t ];
        this.references = [];
        this.replaced = 0;
        this.safe_ids = undefined;
        this.scope = n;
    }
    m.prototype = {
        forEach: function(e) {
            this.orig.forEach(e);
            this.references.forEach(e);
        },
        mangle: function(e) {
            if (this.mangled_name) return;
            var n = this.global && e.cache && e.cache.props;
            if (n && n.has(this.name)) {
                this.mangled_name = n.get(this.name);
            } else if (this.unmangleable(e)) {
                w(this.scope, e).set(this.name, true);
            } else {
                var t = this.redefined();
                if (t) {
                    this.mangled_name = t.mangled_name || t.name;
                } else {
                    this.mangled_name = x(this, e);
                }
                if (n) n.set(this.name, this.mangled_name);
            }
        },
        redefined: function() {
            var e = this;
            var n = e.defun;
            if (!n) return;
            var t = e.name;
            var r = n.variables.get(t) || n instanceof _t && n.globals.get(t) || e.orig[0] instanceof Tr && Ln(function(e) {
                return e.name == t;
            }, n.enclosed);
            if (r && r !== e) return r.redefined() || r;
        },
        unmangleable: function(e) {
            if (this.exported) return true;
            if (this.undeclared) return true;
            if (!e.eval && this.scope.pinned()) return true;
            if (e.keep_fargs && ri(this)) return true;
            if (e.keep_fnames) {
                var n = this.orig[0];
                if (n instanceof qr) return true;
                if (n instanceof Ee) return true;
                if (n instanceof $r) return true;
                if (n instanceof zr) return true;
            }
            if (!e.toplevel && this.global) return true;
            return false;
        }
    };
    a(m, [ "const_redefs", "cross_loop", "direct_access", "exported", "global", "undeclared" ]);
    function ri(e) {
        return e.orig[0] instanceof jn || e.orig[1] instanceof jn;
    }
    var ii = ln("delete ++ --");
    function ai(e, n) {
        if (n instanceof Cn) return n.left === e && e;
        if (n instanceof kn) return n.name === e && e;
        if (n instanceof Fn) return e;
        if (n instanceof _r) return e;
        if (n instanceof dt) return n.init === e && e;
        if (n instanceof On) return ii[n.operator] && n.expression;
    }
    _t.DEFMETHOD("figure_out_scope", function(c) {
        c = be(c, {
            cache: null,
            ie: false
        });
        var l = this;
        var o = null;
        var s = false;
        var t = 0;
        var f = l.parent_scope = null;
        var p = new Rn(function(r, e) {
            if (r instanceof jt) {
                var n = s;
                s = p.parent() instanceof or;
                r.name.walk(p);
                s = n;
                a(function() {
                    if (r.extends) r.extends.walk(p);
                    r.properties.forEach(function(e) {
                        e.walk(p);
                    });
                });
                return true;
            }
            if (r instanceof tr) {
                var n = s;
                s = p.parent() instanceof or;
                e();
                s = n;
                return true;
            }
            if (r instanceof zt) {
                var n = s;
                s = p.parent() instanceof or;
                r.name.walk(p);
                s = n;
                a(function() {
                    r.argnames.forEach(function(e) {
                        e.walk(p);
                    });
                    if (r.rest) r.rest.walk(p);
                    at(r, p);
                });
                return true;
            }
            if (r instanceof Xt) {
                r.init_vars(f);
                e();
                return true;
            }
            if (r instanceof Zt) {
                a(function() {
                    at(r, p);
                });
                if (r.bcatch) r.bcatch.walk(p);
                if (r.bfinally) r.bfinally.walk(p);
                return true;
            }
            if (r instanceof mt) {
                var t = f;
                do {
                    t = t.resolve();
                    if (t.uses_with) break;
                    t.uses_with = true;
                } while (t = t.parent_scope);
                a(e);
                return true;
            }
            if (r instanceof it) {
                a(e);
                return true;
            }
            if (r instanceof Er) {
                r.scope = f;
            }
            if (r instanceof Se) {
                r.thedef = r;
                r.references = [];
            }
            if (r instanceof Cr) {
                f.def_variable(r).defun = o;
            } else if (r instanceof Tr) {
                var i = f.def_variable(r);
                i.defun = o;
                if (s) i.exported = true;
            } else if (r instanceof $r) {
                var i = o.def_function(r, p.parent());
                if (s) i.exported = true;
            } else if (r instanceof jn) {
                o.def_variable(r);
            } else if (r instanceof zr) {
                var i = o.def_function(r, r.name == "arguments" ? undefined : o);
                if (c.ie && r.name != "arguments") i.defun = o.parent_scope.resolve();
            } else if (r instanceof Dr) {
                var i = f.def_variable(r);
                if (s) i.exported = true;
            } else if (r instanceof Or) {
                var i = o.def_variable(r, r instanceof Ar ? undefined : null);
                if (s) i.exported = true;
            }
            function a(e) {
                r.init_vars(f);
                var n = o;
                var t = f;
                if (r instanceof gn) o = r;
                f = r;
                e();
                f = t;
                o = n;
            }
        });
        l.make_def = function(e, n) {
            return new m(++t, this, e, n);
        };
        l.walk(p);
        l.globals = new dn();
        var d = [];
        var p = new Rn(function(e) {
            if (e instanceof er) {
                if (!(e.argname instanceof Fn)) return;
                d.push(e);
                e.argname.walk(p);
                d.pop();
                at(e, p);
                return true;
            }
            if (e instanceof bn) {
                d.push(e);
                if (e.name) e.name.walk(p);
                e.argnames.forEach(function(e) {
                    e.walk(p);
                });
                if (e.rest) e.rest.walk(p);
                d.pop();
                Et(e, p);
                return true;
            }
            if (e instanceof Vt) {
                if (e.label) e.label.thedef.references.push(e);
                return true;
            }
            if (e instanceof Sr) {
                var n = e.definition();
                n.preinit = n.references.length;
                if (e instanceof Cr) {
                    var t = n.redefined();
                    if (t) for (var r = e.scope; r; r = r.parent_scope) {
                        Jn(r.enclosed, t);
                        if (r === t.scope) break;
                    }
                } else if (e instanceof Tr) {
                    var t = n.redefined();
                    if (t) t.const_redefs = true;
                } else if (n.scope !== e.scope && (e instanceof $r || e instanceof jn || e instanceof Or)) {
                    e.mark_enclosed(c);
                    var t = e.scope.find_variable(e.name);
                    if (e.thedef !== t) {
                        e.thedef = t;
                        t.orig.push(e);
                        e.mark_enclosed(c);
                    }
                }
                if (e.name != "arguments") return true;
                var i = e instanceof Or && p.parent();
                if (i instanceof xn && !i.value) return true;
                var a = e.scope.resolve().find_variable("arguments");
                if (a && v(a)) a.scope.uses_arguments = 3;
                return true;
            }
            if (e instanceof Nn) {
                var o = e.name;
                var a = e.scope.find_variable(o);
                for (var s = d.length; s > 0 && a; ) {
                    s = d.lastIndexOf(a.scope, s - 1);
                    if (s < 0) break;
                    var f = a.orig[0];
                    if (f instanceof Cr || f instanceof jn || f instanceof zr) {
                        e.in_arg = true;
                        break;
                    }
                    a = a.scope.parent_scope.find_variable(o);
                }
                if (!a) {
                    a = l.def_global(e);
                } else if (o == "arguments" && v(a)) {
                    var i = p.parent();
                    if (ai(e, i)) {
                        a.scope.uses_arguments = 3;
                    } else if (a.scope.uses_arguments < 2 && !(i instanceof Tn && i.expression === e)) {
                        a.scope.uses_arguments = 2;
                    } else if (!a.scope.uses_arguments) {
                        a.scope.uses_arguments = true;
                    }
                }
                if (o == "eval") {
                    var i = p.parent();
                    if (i.TYPE == "Call" && i.expression === e) {
                        var r = e.scope;
                        do {
                            r = r.resolve();
                            if (r.uses_eval) break;
                            r.uses_eval = true;
                        } while (r = r.parent_scope);
                    } else if (a.undeclared) {
                        l.uses_eval = true;
                    }
                }
                if (a.init instanceof zt && a.scope !== a.init.name.scope) {
                    var u = e.scope;
                    do {
                        if (u === a.init.name.scope) break;
                    } while (u = u.parent_scope);
                    if (!u) a.init = undefined;
                }
                e.thedef = a;
                e.reference(c);
                return true;
            }
        });
        l.walk(p);
        if (c.ie) l.walk(new Rn(function(e) {
            if (e instanceof Cr) {
                var n = e.thedef.defun;
                if (n.name instanceof zr && n.name.name == e.name) {
                    n = n.parent_scope.resolve();
                }
                r(e, n);
                return true;
            }
            if (e instanceof zr) {
                var t = e.thedef;
                if (!r(e, e.scope.parent_scope.resolve())) {
                    t.defun = undefined;
                } else if (typeof e.thedef.init !== "undefined") {
                    e.thedef.init = false;
                } else if (t.init) {
                    e.thedef.init = t.init;
                }
                return true;
            }
        }));
        function v(e) {
            return e.orig[0] instanceof jn && !(e.orig[1] instanceof jn || e.orig[2] instanceof jn) && !wt(e.scope);
        }
        function r(e, n) {
            var t = e.name;
            var r = e.thedef;
            if (!pn(r.orig, function(e) {
                return !(e instanceof Tr || e instanceof Dr);
            })) return false;
            var i = n.find_variable(t);
            if (i) {
                var a = i.redefined();
                if (a) i = a;
            } else {
                i = l.globals.get(t);
            }
            if (i) {
                i.orig.push(e);
            } else {
                i = n.def_variable(e);
            }
            if (i.undeclared) l.variables.set(t, i);
            if (t == "arguments" && v(r) && e instanceof zr) return true;
            r.defun = i.scope;
            r.forEach(function(e) {
                e.redef = r;
                e.thedef = i;
                e.reference(c);
            });
            return true;
        }
    });
    _t.DEFMETHOD("def_global", function(e) {
        var n = this.globals, t = e.name;
        if (n.has(t)) {
            return n.get(t);
        } else {
            var r = this.make_def(e);
            r.undeclared = true;
            r.global = true;
            n.set(t, r);
            return r;
        }
    });
    function b(e, n) {
        e.enclosed = [];
        e.parent_scope = n;
        e.functions = new dn();
        e.variables = new dn();
        if (n) e.make_def = n.make_def;
    }
    function y(e, n) {
        b(e, n);
        e.uses_eval = false;
        e.uses_with = false;
    }
    it.DEFMETHOD("init_vars", function(e) {
        b(this, e);
    });
    gn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    St.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        return this;
    });
    Tt.DEFMETHOD("init_vars", function(e) {
        y(this, e);
    });
    bn.DEFMETHOD("init_vars", function(e) {
        y(this, e);
        this.uses_arguments = false;
        this.def_variable(new jn({
            name: "arguments",
            scope: this,
            start: this.start,
            end: this.end
        }));
        return this;
    });
    Er.DEFMETHOD("mark_enclosed", function(e) {
        var n = this.definition();
        for (var t = this.scope; t; t = t.parent_scope) {
            Jn(t.enclosed, n);
            if (!e) {
                t._var_names = undefined;
            } else {
                if (e.keep_fargs && t instanceof bn) t.each_argname(function(e) {
                    Jn(n.scope.enclosed, e.definition());
                });
                if (e.keep_fnames) t.functions.each(function(e) {
                    Jn(n.scope.enclosed, e);
                });
            }
            if (t === n.scope) break;
        }
    });
    Er.DEFMETHOD("reference", function(e) {
        this.definition().references.push(this);
        this.mark_enclosed(e);
    });
    it.DEFMETHOD("find_variable", function(e) {
        return this.variables.get(e) || this.parent_scope && this.parent_scope.find_variable(e);
    });
    it.DEFMETHOD("def_function", function(e, n) {
        var t = this.def_variable(e, n);
        if (!t.init || t.init instanceof zt) t.init = n;
        this.functions.set(e.name, t);
        return t;
    });
    it.DEFMETHOD("def_variable", function(e, n) {
        var t = this.variables.get(e.name);
        if (t) {
            t.orig.push(e);
            if (t.init instanceof yt) t.init = n;
        } else {
            t = this.make_def(e, n);
            this.variables.set(e.name, t);
            t.global = !this.parent_scope;
        }
        return e.thedef = t;
    });
    function w(e, n) {
        var t = e.names_in_use;
        if (!t) {
            e.cname = -1;
            e.cname_holes = [];
            e.names_in_use = t = new dn();
            var r = n.cache && n.cache.props;
            e.enclosed.forEach(function(e) {
                if (e.unmangleable(n)) t.set(e.name, true);
                if (e.global && r && r.has(e.name)) {
                    t.set(r.get(e.name), true);
                }
            });
        }
        return t;
    }
    function x(e, t) {
        var n = e.scope;
        var r = w(n, t);
        var i = n.cname_holes;
        var a = new dn();
        var o = [ n ];
        e.forEach(function(e) {
            var n = e.scope;
            do {
                if (Bn(n, o)) break;
                w(n, t).each(function(e, n) {
                    a.set(n, e);
                });
                o.push(n);
            } while (n = n.parent_scope);
        });
        var s;
        for (var f = 0; f < i.length; f++) {
            s = E(i[f]);
            if (a.has(s)) continue;
            i.splice(f, 1);
            r.set(s, true);
            return s;
        }
        while (true) {
            s = E(++n.cname);
            if (r.has(s) || N[s] || t.reserved.has[s]) continue;
            if (!a.has(s)) break;
            i.push(n.cname);
        }
        r.set(s, true);
        return s;
    }
    Er.DEFMETHOD("unmangleable", function(e) {
        var n = this.definition();
        return !n || n.unmangleable(e);
    });
    Se.DEFMETHOD("unmangleable", un);
    Er.DEFMETHOD("definition", function() {
        return this.thedef;
    });
    function k(e) {
        e = be(e, {
            eval: false,
            ie: false,
            keep_fargs: false,
            keep_fnames: false,
            reserved: [],
            toplevel: false,
            v8: false,
            webkit: false
        });
        if (!Array.isArray(e.reserved)) e.reserved = [];
        Jn(e.reserved, "arguments");
        e.reserved.has = ln(e.reserved);
        return e;
    }
    _t.DEFMETHOD("mangle_names", function(s) {
        s = k(s);
        if (s.cache && s.cache.props) {
            var n = w(this, s);
            s.cache.props.each(function(e) {
                n.set(e, true);
            });
        }
        var f = 36;
        var u = -1;
        var a = [];
        var c = new Rn(function(e, n) {
            var t;
            if (e instanceof it) {
                if (e instanceof st) t = u;
                if (s.webkit && e instanceof ft && e.init instanceof ir) {
                    e.init.definitions.forEach(function(e) {
                        e.name.match_symbol(function(e) {
                            if (!(e instanceof Dr)) return;
                            var n = e.definition();
                            var t = e.scope.parent_scope;
                            var r = t.def_variable(e);
                            e.thedef = n;
                            t.to_mangle.push(r);
                            n.redefined = function() {
                                return r;
                            };
                        });
                    }, true);
                }
                var r = e.to_mangle = [];
                e.variables.each(function(e) {
                    if (!p(e)) r.push(e);
                });
                n();
                if (s.cache && e instanceof _t) {
                    e.globals.each(l);
                }
                if (e instanceof Mt && c.has_directive("use asm")) {
                    var i = new Nn(e.name);
                    i.scope = e;
                    i.reference(s);
                }
                if (r.length > f) {
                    var a = r.map(function(e, n) {
                        return n;
                    }).sort(function(e, n) {
                        return r[n].references.length - r[e].references.length || e - n;
                    });
                    r = a.slice(0, f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }).concat(a.slice(f).sort(function(e, n) {
                        return e - n;
                    }).map(function(e) {
                        return r[e];
                    }));
                }
                r.forEach(l);
                if (e instanceof st && !(s.v8 && d(c))) u = t;
                return true;
            }
            if (e instanceof Se) {
                var o;
                do {
                    o = E(++u);
                } while (N[o]);
                e.mangled_name = o;
                return true;
            }
        });
        this.walk(c);
        a.forEach(l);
        function l(e) {
            if (s.reserved.has[e.name]) return;
            e.mangle(s);
        }
        function p(n) {
            var e = n.orig[0];
            var t = n.redefined();
            if (!t) {
                if (!(e instanceof Tr)) return false;
                var r = n.scope.resolve();
                if (n.scope === r) return false;
                if (n.scope.parent_scope.find_variable(e.name)) return false;
                t = r.def_variable(e);
                r.to_mangle.push(t);
            }
            a.push(n);
            n.references.forEach(i);
            if (e instanceof Cr || e instanceof Tr) i(e);
            return true;
            function i(e) {
                e.thedef = t;
                e.reference(s);
                e.thedef = n;
            }
        }
        function d(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t instanceof ot) return t instanceof _t && !s.toplevel;
                if (t instanceof st) return true;
            }
        }
    });
    _t.DEFMETHOD("find_colliding_names", function(t) {
        var r = t.cache && t.cache.props;
        var n = Object.create(N);
        t.reserved.forEach(i);
        this.globals.each(a);
        this.walk(new Rn(function(e) {
            if (e instanceof it) e.variables.each(a);
        }));
        return n;
        function i(e) {
            n[e] = true;
        }
        function a(e) {
            var n = e.name;
            if (e.global && r && r.has(n)) n = r.get(n); else if (!e.unmangleable(t)) return;
            i(n);
        }
    });
    _t.DEFMETHOD("expand_names", function(r) {
        E.reset();
        E.sort();
        r = k(r);
        var n = this.find_colliding_names(r);
        var t = 0;
        this.globals.each(a);
        this.walk(new Rn(function(e) {
            if (e instanceof it) e.variables.each(a);
        }));
        function i() {
            var e;
            do {
                e = E(t++);
            } while (n[e]);
            return e;
        }
        function a(n) {
            if (n.global && r.cache) return;
            if (n.unmangleable(r)) return;
            if (r.reserved.has[n.name]) return;
            var e = n.redefined();
            var t = e ? e.rename || e.name : i();
            n.rename = t;
            n.forEach(function(e) {
                if (e.definition() === n) e.name = t;
            });
        }
    });
    vn.DEFMETHOD("tail_node", Vn);
    Sn.DEFMETHOD("tail_node", function() {
        return this.expressions[this.expressions.length - 1];
    });
    _t.DEFMETHOD("compute_char_frequency", function(e) {
        e = k(e);
        E.reset();
        var n = Er.prototype.add_source_map;
        try {
            Er.prototype.add_source_map = function() {
                if (!this.unmangleable(e)) E.consider(this.name, -1);
            };
            if (e.properties) {
                An.prototype.add_source_map = function() {
                    E.consider(this.property, -1);
                };
                pr.prototype.add_source_map = function() {
                    t(this.property);
                };
            }
            E.consider(this.print_to_string(), 1);
        } finally {
            Er.prototype.add_source_map = n;
            delete An.prototype.add_source_map;
            delete pr.prototype.add_source_map;
        }
        E.sort();
        function t(e) {
            if (e instanceof Hn) {
                E.consider(e.value, -1);
            } else if (e instanceof qn) {
                t(e.consequent);
                t(e.alternative);
            } else if (e instanceof Sn) {
                t(e.tail_node());
            }
        }
    });
    var E = function() {
        var i = Object.create(null);
        function e(e) {
            var n = [];
            for (var t = 0; t < e.length; t++) {
                var r = e[t];
                n.push(r);
                i[r] = -.01 * t;
            }
            return n;
        }
        var n = e("0123456789");
        var t = e("abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ$_");
        var r, a;
        function o() {
            r = null;
            a = Object.create(i);
        }
        f.consider = function(e, n) {
            for (var t = e.length; --t >= 0; ) {
                a[e[t]] += n;
            }
        };
        function s(e, n) {
            return a[n] - a[e];
        }
        f.sort = function() {
            r = t.sort(s).concat(n).sort(s);
        };
        f.reset = o;
        o();
        function f(e) {
            var n = t[e % 54];
            for (e = Math.floor(e / 54); --e >= 0; e >>= 6) {
                n += r[e & 63];
            }
            return n;
        }
        return f;
    }();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function oi(e, n) {
        if (!(this instanceof oi)) return new oi(e, n);
        Xr.call(this, this.before, this.after);
        this.options = be(e, {
            annotations: !n,
            arguments: !n,
            arrows: !n,
            assignments: !n,
            awaits: !n,
            booleans: !n,
            collapse_vars: !n,
            comparisons: !n,
            conditionals: !n,
            dead_code: !n,
            default_values: !n,
            directives: !n,
            drop_console: false,
            drop_debugger: !n,
            evaluate: !n,
            expression: false,
            functions: !n,
            global_defs: false,
            hoist_exports: !n,
            hoist_funs: false,
            hoist_props: !n,
            hoist_vars: false,
            ie: false,
            if_return: !n,
            imports: !n,
            inline: !n,
            join_vars: !n,
            keep_fargs: n,
            keep_fnames: false,
            keep_infinity: false,
            loops: !n,
            merge_vars: !n,
            module: false,
            negate_iife: !n,
            objects: !n,
            optional_chains: !n,
            passes: 1,
            properties: !n,
            pure_funcs: null,
            pure_getters: !n && "strict",
            reduce_funcs: !n,
            reduce_vars: !n,
            rests: !n,
            sequences: !n,
            side_effects: !n,
            spreads: !n,
            strings: !n,
            switches: !n,
            templates: !n,
            top_retain: null,
            toplevel: !!(e && (e["module"] || e["top_retain"])),
            typeofs: !n,
            unsafe: false,
            unsafe_comps: false,
            unsafe_Function: false,
            unsafe_math: false,
            unsafe_proto: false,
            unsafe_regexp: false,
            unsafe_undefined: false,
            unused: !n,
            varify: !n,
            webkit: false,
            yields: !n
        }, true);
        var t = this.options["evaluate"];
        this.eval_threshold = /eager/.test(t) ? 1 / 0 : +t;
        var r = this.options["global_defs"];
        if (typeof r == "object") for (var i in r) {
            if (/^@/.test(i) && Qn(r, i)) {
                r[i.slice(1)] = ti(r[i], {
                    expression: true
                });
            }
        }
        if (this.options["inline"] === true) this.options["inline"] = 4;
        this.drop_fargs = this.options["keep_fargs"] ? un : function(e, n) {
            if (e.length_read) return false;
            var t = e.name;
            if (!t) return n && n.TYPE == "Call" && n.expression === e;
            if (t.fixed_value() !== e) return false;
            var r = t.definition();
            if (r.direct_access) return false;
            var i = r.escaped;
            return i && i.depth != 1;
        };
        if (this.options["module"]) this.directives["use strict"] = true;
        var a = this.options["pure_funcs"];
        if (typeof a == "function") {
            this.pure_funcs = a;
        } else if (typeof a == "string") {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof En) {
                    n = e.expression;
                } else if (e instanceof Ir) {
                    n = e.tag;
                }
                return !(n && a === n.print_to_string());
            };
        } else if (Array.isArray(a)) {
            this.pure_funcs = function(e) {
                var n;
                if (e instanceof En) {
                    n = e.expression;
                } else if (e instanceof Ir) {
                    n = e.tag;
                }
                return !(n && Bn(n.print_to_string(), a));
            };
        } else {
            this.pure_funcs = cn;
        }
        var o = this.options["sequences"];
        this.sequences_limit = o == 1 ? 800 : o | 0;
        var s = this.options["top_retain"];
        if (s instanceof RegExp) {
            this.top_retain = function(e) {
                return s.test(e.name);
            };
        } else if (typeof s == "function") {
            this.top_retain = s;
        } else if (s) {
            if (typeof s == "string") {
                s = s.split(/,/);
            }
            this.top_retain = function(e) {
                return Bn(e.name, s);
            };
        }
        var f = this.options["toplevel"];
        this.toplevel = typeof f == "string" ? {
            funcs: /funcs/.test(f),
            vars: /vars/.test(f)
        } : {
            funcs: f,
            vars: f
        };
    }
    oi.prototype = new Xr(function(e, n, t) {
        if (e._squeezed) return e;
        var r = e instanceof gn;
        if (r) {
            e.hoist_properties(this);
            e.hoist_declarations(this);
            e.process_returns(this);
        }
        n(e, this);
        n(e, this);
        var i = e.optimize(this);
        if (r && i === e && !this.has_directive("use asm") && !i.pinned()) {
            i.drop_unused(this);
            if (i.merge_variables(this)) i.drop_unused(this);
            n(i, this);
        }
        if (i === e) i._squeezed = true;
        return i;
    });
    oi.prototype.option = function(e) {
        return this.options[e];
    };
    oi.prototype.exposed = function(e) {
        if (e.exported) return true;
        if (e.undeclared) return true;
        if (!(e.global || e.scope.resolve() instanceof _t)) return false;
        var n = this.toplevel;
        return !pn(e.orig, function(e) {
            return n[e instanceof $r ? "funcs" : "vars"];
        });
    };
    oi.prototype.compress = function(e) {
        e = e.resolve_defines(this);
        e.hoist_exports(this);
        if (this.option("expression")) e.process_expression(true);
        var n = this.options.merge_vars;
        var t = +this.options.passes || 1;
        var r = 1 / 0;
        var i = false;
        var a = {
            ie: this.option("ie")
        };
        for (var o = 0; o < t; o++) {
            e.figure_out_scope(a);
            if (o > 0 || this.option("reduce_vars")) e.reset_opt_flags(this);
            this.options.merge_vars = n && (i || o == t - 1);
            e = e.transform(this);
            if (t > 1) {
                var s = 0;
                e.walk(new Rn(function() {
                    s++;
                }));
                vn.info("pass {pass}: last_count: {min_count}, count: {count}", {
                    pass: o,
                    min_count: r,
                    count: s
                });
                if (s < r) {
                    r = s;
                    i = false;
                } else if (i) {
                    break;
                } else {
                    i = true;
                }
            }
        }
        if (this.option("expression")) e.process_expression(false);
        return e;
    };
    (function(e) {
        e(vn, function(e, n) {
            return e;
        });
        vn.DEFMETHOD("equivalent_to", function(e) {
            return this.TYPE == e.TYPE && this.print_to_string() == e.print_to_string();
        });
        _t.DEFMETHOD("hoist_exports", function(e) {
            if (!e.option("hoist_exports")) return;
            var n = this.body, t = [];
            for (var r = 0; r < n.length; r++) {
                var i = n[r];
                if (i instanceof or) {
                    n[r] = i = i.body;
                    if (i instanceof tr) {
                        i.definitions.forEach(function(e) {
                            e.name.match_symbol(a, true);
                        });
                    } else {
                        a(i.name);
                    }
                } else if (i instanceof fr) {
                    n.splice(r--, 1);
                    [].push.apply(t, i.properties);
                }
            }
            if (t.length) n.push(Ce(fr, this, {
                properties: t
            }));
            function a(e) {
                if (!(e instanceof Sr)) return;
                var n = Ce(Mr, e, e);
                n.alias = n.name;
                t.push(n);
            }
        });
        gn.DEFMETHOD("process_expression", function(i, a) {
            var o = this;
            var s = new Xr(function(e) {
                if (i) {
                    if (e instanceof tt) e = Ce(mn, e, {
                        body: Ce(Hn, e, e)
                    });
                    if (e instanceof mn) {
                        return a ? a(e) : Ce(yn, e, {
                            value: e.body
                        });
                    }
                } else if (e instanceof yn) {
                    if (a) return a(e);
                    var n = e.value;
                    if (n instanceof Hn) return Ce(tt, e, n);
                    return Ce(mn, e, {
                        body: n || Ce($n, e, {
                            operator: "void",
                            expression: Ce(Yn, e, {
                                value: 0
                            })
                        })
                    });
                }
                if (e instanceof ot) {
                    if (e instanceof bn) {
                        if (e !== o) return e;
                    } else if (i === "awaits" && e instanceof Zt) {
                        if (e.bfinally) return e;
                    }
                    for (var t = e.body.length; --t >= 0; ) {
                        var r = e.body[t];
                        if (!P(r, true)) {
                            e.body[t] = r.transform(s);
                            break;
                        }
                    }
                } else if (e instanceof wn) {
                    e.body = e.body.transform(s);
                    if (e.alternative) e.alternative = e.alternative.transform(s);
                } else if (e instanceof mt) {
                    e.body = e.body.transform(s);
                }
                return e;
            });
            o.transform(s);
        });
        function C(e, n) {
            var t = n.get_property();
            if (t instanceof vn) return;
            var r;
            if (e instanceof Mn) {
                var i = e.elements;
                if (t == "length") return fe(i.length, e);
                if (typeof t == "number" && t in i) r = i[t];
            } else if (e instanceof bn) {
                if (t == "length") {
                    e.length_read = true;
                    return fe(e.argnames.length, e);
                }
            } else if (e instanceof Pn) {
                t = "" + t;
                var a = e.properties;
                for (var o = a.length; --o >= 0; ) {
                    var s = a[o];
                    if (!an(s)) return;
                    if (!r && a[o].key === t) r = a[o].value;
                }
            }
            return r instanceof Nn && r.fixed_value() || r;
        }
        function l(e, n) {
            if (e instanceof Wr) return b.Boolean[n];
            if (e instanceof Yn) return b.Number[n];
            if (e instanceof Hn) return b.String[n];
            if (n == "valueOf") return false;
            if (e instanceof Mn) return b.Array[n];
            if (e instanceof bn) return b.Function[n];
            if (e instanceof Pn) return b.Object[n];
            if (e instanceof Yr) return b.RegExp[n] && !e.value.global;
        }
        function Oe(e, n, t, r, i, a, o) {
            var s = n.parent(i);
            if (e.option("unsafe") && s instanceof An && l(r, s.property)) {
                return;
            }
            var f = ai(t, s);
            if (f) return f;
            if (i == 0 && r && r.is_constant()) return;
            if (s instanceof Mn) return Oe(e, n, s, s, i + 1);
            if (s instanceof Cn) switch (s.operator) {
              case "=":
                return Oe(e, n, s, r, i + 1, a, o);

              case "&&=":
              case "||=":
              case "??=":
                return Oe(e, n, s, s, i + 1);

              default:
                return;
            }
            if (s instanceof zn) {
                if (!Ne[s.operator]) return;
                return Oe(e, n, s, s, i + 1);
            }
            if (s instanceof En) {
                return !a && s.expression === t && !s.is_expr_pure(e) && (!(r instanceof yt) || !(s instanceof cr) && r.contains_this());
            }
            if (s instanceof qn) {
                if (s.condition === t) return;
                return Oe(e, n, s, s, i + 1);
            }
            if (s instanceof dt) return s.init === t;
            if (s instanceof yr) {
                if (s.value !== t) return;
                var u = n.parent(i + 1);
                return Oe(e, n, u, u, i + 2);
            }
            if (s instanceof Tn) {
                if (s.expression !== t) return;
                var c = C(r, s);
                return (!a || o) && Oe(e, n, s, c, i + 1);
            }
            if (s instanceof Sn) {
                if (s.tail_node() !== t) return;
                return Oe(e, n, s, r, i + 1, a, o);
            }
        }
        function $(e) {
            return e instanceof Pt || e instanceof bn;
        }
        function He(e) {
            return e instanceof Pt || e instanceof Mt || e instanceof Ot;
        }
        function $e(e) {
            return e.name == "arguments" && e.scope.uses_arguments;
        }
        function te(e, n) {
            do {
                if (e === n) return false;
                if (n instanceof gn) return true;
            } while (n = n.parent_scope);
        }
        function ze(e, n, t) {
            var r = e.redef || e.definition();
            if (e.in_arg && ri(r)) return false;
            return pn(r.orig, function(e) {
                if (e instanceof Tr || e instanceof Dr) {
                    if (e instanceof Ar) return true;
                    return n && Q(n, e);
                }
                return !(t && e instanceof zr);
            });
        }
        function Ye(e, n, t, r) {
            if (r instanceof Cn) return r.operator == "=" && r.right === t;
            if (r instanceof En) return r.expression !== t || r instanceof cr;
            if (r instanceof Lt) return r.value === t && n.resolve() !== e.scope.resolve();
            if (r instanceof xn) return r.value === t;
        }
        var M = /^(0|[1-9][0-9]*)$/;
        (function(e) {
            e(vn, Un);
            function a(e, n, t) {
                t.assignments = 0;
                t.bool_return = 0;
                t.drop_return = 0;
                t.cross_loop = false;
                t.direct_access = false;
                t.escaped = [];
                t.fixed = !t.const_redefs && !t.scope.pinned() && !n.exposed(t) && !(t.init instanceof yt && t.init !== t.scope) && t.init;
                t.reassigned = 0;
                t.recursive_refs = 0;
                t.references = [];
                t.single_use = undefined;
            }
            function s(n, t, e) {
                e.variables.each(function(e) {
                    a(n, t, e);
                });
            }
            function p(t, r, i) {
                i.fn_defs = [];
                i.variables.each(function(e) {
                    a(t, r, e);
                    var n = e.init;
                    if (n instanceof zt) {
                        i.fn_defs.push(n);
                        n.safe_ids = null;
                    }
                    if (e.fixed === null) {
                        e.safe_ids = t.safe_ids;
                        _(t, e);
                    } else if (e.fixed) {
                        t.loop_ids[e.id] = t.in_loop;
                        _(t, e);
                    }
                });
                i.may_call_this = function() {
                    i.may_call_this = i.contains_this() ? cn : un;
                };
                if (i.uses_arguments) i.each_argname(function(e) {
                    e.definition().last_ref = false;
                });
                if (r.option("ie")) i.variables.each(function(e) {
                    var n = e.orig[0].definition();
                    if (n !== e) n.fixed = false;
                });
            }
            function o(e, n) {
                var t = n.safe_ids;
                return t === undefined || t === e.safe_ids;
            }
            function f(e, n) {
                var t = e.fn_scanning;
                e.fn_scanning = n;
                n.walk(e);
                e.fn_scanning = t;
            }
            function u(t, r) {
                r.enclosed.forEach(function(e) {
                    if (r.variables.get(e.name) === e) return;
                    if (b(t, e)) return;
                    e.single_use = false;
                    var n = e.fixed;
                    if (typeof n == "function") n = n();
                    if (n instanceof bn && n.safe_ids !== undefined) return;
                    e.fixed = false;
                });
            }
            function v(e, n, t) {
                var r = t.safe_ids;
                if (r === undefined) return;
                if (r === false) return;
                if (t.parent_scope.resolve().may_call_this === cn) {
                    if (Bn(t, e.fn_visited)) u(e, t);
                } else if (r) {
                    var i = Bn(t, e.fn_visited);
                    if (r === e.safe_ids) {
                        if (!i) f(e, t);
                    } else if (i) {
                        u(e, t);
                    } else {
                        t.safe_ids = false;
                    }
                } else if (e.fn_scanning && e.fn_scanning !== n.scope.resolve()) {
                    t.safe_ids = false;
                } else {
                    t.safe_ids = e.safe_ids;
                    f(e, t);
                }
            }
            function d(n, e) {
                var t = e.fn_defs;
                var r = e.may_call_this === cn ? t : t.filter(function(e) {
                    if (e.safe_ids === false) return true;
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                    return false;
                });
                m(n);
                r.forEach(function(e) {
                    e.safe_ids = n.safe_ids;
                    f(n, e);
                });
                t.forEach(function(e) {
                    e.safe_ids = undefined;
                });
                e.fn_defs = undefined;
                e.may_call_this = undefined;
            }
            function h(e) {
                e.safe_ids = Object.create(e.safe_ids);
            }
            function m(e) {
                e.safe_ids = Object.getPrototypeOf(e.safe_ids);
            }
            function _(e, n) {
                e.safe_ids[n.id] = {};
            }
            function g(e, n) {
                e.references.push(n);
                if (e.last_ref !== false) e.last_ref = n;
            }
            function b(e, n) {
                if (n.single_use == "m") return false;
                var t = e.safe_ids[n.id];
                if (t) {
                    var r = Qn(e.safe_ids, n.id);
                    if (!r) t.read = t.read && t.read !== e.safe_ids ? true : e.safe_ids;
                    if (n.fixed == null) {
                        if ($e(n)) return false;
                        if (n.global && n.name == "arguments") return false;
                        e.loop_ids[n.id] = null;
                        n.fixed = Ce(Lr, n.orig[0]);
                        if (r) n.safe_ids = undefined;
                        return true;
                    }
                    return !t.assign || t.assign === e.safe_ids;
                }
                return n.fixed instanceof zt;
            }
            function y(e, n, t) {
                if (!t) {
                    if (ri(n) && n.scope.uses_arguments && !e.has_directive("use strict")) return false;
                    if (!pn(n.orig, function(e) {
                        return !(e instanceof Tr);
                    })) return false;
                }
                if (n.fixed === undefined) return t || pn(n.orig, function(e) {
                    return !(e instanceof Dr);
                });
                if (n.fixed === false || n.fixed === 0) return false;
                var r = e.safe_ids[n.id];
                if (n.safe_ids) {
                    n.safe_ids[n.id] = false;
                    n.safe_ids = undefined;
                    return n.fixed === null || Qn(e.safe_ids, n.id) && !r.read;
                }
                if (!Qn(e.safe_ids, n.id)) {
                    if (!r) return false;
                    if (r.read || e.in_loop) {
                        var i = e.find_parent(it);
                        if (i instanceof Pt) return false;
                        if (n.scope.resolve() !== i.resolve()) return false;
                    }
                    r.assign = r.assign && r.assign !== e.safe_ids ? true : e.safe_ids;
                }
                if (n.fixed != null && r.read) {
                    if (r.read !== e.safe_ids) return false;
                    if (e.loop_ids[n.id] !== e.in_loop) return false;
                }
                return b(e, n) && pn(n.orig, function(e) {
                    return !(e instanceof zr);
                });
            }
            function w(e, n) {
                var t = Ce(Nn, e, e);
                t.fixed = n || Ce(Lr, e);
                return t;
            }
            function x(t, r) {
                return function() {
                    var e = w(t, r);
                    var n = t.definition();
                    n.references.push(e);
                    n.replaced++;
                    return e;
                };
            }
            function c(e, n) {
                return e.option("unused") && !n.scope.pinned() && n.single_use !== false && n.references.length - n.recursive_refs == 1 && !(ri(n) && n.scope.uses_arguments);
            }
            function k(e) {
                if (!e) return false;
                if (e instanceof Cn) {
                    var n = e.operator;
                    return n == "=" ? k(e.right) : !Ne[n.slice(0, -1)];
                }
                if (e instanceof Sn) return k(e.tail_node());
                return e.is_constant() || $(e) || e instanceof Fr;
            }
            function l(e, n) {
                if (n instanceof Mn) return true;
                if (n instanceof zn) return Ne[n.operator];
                if (n instanceof qn) return n.condition !== e;
                if (n instanceof Sn) return n.tail_node() === e;
                if (n instanceof Dn) return true;
            }
            function E(e, n, t, r, i, a, o) {
                var s = e.parent(a);
                if (i && i.is_constant()) return;
                if (Ye(n, t, r, s)) {
                    n.escaped.push(s);
                    if (o > 1 && !(i && i.is_constant_expression(t))) o = 1;
                    if (!n.escaped.depth || n.escaped.depth > o) n.escaped.depth = o;
                    if (n.scope.resolve() !== t.resolve()) n.escaped.cross_scope = true;
                    if (n.fixed) n.fixed.escaped = n.escaped;
                    return;
                } else if (l(r, s)) {
                    E(e, n, t, s, s, a + 1, o);
                } else if (s instanceof yr && s.value === r) {
                    var f = e.parent(a + 1);
                    E(e, n, t, f, f, a + 2, o);
                } else if (s instanceof Tn && s.expression === r) {
                    i = C(i, s);
                    E(e, n, t, s, i, a + 1, o + 1);
                    if (i) return;
                }
                if (a > 0) return;
                if (s instanceof En && s.expression === r) return;
                if (s instanceof Sn && s.tail_node() !== r) return;
                if (s instanceof mn) return;
                if (s instanceof On && !ii[s.operator]) return;
                n.direct_access = true;
                if (n.fixed) n.fixed.direct_access = true;
            }
            function S(e) {
                if (!(e instanceof pr)) return;
                var n = e.expression;
                if (!(n instanceof Nn)) return;
                var t = n.definition();
                if (!$e(t)) return;
                var r = e.property;
                if (r.is_constant()) r = r.value;
                if (!(r instanceof vn) && !M.test(r)) return;
                t.reassigned++;
                (r instanceof vn ? t.scope.argnames : [ t.scope.argnames[r] ]).forEach(function(e) {
                    if (e instanceof jn) e.definition().fixed = false;
                });
            }
            function T(n, t) {
                var r, i;
                return function() {
                    var e = n();
                    if (r !== e) {
                        r = e;
                        i = t(e);
                    }
                    return i;
                };
            }
            function A(t, r, i) {
                var a, o;
                return function() {
                    if (o === r) return r;
                    var e = i();
                    var n = q(t, e, true);
                    if (n instanceof vn) {
                        o = r;
                    } else if (a !== e) {
                        a = e;
                        o = n === undefined ? Me(r, [ e, r.value ]) : e;
                    }
                    return o;
                };
            }
            function D(a, n, e, o, t) {
                var s = new Rn(function(r) {
                    if (r instanceof kn) {
                        z(r);
                        h(a);
                        r.value.walk(a);
                        m(a);
                        var e = o;
                        if (e) o = A(n, r, e);
                        r.name.walk(s);
                        o = e;
                        return true;
                    }
                    if (r instanceof mr) {
                        z(r);
                        var e = o;
                        r.elements.forEach(function(n, t) {
                            if (n instanceof Ur) return z(n);
                            if (e) o = T(e, function(e) {
                                return Ce(pr, n, {
                                    expression: e,
                                    property: Ce(Yn, n, {
                                        value: t
                                    })
                                });
                            });
                            n.walk(s);
                        });
                        if (r.rest) {
                            var i;
                            if (e) o = n.option("rests") && T(e, function(e) {
                                if (!(e instanceof Mn)) return r;
                                for (var n = 0, t = r.elements.length; n < t; n++) {
                                    if (e.elements[n] instanceof Dn) return r;
                                }
                                if (!i) i = Ce(Mn, r);
                                i.elements = e.elements.slice(t);
                                return i;
                            });
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    if (r instanceof gr) {
                        z(r);
                        var e = o;
                        r.properties.forEach(function(r) {
                            z(r);
                            if (r.key instanceof vn) {
                                h(a);
                                r.key.walk(a);
                                m(a);
                            }
                            if (e) o = T(e, function(e) {
                                var n = r.key;
                                var t = pr;
                                if (typeof n == "string") {
                                    if (Kr(n)) {
                                        t = An;
                                    } else {
                                        n = fe(n, r);
                                    }
                                }
                                return Ce(t, r, {
                                    expression: e,
                                    property: n
                                });
                            });
                            r.value.walk(s);
                        });
                        if (r.rest) {
                            o = false;
                            r.rest.walk(s);
                        }
                        o = e;
                        return true;
                    }
                    t(r, o, function() {
                        var e = a.stack.length;
                        for (var n = 0, t = s.stack.length - 1; n < t; n++) {
                            a.stack.push(s.stack[n]);
                        }
                        r.walk(a);
                        a.stack.length = e;
                    });
                    return true;
                });
                e.walk(s);
            }
            function O(i, e, n) {
                var a = this;
                a.inlined = false;
                var o = i.parent();
                var t = xt(a) || kt(a);
                var r = false;
                a.walk(new Rn(function(e) {
                    if (t) return r = true;
                    if (e instanceof yn) return t = true;
                    if (e instanceof gn && e !== a) return true;
                }));
                if (r) h(i);
                p(i, n, a);
                var s = !a.uses_arguments || i.has_directive("use strict");
                a.argnames.forEach(function(t, e) {
                    var r = o.args[e];
                    D(i, n, t, function() {
                        var e = a.argnames.indexOf(t);
                        var n = e < 0 ? r : o.args[e];
                        if (n instanceof Sn && n.expressions.length < 2) n = n.expressions[0];
                        return n || Ce(Lr, o);
                    }, l);
                });
                var f = a.rest, u;
                if (f) D(i, n, f, n.option("rests") && function() {
                    if (a.rest !== f) return f;
                    if (!u) u = Ce(Mn, a);
                    u.elements = o.args.slice(a.argnames.length);
                    return u;
                }, l);
                Et(a, i);
                var c = i.safe_ids;
                d(i, a);
                if (!r) i.safe_ids = c;
                return true;
                function l(e, n) {
                    var t = e.definition();
                    if (n && s && t.fixed === undefined) {
                        _(i, t);
                        i.loop_ids[t.id] = i.in_loop;
                        t.fixed = n;
                        t.fixed.assigns = [ e ];
                    } else {
                        t.fixed = false;
                    }
                }
            }
            e(Cn, function(a, e, n) {
                var o = this;
                var s = o.left;
                var f = o.right;
                var t = s instanceof Nn && s.definition();
                var r = t || s instanceof Fn;
                switch (o.operator) {
                  case "=":
                    if (s.equivalent_to(f) && !s.has_side_effects(n)) {
                        f.walk(a);
                        l(s);
                        o.redundant = true;
                        return true;
                    }
                    if (t && f instanceof yt) {
                        p();
                        f.parent_scope.resolve().fn_defs.push(f);
                        f.safe_ids = null;
                        if (!t.fixed || !o.write_only) v(a, t, f);
                        return true;
                    }
                    if (r) {
                        f.walk(a);
                        p();
                        return true;
                    }
                    S(s);
                    return;

                  case "&&=":
                  case "||=":
                  case "??=":
                    var i = true;

                  default:
                    if (!r) {
                        S(s);
                        return d();
                    }
                    t.assignments++;
                    var u = t.fixed;
                    if (Oe(n, a, o, o, 0)) {
                        t.fixed = false;
                        return d();
                    }
                    var c = b(a, t);
                    if (i) h(a);
                    f.walk(a);
                    if (i) m(a);
                    if (c && !s.in_arg && y(a, t)) {
                        g(t, s);
                        _(a, t);
                        if (t.single_use) t.single_use = false;
                        s.fixed = t.fixed = function() {
                            return Ce(zn, o, {
                                operator: o.operator.slice(0, -1),
                                left: w(s, u),
                                right: o.right
                            });
                        };
                        s.fixed.assigns = !u || !u.assigns ? [ t.orig[0] ] : u.assigns.slice();
                        s.fixed.assigns.push(o);
                        s.fixed.to_binary = x(s, u);
                    } else {
                        s.walk(a);
                        t.fixed = false;
                    }
                    return true;
                }
                function l(e) {
                    if (e instanceof An) {
                        l(e.expression);
                    } else if (e instanceof pr) {
                        l(e.expression);
                        e.property.walk(a);
                    } else if (e instanceof Nn) {
                        var n = e.definition();
                        g(n, e);
                        if (n.fixed) {
                            e.fixed = n.fixed;
                            if (e.fixed.assigns) {
                                e.fixed.assigns.push(o);
                            } else {
                                e.fixed.assigns = [ o ];
                            }
                        }
                    } else {
                        e.walk(a);
                    }
                }
                function p() {
                    var e = t && Xe(a, t);
                    var i = Oe(n, a, o, f, 0, k(f), e);
                    D(a, n, s, function() {
                        return o.right;
                    }, function(e, n, t) {
                        if (!(e instanceof Nn)) {
                            S(e);
                            t();
                            return;
                        }
                        var r = e.definition();
                        r.assignments++;
                        if (!n || e.in_arg || !y(a, r)) {
                            t();
                            r.fixed = false;
                        } else if (i) {
                            t();
                            r.fixed = 0;
                        } else {
                            g(r, e);
                            _(a, r);
                            if (s instanceof Fn || r.orig.length == 1 && r.orig[0] instanceof $r) {
                                r.single_use = false;
                            }
                            a.loop_ids[r.id] = a.in_loop;
                            e.fixed = r.fixed = n;
                            e.fixed.assigns = [ o ];
                            E(a, r, e.scope, o, f, 0, 1);
                        }
                    });
                }
                function d() {
                    if (!i) return;
                    s.walk(a);
                    h(a);
                    f.walk(a);
                    m(a);
                    return true;
                }
            });
            e(zn, function(e) {
                if (!Ne[this.operator]) return;
                this.left.walk(e);
                h(e);
                this.right.walk(e);
                m(e);
                return true;
            });
            e(it, function(e, n, t) {
                s(e, t, this);
            });
            e(En, function(n, e) {
                var t = this;
                var r = t.expression;
                if (r instanceof yt) {
                    var i = Be(t);
                    t.args.forEach(function(e) {
                        e.walk(n);
                        if (e instanceof Dn) i = false;
                    });
                    if (i) r.reduce_vars = O;
                    r.walk(n);
                    if (i) delete r.reduce_vars;
                    return true;
                }
                if (t.TYPE == "Call") switch (n.in_boolean_context()) {
                  case "d":
                    var a = true;

                  case true:
                    f(r, a);
                }
                r.walk(n);
                var o = t.optional;
                if (o) h(n);
                t.args.forEach(function(e) {
                    e.walk(n);
                });
                if (o) m(n);
                var s = r instanceof Nn && r.fixed_value();
                if (s instanceof bn) {
                    v(n, r.definition(), s);
                } else {
                    n.find_parent(gn).may_call_this();
                }
                return true;
                function f(e, n) {
                    if (e instanceof Cn) {
                        if (e.operator != "=") return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof zn) {
                        if (!Ne[e.operator]) return;
                        f(e.left, n);
                        f(e.right, n);
                    } else if (e instanceof qn) {
                        f(e.consequent, n);
                        f(e.alternative, n);
                    } else if (e instanceof Nn) {
                        var t = e.definition();
                        t.bool_return++;
                        if (n) t.drop_return++;
                    }
                }
            });
            e(Pt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                if (r.extends) r.extends.walk(n);
                var i = r.properties.filter(function(e) {
                    z(e);
                    if (e.key instanceof vn) e.key.walk(n);
                    return e.value;
                });
                if (r.name) {
                    var a = r.name.definition();
                    var o = n.parent();
                    if (o instanceof or || o instanceof sr) a.single_use = false;
                    if (y(n, a, true)) {
                        _(n, a);
                        n.loop_ids[a.id] = n.in_loop;
                        a.fixed = function() {
                            return r;
                        };
                        a.fixed.assigns = [ r ];
                        if (!ne(a)) a.single_use = false;
                    } else {
                        a.fixed = false;
                    }
                }
                i.forEach(function(e) {
                    if (!e.static || re(e) && e.value.contains_this()) {
                        h(n);
                        e.value.walk(n);
                        m(n);
                    } else {
                        e.value.walk(n);
                    }
                });
                return true;
            });
            e(gt, function(e, n, t) {
                var r = this;
                h(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(qn, function(e) {
                this.condition.walk(e);
                h(e);
                this.consequent.walk(e);
                m(e);
                h(e);
                this.alternative.walk(e);
                m(e);
                return true;
            });
            e(kn, function(e) {
                this.name.walk(e);
                h(e);
                this.value.walk(e);
                m(e);
                return true;
            });
            e(ct, function(e) {
                var n = e.in_loop;
                e.in_loop = this;
                h(e);
                this.body.walk(e);
                if (V(this, e.parent())) {
                    m(e);
                    h(e);
                }
                this.condition.walk(e);
                m(e);
                e.in_loop = n;
                return true;
            });
            e(pt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                if (r.init) r.init.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                h(e);
                if (r.condition) r.condition.walk(e);
                r.body.walk(e);
                if (r.step) {
                    if (V(r, e.parent())) {
                        m(e);
                        h(e);
                    }
                    r.step.walk(e);
                }
                m(e);
                e.in_loop = i;
                return true;
            });
            e(dt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                r.object.walk(e);
                var i = e.in_loop;
                e.in_loop = r;
                h(e);
                var a = r.init;
                if (a instanceof tr) {
                    a.definitions[0].name.mark_symbol(function(e) {
                        if (e instanceof Sr) {
                            var n = e.definition();
                            n.assignments++;
                            n.fixed = false;
                        }
                    }, e);
                } else if (a instanceof Fn || a instanceof Nn) {
                    a.mark_symbol(function(e) {
                        if (e instanceof Nn) {
                            var n = e.definition();
                            g(n, e);
                            n.assignments++;
                            if (!e.is_immutable()) n.fixed = false;
                        }
                    }, e);
                } else {
                    a.walk(e);
                }
                r.body.walk(e);
                m(e);
                e.in_loop = i;
                return true;
            });
            e(wn, function(e) {
                this.condition.walk(e);
                h(e);
                this.body.walk(e);
                m(e);
                if (this.alternative) {
                    h(e);
                    this.alternative.walk(e);
                    m(e);
                }
                return true;
            });
            e(st, function(e) {
                h(e);
                this.body.walk(e);
                m(e);
                return true;
            });
            e(bn, function(e, n, t) {
                var r = this;
                if (!o(e, r)) return true;
                if (!Jn(e.fn_visited, r)) return true;
                r.inlined = false;
                h(e);
                p(e, t, r);
                n();
                d(e, r);
                if (r.name) E(e, r.name.definition(), r, r.name, r, 0, 1);
                return true;
            });
            e(zt, function(e, n, t) {
                var r = this;
                var i = r.name.definition();
                var a = e.parent();
                if (a instanceof or || a instanceof sr) i.single_use = false;
                if (!o(e, r)) return true;
                if (!Jn(e.fn_visited, r)) return true;
                r.inlined = false;
                h(e);
                p(e, t, r);
                n();
                d(e, r);
                return true;
            });
            e(pr, function(e) {
                if (!this.optional) return;
                this.expression.walk(e);
                h(e);
                this.property.walk(e);
                m(e);
                return true;
            });
            e(Jt, function(n, e, t) {
                var r = this;
                s(n, t, r);
                r.expression.walk(n);
                var i = true;
                r.body.forEach(function(e) {
                    if (e instanceof Kt) return;
                    e.expression.walk(n);
                    if (i) {
                        i = false;
                        h(n);
                    }
                });
                if (!i) m(n);
                at(r, n);
                return true;
            });
            e(Xt, function(e) {
                h(e);
                at(this, e);
                m(e);
                return true;
            });
            e(Cr, function() {
                this.definition().fixed = false;
            });
            e(Ar, function() {
                this.definition().fixed = false;
            });
            e(Nn, function(r, e, n) {
                var i = this.definition();
                g(i, this);
                if (i.references.length == 1 && !i.fixed && i.orig[0] instanceof $r) {
                    r.loop_ids[i.id] = r.in_loop;
                }
                var a = Xe(r, i);
                if (a) a.enclosed.forEach(function(e) {
                    if (i === e) return;
                    if (e.scope.resolve() === a) return;
                    var n = e.fixed && e.fixed.assigns;
                    if (!n) return;
                    if (n[n.length - 1] instanceof xn) return;
                    var t = r.safe_ids[e.id];
                    if (!t) return;
                    t.assign = true;
                });
                if (i.fixed === false || i.fixed === 0) {
                    var t = i.redefined();
                    if (t && te(i.scope, this.scope)) t.single_use = false;
                } else if (i.fixed === undefined || !b(r, i)) {
                    i.fixed = false;
                } else if (i.fixed) {
                    if (this.in_arg && i.orig[0] instanceof zr) this.fixed = i.scope;
                    var o = this.fixed_value();
                    if (a) {
                        i.recursive_refs++;
                    } else if (o && c(n, i)) {
                        i.in_loop = r.loop_ids[i.id] !== r.in_loop;
                        i.single_use = $(o) && !o.pinned() && (!i.in_loop || r.parent() instanceof En) || !i.in_loop && i.scope === this.scope.resolve() && o.is_constant_expression();
                    } else {
                        i.single_use = false;
                    }
                    if (Oe(n, r, this, o, 0, k(o), a)) {
                        if (i.single_use) {
                            i.single_use = "m";
                        } else {
                            i.fixed = 0;
                        }
                    }
                    if (i.fixed && r.loop_ids[i.id] !== r.in_loop) i.cross_loop = true;
                    E(r, i, this.scope, this, o, 0, 1);
                }
                if (!this.fixed) this.fixed = i.fixed;
                var s;
                if (o instanceof bn && !((s = r.parent()) instanceof En && s.expression === this)) {
                    v(r, i, o);
                }
            });
            e(Ir, function(n, e) {
                var t = this;
                var r = t.tag;
                if (!r) return;
                if (r instanceof yt) {
                    t.expressions.forEach(function(e) {
                        e.walk(n);
                    });
                    r.walk(n);
                    return true;
                }
                r.walk(n);
                t.expressions.forEach(function(e) {
                    e.walk(n);
                });
                var i = r instanceof Nn && r.fixed_value();
                if (i instanceof bn) {
                    v(n, r.definition(), i);
                } else {
                    n.find_parent(gn).may_call_this();
                }
                return true;
            });
            e(_t, function(n, e, t) {
                var r = this;
                r.globals.each(function(e) {
                    a(n, t, e);
                });
                h(n);
                p(n, t, r);
                e();
                d(n, r);
                return true;
            });
            e(Zt, function(e, n, t) {
                var r = this;
                s(e, t, r);
                h(e);
                at(r, e);
                m(e);
                if (r.bcatch) {
                    h(e);
                    r.bcatch.walk(e);
                    m(e);
                }
                if (r.bfinally) r.bfinally.walk(e);
                return true;
            });
            e(On, function(e, n) {
                var t = this;
                if (!ei[t.operator]) return;
                var r = t.expression;
                if (!(r instanceof Nn)) {
                    S(r);
                    return;
                }
                var i = r.definition();
                i.assignments++;
                var a = i.fixed;
                if (b(e, i) && !r.in_arg && y(e, i)) {
                    g(i, r);
                    _(e, i);
                    if (i.single_use) i.single_use = false;
                    i.fixed = function() {
                        return Ce(zn, t, {
                            operator: t.operator.slice(0, -1),
                            left: Ce($n, t, {
                                operator: "+",
                                expression: w(r, a)
                            }),
                            right: Ce(Yn, t, {
                                value: 1
                            })
                        });
                    };
                    i.fixed.assigns = a && a.assigns ? a.assigns.slice() : [];
                    i.fixed.assigns.push(t);
                    if (t instanceof $n) {
                        r.fixed = i.fixed;
                    } else {
                        r.fixed = function() {
                            return Ce($n, t, {
                                operator: "+",
                                expression: w(r, a)
                            });
                        };
                        r.fixed.assigns = a && a.assigns;
                        r.fixed.to_prefix = x(r, i.fixed);
                    }
                } else {
                    r.walk(e);
                    i.fixed = false;
                }
                return true;
            });
            e(xn, function(r, e, n) {
                var i = this;
                var t = i.value;
                if (t instanceof yt && i.name instanceof Sr) {
                    o();
                    t.parent_scope.resolve().fn_defs.push(t);
                    t.safe_ids = null;
                    var a = i.name.definition();
                    if (!a.fixed) v(r, a, t);
                } else if (t) {
                    t.walk(r);
                    o();
                } else if (r.parent() instanceof ir) {
                    o();
                }
                return true;
                function o() {
                    D(r, n, i.name, function() {
                        return i.value || Ce(Lr, i);
                    }, function(e, n) {
                        var t = e.definition();
                        if (n && y(r, t, true)) {
                            _(r, t);
                            r.loop_ids[t.id] = r.in_loop;
                            t.fixed = n;
                            t.fixed.assigns = [ i ];
                            if (e instanceof Tr && t.redefined() || !(ze(e) || ne(t))) {
                                t.single_use = false;
                            }
                        } else {
                            t.fixed = false;
                        }
                    });
                }
            });
            e(lt, function(e, n) {
                var t = e.in_loop;
                e.in_loop = this;
                h(e);
                n();
                m(e);
                e.in_loop = t;
                return true;
            });
        })(function(e, n) {
            e.DEFMETHOD("reduce_vars", n);
        });
        function z(e) {
            e._squeezed = false;
            e._optimized = false;
            if (e instanceof it) e._var_names = undefined;
            if (e instanceof Nn) e.fixed = undefined;
        }
        _t.DEFMETHOD("reset_opt_flags", function(t) {
            var r = new Rn(t.option("reduce_vars") ? function(e, n) {
                z(e);
                return e.reduce_vars(r, n, t);
            } : z);
            r.fn_scanning = null;
            r.fn_visited = [];
            r.in_loop = null;
            r.loop_ids = Object.create(null);
            r.safe_ids = Object.create(null);
            this.walk(r);
        });
        Er.DEFMETHOD("fixed_value", function() {
            var e = this.definition().fixed;
            if (e) {
                if (this.fixed) e = this.fixed;
                return (e instanceof vn ? e : e()).tail_node();
            }
            e = e === 0 && this.fixed;
            if (!e) return e;
            var n = (e instanceof vn ? e : e()).tail_node();
            return n.is_constant() && n;
        });
        Nn.DEFMETHOD("is_immutable", function() {
            var e = this.redef || this.definition();
            if (!(e.orig[0] instanceof zr)) return false;
            if (e.orig.length == 1) return true;
            if (!this.in_arg) return false;
            return !(e.orig[1] instanceof jn);
        });
        vn.DEFMETHOD("convert_symbol", Un);
        function t(t, r) {
            return this.transform(new Xr(function(e, n) {
                if (e instanceof kn) {
                    e = e.clone();
                    e.name = e.name.transform(this);
                    return e;
                }
                if (e instanceof Fn) {
                    e = e.clone();
                    n(e, this);
                    return e;
                }
                if (e instanceof _r) {
                    e = e.clone();
                    e.value = e.value.transform(this);
                    return e;
                }
                return e.convert_symbol(t, r);
            }));
        }
        kn.DEFMETHOD("convert_symbol", t);
        Fn.DEFMETHOD("convert_symbol", t);
        function r(e, n) {
            var t = Ce(e, this, this);
            n(t, this);
            return t;
        }
        Sr.DEFMETHOD("convert_symbol", r);
        Nn.DEFMETHOD("convert_symbol", r);
        function F(e) {
            var n = e.definition();
            n.assignments++;
            n.references.push(e);
        }
        function i(n, t) {
            var r = new Rn(function(e) {
                if (e instanceof kn) {
                    e.value.walk(t);
                    e.name.walk(r);
                    return true;
                }
                if (e instanceof _r) {
                    if (e.key instanceof vn) e.key.walk(t);
                    e.value.walk(r);
                    return true;
                }
                return n(e);
            });
            this.walk(r);
        }
        kn.DEFMETHOD("mark_symbol", i);
        Fn.DEFMETHOD("mark_symbol", i);
        function a(e) {
            return e(this);
        }
        Sr.DEFMETHOD("mark_symbol", a);
        Nn.DEFMETHOD("mark_symbol", a);
        vn.DEFMETHOD("match_symbol", function(e) {
            return e(this);
        });
        function o(n, t) {
            var r = false;
            var i = new Rn(function(e) {
                if (r) return true;
                if (e instanceof kn) {
                    if (!t) return r = true;
                    e.name.walk(i);
                    return true;
                }
                if (e instanceof _r) {
                    if (!t && e.key instanceof vn) return r = true;
                    e.value.walk(i);
                    return true;
                }
                if (n(e)) return r = true;
            });
            this.walk(i);
            return r;
        }
        kn.DEFMETHOD("match_symbol", o);
        Fn.DEFMETHOD("match_symbol", o);
        function k(e) {
            return e instanceof Ct || e instanceof Dt;
        }
        function qe(e) {
            var n = 0, t;
            while (t = e.parent(n++)) {
                if (t.variables) return t;
            }
        }
        var _e = ln("Infinity NaN undefined");
        function Re(e, n) {
            if (e instanceof Fr) return true;
            if (e instanceof Tn) {
                if (e.property === "__proto__") return true;
                e = e.expression;
                if (e instanceof Nn) {
                    if (e.is_immutable()) return false;
                    e = e.fixed_value();
                }
                if (!e) return true;
                if (e.tail_node().is_constant()) return true;
                return Re(e, n);
            }
            if (e instanceof Nn) {
                if (e.is_immutable()) return true;
                var t = e.definition();
                return n.exposed(t) && _e[t.name];
            }
            return false;
        }
        function Ce(e, n, t) {
            if (!t) t = {};
            if (n) {
                if (!t.start) t.start = n.start;
                if (!t.end) t.end = n.end;
            }
            return new e(t);
        }
        function Me(e, n) {
            if (n.length == 1) return n[0];
            return Ce(Sn, e, {
                expressions: n.reduce(T, [])
            });
        }
        function fe(e, n) {
            switch (typeof e) {
              case "string":
                return Ce(Hn, n, {
                    value: e
                });

              case "number":
                if (isNaN(e)) return Ce(Br, n);
                if (isFinite(e)) {
                    return 1 / e < 0 ? Ce($n, n, {
                        operator: "-",
                        expression: Ce(Yn, n, {
                            value: -e
                        })
                    }) : Ce(Yn, n, {
                        value: e
                    });
                }
                return e < 0 ? Ce($n, n, {
                    operator: "-",
                    expression: Ce(Vr, n)
                }) : Ce(Vr, n);

              case "boolean":
                return Ce(e ? Jr : Gr, n);

              case "undefined":
                return Ce(Lr, n);

              default:
                if (e === null) {
                    return Ce(Rr, n);
                }
                if (e instanceof RegExp) {
                    return Ce(Yr, n, {
                        value: e
                    });
                }
                throw new Error(Xn("Can't handle constant of type: {type}", {
                    type: typeof e
                }));
            }
        }
        function ge(e, n) {
            return n instanceof Tn || Pe(n) && n.name == "eval";
        }
        function Fe(e, n, t, r) {
            var i = false;
            if (n.TYPE == "Call") {
                i = n.expression === t && ge(e, r);
            } else if (n instanceof Ir) {
                i = n.tag === t && ge(e, r);
            } else if (n instanceof $n) {
                i = n.operator == "delete" || n.operator == "typeof" && Pe(r);
            }
            return i ? Me(t, [ Ce(Yn, t, {
                value: 0
            }), r ]) : r;
        }
        function T(e, n) {
            if (n instanceof Sn) {
                [].push.apply(e, n.expressions);
            } else {
                e.push(n);
            }
            return e;
        }
        function I(e) {
            return e instanceof rr || e instanceof jt || e instanceof ir;
        }
        function A(e) {
            if (e instanceof zt) {
                var n = e.name.definition();
                var t = e.name.scope;
                return n.scope === t || pn(n.references, function(e) {
                    var n = e.scope;
                    do {
                        if (n === t) return true;
                    } while (n = n.parent_scope);
                });
            }
            return !I(e);
        }
        function H(e) {
            if (e === null) return [];
            if (e instanceof _n) return pn(e.body, A) ? e.body : [ e ];
            if (e instanceof hn) return [];
            if (rt(e)) return [ e ];
            throw new Error("Can't convert thing to statement array");
        }
        function ue(e) {
            if (e === null) return true;
            if (e instanceof hn) return true;
            if (e instanceof _n) return e.body.length == 0;
            return false;
        }
        function E(e) {
            return pn(e.body, function(e) {
                return ue(e) || e instanceof Mt || e instanceof ar && ce(e);
            });
        }
        function Y(e) {
            if (e instanceof ft) {
                return e.body instanceof _n ? e.body : e;
            }
            return e;
        }
        function be(e) {
            if (e.TYPE != "Call") return false;
            do {
                e = e.expression;
            } while (e instanceof Tn);
            return e instanceof yt ? !wt(e) : be(e);
        }
        function Be(e) {
            var n = e.expression;
            if (n.name) return false;
            if (!(e instanceof cr)) return true;
            var t = false;
            n.walk(new Rn(function(e) {
                if (t) return true;
                if (e instanceof Nr) return t = true;
                if (e instanceof gn && e !== n) return true;
            }));
            return !t;
        }
        function Pe(e) {
            return e instanceof Nn && e.definition().undeclared;
        }
        var Le = ln("Array Boolean clearInterval clearTimeout console Date decodeURI decodeURIComponent encodeURI encodeURIComponent Error escape eval EvalError Function isFinite isNaN JSON Map Math Number parseFloat parseInt RangeError ReferenceError RegExp Object Set setInterval setTimeout String SyntaxError TypeError unescape URIError WeakMap WeakSet");
        Nn.DEFMETHOD("is_declared", function(e) {
            return this.defined || !this.definition().undeclared || e.option("unsafe") && Le[this.name];
        });
        function re(e) {
            return e.static && e.value && (e instanceof Ht || e instanceof Rt);
        }
        function ce(e) {
            return pn(e.definitions, function(e) {
                return !e.value;
            });
        }
        function P(e, n) {
            if (e instanceof jt) return n && !e.extends && pn(e.properties, function(e) {
                if (e.key instanceof vn) return false;
                return !re(e);
            });
            if (e instanceof tr) return (n || e instanceof ar) && ce(e);
            if (e instanceof or) return P(e.body, n);
            if (e instanceof sr) return P(e.body, n);
            return e instanceof zt;
        }
        function D(e, n) {
            var t = e.lastIndexOf(n);
            if (t < 0) return false;
            while (++t < e.length) {
                if (!P(e[t], true)) return false;
            }
            return true;
        }
        function Ue(e, n) {
            var t;
            if (e.init instanceof _n) {
                t = e.init;
                e.init = t.body.pop();
                t.body.push(e);
            }
            if (e.init instanceof Mt) {
                if (!t) t = Ce(_n, e, {
                    body: [ e ]
                });
                t.body.splice(-1, 0, e.init);
                e.init = null;
            } else if (e.init instanceof mn) {
                e.init = e.init.body;
            } else if (ue(e.init)) {
                e.init = null;
            }
            if (!t) return;
            return n ? Gn.splice(t.body) : t;
        }
        function c(e, s) {
            var C = M(s, function(e) {
                return e instanceof bn;
            });
            var Se, Te, Ae, De;
            i();
            var n, t, r = 10;
            do {
                t = n;
                n = 0;
                if (o(e)) n = 1;
                if (!n && t == 1) break;
                if (s.option("dead_code")) {
                    if (u(e, s)) n = 2;
                    if (!n && t == 2) break;
                }
                if (s.option("if_return")) {
                    if (f(e, s)) n = 3;
                    if (!n && t == 3) break;
                }
                if (s.option("awaits") && s.option("side_effects")) {
                    if (c(e, s)) n = 4;
                    if (!n && t == 4) break;
                }
                if (s.option("inline") >= 4) {
                    if (l(e, s)) n = 5;
                    if (!n && t == 5) break;
                }
                if (s.sequences_limit > 0) {
                    if (p(e, s)) n = 6;
                    if (!n && t == 6) break;
                    if (v(e, s)) n = 7;
                    if (!n && t == 7) break;
                }
                if (s.option("join_vars")) {
                    if (w(e)) n = 8;
                    if (!n && t == 8) break;
                }
                if (s.option("collapse_vars")) {
                    if (a(e, s)) n = 9;
                }
            } while (n && r-- > 0);
            return e;
            function M(e, n) {
                var t = e.self(), r, i = 0;
                do {
                    do {
                        if (n(t)) return true;
                        t = e.parent(i++);
                    } while (t instanceof wn && (r = t));
                } while ((t instanceof _n || t instanceof gn) && D(t.body, r));
            }
            function i() {
                var e = s.self(), n = 0;
                do {
                    if (!Se && e.variables) Se = e;
                    if (e instanceof er) {
                        if (s.parent(n).bfinally) {
                            if (!Ae) Ae = {};
                            Ae.bfinally = true;
                        }
                        n++;
                    } else if (e instanceof nr) {
                        n++;
                    } else if (e instanceof ft) {
                        Te = true;
                    } else if (e instanceof gn) {
                        De = e;
                        break;
                    } else if (e instanceof Zt) {
                        if (!Ae) Ae = {};
                        if (e.bcatch) Ae.bcatch = true;
                        if (e.bfinally) Ae.bfinally = true;
                    }
                } while (e = s.parent(n++));
            }
            function a(i, d) {
                if (De.pinned()) return;
                var v;
                var j = new dn();
                var h = [];
                var N = false;
                var p = new dn();
                var I;
                var a = i.length;
                var m = new Xr(function(e, n) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        if (g < _.length) return q(e, m);
                        A = true;
                        y = (b ? F : ie)(e, 0);
                        if (y === e) D = true;
                        return e;
                    }
                    var t = m.parent();
                    if (!w && ne(e, t)) {
                        w = t;
                    }
                    if (R && Y && $ && !w && e instanceof Cn && e.operator != "=" && e.left.equivalent_to(x)) {
                        O++;
                        N = true;
                        vn.info("Cascading {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        $ = false;
                        S = _e(x);
                        e.right.transform(m);
                        ve(f);
                        var r;
                        if (D) {
                            r = f;
                        } else {
                            D = true;
                            r = Ce(zn, f, {
                                operator: R,
                                left: x.fixed && x.definition().fixed ? x.fixed.to_binary() : x,
                                right: T
                            });
                        }
                        return Ce(Cn, e, {
                            operator: "=",
                            left: e.left,
                            right: Ce(zn, e, {
                                operator: e.operator.slice(0, -1),
                                left: r,
                                right: e.right
                            })
                        });
                    }
                    if (Z(e, t)) {
                        D = true;
                        return e;
                    }
                    if (e.single_use && t instanceof xn && t.value === e) return e;
                    var i;
                    if (!(e instanceof Sr) && (Y && x.equivalent_to(e) || E && (i = E(e, this)))) {
                        if (!$ || w && (i || !J || !K)) {
                            if (!i && !b) D = true;
                            return e;
                        }
                        if (ai(e, t)) {
                            if (b && !i) c = true;
                            return e;
                        }
                        if (!i && H && e.fixed !== x.fixed) {
                            D = true;
                            return e;
                        }
                        if (b) {
                            if (w && u == 0) u = l - O;
                            if (!i) O++;
                            return e;
                        }
                        O++;
                        N = D = true;
                        vn.info("Collapsing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        if (f.TYPE == "Binary") {
                            he(f, e);
                            return Ce(Cn, f, {
                                operator: "=",
                                left: f.right.left,
                                right: f.operator == "&&" ? Ce(qn, f, {
                                    condition: f.left,
                                    consequent: f.right.right,
                                    alternative: e
                                }) : Ce(qn, f, {
                                    condition: f.left,
                                    consequent: e,
                                    alternative: f.right.right
                                })
                            });
                        }
                        if (f instanceof dr) return Ce($n, f, {
                            operator: f.operator,
                            expression: x.fixed && x.definition().fixed ? x.fixed.to_prefix() : x
                        });
                        if (f instanceof $n) {
                            ve(f);
                            return f;
                        }
                        he(T, e);
                        if (f instanceof xn) {
                            var a = f.name.definition();
                            if (a.references.length - a.replaced == 1 && !d.exposed(a)) {
                                a.replaced++;
                                return Fe(d, t, e, T);
                            }
                            return Ce(Cn, f, {
                                operator: "=",
                                left: e,
                                right: T
                            });
                        }
                        ve(T);
                        var o = f.clone();
                        o.right = T;
                        return o;
                    }
                    if (ee(e, t)) {
                        D = true;
                        return e;
                    }
                    if (te(e, t) || L(e)) {
                        y = e;
                        if (e instanceof gn) D = true;
                    }
                    if (e instanceof bt) {
                        var s = $;
                        $ = false;
                        n(e, m);
                        $ = s;
                        return z(e);
                    }
                    if (e instanceof Fn) {
                        var s = $;
                        $ = false;
                        n(e, m);
                        $ = s;
                        return z(e);
                    }
                    if (e instanceof kn) {
                        e.name = e.name.transform(m);
                        var s = $;
                        $ = false;
                        e.value = e.value.transform(m);
                        $ = s;
                        return z(e);
                    }
                    if (e instanceof it && !(e instanceof gn) && !(e.variables && e.variables.all(function(e) {
                        return !W.has(e.name) && !S.has(e.name);
                    }))) {
                        var s = $;
                        $ = false;
                        if (!q(e, m)) n(e, m);
                        $ = s;
                        return z(e);
                    }
                    if (q(e, m)) return z(e);
                }, z);
                var r = new Xr(function(e) {
                    if (D) return e;
                    if (!A) {
                        if (e !== _[g]) return e;
                        g++;
                        switch (_.length - g) {
                          case 0:
                            A = true;
                            if (c) return e;
                            if (e !== f) return e;
                            if (e instanceof xn) return e;
                            s.replaced++;
                            var n = r.parent();
                            if (n instanceof Sn && n.tail_node() !== e) {
                                b.replaced++;
                                if (T === o) return Gn.skip;
                                return Me(o, o.expressions.slice(0, -1));
                            }
                            return T;

                          case 1:
                            if (!c && e.body === f) {
                                A = true;
                                s.replaced++;
                                b.replaced++;
                                return null;
                            }

                          default:
                            return q(e, r);
                        }
                    }
                    if (e instanceof Nn && e.definition() === s) {
                        if (ai(e, r.parent())) return e;
                        if (!--O) D = true;
                        vn.info("Replacing {node} [{file}:{line},{col}]", {
                            node: e,
                            file: e.start.file,
                            line: e.start.line,
                            col: e.start.col
                        });
                        var t = T.clone();
                        t.scope = e.scope;
                        t.reference();
                        if (O == u) {
                            D = true;
                            return Ce(Cn, f, {
                                operator: "=",
                                left: e,
                                right: t
                            });
                        }
                        s.replaced++;
                        return t;
                    }
                    if (e instanceof Kt || e instanceof gn) return e;
                }, function(e) {
                    return be(e, r);
                });
                while (--a >= 0) {
                    if (a == 0 && d.option("unused")) re();
                    var _ = [];
                    M(i[a]);
                    while (h.length > 0) {
                        _ = h.pop();
                        var g = 0;
                        var f = _[_.length - 1];
                        var u = -1;
                        var c = false;
                        var H = false;
                        var l;
                        var b = null;
                        var y = null;
                        var w = null;
                        var x = ue(f);
                        var k = x && x.has_side_effects(d);
                        var Y = x && (!k || x instanceof Nn) && !Re(x, d);
                        var E = pe(f);
                        if (!Y && !E) continue;
                        var R = f instanceof Cn && f.operator.slice(0, -1);
                        var B = f.name instanceof jn;
                        var L = un;
                        if (f.may_throw(d)) {
                            if (B && xt(De)) continue;
                            L = Ae ? function(e) {
                                return e.has_side_effects(d);
                            } : t;
                        }
                        var U = false;
                        var V = false;
                        var W = new dn();
                        var G = true;
                        var S = _e(f);
                        var J = ye(x);
                        var o = ce(f);
                        var T = o;
                        if (!k) {
                            if (!R && T instanceof Sn) T = T.tail_node();
                            k = we();
                        }
                        var X = Ae || !J ? function(e) {
                            return e instanceof Fn;
                        } : un;
                        var K = xe(f);
                        var A = B;
                        var D = false;
                        var O = 0;
                        var $ = !v || !A;
                        if (!$) {
                            for (var n = f.arg_index + 1; !D && n < v.length; n++) {
                                if (v[n]) v[n].transform(m);
                            }
                            $ = true;
                        }
                        for (var e = a; !D && e < i.length; e++) {
                            i[e].transform(m);
                        }
                        if (b) {
                            if (!O || l > O + c) {
                                h.push(_);
                                I = true;
                                continue;
                            }
                            if (O == u) c = true;
                            var s = x.definition();
                            D = false;
                            g = 0;
                            A = B;
                            for (var e = a; !D && e < i.length; e++) {
                                if (!i[e].transform(r)) i.splice(e--, 1);
                            }
                            O = f instanceof xn && f === _[_.length - 1] && s.references.length == s.replaced && !d.exposed(s);
                            b.last_ref = false;
                            b.single_use = false;
                            N = true;
                        }
                        if (O) ge(f);
                    }
                }
                return N;
                function z(e) {
                    if (D) return e;
                    if (y === e) D = true;
                    if (w === e) w = null;
                    return e;
                }
                function q(e, n) {
                    if (!(e instanceof it)) return;
                    if (e instanceof gn) return e;
                    if (e instanceof Pt) {
                        if (e.name) e.name = e.name.transform(n);
                        if (!D && e.extends) e.extends = e.extends.transform(n);
                        var t = [], r = [];
                        for (var i = 0; !D && i < e.properties.length; i++) {
                            var a = e.properties[i];
                            if (a.key instanceof vn) a.key = a.key.transform(n);
                            if (!a.static) continue;
                            if (a instanceof Ht) {
                                if (a.value) t.push(a);
                            } else if (a instanceof Rt) {
                                [].push.apply(r, a.value.body);
                            }
                        }
                        for (var i = 0; !D && i < r.length; i++) {
                            r[i].transform(n);
                        }
                        for (var i = 0; !D && i < t.length; i++) {
                            var a = t[i];
                            a.value = a.value.transform(n);
                        }
                        return e;
                    }
                    if (e instanceof dt) {
                        e.object = e.object.transform(n);
                        D = true;
                        return e;
                    }
                    if (e instanceof Jt) {
                        e.expression = e.expression.transform(n);
                        for (var i = 0; !D && i < e.body.length; i++) {
                            var o = e.body[i];
                            if (o instanceof Qt) {
                                if (!A) {
                                    if (o !== _[g]) continue;
                                    g++;
                                }
                                o.expression = o.expression.transform(n);
                                if (!K) break;
                                E = false;
                            }
                        }
                        D = true;
                        return e;
                    }
                }
                function Q(e, n) {
                    if (n instanceof Cn) return n.operator == "=" && n.left === e;
                    if (n instanceof kn) return n.name === e;
                    if (n instanceof mr) return true;
                    if (n instanceof _r) return n.value === e;
                }
                function Z(e, n) {
                    if (e === T) return true;
                    if (n instanceof pt) {
                        if (e !== n.init) return true;
                    }
                    if (e instanceof Cn) {
                        return e.operator != "=" && x.equivalent_to(e.left);
                    }
                    if (e instanceof En) {
                        if (!(x instanceof Tn)) return false;
                        if (!x.equivalent_to(e.expression)) return false;
                        return !(T instanceof yt && !T.contains_this());
                    }
                    if (e instanceof Pt) return !d.has_directive("use strict");
                    if (e instanceof nt) return true;
                    if (e instanceof Mt) return B && x.name === e.name.name;
                    if (e instanceof _r) return e.key instanceof vn;
                    if (e instanceof ut) return true;
                    if (e instanceof Vt) return true;
                    if (e instanceof Zt) return true;
                    if (e instanceof mt) return true;
                    return false;
                }
                function ee(e, n) {
                    if (!(e instanceof Nn)) return false;
                    if (e.is_declared(d)) {
                        if (e.fixed_value()) return false;
                        if (ze(e)) {
                            return !(n instanceof Tn && n.expression === e) && $e(e.definition());
                        }
                    } else if (Q(e, n)) {
                        return false;
                    }
                    if (!K) return true;
                    E = false;
                    return false;
                }
                function ne(e, n) {
                    if (n instanceof Cn) return n.left !== e && Ne[n.operator.slice(0, -1)];
                    if (n instanceof zn) return n.left !== e && Ne[n.operator];
                    if (n instanceof En) return n.optional && n.expression !== e;
                    if (n instanceof Qt) return n.expression !== e;
                    if (n instanceof qn) return n.condition !== e;
                    if (n instanceof wn) return n.condition !== e;
                    if (n instanceof pr) return n.optional && n.expression !== e;
                }
                function te(e, n) {
                    if (e instanceof vr) return true;
                    if (e.TYPE == "Binary") return !We(e.operator, e.right, d);
                    if (e instanceof En) {
                        var t, r = e.expression;
                        if (r instanceof Nn) {
                            t = r.definition();
                            r = r.fixed_value();
                        }
                        if (!(r instanceof bn)) return !e.is_expr_pure(d);
                        if (t && Xe(d, t, r)) return true;
                        if (r.collapse_scanning) return false;
                        r.collapse_scanning = true;
                        var i = $;
                        $ = false;
                        var a = y;
                        var o = w;
                        if (!pn(r.argnames, function(e) {
                            if (e instanceof kn) {
                                e.value.transform(m);
                                if (D) return false;
                                e = e.name;
                            }
                            return !(e instanceof Fn);
                        })) {
                            D = true;
                        } else if (wt(r) && r.value) {
                            r.value.transform(m);
                        } else for (var s = 0; !D && s < r.body.length; s++) {
                            var f = r.body[s];
                            if (f instanceof yn) {
                                if (f.value) f.value.transform(m);
                                break;
                            }
                            f.transform(m);
                        }
                        w = o;
                        y = a;
                        $ = i;
                        r.collapse_scanning = false;
                        if (!D) return false;
                        D = false;
                        return true;
                    }
                    if (e instanceof Pt) {
                        if (!Ae) return false;
                        var u = e.extends;
                        if (!u) return false;
                        if (u instanceof Nn) u = u.fixed_value();
                        return !He(u);
                    }
                    if (e instanceof Lt) {
                        if (Ae) {
                            if (Ae.bfinally) return true;
                            if (Ae.bcatch && e instanceof Ut) return true;
                        }
                        return k || x instanceof Tn || Ee(x);
                    }
                    if (e instanceof Ot) {
                        return d.option("ie") && e.name && S.has(e.name.name);
                    }
                    if (e instanceof Fr) return ke(e, n);
                    if (e instanceof Tn) {
                        if (k) return true;
                        var c = e.expression;
                        if (c instanceof Nn && $e(c.definition())) return true;
                        if (d.option("unsafe")) {
                            if (Pe(c) && Le[c.name]) return false;
                            if (Ve(c)) return false;
                        }
                        if (!G) return true;
                        if (b) return false;
                        if (!Ae && J) return false;
                        if (e.optional) return false;
                        return c.may_throw_on_access(d);
                    }
                    if (e instanceof Dn) return true;
                    if (e instanceof Nn) {
                        if (ke(e, n)) return !Q(e, n);
                        if (k && Ee(e)) return true;
                        var t = e.definition();
                        return (Ae || t.scope.resolve() !== De) && !ze(e);
                    }
                    if (e instanceof Ir) return !e.is_expr_pure(d);
                    if (e instanceof xn) {
                        if (X(e.name)) return true;
                        return (e.value || n instanceof ir) && e.name.match_symbol(function(e) {
                            return e instanceof Sr && (S.has(e.name) || k && Ee(e));
                        }, true);
                    }
                    if (e instanceof hr) return true;
                    var l = ai(e.left, e);
                    if (!l) return false;
                    if (l instanceof Tn) return true;
                    if (X(l)) return true;
                    return l.match_symbol(function(e) {
                        return e instanceof Nn && (S.has(e.name) || U && d.exposed(e.definition()));
                    }, true);
                }
                function C(e, n) {
                    if (!n) return !(e instanceof Er);
                    if (e instanceof kn) {
                        return n.has_side_effects(d) || e.value.has_side_effects(d) || C(e.name, je(n) && e.value);
                    }
                    if (e instanceof Fn) {
                        if (e.rest && C(e.rest)) return true;
                        if (e instanceof mr) {
                            if (!(n instanceof Mn || n.is_string(d))) return true;
                            return !pn(e.elements, function(e) {
                                return !C(e);
                            });
                        }
                        if (e instanceof gr) {
                            if (!n.is_defined(d)) return true;
                            return !pn(e.properties, function(e) {
                                if (e instanceof vn && e.has_side_effects(d)) return false;
                                return !C(e.value);
                            });
                        }
                    }
                }
                function re() {
                    var e, i = d.self();
                    if (i instanceof yt && !kt(i) && !i.uses_arguments && !i.pinned() && (e = d.parent()) instanceof En && e.expression === i && Be(e) && pn(e.args, function(e) {
                        return !(e instanceof Dn);
                    })) {
                        var a = i.in_strict_mode(d) && !i.parent_scope.resolve(true).in_strict_mode(d);
                        var o = xt(i) ? function(e) {
                            return e instanceof Er && e.name == "await";
                        } : function(e) {
                            return e instanceof vr && !n.find_parent(gn);
                        };
                        var s = null;
                        var n = new Rn(function(e, n) {
                            if (!c) return true;
                            if (o(e) || e instanceof hr) {
                                c = null;
                                return true;
                            }
                            if (e instanceof Fr && (a || !s)) {
                                c = null;
                                return true;
                            }
                            if (e instanceof Nn && i.variables.has(e.name)) {
                                var t = e.definition().scope;
                                if (t !== De) while (t = t.parent_scope) {
                                    if (t === De) return true;
                                }
                                c = null;
                            }
                            if (e instanceof gn && !wt(e)) {
                                var r = s;
                                s = e;
                                n();
                                s = r;
                                return true;
                            }
                        });
                        v = e.args.slice();
                        var t = v.length;
                        var r = new dn();
                        for (var f = i.argnames.length; --f >= 0; ) {
                            var u = i.argnames[f];
                            var c = v[f];
                            var l;
                            if (u instanceof kn) {
                                l = u.value;
                                u = u.name;
                                v[t + f] = l;
                            }
                            if (u instanceof Fn) {
                                if (!C(u, c)) continue;
                                h.length = 0;
                                break;
                            }
                            if (r.has(u.name)) continue;
                            r.set(u.name, true);
                            if (l) c = je(c) ? l : null;
                            if (!c && !l) {
                                c = Ce(Lr, u).transform(d);
                            } else if (c instanceof bn && c.pinned()) {
                                c = null;
                            } else if (c) {
                                c.walk(n);
                            }
                            if (!c) continue;
                            var p = Ce(xn, u, {
                                name: u,
                                value: c
                            });
                            p.name_index = f;
                            p.arg_index = l ? t + f : f;
                            h.unshift([ p ]);
                        }
                    }
                }
                function M(e, n) {
                    _.push(e);
                    if (e instanceof Mn) {
                        e.elements.forEach(function(e) {
                            M(e, n);
                        });
                    } else if (e instanceof Cn) {
                        var t = e.left;
                        if (!(t instanceof Fn)) h.push(_.slice());
                        M(t);
                        M(e.right);
                        if (t instanceof Nn && e.operator == "=") {
                            j.set(t.name, (j.get(t.name) || 0) + 1);
                        }
                    } else if (e instanceof vr) {
                        M(e.expression, n);
                    } else if (e instanceof zn) {
                        var r = Ne[e.operator];
                        if (n && r && e.operator != "??" && e.right instanceof Cn && e.right.operator == "=" && !(e.right.left instanceof Fn)) {
                            h.push(_.slice());
                        }
                        M(e.left, !r && n);
                        M(e.right, n);
                    } else if (e instanceof En) {
                        M(e.expression);
                        e.args.forEach(M);
                    } else if (e instanceof Qt) {
                        M(e.expression);
                    } else if (e instanceof qn) {
                        M(e.condition);
                        M(e.consequent, n);
                        M(e.alternative, n);
                    } else if (e instanceof tr) {
                        e.definitions.forEach(M);
                    } else if (e instanceof An) {
                        M(e.expression);
                    } else if (e instanceof ut) {
                        M(e.condition);
                        if (!(e.body instanceof ot)) {
                            M(e.body);
                        }
                    } else if (e instanceof Lt) {
                        if (e.value) M(e.value);
                    } else if (e instanceof pt) {
                        if (e.init) M(e.init, true);
                        if (e.condition) M(e.condition);
                        if (e.step) M(e.step, true);
                        if (!(e.body instanceof ot)) {
                            M(e.body);
                        }
                    } else if (e instanceof dt) {
                        M(e.object);
                        if (!(e.body instanceof ot)) {
                            M(e.body);
                        }
                    } else if (e instanceof wn) {
                        M(e.condition);
                        if (!(e.body instanceof ot)) {
                            M(e.body);
                        }
                        if (e.alternative && !(e.alternative instanceof ot)) {
                            M(e.alternative);
                        }
                    } else if (e instanceof Pn) {
                        e.properties.forEach(function(e) {
                            _.push(e);
                            if (e.key instanceof vn) M(e.key);
                            if (e instanceof yr) M(e.value, n);
                            _.pop();
                        });
                    } else if (e instanceof Sn) {
                        var i = e.expressions.length - (n ? 0 : 1);
                        e.expressions.forEach(function(e, n) {
                            M(e, n < i);
                        });
                    } else if (e instanceof mn) {
                        M(e.body, true);
                    } else if (e instanceof Dn) {
                        M(e.expression);
                    } else if (e instanceof pr) {
                        M(e.expression);
                        M(e.property);
                    } else if (e instanceof Jt) {
                        M(e.expression);
                        e.body.forEach(M);
                    } else if (e instanceof On) {
                        if (ei[e.operator]) {
                            h.push(_.slice());
                        } else {
                            M(e.expression);
                        }
                    } else if (e instanceof xn) {
                        if (e.name instanceof Or) {
                            if (e.value) {
                                var a = e.name.definition();
                                if (a.references.length > a.replaced) {
                                    h.push(_.slice());
                                }
                            } else {
                                p.set(e.name.name, (p.get(e.name.name) || 0) + 1);
                            }
                        }
                        if (e.value) M(e.value);
                    } else if (e instanceof hr) {
                        if (e.expression) M(e.expression);
                    }
                    _.pop();
                }
                function ie(e, n) {
                    var t = m.parent(n);
                    if (t instanceof Mn) return e;
                    if (t instanceof Cn) return e;
                    if (t instanceof vr) return e;
                    if (t instanceof zn) return e;
                    if (t instanceof En) return e;
                    if (t instanceof Qt) return e;
                    if (t instanceof qn) return e;
                    if (t instanceof tr) return P(t, n + 1);
                    if (t instanceof Lt) return e;
                    if (t instanceof wn) return e;
                    if (t instanceof ft) return e;
                    if (t instanceof br) return e;
                    if (t instanceof Tn) return e;
                    if (t instanceof Sn) {
                        return (t.tail_node() === e ? ie : P)(t, n + 1);
                    }
                    if (t instanceof mn) return P(t, n + 1);
                    if (t instanceof Dn) return e;
                    if (t instanceof Jt) return e;
                    if (t instanceof On) return e;
                    if (t instanceof xn) return e;
                    if (t instanceof hr) return e;
                    return null;
                }
                function ae(e, n, t) {
                    var r;
                    do {
                        r = e;
                        e = m.parent(++t);
                    } while (e instanceof Cn && e.operator.slice(0, -1) == n || e instanceof zn && e.operator == n);
                    return r;
                }
                function oe(e, n, t, r, i) {
                    var a = $;
                    $ = false;
                    var o = y;
                    var s = w;
                    var f = m.stack;
                    m.stack = [ r ];
                    e.transform(m);
                    m.stack = f;
                    w = s;
                    y = o;
                    $ = a;
                    if (D) {
                        D = false;
                        return t;
                    }
                    return n(r, i + 1);
                }
                function F(e, n) {
                    var t = m.parent(n);
                    if (t instanceof Mn) return F(t, n + 1);
                    if (t instanceof Cn) {
                        if (L(t)) return e;
                        if (t.left.match_symbol(function(e) {
                            return e instanceof Nn && (x.name == e.name || b.name == e.name);
                        })) return e;
                        var r;
                        if (t.left === e || !Ne[r = t.operator.slice(0, -1)]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof vr) return F(t, n + 1);
                    if (t instanceof zn) {
                        var r;
                        if (t.left === e || !Ne[r = t.operator]) {
                            return F(t, n + 1);
                        }
                        return ae(t, r, n);
                    }
                    if (t instanceof En) return t;
                    if (t instanceof Qt) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof qn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof tr) return P(t, n + 1);
                    if (t instanceof ct) return e;
                    if (t instanceof Lt) return P(t, n + 1);
                    if (t instanceof pt) {
                        if (t.init !== e && t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof dt) {
                        if (t.init !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof wn) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof br) {
                        var i = m.parent(n + 1);
                        return pn(i.properties, function(e) {
                            return e instanceof yr;
                        }) ? F(i, n + 2) : i;
                    }
                    if (t instanceof Tn) {
                        var a = t.expression;
                        return a === e ? F(t, n + 1) : e;
                    }
                    if (t instanceof Sn) {
                        return (t.tail_node() === e ? F : P)(t, n + 1);
                    }
                    if (t instanceof mn) return P(t, n + 1);
                    if (t instanceof Dn) return F(t, n + 1);
                    if (t instanceof Jt) {
                        if (t.expression !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof On) {
                        if (t.operator == "delete") return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof xn) return t.name.match_symbol(function(e) {
                        return e instanceof Sr && (x.name == e.name || b.name == e.name);
                    }) ? e : F(t, n + 1);
                    if (t instanceof lt) {
                        if (t.condition !== e) return e;
                        return F(t, n + 1);
                    }
                    if (t instanceof hr) return F(t, n + 1);
                    return null;
                }
                function P(n, t) {
                    var r = m.parent(t);
                    if (te(n, r)) return n;
                    if (ne(n, r)) return n;
                    if (r instanceof Mn) return P(r, t + 1);
                    if (r instanceof Cn) return a(r.left);
                    if (r instanceof vr) return n;
                    if (r instanceof zn) return P(r, t + 1);
                    if (r instanceof En) return P(r, t + 1);
                    if (r instanceof Qt) return P(r, t + 1);
                    if (r instanceof qn) return P(r, t + 1);
                    if (r instanceof tr) return P(r, t + 1);
                    if (r instanceof Lt) return P(r, t + 1);
                    if (r instanceof wn) return P(r, t + 1);
                    if (r instanceof ft) return n;
                    if (r instanceof br) {
                        var e = m.parent(t + 1);
                        return pn(e.properties, function(e) {
                            return e instanceof yr;
                        }) ? P(e, t + 2) : e;
                    }
                    if (r instanceof Tn) {
                        var i = r.expression;
                        if (i === n) return P(r, t + 1);
                        return oe(i, P, n, r, t);
                    }
                    if (r instanceof Sn) return P(r, t + 1);
                    if (r instanceof mn) return P(r, t + 1);
                    if (r instanceof Dn) return n;
                    if (r instanceof Jt) return P(r, t + 1);
                    if (r instanceof On) return P(r, t + 1);
                    if (r instanceof xn) return a(r.name);
                    if (r instanceof hr) return n;
                    return null;
                    function a(e) {
                        if (L(r)) return n;
                        if (e !== n && e instanceof Fn) {
                            return oe(e, P, n, r, t);
                        }
                        return P(r, t + 1);
                    }
                }
                function se(e) {
                    if (I) {
                        I = false;
                        return;
                    }
                    if (l < 1) return;
                    e = e.tail_node();
                    var n = e instanceof Cn && e.operator == "=" ? e.left : e;
                    if (!(n instanceof Nn)) return;
                    var t = n.definition();
                    if (t.undeclared) return;
                    if ($e(t)) return;
                    if (n !== e) {
                        if (Re(n, d)) return;
                        var r = t.references.length - t.replaced;
                        if (r < 2) return;
                        var i = f.clone();
                        i[i instanceof Cn ? "right" : "value"] = n;
                        if (f.name_index >= 0) {
                            i.name_index = f.name_index;
                            i.arg_index = f.arg_index;
                        }
                        f = i;
                    }
                    return b = t;
                }
                function fe(e) {
                    return e.references.length - e.replaced - (j.get(e.name) || 0);
                }
                function ue(t) {
                    if (t instanceof Cn) {
                        var r = t.left;
                        if (!(r instanceof Nn)) return r;
                        var e = r.definition();
                        if (De.uses_arguments && ri(e)) return r;
                        if (d.exposed(e)) return r;
                        l = fe(e);
                        if (e.fixed && r.fixed) {
                            var n = e.references.filter(function(e) {
                                return e.fixed === r.fixed;
                            }).length - 1;
                            if (n < l) {
                                l = n;
                                u = 0;
                                H = true;
                            }
                        }
                        if (t.operator == "=") se(t.right);
                        return r;
                    }
                    if (t instanceof zn) return t.right.left;
                    if (t instanceof On) return t.expression;
                    if (t instanceof xn) {
                        var r = t.name;
                        var e = r.definition();
                        if (e.const_redefs) return;
                        if (!Bn(r, e.orig)) return;
                        if (De.uses_arguments && ri(e)) return;
                        var i = e.orig.length - e.eliminated - (p.get(e.name) || 0);
                        l = fe(e);
                        if (e.fixed) l = Math.min(l, e.references.filter(function(e) {
                            if (!e.fixed) return true;
                            if (!e.fixed.assigns) return true;
                            var n = e.fixed.assigns[0];
                            return n === r || ce(n) === t.value;
                        }).length);
                        if (i > 1 && !(r instanceof jn)) {
                            se(t.value);
                            return Ce(Nn, r, r);
                        }
                        if (se(t.value) || l == 1 && !d.exposed(e)) {
                            return Ce(Nn, r, r);
                        }
                        return;
                    }
                }
                function ce(e) {
                    if (e instanceof Cn) return e.right;
                    if (e instanceof zn) {
                        var n = e.clone();
                        n.right = e.right.right;
                        return n;
                    }
                    if (e instanceof xn) return e.value;
                }
                function le(e) {
                    if (e instanceof Mn) return false;
                    if (e instanceof zn && Ne[e.operator]) {
                        return le(e.left) && le(e.right);
                    }
                    if (e instanceof En) return false;
                    if (e instanceof qn) {
                        return le(e.consequent) && le(e.alternative);
                    }
                    if (e instanceof Pn) return false;
                    return !e.has_side_effects(d);
                }
                function pe(n) {
                    if (n instanceof Cn && n.right.single_use) return;
                    var t = Object.create(null);
                    var e = new Rn(function(e) {
                        if (e instanceof Nn) t[e.definition().id] = true;
                    });
                    while (n instanceof Cn && n.operator == "=") {
                        n.left.walk(e);
                        n = n.right;
                    }
                    if (n instanceof Fr) return o;
                    if (n instanceof Nn) {
                        var r = n.evaluate(d);
                        if (r === n) return o;
                        return de(r, o);
                    }
                    if (n.is_truthy()) return de(true, un);
                    if (n.is_constant()) {
                        var i = n.evaluate(d);
                        if (!(i instanceof vn)) return de(i, o);
                    }
                    if (!(x instanceof Nn)) return false;
                    if (!le(n)) return false;
                    var a;
                    n.walk(new Rn(function(e) {
                        if (a) return true;
                        if (e instanceof Nn && t[e.definition().id]) a = true;
                    }));
                    return !a && o;
                    function o(e) {
                        return n.equivalent_to(e);
                    }
                }
                function de(r, i) {
                    return function(e, n) {
                        if (n.in_boolean_context()) {
                            if (r && e.is_truthy() && !e.has_side_effects(d)) {
                                return true;
                            }
                            if (e.is_constant()) {
                                var t = e.evaluate(d);
                                if (!(t instanceof vn)) return !t == !r;
                            }
                        }
                        return i(e);
                    };
                }
                function ve(e) {
                    while (e.write_only) {
                        e.write_only = false;
                        if (!(e instanceof Cn)) break;
                        e = e.right;
                    }
                }
                function he(e, n) {
                    var t = n.scope || qe(m) || Se;
                    e.walk(new Rn(function(e) {
                        if (e instanceof it) return true;
                        if (e instanceof Er) e.scope = t;
                    }));
                }
                function me(e) {
                    if (e instanceof Nn) {
                        e = e.fixed_value();
                        if (!e) return true;
                    }
                    if (e instanceof Cn) return e.operator == "=" && me(e.right);
                    return e instanceof Tn || e instanceof Fr;
                }
                function _e(f) {
                    var u = new dn();
                    if (f instanceof xn) {
                        if (!f.name.definition().fixed) G = false;
                        u.add(f.name.name, x);
                    }
                    var c = De.uses_arguments && !d.has_directive("use strict");
                    var l = De instanceof _t;
                    var p = new Rn(function(n) {
                        var e;
                        if (n instanceof Nn) {
                            e = n.fixed_value();
                            if (!e) {
                                e = n;
                                var t = n.definition();
                                var r = n.fixed && n.fixed.escaped || t.escaped;
                                if (!t.undeclared && (t.assignments || !r || r.cross_scope) && (Ye(t, n.scope, n, p.parent()) || !Ie(t))) {
                                    G = false;
                                }
                            }
                        } else if (n instanceof Fr) {
                            e = n;
                        }
                        if (e) {
                            u.add(n.name, Oe(d, p, n, e, 0));
                        } else if (n instanceof bn) {
                            for (var i = 0, a, o = n; a = p.parent(i++); o = a) {
                                if (a instanceof Cn) {
                                    if (a.left === o) break;
                                    if (a.operator == "=") continue;
                                    if (Ne[a.operator.slice(0, -1)]) continue;
                                    break;
                                }
                                if (a instanceof zn) {
                                    if (Ne[a.operator]) continue;
                                    break;
                                }
                                if (a instanceof En) return;
                                if (a instanceof gn) return;
                                if (a instanceof Sn) {
                                    if (a.tail_node() === o) continue;
                                    break;
                                }
                                if (a instanceof Ir) {
                                    if (a.tag) return;
                                    break;
                                }
                            }
                            n.enclosed.forEach(function(e) {
                                if (e.scope !== n) W.set(e.name, true);
                            });
                            return true;
                        } else if (c && n instanceof pr) {
                            De.each_argname(function(e) {
                                if (!d.option("reduce_vars") || e.definition().assignments) {
                                    if (!e.definition().fixed) G = false;
                                    u.add(e.name, true);
                                }
                            });
                            c = false;
                        }
                        if (!l) return;
                        if (n.TYPE == "Call") {
                            if (V) return;
                            var s = n.expression;
                            if (s instanceof Tn) return;
                            if (s instanceof yt && !s.contains_this()) return;
                            V = true;
                        } else if (n instanceof Tn && me(n.expression)) {
                            if (n === x && !(f instanceof On)) {
                                V = true;
                            } else {
                                U = true;
                            }
                        }
                    });
                    f.walk(p);
                    return u;
                }
                function ge(e) {
                    var f = T === o ? null : Me(o, o.expressions.slice(0, -1));
                    var n = e.name_index;
                    if (n >= 0) {
                        var t, r = De.argnames[n];
                        if (r instanceof kn) {
                            De.argnames[n] = r = r.clone();
                            r.value = f || Ce(Yn, r, {
                                value: 0
                            });
                        } else if ((t = d.parent().args)[n]) {
                            De.argnames[n] = r.clone();
                            t[n] = f || Ce(Yn, t[n], {
                                value: 0
                            });
                        }
                        return;
                    }
                    var u = _.length - 1;
                    var c = _[u];
                    if (c instanceof xn || _[u - 1].body === c) u--;
                    var l = new Xr(function(e, n, t) {
                        if (A) return e;
                        if (e !== _[g]) return e;
                        g++;
                        if (g <= u) return q(e, l);
                        A = true;
                        if (e instanceof tr) {
                            p.set(c.name.name, (p.get(c.name.name) || 0) + 1);
                            if (b) b.replaced++;
                            var r = e.definitions;
                            var i = r.indexOf(c);
                            var a = c.clone();
                            a.value = null;
                            if (!f) {
                                e.definitions[i] = a;
                                return e;
                            }
                            var o = [ Ce(mn, f, {
                                body: f
                            }) ];
                            if (i > 0) {
                                var s = e.clone();
                                s.definitions = r.slice(0, i);
                                o.unshift(s);
                                e = e.clone();
                                e.definitions = r.slice(i);
                            }
                            o.push(e);
                            e.definitions[0] = a;
                            return t ? Gn.splice(o) : Ce(_n, e, {
                                body: o
                            });
                        }
                        if (!f) return t ? Gn.skip : null;
                        return rt(e) ? Ce(mn, f, {
                            body: f
                        }) : f;
                    }, function(e, n) {
                        if (e instanceof pt) return Ue(e, n);
                        return be(e, l);
                    });
                    D = false;
                    A = false;
                    g = 0;
                    if (!(i[a] = i[a].transform(l))) i.splice(a, 1);
                }
                function be(e, n) {
                    if (e instanceof Sn) switch (e.expressions.length) {
                      case 0:
                        return null;

                      case 1:
                        return Fe(d, n.parent(), e, e.expressions[0]);
                    }
                }
                function ye(e) {
                    var n = lr(e);
                    if (!(n instanceof Nn)) return false;
                    if (n.definition().scope.resolve() !== De) return false;
                    if (!Te) return true;
                    if (R) return false;
                    if (f instanceof On) return false;
                    var t = S.get(n.name);
                    return !t || t[0] === e;
                }
                function we() {
                    if (f instanceof On) return false;
                    return T.has_side_effects(d);
                }
                function xe(e) {
                    if (e instanceof On) return false;
                    if (k) return false;
                    if (b) return true;
                    if (!(x instanceof Nn)) return false;
                    var n;
                    if (e instanceof xn) {
                        n = 1;
                    } else if (e.operator == "=") {
                        n = 2;
                    } else {
                        return false;
                    }
                    var t = x.definition();
                    if (t.references.length - t.replaced == n) return true;
                    if (!t.fixed) return false;
                    if (!x.fixed) return false;
                    if (t.references.filter(function(e) {
                        return e.fixed === x.fixed;
                    }).length != n) return false;
                    H = true;
                    return true;
                }
                function ke(e, n) {
                    var t = S.get(e.name);
                    if (!t || pn(t, function(e) {
                        return !e;
                    })) return;
                    if (t[0] !== x) return true;
                    E = false;
                }
                function Ee(e) {
                    var n = e.definition();
                    if (n.orig.length == 1 && n.orig[0] instanceof $r) return false;
                    if (n.scope.resolve() !== De) return true;
                    if (V && d.exposed(n)) return true;
                    return !pn(n.references, function(e) {
                        return e.scope.resolve(true) === De;
                    });
                }
                function t(e, n) {
                    if (e instanceof Cn) return t(e.left, true);
                    if (e instanceof On) return t(e.expression, true);
                    if (e instanceof xn) return e.value && t(e.value);
                    if (n) {
                        if (e instanceof An) return t(e.expression, true);
                        if (e instanceof pr) return t(e.expression, true);
                        if (e instanceof Nn) return e.definition().scope.resolve() !== De;
                    }
                    return false;
                }
            }
            function o(e) {
                var n = false, t = [];
                for (var r = 0; r < e.length; ) {
                    var i = e[r];
                    if (i instanceof _n) {
                        if (pn(i.body, A)) {
                            n = true;
                            o(i.body);
                            [].splice.apply(e, [ r, 1 ].concat(i.body));
                            r += i.body.length;
                            continue;
                        }
                    }
                    if (i instanceof tt) {
                        if (Bn(i.value, t)) {
                            n = true;
                            e.splice(r, 1);
                            continue;
                        }
                        t.push(i.value);
                    }
                    if (i instanceof hn) {
                        n = true;
                        e.splice(r, 1);
                        continue;
                    }
                    r++;
                }
                return n;
            }
            function f(a, o) {
                var e = false;
                var n = o.parent();
                var t = o.self();
                var r = C && n && n.TYPE == "Call" && n.expression === t;
                var i = C && o.option("conditionals") && o.option("sequences");
                var s = E(a);
                for (var f = a.length; --f >= 0; ) {
                    var u = a[f];
                    var c = $(f);
                    var l = a[c];
                    if (C && !l && u instanceof yn) {
                        if (!u.value) {
                            e = true;
                            a.splice(f, 1);
                            continue;
                        }
                        var p = u.value.tail_node();
                        if (p instanceof $n && p.operator == "void") {
                            e = true;
                            var d;
                            if (p === u.value) {
                                d = p.expression;
                            } else {
                                d = u.value.clone();
                                d.expressions[d.length - 1] = p.expression;
                            }
                            a[f] = Ce(mn, u, {
                                body: d
                            });
                            continue;
                        }
                    }
                    if (u instanceof wn) {
                        var v = j(u.body);
                        if (A(v)) {
                            if (v.label) Kn(v.label.thedef.references, v);
                            e = true;
                            u = u.clone();
                            u.body = Ce(_n, u, {
                                body: O(u.body, v)
                            });
                            u.alternative = Ce(_n, u, {
                                body: H(u.alternative).concat(D())
                            });
                            a[f] = u;
                            a[f] = u.transform(o);
                            continue;
                        }
                        if (v && !u.alternative && l instanceof Bt) {
                            var h = u.condition;
                            h = le(h, h.negate(o), u.body instanceof _n);
                            if (h !== u.condition) {
                                e = true;
                                u = u.clone();
                                u.condition = h;
                                a[c] = u.body;
                                u.body = l;
                                a[f] = u;
                                a[f] = u.transform(o);
                                continue;
                            }
                        }
                        var m = j(u.alternative);
                        if (A(m)) {
                            if (m.label) Kn(m.label.thedef.references, m);
                            e = true;
                            u = u.clone();
                            u.body = Ce(_n, u.body, {
                                body: H(u.body).concat(D())
                            });
                            u.alternative = Ce(_n, u.alternative, {
                                body: O(u.alternative, m)
                            });
                            a[f] = u;
                            a[f] = u.transform(o);
                            continue;
                        }
                        if (o.option("typeofs")) {
                            if (v && !m) {
                                var _ = Ce(_n, t, {
                                    body: a.slice(f + 1)
                                });
                                N(u.condition, null, _);
                            }
                            if (!v && m) {
                                var _ = Ce(_n, t, {
                                    body: a.slice(f + 1)
                                });
                                N(u.condition, _);
                            }
                        }
                    }
                    if (u instanceof wn && u.body instanceof yn) {
                        var g = u.body.value;
                        var b = u.body.in_bool || l instanceof yn && l.in_bool;
                        if (!u.alternative && l instanceof yn) {
                            e = true;
                            u = u.clone();
                            u.alternative = l;
                            a.splice(f, 1, u.transform(o));
                            a.splice(c, 1);
                            continue;
                        }
                        if (!u.alternative && !l && C && (b || g && s)) {
                            e = true;
                            u = u.clone();
                            u.alternative = Ce(yn, u, {
                                value: null
                            });
                            a.splice(f, 1, u.transform(o));
                            continue;
                        }
                        var y, w;
                        if (i && !u.alternative && (!(w = a[y = z(f)]) && r || w instanceof wn && w.body instanceof yn) && $(c) == a.length && l instanceof mn) {
                            e = true;
                            var x = [];
                            var k = w ? q(y, x) : [ f, 1 ];
                            u = u.clone();
                            x.push(u.condition);
                            u.condition = Me(u, x);
                            u.alternative = Ce(_n, l, {
                                body: [ l, Ce(yn, l, {
                                    value: null
                                }) ]
                            });
                            k.push(u.transform(o));
                            a.splice(c, 1);
                            [].splice.apply(a, k);
                            f = y + 1;
                            continue;
                        }
                    }
                }
                return e;
                function E(e) {
                    var n = 0;
                    for (var t = e.length; --t >= 0; ) {
                        var r = e[t];
                        if (r instanceof wn && r.body instanceof yn) {
                            if (++n > 1) return true;
                        }
                    }
                    return false;
                }
                function S(n) {
                    return M(o, function(e) {
                        return e === n;
                    });
                }
                function T(e) {
                    if (e instanceof yn) return C && je(e.value);
                    if (!(e instanceof Vt)) return false;
                    var n = o.loopcontrol_target(e);
                    if (e instanceof Gt) return S(Y(n));
                    if (n instanceof ft) return false;
                    return S(n);
                }
                function A(e) {
                    if (!T(e)) return false;
                    for (var n = a.length; --n > f; ) {
                        var t = a[n];
                        if (t instanceof jt) {
                            if (t.name.definition().preinit) return false;
                        } else if (t instanceof rr || t instanceof ir) {
                            if (!pn(t.definitions, function(e) {
                                return !e.name.match_symbol(function(e) {
                                    return e instanceof Sr && e.definition().preinit;
                                });
                            })) return false;
                        }
                    }
                    return true;
                }
                function D() {
                    var n = [];
                    var t = false;
                    var e = a.splice(f + 1).filter(function(e) {
                        if (e instanceof zt) {
                            n.push(e);
                            return false;
                        }
                        if (I(e)) t = true;
                        return true;
                    });
                    [].push.apply(t ? e : a, n);
                    return e;
                }
                function O(e, n) {
                    var t = H(e);
                    var r = t, i;
                    while ((i = r[r.length - 1]) !== n) {
                        r = i.body;
                    }
                    r.pop();
                    if (n.value) r.push(Ce(mn, n.value, {
                        body: n.value
                    }));
                    return t;
                }
                function $(e) {
                    for (var n = e + 1; n < a.length; n++) {
                        if (!P(a[n])) break;
                    }
                    return n;
                }
                function z(e) {
                    for (var n = e; --n >= 0; ) {
                        if (!(a[n] instanceof ar)) break;
                    }
                    return n;
                }
                function q(e, n) {
                    var t = [ e + 1, f - e ];
                    var r = [];
                    while (++e < f) {
                        var i = a[e];
                        i.remove_initializers(o, r);
                        i.definitions.forEach(function(e) {
                            if (!e.value) return;
                            n.push(Ce(Cn, e, {
                                operator: "=",
                                left: e.name.convert_symbol(Nn, F),
                                right: e.value
                            }));
                        });
                    }
                    if (r.length > 0) t.push(Ce(ar, i, {
                        definitions: r
                    }));
                    return t;
                }
            }
            function u(n, t) {
                var e;
                var r = t.self();
                for (var i = 0, a = 0, o = n.length; i < o; i++) {
                    var s = n[i];
                    if (s instanceof Vt) {
                        var f = t.loopcontrol_target(s);
                        if (Y(f) !== r || s instanceof Wt && f instanceof ft) {
                            n[a++] = s;
                        } else if (s.label) {
                            Kn(s.label.thedef.references, s);
                        }
                    } else {
                        n[a++] = s;
                    }
                    if (j(s)) {
                        e = n.slice(i + 1);
                        break;
                    }
                }
                n.length = a;
                if (e) e.forEach(function(e) {
                    S(t, e, n);
                });
                return n.length != o;
            }
            function c(e, n) {
                if (!C || Ae && Ae.bfinally) return;
                var t = false;
                for (var r = e.length; --r >= 0; ) {
                    var i = e[r];
                    if (!(i instanceof mn)) break;
                    var a = i.body;
                    if (!(a instanceof vr)) break;
                    var o = a.expression;
                    if (!x(n, o)) break;
                    t = true;
                    o = o.drop_side_effect_free(n, true);
                    if (o) {
                        i.body = o;
                        break;
                    }
                }
                e.length = r + 1;
                return t;
            }
            function l(e, n) {
                var t = false;
                var r = e.length - 1;
                if (C && r >= 0) {
                    var i = e[r].try_inline(n, Se);
                    if (i) {
                        e[r--] = i;
                        t = true;
                    }
                }
                var a = Te && Ae && Ae.bfinally ? "try" : Te;
                for (;r >= 0; r--) {
                    var i = e[r].try_inline(n, Se, true, a);
                    if (!i) continue;
                    e[r] = i;
                    t = true;
                }
                return t;
            }
            function p(n, e) {
                if (n.length < 2) return;
                var t = [], r = 0;
                function i() {
                    if (!t.length) return;
                    var e = Me(t[0], t);
                    n[r++] = Ce(mn, e, {
                        body: e
                    });
                    t = [];
                }
                for (var a = 0, o = n.length; a < o; a++) {
                    var s = n[a];
                    if (s instanceof mn) {
                        if (t.length >= e.sequences_limit) i();
                        T(t, s.body);
                    } else if (P(s)) {
                        n[r++] = s;
                    } else {
                        i();
                        n[r++] = s;
                    }
                }
                i();
                n.length = r;
                return r != o;
            }
            function d(e, n) {
                if (!(e instanceof _n)) return e;
                var t = null;
                for (var r = 0; r < e.body.length; r++) {
                    var i = e.body[r];
                    if (i instanceof ar && ce(i)) {
                        n.push(i);
                    } else if (t || I(i)) {
                        return false;
                    } else {
                        t = i;
                    }
                }
                return t;
            }
            function v(e, n) {
                var t = false, r = 0, i;
                for (var a = 0; a < e.length; a++) {
                    var o = e[a];
                    if (i) {
                        if (o instanceof Lt) {
                            if (o.value || !k(De)) {
                                o.value = p(o.value || Ce(Lr, o)).optimize(n);
                            }
                        } else if (o instanceof pt) {
                            if (!(o.init instanceof tr)) {
                                var s = false;
                                i.body.walk(new Rn(function(e) {
                                    if (s || e instanceof gn) return true;
                                    if (e instanceof zn && e.operator == "in") {
                                        s = true;
                                        return true;
                                    }
                                }));
                                if (!s) {
                                    if (o.init) o.init = p(o.init); else {
                                        o.init = i.body;
                                        r--;
                                        t = true;
                                    }
                                }
                            }
                        } else if (o instanceof vt) {
                            if (!I(o.init)) o.object = p(o.object);
                        } else if (o instanceof wn) {
                            o.condition = p(o.condition);
                        } else if (o instanceof Jt) {
                            o.expression = p(o.expression);
                        } else if (o instanceof mt) {
                            o.expression = p(o.expression);
                        }
                    }
                    if (n.option("conditionals") && o instanceof wn) {
                        var f = [];
                        var u = d(o.body, f);
                        var c = d(o.alternative, f);
                        if (u !== false && c !== false && f.length > 0) {
                            var l = f.length;
                            f.push(Ce(wn, o, {
                                condition: o.condition,
                                body: u || Ce(hn, o.body),
                                alternative: c
                            }));
                            f.unshift(r, 1);
                            [].splice.apply(e, f);
                            a += l;
                            r += l + 1;
                            i = null;
                            t = true;
                            continue;
                        }
                    }
                    e[r++] = o;
                    i = o instanceof mn ? o : null;
                }
                e.length = r;
                return t;
                function p(e) {
                    r--;
                    t = true;
                    var n = i.body;
                    return Me(n, [ n, e ]);
                }
            }
            function h(e) {
                if (e instanceof Cn) return [ e ];
                if (e instanceof Sn) return e.expressions.slice();
            }
            function m(e, n, t) {
                var r = h(n);
                if (!r) return;
                t = t || 0;
                var i = false;
                for (var a = r.length - t; --a >= 0; ) {
                    var o = r[a];
                    if (!c(o)) continue;
                    var s;
                    if (o.left instanceof Nn) {
                        s = r.slice(a + 1);
                    } else if (o.left instanceof Tn && c(o.left.expression)) {
                        s = r.slice(a + 1);
                        var f = o.clone();
                        o = o.left.expression;
                        f.left = f.left.clone();
                        f.left.expression = o.left.clone();
                        s.unshift(f);
                    } else {
                        continue;
                    }
                    if (s.length == 0) continue;
                    if (!y(o.left, o.right, s)) continue;
                    i = true;
                    r = r.slice(0, a).concat(o, s);
                }
                if (e instanceof tr) {
                    for (var a = e.definitions.length; --a >= 0; ) {
                        var u = e.definitions[a];
                        if (!u.value) continue;
                        if (y(u.name, u.value, r)) i = true;
                        if (g(u, r, t)) i = true;
                        break;
                    }
                    if (e instanceof ar && b(e.definitions, r, t)) i = true;
                }
                return i && r;
                function c(e) {
                    return e instanceof Cn && e.operator == "=";
                }
            }
            function _(e, n) {
                if (!(e instanceof mn)) return;
                if (ce(n)) return;
                var t = h(e.body);
                if (!t) return;
                var r = [];
                if (!b(r, t.reverse(), 0)) return;
                n.definitions = r.reverse().concat(n.definitions);
                return t.reverse();
            }
            function g(e, n, t) {
                if (!s.option("conditionals")) return;
                if (e.name instanceof Fn) return;
                var r = false;
                var i = e.name.definition();
                while (n.length > t) {
                    var a = ee(s, i, e.value, n[0]);
                    if (!a) break;
                    e.value = a;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function b(e, n, t) {
                var r = false;
                while (n.length > t) {
                    var i = n[0];
                    if (!(i instanceof Cn)) break;
                    if (i.operator != "=") break;
                    var a = i.left;
                    if (!(a instanceof Nn)) break;
                    if (Pe(a)) break;
                    if (a.scope.resolve() !== De) break;
                    var o = a.definition();
                    if (o.scope !== De) break;
                    if (o.orig.length > o.eliminated + 1) break;
                    if (o.orig[0].TYPE != "SymbolVar") break;
                    var s = Ce(Or, a, a);
                    e.push(Ce(xn, i, {
                        name: s,
                        value: i.right
                    }));
                    o.orig.push(s);
                    o.replaced++;
                    n.shift();
                    r = true;
                }
                return r;
            }
            function y(e, i, n) {
                var a = new dn();
                a.set(e.name, true);
                while (i instanceof Cn && i.operator == "=") {
                    if (i.left instanceof Nn) a.set(i.left.name, true);
                    i = i.right;
                }
                if (!(i instanceof Pn)) return;
                var t = false;
                do {
                    if (!o(n[0])) break;
                    n.shift();
                    t = true;
                } while (n.length);
                return t;
                function o(e) {
                    if (!(e instanceof Cn)) return;
                    if (e.operator != "=") return;
                    if (!(e.left instanceof Tn)) return;
                    var n = e.left.expression;
                    if (!(n instanceof Nn)) return;
                    if (!a.has(n.name)) return;
                    if (!e.right.is_constant_expression(De)) return;
                    var t = e.left.property;
                    if (t instanceof vn) {
                        if (o(t)) t = e.left.property = t.right.clone();
                        t = t.evaluate(s);
                    }
                    if (t instanceof vn) return;
                    t = "" + t;
                    var r = t == "__proto__" || s.has_directive("use strict") ? function(e) {
                        var n = e.key;
                        return typeof n == "string" && n != t && n != "__proto__";
                    } : function(e) {
                        var n = e.key;
                        if (e instanceof kr || e instanceof xr) {
                            return typeof n == "string" && n != t;
                        }
                        return n !== "__proto__";
                    };
                    if (!pn(i.properties, r)) return;
                    i.properties.push(Ce(yr, e, {
                        key: t,
                        value: e.right
                    }));
                    return true;
                }
            }
            function w(e) {
                var i = false, a;
                for (var n = 0, t = -1; n < e.length; n++) {
                    var r = e[n];
                    var o = e[t];
                    if (r instanceof tr) {
                        if (o && o.TYPE == r.TYPE) {
                            o.definitions = o.definitions.concat(r.definitions);
                            i = true;
                        } else if (a && a.TYPE == r.TYPE && ce(r)) {
                            a.definitions = a.definitions.concat(r.definitions);
                            i = true;
                        } else if (r instanceof ar) {
                            var s = _(o, r);
                            if (s) {
                                if (s.length) {
                                    o.body = Me(o, s);
                                    t++;
                                }
                                i = true;
                            } else {
                                t++;
                            }
                            e[t] = a = r;
                        } else {
                            e[++t] = r;
                        }
                        continue;
                    } else if (r instanceof Lt) {
                        r.value = c(r.value);
                    } else if (r instanceof pt) {
                        var s = m(o, r.init);
                        if (s) {
                            i = true;
                            r.init = s.length ? Me(r.init, s) : null;
                        } else if (o instanceof ar && (!r.init || r.init.TYPE == o.TYPE)) {
                            if (r.init) {
                                o.definitions = o.definitions.concat(r.init.definitions);
                            }
                            r = r.clone();
                            a = r.init = o;
                            e[t] = l(r);
                            i = true;
                            continue;
                        } else if (a && r.init && a.TYPE == r.init.TYPE && ce(r.init)) {
                            a.definitions = a.definitions.concat(r.init.definitions);
                            r.init = null;
                            i = true;
                        } else if (r.init instanceof ar) {
                            a = r.init;
                            s = _(o, r.init);
                            if (s) {
                                i = true;
                                if (s.length == 0) {
                                    e[t] = l(r);
                                    continue;
                                }
                                o.body = Me(o, s);
                            }
                        }
                    } else if (r instanceof dt) {
                        if (a && a.TYPE == r.init.TYPE) {
                            var f = a.definitions.slice();
                            r.init = r.init.definitions[0].name.convert_symbol(Nn, function(e, n) {
                                f.push(Ce(xn, n, {
                                    name: n,
                                    value: null
                                }));
                                n.definition().references.push(e);
                            });
                            a.definitions = f;
                            i = true;
                        }
                        r.object = c(r.object);
                    } else if (r instanceof wn) {
                        r.condition = c(r.condition);
                    } else if (r instanceof mn) {
                        var s = m(o, r.body), u;
                        if (s) {
                            i = true;
                            if (!s.length) continue;
                            r.body = Me(r.body, s);
                        } else if (o instanceof tr && (u = e[n + 1]) && o.TYPE == u.TYPE && (u = u.definitions[0]).value) {
                            i = true;
                            u.value = Me(r, [ r.body, u.value ]);
                            continue;
                        }
                    } else if (r instanceof Jt) {
                        r.expression = c(r.expression);
                    } else if (r instanceof mt) {
                        r.expression = c(r.expression);
                    }
                    e[++t] = a ? l(r) : r;
                }
                e.length = t + 1;
                return i;
                function c(e) {
                    var n = m(o, e, 1);
                    if (!n) return e;
                    i = true;
                    var t = e.tail_node();
                    if (n[n.length - 1] !== t) n.push(t.left);
                    return Me(e, n);
                }
                function l(e) {
                    return e.transform(new Xr(function(e, n, t) {
                        if (e instanceof tr) {
                            if (a === e) return e;
                            if (a.TYPE != e.TYPE) return e;
                            var r = this.parent();
                            if (r instanceof dt && r.init === e) return e;
                            if (!ce(e)) return e;
                            a.definitions = a.definitions.concat(e.definitions);
                            i = true;
                            if (r instanceof pt && r.init === e) return null;
                            return t ? Gn.skip : Ce(hn, e);
                        }
                        if (e instanceof or) return e;
                        if (e instanceof gn) return e;
                        if (!rt(e)) return e;
                    }));
                }
            }
        }
        function S(i, a, o) {
            var s;
            var f = false;
            a.walk(new Rn(function(e, n) {
                if (e instanceof jt) {
                    e.extends = null;
                    e.properties = [];
                    u(e);
                    return true;
                }
                if (e instanceof tr) {
                    var t = [];
                    if (e.remove_initializers(i, t)) {
                        vn.warn("Dropping initialization in unreachable code [{file}:{line},{col}]", e.start);
                    }
                    if (t.length > 0) {
                        e.definitions = t;
                        u(e);
                    }
                    return true;
                }
                if (e instanceof zt) {
                    u(e);
                    return true;
                }
                if (e instanceof gn) return true;
                if (e instanceof it) {
                    var r = s;
                    s = [];
                    n();
                    if (s.required) {
                        o.push(Ce(_n, a, {
                            body: s
                        }));
                    } else if (s.length) {
                        [].push.apply(o, s);
                    }
                    s = r;
                    return true;
                }
                if (!(e instanceof Vt)) f = true;
            }));
            if (f) vn.warn("Dropping unreachable code [{file}:{line},{col}]", a.start);
            function u(e) {
                if (s) {
                    s.push(e);
                    if (!A(e)) s.required = true;
                } else {
                    o.push(e);
                }
            }
        }
        function je(e, n) {
            return e == null || e.is_undefined || e instanceof Lr || e instanceof $n && e.operator == "void" && !(n && e.expression.has_side_effects(n));
        }
        (function(e) {
            e(Pt, cn);
            e(gn, function(e) {
                var n = this.body;
                for (var t = 0; t < n.length; t++) {
                    var r = n[t];
                    if (!(r instanceof tt)) break;
                    if (r.value == "use strict") return true;
                }
                var i = this.parent_scope;
                if (!i) return e.option("module");
                return i.resolve(true).in_strict_mode(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("in_strict_mode", n);
        });
        (function(e) {
            e(vn, un);
            e(Mn, cn);
            e(Cn, function() {
                return this.operator == "=" && this.right.is_truthy();
            });
            e(bn, cn);
            e(Pn, cn);
            e(Yr, cn);
            e(Sn, function() {
                return this.tail_node().is_truthy();
            });
            e(Nn, function() {
                var e = this.fixed_value();
                if (!e) return false;
                this.is_truthy = un;
                var n = e.is_truthy();
                delete this.is_truthy;
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_truthy", n);
        });
        (function(e) {
            e(vn, cn);
            e(Mn, un);
            function n(e, n, t) {
                switch (e) {
                  case "-":
                    return n.is_negative_zero() && (!(t instanceof In) || t.value == 0);

                  case "&&":
                  case "||":
                    return n.is_negative_zero() || t.is_negative_zero();

                  case "*":
                  case "/":
                  case "%":
                  case "**":
                    return true;

                  default:
                    return false;
                }
            }
            e(Cn, function() {
                var e = this.operator;
                if (e == "=") return this.right.is_negative_zero();
                return n(e.slice(0, -1), this.left, this.right);
            });
            e(zn, function() {
                return n(this.operator, this.left, this.right);
            });
            e(In, function() {
                return this.value == 0 && 1 / this.value < 0;
            });
            e(bn, un);
            e(Pn, un);
            e(Yr, un);
            e(Sn, function() {
                return this.tail_node().is_negative_zero();
            });
            e(Nn, function() {
                var e = this.fixed_value();
                if (!e) return true;
                this.is_negative_zero = cn;
                var n = e.is_negative_zero();
                delete this.is_negative_zero;
                return n;
            });
            e($n, function() {
                return this.operator == "+" && this.expression.is_negative_zero() || this.operator == "-";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_negative_zero", n);
        });
        (function(e) {
            vn.DEFMETHOD("may_throw_on_access", function(e, n) {
                return !e.option("pure_getters") || this._dot_throw(e, n);
            });
            function i(e, n) {
                return n || /strict/.test(e.option("pure_getters"));
            }
            e(vn, i);
            e(Mn, un);
            e(Cn, function(e) {
                var n = this.operator;
                var t = this.left;
                var r = this.right;
                if (n != "=") {
                    return Ne[n.slice(0, -1)] && (t._dot_throw(e) || r._dot_throw(e));
                }
                if (!r._dot_throw(e)) return false;
                if (!(t instanceof Nn)) return true;
                if (r instanceof zn && r.operator == "||" && t.name == r.left.name) {
                    return r.right._dot_throw(e);
                }
                return true;
            });
            e(zn, function(e) {
                return Ne[this.operator] && (this.left._dot_throw(e) || this.right._dot_throw(e));
            });
            e(Pt, un);
            e(qn, function(e) {
                return this.consequent._dot_throw(e) || this.alternative._dot_throw(e);
            });
            e(In, un);
            e(An, function(e, n) {
                if (!i(e, n)) return false;
                var t = this.expression;
                if (t instanceof Nn) t = t.fixed_value();
                return !(this.property == "prototype" && $(t));
            });
            e(bn, un);
            e(Rr, cn);
            e(Pn, function(n, t) {
                return i(n, t) && !pn(this.properties, function(e) {
                    if (!(e instanceof yr)) return false;
                    return !(e.key === "__proto__" && e.value._dot_throw(n, t));
                });
            });
            e(Fr, function(e, n) {
                return i(e, n) && !this.scope.resolve().new;
            });
            e(Sn, function(e) {
                return this.tail_node()._dot_throw(e);
            });
            e(Nn, function(e, n) {
                if (this.is_undefined) return true;
                if (!i(e, n)) return false;
                if (Pe(this) && this.is_declared(e)) return false;
                if (this.is_immutable()) return false;
                var t = this.definition();
                if ($e(t) && !t.scope.rest && pn(t.scope.argnames, function(e) {
                    return e instanceof jn;
                })) return t.scope.uses_arguments > 2;
                var r = this.fixed_value();
                if (!r) return true;
                this._dot_throw = cn;
                if (r._dot_throw(e)) {
                    delete this._dot_throw;
                    return true;
                }
                this._dot_throw = un;
                return false;
            });
            e($n, function() {
                return this.operator == "void";
            });
            e(dr, un);
            e(Lr, cn);
        })(function(e, n) {
            e.DEFMETHOD("_dot_throw", n);
        });
        (function(e) {
            e(vn, un);
            e(Mn, cn);
            function t(e, n, t) {
                switch (n) {
                  case "&&":
                    return t.left.is_defined(e) && t.right.is_defined(e);

                  case "||":
                    return t.left.is_truthy() || t.right.is_defined(e);

                  case "??":
                    return t.left.is_defined(e) || t.right.is_defined(e);

                  default:
                    return true;
                }
            }
            e(Cn, function(e) {
                var n = this.operator;
                if (n == "=") return this.right.is_defined(e);
                return t(e, n.slice(0, -1), this);
            });
            e(zn, function(e) {
                return t(e, this.operator, this);
            });
            e(qn, function(e) {
                return this.consequent.is_defined(e) && this.alternative.is_defined(e);
            });
            e(In, cn);
            e(Ur, un);
            e(bn, cn);
            e(Pn, cn);
            e(Sn, function(e) {
                return this.tail_node().is_defined(e);
            });
            e(Nn, function(e) {
                if (this.is_undefined) return false;
                if (Pe(this) && this.is_declared(e)) return true;
                if (this.is_immutable()) return true;
                var n = this.fixed_value();
                if (!n) return false;
                this.is_defined = un;
                var t = n.is_defined(e);
                delete this.is_defined;
                return t;
            });
            e($n, function() {
                return this.operator != "void";
            });
            e(dr, cn);
            e(Lr, un);
        })(function(e, n) {
            e.DEFMETHOD("is_defined", n);
        });
        (function(e) {
            e(vn, un);
            e(Cn, function(e) {
                return this.operator == "=" && this.right.is_boolean(e);
            });
            var n = ln("in instanceof == != === !== < <= >= >");
            e(zn, function(e) {
                return n[this.operator] || Ne[this.operator] && this.left.is_boolean(e) && this.right.is_boolean(e);
            });
            e(Wr, cn);
            var t = ln("every hasOwnProperty isPrototypeOf propertyIsEnumerable some");
            e(En, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof An && (t[n.property] || n.property == "test" && n.expression instanceof Yr);
            });
            e(qn, function(e) {
                return this.consequent.is_boolean(e) && this.alternative.is_boolean(e);
            });
            e(cr, un);
            e(Sn, function(e) {
                return this.tail_node().is_boolean(e);
            });
            e(Nn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_boolean = un;
                var t = n.is_boolean(e);
                delete this.is_boolean;
                return t;
            });
            var r = ln("! delete");
            e($n, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_boolean", n);
        });
        (function(e) {
            e(vn, un);
            var n = ln("- * / % ** & | ^ << >> >>>");
            e(Cn, function(e) {
                return n[this.operator.slice(0, -1)] || this.operator == "=" && this.right.is_number(e);
            });
            e(zn, function(e) {
                if (n[this.operator]) return true;
                if (this.operator != "+") return false;
                return (this.left.is_boolean(e) || this.left.is_number(e)) && (this.right.is_boolean(e) || this.right.is_number(e));
            });
            var t = ln([ "charCodeAt", "getDate", "getDay", "getFullYear", "getHours", "getMilliseconds", "getMinutes", "getMonth", "getSeconds", "getTime", "getTimezoneOffset", "getUTCDate", "getUTCDay", "getUTCFullYear", "getUTCHours", "getUTCMilliseconds", "getUTCMinutes", "getUTCMonth", "getUTCSeconds", "getYear", "indexOf", "lastIndexOf", "localeCompare", "push", "search", "setDate", "setFullYear", "setHours", "setMilliseconds", "setMinutes", "setMonth", "setSeconds", "setTime", "setUTCDate", "setUTCFullYear", "setUTCHours", "setUTCMilliseconds", "setUTCMinutes", "setUTCMonth", "setUTCSeconds", "setYear" ]);
            e(En, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof An && (t[n.property] || Pe(n.expression) && n.expression.name == "Math");
            });
            e(qn, function(e) {
                return this.consequent.is_number(e) && this.alternative.is_number(e);
            });
            e(cr, un);
            e(Yn, cn);
            e(Sn, function(e) {
                return this.tail_node().is_number(e);
            });
            e(Nn, function(e, n) {
                var t = this.fixed_value();
                if (!t) return false;
                if (n && t instanceof $n && t.operator == "+" && t.expression.equivalent_to(this)) {
                    return false;
                }
                this.is_number = un;
                var r = t.is_number(e);
                delete this.is_number;
                return r;
            });
            var r = ln("+ - ~ ++ --");
            e(On, function() {
                return r[this.operator];
            });
        })(function(e, n) {
            e.DEFMETHOD("is_number", n);
        });
        (function(e) {
            e(vn, un);
            e(Cn, function(e) {
                switch (this.operator) {
                  case "+=":
                    if (this.left.is_string(e)) return true;

                  case "=":
                    return this.right.is_string(e);
                }
            });
            e(zn, function(e) {
                return this.operator == "+" && (this.left.is_string(e) || this.right.is_string(e));
            });
            var t = ln([ "charAt", "substr", "substring", "toExponential", "toFixed", "toLowerCase", "toPrecision", "toString", "toUpperCase", "trim" ]);
            e(En, function(e) {
                if (!e.option("unsafe")) return false;
                var n = this.expression;
                return n instanceof An && t[n.property];
            });
            e(qn, function(e) {
                return this.consequent.is_string(e) && this.alternative.is_string(e);
            });
            e(Sn, function(e) {
                return this.tail_node().is_string(e);
            });
            e(Hn, cn);
            e(Nn, function(e) {
                var n = this.fixed_value();
                if (!n) return false;
                this.is_string = un;
                var t = n.is_string(e);
                delete this.is_string;
                return t;
            });
            e(Ir, function(e) {
                return !this.tag || Ke(e, this.tag);
            });
            e($n, function() {
                return this.operator == "typeof";
            });
        })(function(e, n) {
            e.DEFMETHOD("is_string", n);
        });
        var Ne = ln("&& || ??");
        (function(e) {
            function i(e, n) {
                if (e instanceof vn) return e.clone(true);
                if (Array.isArray(e)) return Ce(Mn, n, {
                    elements: e.map(function(e) {
                        return i(e, n);
                    })
                });
                if (e && typeof e == "object") {
                    var t = [];
                    for (var r in e) if (Qn(e, r)) {
                        t.push(Ce(yr, n, {
                            key: r,
                            value: i(e[r], n)
                        }));
                    }
                    return Ce(Pn, n, {
                        properties: t
                    });
                }
                return fe(e, n);
            }
            function o(e) {
                vn.warn("global_defs {node} redefined [{file}:{line},{col}]", {
                    node: e,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            _t.DEFMETHOD("resolve_defines", function(a) {
                if (!a.option("global_defs")) return this;
                this.figure_out_scope({
                    ie: a.option("ie")
                });
                return this.transform(new Xr(function(e) {
                    var n = e._find_defs(a, "");
                    if (!n) return;
                    var t = 0, r = e, i;
                    while (i = this.parent(t++)) {
                        if (!(i instanceof Tn)) break;
                        if (i.expression !== r) break;
                        r = i;
                    }
                    if (ai(r, i)) {
                        o(e);
                        return;
                    }
                    return n;
                }));
            });
            e(vn, Un);
            e(An, function(e, n) {
                return this.expression._find_defs(e, "." + this.property + n);
            });
            e(Sr, function(e) {
                if (!this.definition().global) return;
                if (Qn(e.option("global_defs"), this.name)) o(this);
            });
            e(Nn, function(e, n) {
                if (!this.definition().global) return;
                var t = e.option("global_defs");
                var r = this.name + n;
                if (Qn(t, r)) return i(t[r], this);
            });
        })(function(e, n) {
            e.DEFMETHOD("_find_defs", n);
        });
        function le(e, n, t) {
            var r = n.print_to_string().length - e.print_to_string().length;
            return r < (t || 0) ? n : e;
        }
        function v(e, n, t) {
            return le(Ce(mn, e, {
                body: e
            }), Ce(mn, n, {
                body: n
            }), t).body;
        }
        function pe(e, n, t, r) {
            return (Zn(e) ? v : le)(n, t, r);
        }
        function s(n) {
            var t = Object.create(null);
            Object.keys(n).forEach(function(e) {
                t[e] = ln(n[e]);
            });
            return t;
        }
        function f(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof tt)) return t;
            }
        }
        function u() {
            if (this.value) return Ce(yn, this.value, {
                value: this.value
            });
            return f(this.body);
        }
        St.DEFMETHOD("first_statement", u);
        Tt.DEFMETHOD("first_statement", u);
        bn.DEFMETHOD("first_statement", function() {
            return f(this.body);
        });
        bn.DEFMETHOD("length", function() {
            var e = this.argnames;
            for (var n = 0; n < e.length; n++) {
                if (e[n] instanceof kn) break;
            }
            return n;
        });
        function de(e, n) {
            var t = n.evaluate(e);
            if (t === n) return n;
            t = fe(t, n).optimize(e);
            return pe(e, n, t, e.eval_threshold);
        }
        var n = [ "constructor", "toString", "valueOf" ];
        var b = s({
            Array: [ "indexOf", "join", "lastIndexOf", "slice" ].concat(n),
            Boolean: n,
            Function: n,
            Number: [ "toExponential", "toFixed", "toPrecision" ].concat(n),
            Object: n,
            RegExp: [ "exec", "test" ].concat(n),
            String: [ "charAt", "charCodeAt", "concat", "indexOf", "italics", "lastIndexOf", "match", "replace", "search", "slice", "split", "substr", "substring", "toLowerCase", "toUpperCase", "trim" ].concat(n)
        });
        var y = s({
            Array: [ "isArray" ],
            Math: [ "abs", "acos", "asin", "atan", "ceil", "cos", "exp", "floor", "log", "round", "sin", "sqrt", "tan", "atan2", "pow", "max", "min" ],
            Number: [ "isFinite", "isNaN" ],
            Object: [ "create", "getOwnPropertyDescriptor", "getOwnPropertyNames", "getPrototypeOf", "isExtensible", "isFrozen", "isSealed", "keys" ],
            String: [ "fromCharCode", "raw" ]
        });
        function Ve(e) {
            if (!(e instanceof An)) return false;
            var n = e.expression;
            if (!Pe(n)) return false;
            var t = y[n.name];
            return t && (t[e.property] || n.name == "Math" && e.property == "random");
        }
        (function(e) {
            e(vn, un);
            e(In, cn);
            e(Yr, un);
            var n = ln("! ~ - + void");
            e($n, function() {
                return n[this.operator] && this.expression instanceof In;
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant", n);
        });
        (function(e) {
            vn.DEFMETHOD("evaluate", function(e, n) {
                if (!e.option("evaluate")) return this;
                var t = [];
                var r = this._eval(e, n, t, 1);
                t.forEach(function(e) {
                    delete e._eval;
                });
                if (n) return r;
                if (!r || r instanceof RegExp) return r;
                if (typeof r == "function" || typeof r == "object") return this;
                return r;
            });
            var m = new Rn(function(e) {
                if (e instanceof Cn) u(e.left);
                if (e instanceof dt) u(e.init);
                if (e instanceof On && ei[e.operator]) u(e.expression);
            });
            function u(e) {
                if (e instanceof mr) {
                    e.elements.forEach(u);
                } else if (e instanceof gr) {
                    e.properties.forEach(function(e) {
                        u(e.value);
                    });
                } else if (e instanceof Tn) {
                    u(e.expression);
                } else if (e instanceof Nn) {
                    e.definition().references.forEach(function(e) {
                        delete e._eval;
                    });
                }
            }
            e(et, function() {
                throw new Error(Xn("Cannot evaluate a statement [{file}:{line},{col}]", this.start));
            });
            e(bt, Vn);
            e(Hr, Vn);
            e(Pt, Vn);
            e(vn, Vn);
            e(In, function() {
                return this.value;
            });
            e(Cn, function(e, n, t, r) {
                var i = this.left;
                if (!n) {
                    if (!(i instanceof Nn)) return this;
                    if (!Qn(i, "_eval")) {
                        if (!i.fixed) return this;
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                        if (a.single_use == "m") return this;
                    }
                }
                var o = this.operator;
                var s;
                if (!Qn(i, "_eval") && i instanceof Nn && i.fixed && i.definition().fixed) {
                    s = i;
                } else if (o == "=") {
                    s = this.right;
                } else {
                    s = Ce(zn, this, {
                        operator: o.slice(0, -1),
                        left: i,
                        right: this.right
                    });
                }
                i.walk(m);
                var f = s._eval(e, n, t, r);
                if (typeof f == "object") return this;
                u(i);
                return f;
            });
            e(Sn, function(e, n, t, r) {
                if (!n) return this;
                var i = this.expressions;
                for (var a = 0, o = i.length - 1; a < o; a++) {
                    i[a].walk(m);
                }
                var s = i[o];
                var f = s._eval(e, n, t, r);
                return f === s ? this : f;
            });
            e(bn, function(e) {
                if (e.option("unsafe")) {
                    var n = function() {};
                    n.node = this;
                    n.toString = function() {
                        return "function(){}";
                    };
                    return n;
                }
                return this;
            });
            e(Mn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = [];
                    for (var a = 0; a < this.elements.length; a++) {
                        var o = this.elements[a];
                        if (o instanceof Ur) return this;
                        var s = o._eval(e, n, t, r);
                        if (o === s) return this;
                        i.push(s);
                    }
                    return i;
                }
                return this;
            });
            e(Pn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i = {};
                    for (var a = 0; a < this.properties.length; a++) {
                        var o = this.properties[a];
                        if (!(o instanceof yr)) return this;
                        var s = o.key;
                        if (s instanceof vn) {
                            s = s._eval(e, n, t, r);
                            if (s === o.key) return this;
                        }
                        switch (s) {
                          case "__proto__":
                          case "toString":
                          case "valueOf":
                            return this;
                        }
                        i[s] = o.value._eval(e, n, t, r);
                        if (i[s] === o.value) return this;
                    }
                    return i;
                }
                return this;
            });
            var f = ln("! typeof void");
            e($n, function(e, n, t, r) {
                var i = this.expression;
                var a = this.operator;
                if (e.option("typeofs") && a == "typeof" && (i instanceof bn || i instanceof Nn && i.fixed_value() instanceof bn)) {
                    return typeof function() {};
                }
                var o = i instanceof Nn && i.definition();
                if (!f[a] && !(o && o.fixed)) r++;
                i.walk(m);
                var s = i._eval(e, n, t, r);
                if (s === i) {
                    if (n && a == "void") return;
                    return this;
                }
                switch (a) {
                  case "!":
                    return !s;

                  case "typeof":
                    if (s instanceof RegExp) return this;
                    return typeof s;

                  case "void":
                    return;

                  case "~":
                    return ~s;

                  case "-":
                    return -s;

                  case "+":
                    return +s;

                  case "++":
                  case "--":
                    if (!o) return this;
                    if (!n) {
                        if (o.undeclared) return this;
                        if (o.last_ref !== i) return this;
                    }
                    if (Qn(i, "_eval")) s = +(a[0] + 1) + +s;
                    u(i);
                    return s;
                }
                return this;
            });
            e(dr, function(e, n, t, r) {
                var i = this.expression;
                if (!(i instanceof Nn)) {
                    if (!n) return this;
                } else if (!Qn(i, "_eval")) {
                    if (!i.fixed) return this;
                    if (!n) {
                        var a = i.definition();
                        if (!a.fixed) return this;
                        if (a.undeclared) return this;
                        if (a.last_ref !== i) return this;
                    }
                }
                if (!(i instanceof Nn && i.definition().fixed)) r++;
                i.walk(m);
                var o = i._eval(e, n, t, r);
                if (o === i) return this;
                u(i);
                return +o;
            });
            var c = ln("&& || === !==");
            e(zn, function(e, n, t, r) {
                if (!c[this.operator]) r++;
                var i = this.left._eval(e, n, t, r);
                if (i === this.left) return this;
                if (this.operator == (i ? "||" : "&&")) return i;
                var a = n && !(i && typeof i == "object");
                var o = this.right._eval(e, a, t, r);
                if (o === this.right) return this;
                var s;
                switch (this.operator) {
                  case "&&":
                    s = i && o;
                    break;

                  case "||":
                    s = i || o;
                    break;

                  case "??":
                    s = i == null ? o : i;
                    break;

                  case "|":
                    s = i | o;
                    break;

                  case "&":
                    s = i & o;
                    break;

                  case "^":
                    s = i ^ o;
                    break;

                  case "+":
                    s = i + o;
                    break;

                  case "-":
                    s = i - o;
                    break;

                  case "*":
                    s = i * o;
                    break;

                  case "/":
                    s = i / o;
                    break;

                  case "%":
                    s = i % o;
                    break;

                  case "<<":
                    s = i << o;
                    break;

                  case ">>":
                    s = i >> o;
                    break;

                  case ">>>":
                    s = i >>> o;
                    break;

                  case "==":
                    s = i == o;
                    break;

                  case "===":
                    s = i === o;
                    break;

                  case "!=":
                    s = i != o;
                    break;

                  case "!==":
                    s = i !== o;
                    break;

                  case "<":
                    s = i < o;
                    break;

                  case "<=":
                    s = i <= o;
                    break;

                  case ">":
                    s = i > o;
                    break;

                  case ">=":
                    s = i >= o;
                    break;

                  case "**":
                    s = Math.pow(i, o);
                    break;

                  case "in":
                    if (o && typeof o == "object" && Qn(o, i)) {
                        s = true;
                        break;
                    }

                  default:
                    return this;
                }
                if (isNaN(s)) return e.find_parent(mt) ? this : s;
                if (e.option("unsafe_math") && !n && s && typeof s == "number" && (this.operator == "+" || this.operator == "-")) {
                    var f = Math.max(0, u(i), u(o));
                    if (f < 16) return +s.toFixed(f);
                }
                return s;
                function u(e) {
                    var n = /(\.[0-9]*)?(e[^e]+)?$/.exec(+e);
                    return (n[1] || ".").length - 1 - (n[2] || "").slice(1);
                }
            });
            e(qn, function(e, n, t, r) {
                var i = this.condition._eval(e, n, t, r);
                if (i === this.condition) return this;
                var a = i ? this.consequent : this.alternative;
                var o = a._eval(e, n, t, r);
                return o === a ? this : o;
            });
            function o(n, e) {
                var t = n.definition().escaped;
                switch (t.length) {
                  case 0:
                    return true;

                  case 1:
                    var r = false;
                    t[0].walk(new Rn(function(e) {
                        if (r) return true;
                        if (e === n) return r = true;
                        if (e instanceof gn) return true;
                    }));
                    return r;

                  default:
                    return e <= t.depth;
                }
            }
            e(Nn, function(e, n, t, r) {
                var i = this.fixed_value();
                if (!i) return this;
                var a;
                if (Qn(i, "_eval")) {
                    a = i._eval();
                } else {
                    this._eval = Vn;
                    a = i._eval(e, n, t, r);
                    delete this._eval;
                    if (a === i) return this;
                    i._eval = function() {
                        return a;
                    };
                    t.push(i);
                }
                return a && typeof a == "object" && !o(this, r) ? this : a;
            });
            var _ = {
                Array: Array,
                Math: Math,
                Number: Number,
                Object: Object,
                String: String
            };
            var l = s({
                Math: [ "E", "LN10", "LN2", "LOG2E", "LOG10E", "PI", "SQRT1_2", "SQRT2" ],
                Number: [ "MAX_VALUE", "MIN_VALUE", "NaN", "NEGATIVE_INFINITY", "POSITIVE_INFINITY" ]
            });
            var p = ln("global ignoreCase multiline source");
            e(Tn, function(e, n, t, r) {
                if (e.option("unsafe")) {
                    var i;
                    var a = this.expression;
                    if (!Pe(a)) {
                        i = a._eval(e, n, t, r + 1);
                        if (i == null || i === a) return this;
                    }
                    var o = this.property;
                    if (o instanceof vn) {
                        o = o._eval(e, n, t, r);
                        if (o === this.property) return this;
                    }
                    if (i === undefined) {
                        var s = l[a.name];
                        if (!s || !s[o]) return this;
                        i = _[a.name];
                    } else if (i instanceof RegExp) {
                        if (!p[o]) return this;
                    } else if (typeof i == "object") {
                        if (!Qn(i, o)) return this;
                    } else if (typeof i == "function") switch (o) {
                      case "name":
                        return i.node.name ? i.node.name.name : "";

                      case "length":
                        return i.node.length();

                      default:
                        return this;
                    }
                    return i[o];
                }
                return this;
            });
            function g(e, n, t, r, i) {
                var a = [];
                for (var o = 0; o < e.length; o++) {
                    var s = e[o];
                    var f = s._eval(n, t, r, i);
                    if (s === f) return;
                    a.push(f);
                }
                return a;
            }
            e(En, function(r, i, a, o) {
                var e = this.expression;
                var n = e instanceof Nn ? e.fixed_value() : e;
                if (n instanceof St || n instanceof Mt || n instanceof Ot) {
                    if (n.evaluating) return this;
                    if (n.name && n.name.definition().recursive_refs > 0) return this;
                    if (this.is_expr_pure(r)) return this;
                    var s = g(this.args, r, i, a, o);
                    if (!pn(n.argnames, function(e, n) {
                        if (e instanceof kn) {
                            if (!s) return false;
                            if (s[n] === undefined) {
                                var t = e.value._eval(r, i, a, o);
                                if (t === e.value) return false;
                                s[n] = t;
                            }
                            e = e.name;
                        }
                        return !(e instanceof Fn);
                    })) return this;
                    if (n.rest instanceof Fn) return this;
                    if (!s && !i) return this;
                    var t = n.first_statement();
                    if (!(t instanceof yn)) {
                        if (i) {
                            n.walk(m);
                            var f = false;
                            n.evaluating = true;
                            at(n, new Rn(function(e) {
                                if (f) return true;
                                if (e instanceof yn) {
                                    if (e.value && e.value._eval(r, true, a, o) !== undefined) {
                                        f = true;
                                    }
                                    return true;
                                }
                                if (e instanceof gn && e !== n) return true;
                            }));
                            n.evaluating = false;
                            if (!f) return;
                        }
                        return this;
                    }
                    var u = t.value;
                    if (!u) return;
                    var c = [];
                    if (!s || pn(n.argnames, function(e, n) {
                        return h(e, s[n]);
                    }) && !(n.rest && !h(n.rest, s.slice(n.argnames.length))) || i) {
                        if (i) n.argnames.forEach(function(e) {
                            if (e instanceof kn) e.value.walk(m);
                        });
                        n.evaluating = true;
                        u = u._eval(r, i, a, o);
                        n.evaluating = false;
                    }
                    c.forEach(function(e) {
                        delete e._eval;
                    });
                    return u === t.value ? this : u;
                } else if (r.option("unsafe") && e instanceof Tn) {
                    var l = e.property;
                    if (l instanceof vn) {
                        l = l._eval(r, i, a, o);
                        if (l === e.property) return this;
                    }
                    var u;
                    var p = e.expression;
                    if (Pe(p)) {
                        var d = y[p.name];
                        if (!d || !d[l]) return this;
                        u = _[p.name];
                    } else {
                        u = p._eval(r, i, a, o + 1);
                        if (u == null || u === p) return this;
                        var v = b[u.constructor.name];
                        if (!v || !v[l]) return this;
                        if (u instanceof RegExp && u.global && !(p instanceof Yr)) return this;
                    }
                    var s = g(this.args, r, i, a, o);
                    if (!s) return this;
                    if (l == "replace" && typeof s[1] == "function") return this;
                    try {
                        return u[l].apply(u, s);
                    } catch (e) {
                        vn.warn("Error evaluating {code} [{file}:{line},{col}]", {
                            code: this,
                            file: this.start.file,
                            line: this.start.line,
                            col: this.start.col
                        });
                    } finally {
                        if (u instanceof RegExp) u.lastIndex = 0;
                    }
                }
                return this;
                function h(e, n) {
                    if (e instanceof kn) e = e.name;
                    var t = e.definition();
                    if (t.orig[t.orig.length - 1] !== e) return false;
                    var r = n;
                    t.references.forEach(function(e) {
                        e._eval = function() {
                            return r;
                        };
                        c.push(e);
                    });
                    return true;
                }
            });
            e(cr, Vn);
            e(Ir, function(e, n, t, r) {
                if (!e.option("templates")) return this;
                if (this.tag) {
                    if (!Ke(e, this.tag)) return this;
                    f = function(e) {
                        return e;
                    };
                }
                var i = g(this.expressions, e, n, t, r);
                if (!i) return this;
                var a = false;
                var o = f(this.strings[0]);
                for (var s = 0; s < i.length; s++) {
                    o += i[s] + f(this.strings[s + 1]);
                }
                if (!a) return o;
                this._eval = Vn;
                return this;
                function f(e) {
                    e = Qe(e);
                    if (typeof e != "string") a = true;
                    return e;
                }
            });
        })(function(e, n) {
            e.DEFMETHOD("_eval", n);
        });
        (function(e) {
            function a(e) {
                return Ce($n, e, {
                    operator: "!",
                    expression: e
                });
            }
            function i(e, n, t) {
                var r = a(e);
                if (t) {
                    var i = Ce(mn, n, {
                        body: n
                    });
                    return le(r, i) === i ? n : r;
                }
                return le(r, n);
            }
            e(vn, function() {
                return a(this);
            });
            e(et, function() {
                throw new Error("Cannot negate a statement");
            });
            e(zn, function(e, n) {
                var t = this.clone(), r = this.operator;
                if (e.option("unsafe_comps")) {
                    switch (r) {
                      case "<=":
                        t.operator = ">";
                        return t;

                      case "<":
                        t.operator = ">=";
                        return t;

                      case ">=":
                        t.operator = "<";
                        return t;

                      case ">":
                        t.operator = "<=";
                        return t;
                    }
                }
                switch (r) {
                  case "==":
                    t.operator = "!=";
                    return t;

                  case "!=":
                    t.operator = "==";
                    return t;

                  case "===":
                    t.operator = "!==";
                    return t;

                  case "!==":
                    t.operator = "===";
                    return t;

                  case "&&":
                    t.operator = "||";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);

                  case "||":
                    t.operator = "&&";
                    t.left = t.left.negate(e, n);
                    t.right = t.right.negate(e);
                    return i(this, t, n);
                }
                return a(this);
            });
            e(Nt, function() {
                return a(this);
            });
            e(qn, function(e, n) {
                var t = this.clone();
                t.consequent = t.consequent.negate(e);
                t.alternative = t.alternative.negate(e);
                return i(this, t, n);
            });
            e(yt, function() {
                return a(this);
            });
            e(Sn, function(e) {
                var n = this.expressions.slice();
                n.push(n.pop().negate(e));
                return Me(this, n);
            });
            e($n, function() {
                if (this.operator == "!") return this.expression;
                return a(this);
            });
        })(function(e, t) {
            e.DEFMETHOD("negate", function(e, n) {
                return t.call(this, e, n);
            });
        });
        var p = ln("Boolean decodeURI decodeURIComponent Date encodeURI encodeURIComponent Error escape EvalError isFinite isNaN Number Object parseFloat parseInt RangeError ReferenceError String SyntaxError TypeError unescape URIError");
        var d = ln("Map Set WeakMap WeakSet");
        En.DEFMETHOD("is_expr_pure", function(e) {
            if (e.option("unsafe")) {
                var n = this.expression;
                if (Pe(n)) {
                    if (p[n.name]) return true;
                    if (this instanceof cr && d[n.name]) return true;
                }
                if (Ve(n)) return true;
            }
            return e.option("annotations") && this.pure || !e.pure_funcs(this);
        });
        Ir.DEFMETHOD("is_expr_pure", function(e) {
            var n = this.tag;
            if (!n) return true;
            if (e.option("unsafe")) {
                if (Pe(n) && p[n.name]) return true;
                if (n instanceof An && Pe(n.expression)) {
                    var t = y[n.expression.name];
                    return t && (t[n.property] || n.expression.name == "Math" && n.property == "random");
                }
            }
            return !e.pure_funcs(this);
        });
        vn.DEFMETHOD("is_call_pure", un);
        En.DEFMETHOD("is_call_pure", function(e) {
            if (!e.option("unsafe")) return false;
            var n = this.expression;
            if (!(n instanceof An)) return false;
            var t = n.expression;
            var r;
            var i = n.property;
            if (t instanceof Mn) {
                r = b.Array;
            } else if (t.is_boolean(e)) {
                r = b.Boolean;
            } else if (t.is_number(e)) {
                r = b.Number;
            } else if (t instanceof Yr) {
                r = b.RegExp;
            } else if (t.is_string(e)) {
                r = b.String;
                if (i == "replace") {
                    var a = this.args[1];
                    if (a && !a.is_string(e)) return false;
                }
            } else if (!n.may_throw_on_access(e)) {
                r = b.Object;
            }
            return r && r[i];
        });
        (function(e) {
            e(vn, un);
            e(Mn, cn);
            e(Cn, function() {
                switch (this.operator) {
                  case "=":
                    return this.right.safe_to_spread();

                  case "&&=":
                  case "||=":
                  case "??=":
                    return this.left.safe_to_spread() && this.right.safe_to_spread();
                }
                return true;
            });
            e(zn, function() {
                return !Ne[this.operator] || this.left.safe_to_spread() && this.right.safe_to_spread();
            });
            e(In, cn);
            e(bn, cn);
            e(Pn, function() {
                return pn(this.properties, function(e) {
                    return !(e instanceof kr || e instanceof Dn);
                });
            });
            e(Sn, function() {
                return this.tail_node().safe_to_spread();
            });
            e(Nn, function() {
                var e = this.fixed_value();
                return e && e.safe_to_spread();
            });
            e(On, cn);
        })(function(e, n) {
            e.DEFMETHOD("safe_to_spread", n);
        });
        (function(e) {
            function t(e, n, t) {
                return !pn(e, t ? function(e) {
                    return e instanceof Dn ? !t(e, n) : !e.has_side_effects(n);
                } : function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function n(e, n) {
                var t = e.expression;
                return !t.is_string(n) || t.has_side_effects(n);
            }
            e(vn, cn);
            e(Mn, function(e) {
                return t(this.elements, e, n);
            });
            e(Cn, function(e) {
                var n = this.left;
                if (!(n instanceof Tn)) return true;
                var t = n.expression;
                return !(t instanceof Fr) || !t.scope.resolve().new || n instanceof pr && n.property.has_side_effects(e) || this.right.has_side_effects(e);
            });
            e(zn, function(e) {
                return this.left.has_side_effects(e) || this.right.has_side_effects(e) || !We(this.operator, this.right, e);
            });
            e(ot, function(e) {
                return t(this.body, e);
            });
            e(En, function(e) {
                if (!this.is_expr_pure(e) && (!this.is_call_pure(e) || this.expression.has_side_effects(e))) {
                    return true;
                }
                return t(this.args, e, n);
            });
            e(Qt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Pt, function(e) {
                var n = this.extends;
                if (n) {
                    if (n instanceof Nn) n = n.fixed_value();
                    if (!He(n)) return true;
                }
                return t(this.properties, e);
            });
            e(It, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.static && this.value && this.value.has_side_effects(e);
            });
            e(qn, function(e) {
                return this.condition.has_side_effects(e) || this.consequent.has_side_effects(e) || this.alternative.has_side_effects(e);
            });
            e(In, un);
            e(tr, function(e) {
                return t(this.definitions, e);
            });
            e(mr, function(e) {
                return t(this.elements, e);
            });
            e(_r, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(gr, function(e) {
                return t(this.properties, e);
            });
            e(An, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e);
            });
            e(hn, un);
            e(wn, function(e) {
                return this.condition.has_side_effects(e) || this.body && this.body.has_side_effects(e) || this.alternative && this.alternative.has_side_effects(e);
            });
            e(st, function(e) {
                return this.body.has_side_effects(e);
            });
            e(bn, un);
            e(Pn, function(e) {
                return t(this.properties, e, function(e, n) {
                    var t = e.expression;
                    return !t.safe_to_spread() || t.has_side_effects(n);
                });
            });
            e(Fr, un);
            e(br, function(e) {
                return this.key instanceof vn && this.key.has_side_effects(e) || this.value.has_side_effects(e);
            });
            e(Sn, function(e) {
                return t(this.expressions, e);
            });
            e(mn, function(e) {
                return this.body.has_side_effects(e);
            });
            e(pr, function(e) {
                return this.expression.may_throw_on_access(e) || this.expression.has_side_effects(e) || this.property.has_side_effects(e);
            });
            e(Jt, function(e) {
                return this.expression.has_side_effects(e) || t(this.body, e);
            });
            e(Sr, un);
            e(Nn, function(e) {
                return !this.is_declared(e) || !ze(this, e);
            });
            e(Ir, function(e) {
                return !this.is_expr_pure(e) || t(this.expressions, e);
            });
            e(Zt, function(e) {
                return t(this.body, e) || this.bcatch && this.bcatch.has_side_effects(e) || this.bfinally && this.bfinally.has_side_effects(e);
            });
            e(On, function(e) {
                return ii[this.operator] || this.expression.has_side_effects(e);
            });
            e(xn, function() {
                return this.value;
            });
        })(function(e, n) {
            e.DEFMETHOD("has_side_effects", n);
        });
        (function(e) {
            e(vn, cn);
            e(In, un);
            e(hn, un);
            e(bn, un);
            e(Fr, un);
            e(Sr, un);
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (e[t].may_throw(n)) return true;
                return false;
            }
            function r(e, n) {
                if (e.may_throw(n)) return true;
                if (e instanceof Nn) e = e.fixed_value();
                if (!(e instanceof bn)) return true;
                if (t(e.argnames, n)) return true;
                if (t(e.body, n)) return true;
                return wt(e) && e.value && e.value.may_throw(n);
            }
            e(Mn, function(e) {
                return t(this.elements, e);
            });
            e(Cn, function(e) {
                if (this.right.may_throw(e)) return true;
                if (!e.has_directive("use strict") && this.operator == "=" && this.left instanceof Nn) {
                    return false;
                }
                return this.left.may_throw(e);
            });
            e(vr, function(e) {
                return this.expression.may_throw(e);
            });
            e(zn, function(e) {
                return this.left.may_throw(e) || this.right.may_throw(e) || !We(this.operator, this.right, e);
            });
            e(ot, function(e) {
                return t(this.body, e);
            });
            e(En, function(e) {
                if (t(this.args, e)) return true;
                if (this.is_expr_pure(e)) return false;
                this.may_throw = cn;
                var n = r(this.expression, e);
                delete this.may_throw;
                return n;
            });
            e(Qt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(qn, function(e) {
                return this.condition.may_throw(e) || this.consequent.may_throw(e) || this.alternative.may_throw(e);
            });
            e(kn, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
            e(tr, function(e) {
                return t(this.definitions, e);
            });
            e(An, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e);
            });
            e(dt, function(e) {
                if (this.init.may_throw(e)) return true;
                var n = this.object;
                if (n.may_throw(e)) return true;
                n = n.tail_node();
                if (!(n instanceof Mn || n.is_string(e))) return true;
                return this.body.may_throw(e);
            });
            e(wn, function(e) {
                return this.condition.may_throw(e) || this.body && this.body.may_throw(e) || this.alternative && this.alternative.may_throw(e);
            });
            e(st, function(e) {
                return this.body.may_throw(e);
            });
            e(Pn, function(e) {
                return t(this.properties, e);
            });
            e(br, function(e) {
                return this.value.may_throw(e) || this.key instanceof vn && this.key.may_throw(e);
            });
            e(yn, function(e) {
                return this.value && this.value.may_throw(e);
            });
            e(Sn, function(e) {
                return t(this.expressions, e);
            });
            e(mn, function(e) {
                return this.body.may_throw(e);
            });
            e(pr, function(e) {
                return !this.optional && this.expression.may_throw_on_access(e) || this.expression.may_throw(e) || this.property.may_throw(e);
            });
            e(Jt, function(e) {
                return this.expression.may_throw(e) || t(this.body, e);
            });
            e(Nn, function(e) {
                return !this.is_declared(e) || !ze(this, e);
            });
            e(Ir, function(e) {
                if (t(this.expressions, e)) return true;
                if (this.is_expr_pure(e)) return false;
                if (!this.tag) return false;
                this.may_throw = cn;
                var n = r(this.tag, e);
                delete this.may_throw;
                return n;
            });
            e(Zt, function(e) {
                return (this.bcatch ? this.bcatch.may_throw(e) : t(this.body, e)) || this.bfinally && this.bfinally.may_throw(e);
            });
            e(On, function(e) {
                return this.expression.may_throw(e) && !(this.operator == "typeof" && this.expression instanceof Nn);
            });
            e(xn, function(e) {
                return this.name.may_throw(e) || this.value && this.value.may_throw(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("may_throw", n);
        });
        (function(e) {
            function t(e, n) {
                for (var t = e.length; --t >= 0; ) if (!e[t].is_constant_expression(n)) return false;
                return true;
            }
            e(vn, un);
            e(Mn, function(e) {
                return t(this.elements, e);
            });
            e(zn, function(e) {
                return this.left.is_constant_expression(e) && this.right.is_constant_expression(e) && We(this.operator, this.right);
            });
            e(Pt, function(e) {
                var n = this.extends;
                if (n && !He(n)) return false;
                return t(this.properties, e);
            });
            e(It, function(e) {
                return typeof this.key == "string" && (!this.value || this.value.is_constant_expression(e));
            });
            e(In, cn);
            e(bn, function(i) {
                var a = this;
                var o = true;
                var s = [];
                a.walk(new Rn(function(e, n) {
                    if (!o) return true;
                    if (e instanceof it) {
                        if (e === a) return;
                        s.push(e);
                        n();
                        s.pop();
                        return true;
                    }
                    if (e instanceof Nn) {
                        if (a.inlined || e.redef) {
                            o = false;
                            return true;
                        }
                        if (a.variables.has(e.name)) return true;
                        var t = e.definition();
                        if (Bn(t.scope, s)) return true;
                        if (i && !t.redefined()) {
                            var r = i.find_variable(e.name);
                            if (r ? r === t : t.undeclared) {
                                o = "f";
                                return true;
                            }
                        }
                        o = false;
                        return true;
                    }
                    if (e instanceof Fr) {
                        if (wt(a) && pn(s, function(e) {
                            return !(e instanceof gn) || wt(e);
                        })) o = false;
                        return true;
                    }
                }));
                return o;
            });
            e(Pn, function(e) {
                return t(this.properties, e);
            });
            e(br, function(e) {
                return typeof this.key == "string" && this.value.is_constant_expression(e);
            });
            e(On, function(e) {
                return this.expression.is_constant_expression(e);
            });
        })(function(e, n) {
            e.DEFMETHOD("is_constant_expression", n);
        });
        function j(e) {
            return e && e.aborts();
        }
        (function(e) {
            e(et, Wn);
            e(Bt, Vn);
            function n() {
                var e = this.body.length;
                return e > 0 && j(this.body[e - 1]);
            }
            e(_n, n);
            e(Xt, n);
            e(wn, function() {
                return this.alternative && j(this.body) && j(this.alternative) && this;
            });
        })(function(e, n) {
            e.DEFMETHOD("aborts", n);
        });
        var h = ln([ "use asm", "use strict" ]);
        e(tt, function(e, n) {
            if (n.option("directives") && (!h[e.value] || n.has_directive(e.value) !== e)) {
                return Ce(hn, e);
            }
            return e;
        });
        e(nt, function(e, n) {
            if (n.option("drop_debugger")) return Ce(hn, e);
            return e;
        });
        e(st, function(e, n) {
            if (n.option("dead_code") && e.body instanceof Wt && n.loopcontrol_target(e.body) === e.body) {
                return Ce(hn, e);
            }
            return n.option("unused") && e.label.references.length == 0 ? e.body : e;
        });
        e(Vt, function(e, n) {
            if (!n.option("dead_code")) return e;
            var t = e.label;
            if (t) {
                var r = n.loopcontrol_target(e);
                e.label = null;
                if (n.loopcontrol_target(e) === r) {
                    Kn(t.thedef.references, e);
                } else {
                    e.label = t;
                }
            }
            return e;
        });
        e(ot, function(e, n) {
            e.body = c(e.body, n);
            return e;
        });
        function O(e, n, t) {
            switch (e.body.length) {
              case 0:
                return t ? Gn.skip : Ce(hn, e);

              case 1:
                var r = e.body[0];
                if (!A(r)) return e;
                if (n instanceof ft && r instanceof zt) return e;
                return r;
            }
            return e;
        }
        e(_n, function(e, n) {
            e.body = c(e.body, n);
            return O(e, n.parent());
        });
        function m(e, n) {
            if (!n.option("rests")) return;
            if (e.uses_arguments) return;
            if (!(e.rest instanceof mr)) return;
            if (!n.drop_fargs(e, n.parent())) return;
            e.argnames = e.argnames.concat(e.rest.elements);
            e.rest = e.rest.rest;
        }
        e(bn, function(e, n) {
            m(e, n);
            e.body = c(e.body, n);
            return e;
        });
        function g(e, n) {
            if (!n.option("arrows")) return e;
            m(e, n);
            var t = c(e.value ? [ e.first_statement() ] : e.body, n);
            switch (t.length) {
              case 1:
                var r = t[0];
                if (r instanceof yn) {
                    e.body.length = 0;
                    e.value = r.value;
                    break;
                }

              default:
                e.body = t;
                e.value = null;
                break;
            }
            return e;
        }
        e(St, g);
        e(Tt, g);
        e(Ot, function(n, e) {
            m(n, e);
            n.body = c(n.body, e);
            var t = e.parent();
            if (e.option("inline")) for (var r = 0; r < n.body.length; r++) {
                var i = n.body[r];
                if (i instanceof tt) continue;
                if (i instanceof yn) {
                    if (r != n.body.length - 1) break;
                    var a = i.value;
                    if (!a || a.TYPE != "Call") break;
                    if (a.is_expr_pure(e)) break;
                    var o = a.expression;
                    if (o instanceof Nn) {
                        if (n.name && n.name.definition() === o.definition()) break;
                        o = o.fixed_value();
                    }
                    if (!(o instanceof Mt || o instanceof Ot)) break;
                    if (o.rest) break;
                    if (o.uses_arguments) break;
                    if (o === a.expression) {
                        if (o.parent_scope !== n) break;
                        if (!pn(o.enclosed, function(e) {
                            return e.scope !== n;
                        })) break;
                    }
                    if (o.name && (t instanceof Yt || t instanceof wr) && t.value === e.self()) break;
                    if (o.contains_this()) break;
                    var s = o.argnames.length;
                    if (s > 0 && e.option("inline") < 2) break;
                    if (s > n.argnames.length) break;
                    if (!pn(n.argnames, function(e) {
                        return e instanceof jn;
                    })) break;
                    if (!pn(a.args, function(e) {
                        return !(e instanceof Dn);
                    })) break;
                    for (var f = 0; f < s; f++) {
                        var u = a.args[f];
                        if (!(u instanceof Nn)) break;
                        if (u.definition() !== n.argnames[f].definition()) break;
                    }
                    if (f < s) break;
                    for (;f < a.args.length; f++) {
                        if (a.args[f].has_side_effects(e)) break;
                    }
                    if (f < a.args.length) break;
                    if (s < n.argnames.length && !e.drop_fargs(n, t)) {
                        if (!e.drop_fargs(o, a)) break;
                        do {
                            o.argnames.push(o.make_var(jn, o, "argument_" + s));
                        } while (++s < n.argnames.length);
                    }
                    return a.expression;
                }
                break;
            }
            return n;
        });
        var R = ln("arguments await yield");
        gn.DEFMETHOD("merge_variables", function(d) {
            if (!d.option("merge_vars")) return;
            var v = [], h, m, _ = {}, g = this;
            var o = [], s = [], f = 0;
            var b = new dn();
            var y = Object.create(null);
            var u = Object.create(null);
            var w = new Rn(function(t, e) {
                if (t instanceof Cn) {
                    var n = t.left;
                    var r = t.right;
                    if (n instanceof Fn) {
                        r.walk(w);
                        E(Nn, S, n);
                        return true;
                    }
                    if (Ne[t.operator.slice(0, -1)]) {
                        n.walk(w);
                        x();
                        r.walk(w);
                        if (n instanceof Nn) S(n);
                        k();
                        return true;
                    }
                    if (n instanceof Nn) {
                        if (t.operator != "=") S(n, true);
                        r.walk(w);
                        S(n);
                        return true;
                    }
                    return;
                }
                if (t instanceof zn) {
                    if (!Ne[t.operator]) return;
                    p(t);
                    return true;
                }
                if (t instanceof Wt) {
                    var i = w.loopcontrol_target(t);
                    if (!(i instanceof ft)) T(i);
                    return true;
                }
                if (t instanceof En) {
                    var a = t.expression;
                    if (a instanceof yt) {
                        t.args.forEach(function(e) {
                            e.walk(w);
                        });
                        a.walk(w);
                    } else {
                        e();
                        l(a);
                    }
                    return true;
                }
                if (t instanceof Pt) {
                    if (t.name) t.name.walk(w);
                    if (t.extends) t.extends.walk(w);
                    t.properties.filter(function(e) {
                        if (e.key instanceof vn) e.key.walk(w);
                        return e.value;
                    }).forEach(function(e) {
                        if (e.static) {
                            e.value.walk(w);
                        } else {
                            x();
                            _.block = t;
                            e.value.walk(w);
                            k();
                        }
                    });
                    return true;
                }
                if (t instanceof qn) {
                    p(t.condition, t.consequent, t.alternative);
                    return true;
                }
                if (t instanceof Gt) {
                    var i = w.loopcontrol_target(t);
                    if (i instanceof ct) T(i);
                    return true;
                }
                if (t instanceof ct) {
                    x();
                    _.block = t;
                    _.loop = true;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    t.condition.walk(w);
                    k();
                    return true;
                }
                if (t instanceof pt) {
                    if (t.init) t.init.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    if (t.condition) t.condition.walk(w);
                    t.body.walk(w);
                    if (t.step) t.step.walk(w);
                    k();
                    return true;
                }
                if (t instanceof dt) {
                    t.object.walk(w);
                    x();
                    _.block = t;
                    _.loop = true;
                    t.init.walk(w);
                    t.body.walk(w);
                    k();
                    return true;
                }
                if (t instanceof wn) {
                    p(t.condition, t.body, t.alternative);
                    return true;
                }
                if (t instanceof st) {
                    x();
                    _.block = t;
                    var o = _;
                    t.body.walk(w);
                    if (_.inserted === t) _ = o;
                    k();
                    return true;
                }
                if (t instanceof gn) {
                    x();
                    _.block = t;
                    if (t === g) m = _;
                    if (t instanceof bn) {
                        if (t.name) y[t.name.definition().id] = false;
                        var s = t.uses_arguments && !w.has_directive("use strict") ? function(e) {
                            y[e.definition().id] = false;
                        } : function(e) {
                            S(e);
                        };
                        v.push(t);
                        t.argnames.forEach(function(e) {
                            E(jn, s, e);
                        });
                        if (t.rest) E(jn, s, t.rest);
                        v.pop();
                    }
                    Et(t, w);
                    k();
                    return true;
                }
                if (t instanceof pr) {
                    var a = t.expression;
                    if (t.optional) {
                        a.walk(w);
                        x();
                        t.property.walk(w);
                        k();
                    } else {
                        e();
                    }
                    l(a);
                    return true;
                }
                if (t instanceof Jt) {
                    t.expression.walk(w);
                    var o = _;
                    t.body.forEach(function(e) {
                        if (e instanceof Kt) return;
                        e.expression.walk(w);
                        if (o === _) x();
                    });
                    _ = o;
                    t.body.forEach(function(e) {
                        x();
                        _.block = t;
                        var n = _;
                        at(e, w);
                        if (_.inserted === t) _ = n;
                        k();
                    });
                    return true;
                }
                if (t instanceof Tr || t instanceof Dr) {
                    y[t.definition().id] = false;
                    return true;
                }
                if (t instanceof Nn) {
                    S(t, true);
                    return true;
                }
                if (t instanceof Zt) {
                    var f = h;
                    h = t;
                    at(t, w);
                    if (t.bcatch) {
                        if (t.bcatch.argname) t.bcatch.argname.mark_symbol(function(e) {
                            if (e instanceof Cr) {
                                var n = e.definition();
                                y[n.id] = false;
                                if (n = n.redefined()) y[n.id] = false;
                            }
                        }, w);
                        if (t.bfinally || (h = f)) {
                            at(t.bcatch, w);
                        } else {
                            x();
                            at(t.bcatch, w);
                            k();
                        }
                    }
                    h = f;
                    if (t.bfinally) t.bfinally.walk(w);
                    return true;
                }
                if (t instanceof On) {
                    if (!ei[t.operator]) return;
                    var u = t.expression;
                    if (!(u instanceof Nn)) return;
                    S(u, true);
                    return true;
                }
                if (t instanceof xn) {
                    var c = t.value;
                    if (c) {
                        c.walk(w);
                    } else {
                        c = _.block instanceof dt && _.block.init === w.parent();
                    }
                    t.name.mark_symbol(c ? function(e) {
                        if (!(e instanceof Sr)) return;
                        if (e instanceof Or) {
                            S(e);
                        } else {
                            y[e.definition().id] = false;
                        }
                        return true;
                    } : function(e) {
                        if (!(e instanceof Sr)) return;
                        var n = e.definition().id;
                        if (!(e instanceof Or)) {
                            y[n] = false;
                        } else if (!(n in y)) {
                            b.add(n, e);
                        } else if (y[n]) {
                            y[n].push(e);
                        }
                        return true;
                    }, w);
                    return true;
                }
                if (t instanceof lt) {
                    x();
                    _.block = t;
                    _.loop = true;
                    e();
                    k();
                    return true;
                }
                function l(e) {
                    if (!d.option("ie")) return;
                    var n = lr(e);
                    if (n instanceof Nn) n.walk(w);
                }
                function p(e, n, t) {
                    var r = _;
                    var i = [ r, r ];
                    if (e instanceof zn) switch (e.operator) {
                      case "&&":
                        i[0] = p(e.left, e.right)[0];
                        break;

                      case "||":
                      case "??":
                        i[1] = p(e.left, null, e.right)[1];
                        break;

                      default:
                        e.walk(w);
                        break;
                    } else if (e instanceof qn) {
                        p(e.condition, e.consequent, e.alternative);
                    } else {
                        e.walk(w);
                    }
                    _ = i[0];
                    if (n) {
                        x();
                        n.walk(w);
                    }
                    i[0] = _;
                    _ = i[1];
                    if (t) {
                        x();
                        t.walk(w);
                    }
                    i[1] = _;
                    _ = r;
                    return i;
                }
            });
            w.directives = Object.create(d.directives);
            g.walk(w);
            var e = false;
            var n = Object.create(null);
            while (o.length && s.length) {
                var t = s.shift();
                if (!t) continue;
                var r = t.definition;
                var i = y[r.id];
                if (!i) continue;
                i = {
                    end: i.end
                };
                while (r.id in n) r = n[r.id];
                i.start = y[r.id].start;
                var a = [];
                do {
                    var c = o.shift();
                    if (t.index > c.index) continue;
                    var l = c.definition.id;
                    if (!(l in u)) continue;
                    var p = y[l];
                    if (!p) continue;
                    if (p.start.block !== i.start.block || !D(p, i) || (p.start.loop || !Ie(r)) && !D(i, p) || d.option("webkit") && ri(r) !== ri(c.definition) || c.definition.const_redefs || !pn(p, function(e) {
                        return e.scope.find_variable(r.name) === r;
                    })) {
                        a.push(c);
                        continue;
                    }
                    p.forEach(function(e) {
                        e.thedef = r;
                        e.name = r.name;
                        if (e instanceof Nn) {
                            r.references.push(e);
                        } else {
                            r.orig.push(e);
                        }
                    });
                    if (!c.definition.fixed) r.fixed = false;
                    n[l] = r;
                    e = true;
                    break;
                } while (o.length);
                if (a.length) o = a.concat(o);
            }
            return e;
            function x() {
                _ = Object.create(_);
            }
            function k() {
                _ = Object.getPrototypeOf(_);
            }
            function E(n, t, e) {
                var r = new Rn(function(e) {
                    if (e instanceof Fn) return;
                    if (e instanceof kn) {
                        x();
                        e.value.walk(w);
                        k();
                        e.name.walk(r);
                    } else if (e instanceof _r) {
                        if (e.key instanceof vn) {
                            x();
                            _.block = e;
                            e.key.walk(w);
                            e.value.walk(r);
                            k();
                        } else {
                            e.value.walk(r);
                        }
                    } else if (e instanceof n) {
                        t(e);
                    } else {
                        e.walk(w);
                    }
                    return true;
                });
                e.walk(r);
            }
            function S(n, e) {
                var t = n.definition(), r;
                if (e && !pn(v, function(e) {
                    r = e.variables.get(n.name);
                    if (!r) return true;
                    if (!ri(r)) return true;
                    return r !== t && !t.undeclared && e.parent_scope.find_variable(n.name) !== t;
                })) return y[t.id] = y[r.id] = false;
                var i = _;
                if (h) {
                    x();
                    i = _;
                    k();
                }
                if (t.id in y) {
                    var a = y[t.id];
                    if (!a) return;
                    if (a.start.block !== i.block) return y[t.id] = false;
                    a.push(n);
                    a.end = i;
                    if (t.id in u) {
                        s[u[t.id]] = null;
                    } else if (!e) {
                        return;
                    }
                } else if ((r = g.variables.get(t.name)) !== t) {
                    if (r && m === i) y[r.id] = false;
                    return y[t.id] = false;
                } else if (d.exposed(t) || R[n.name]) {
                    return y[t.id] = false;
                } else {
                    var a = b.get(t.id) || [];
                    a.push(n);
                    y[t.id] = a;
                    if (!e) {
                        a.start = i;
                        return o.push({
                            index: f++,
                            definition: t
                        });
                    }
                    if (i.block !== g) return y[t.id] = false;
                    a.start = m;
                }
                u[t.id] = s.length;
                s.push({
                    index: f++,
                    definition: t
                });
            }
            function T(e) {
                var n = [];
                while (true) {
                    if (Qn(_, "block")) {
                        var t = _.block;
                        if (t instanceof st) t = t.body;
                        if (t === e) break;
                    }
                    n.push(_);
                    k();
                }
                _.inserted = _.block;
                x();
                while (n.length) {
                    var r = n.pop();
                    x();
                    if (Qn(r, "block")) _.block = r.block;
                    if (Qn(r, "loop")) _.loop = r.loop;
                }
            }
            function A(e, n) {
                return e === n || e.isPrototypeOf(n);
            }
            function D(e, n) {
                return A(e.start, e.end) || A(e.start, n.start);
            }
        });
        function ye(e, n) {
            for (var t = n.length; --t >= 0; ) {
                if (!n[t]) n[t] = Ce(Ur, e);
            }
        }
        function ie(e, n) {
            var t = Ce(Nt, e, e);
            if (t.name) t.name = n ? null : Ce(qr, t.name, t.name);
            return t;
        }
        function we(e, n) {
            var t;
            switch (e.CTOR) {
              case qt:
                t = At;
                break;

              case Ct:
                t = Dt;
                break;

              case Mt:
                t = Ot;
                break;

              case Ft:
                t = $t;
                break;
            }
            var r = Ce(t, e, e);
            r.name = n ? null : Ce(zr, e.name, e.name);
            return r;
        }
        gn.DEFMETHOD("drop_unused", function(q) {
            if (!q.option("unused")) return;
            var C = this;
            var M = !(C instanceof _t) || q.toplevel.funcs;
            var F = !(C instanceof _t) || q.toplevel.vars;
            var P = /keep_assign/.test(q.option("unused")) ? un : function(e, n) {
                var t, i = false;
                if (e instanceof Cn) {
                    if (e.write_only || e.operator == "=") t = a(e.left, n);
                } else if (e instanceof On) {
                    if (e.write_only) t = a(e.expression, n);
                }
                if (!(t instanceof Nn)) return;
                var r = t.definition();
                if (o[r.id]) return;
                if (q.exposed(r)) return;
                if (!ze(t, q, i)) return;
                return t;
                function a(e, n) {
                    if (e instanceof Tn) {
                        var t = e.expression;
                        if (!t.may_throw_on_access(q, true)) {
                            i = true;
                            if (n && e instanceof pr) n.unshift(e.property);
                            return a(t, n);
                        }
                    } else if (e instanceof Cn && e.operator == "=") {
                        e.write_only = "p";
                        var r = a(e.right);
                        if (!n) return r;
                        n.assign = e;
                        return r instanceof Nn ? r : e.left;
                    }
                    return e;
                }
            };
            var j = Object.create(null);
            var o = Object.create(null);
            var h = function(e) {
                h = a(C, 0, Un);
                return h(e);
                function a(e, n, r) {
                    var i = q.parent(n);
                    if (!i) return r;
                    var t = i instanceof bn && Bn(e, i.argnames);
                    return a(i, n + 1, t ? function(e) {
                        var n = r(e);
                        if (n) return n;
                        n = i.variables.get(e);
                        if (n) {
                            var t = n.orig[0];
                            if (t instanceof jn || t instanceof zr) return n;
                        }
                    } : i.variables ? function(e) {
                        return r(e) || i.variables.get(e);
                    } : r);
                }
            };
            var N = Object.create(null);
            var m = [];
            var I = Object.create(null);
            var _ = Object.create(null);
            var g = Object.create(null);
            var b = Object.create(null);
            var H = Object.create(null);
            if (C instanceof _t && q.top_retain) {
                C.variables.each(function(e) {
                    if (q.top_retain(e) && !(e.id in I)) {
                        I[e.id] = true;
                        m.push(e);
                    }
                });
            }
            var y = new dn();
            var w = new dn();
            var Y = this;
            var x = new Rn(function(s, e) {
                if (s instanceof bn && s.uses_arguments && !x.has_directive("use strict")) {
                    s.each_argname(function(e) {
                        var n = e.definition();
                        if (!(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                    });
                }
                if (s === C) return;
                if (Y === C) {
                    if (s instanceof jt) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        var r = x.parent() instanceof sr;
                        if (r) {
                            o[n.id] = true;
                        } else if (t && !(n.id in _)) {
                            _[n.id] = 1;
                        }
                        if (s.extends) s.extends.walk(x);
                        var i = [];
                        s.properties.forEach(function(e) {
                            if (e.key instanceof vn) e.key.walk(x);
                            var n = e.value;
                            if (!n) return;
                            if (re(e)) {
                                if (!r && n.contains_this()) r = true;
                                a(n);
                            } else {
                                i.push(n);
                            }
                        });
                        i.forEach(t && r ? a : function(e) {
                            w.add(n.id, e);
                        });
                        return true;
                    }
                    if (s instanceof zt) {
                        var n = s.name.definition();
                        var t = M && !n.exported;
                        if (!t && !(n.id in I)) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        w.add(n.id, s);
                        if (x.parent() instanceof sr) {
                            o[n.id] = true;
                            return;
                        }
                        if (t && !(n.id in _)) _[n.id] = 1;
                        return true;
                    }
                    if (s instanceof tr) {
                        s.definitions.forEach(function(r) {
                            var i = r.value;
                            var a = i && (r.name instanceof Fn || i.has_side_effects(q));
                            var o = a && i.tail_node().operator == "=";
                            r.name.mark_symbol(function(e) {
                                if (!(e instanceof Sr)) return;
                                var n = e.definition();
                                H[n.id] = (H[n.id] || 0) + 1;
                                if (s instanceof ar && n.orig[0] instanceof Cr) {
                                    var t = n.redefined();
                                    if (t) H[t.id] = (H[t.id] || 0) + 1;
                                }
                                if (!(n.id in I) && (!F || n.exported || (s instanceof rr ? n.redefined() : n.const_redefs) || !(s instanceof ar || ne(n)))) {
                                    I[n.id] = true;
                                    m.push(n);
                                }
                                if (i) {
                                    if (!a) {
                                        w.add(n.id, i);
                                    } else if (o) {
                                        S(n, e, b[n.id]);
                                    }
                                    y.add(n.id, r);
                                }
                                T(n);
                                return true;
                            }, x);
                            if (a) i.walk(x);
                        });
                        return true;
                    }
                    if (s instanceof jn) {
                        var n = s.definition();
                        H[n.id] = (H[n.id] || 0) + 1;
                        y.add(n.id, s);
                        return true;
                    }
                    if (s instanceof Ar) {
                        var n = s.definition();
                        if (!(n.id in I) && (!F || !ne(n))) {
                            I[n.id] = true;
                            m.push(n);
                        }
                        return true;
                    }
                }
                return f(s, e, true);
                function a(e) {
                    var n = Y;
                    Y = s;
                    e.walk(x);
                    Y = n;
                }
            });
            x.directives = Object.create(q.directives);
            C.walk(x);
            var R = q.option("keep_fnames") ? un : q.option("ie") ? function(e) {
                return !q.exposed(e) && e.references.length == e.replaced;
            } : function(e) {
                if (!(e.id in I)) return true;
                if (e.orig.length - e.eliminated < 2) return false;
                if (e.orig[1] instanceof jn) return true;
                return pn(e.references, function(e) {
                    return !e.in_arg;
                });
            };
            if (q.option("ie")) w.each(function(e, n) {
                if (n in I) return;
                e.forEach(function(e) {
                    e.walk(new Rn(function(e) {
                        if (e instanceof Ot && e.name && !R(e.name.definition())) {
                            e.walk(x);
                            return true;
                        }
                        if (e instanceof gn) return true;
                    }));
                });
            });
            x = new Rn(f);
            for (var e = 0; e < m.length; e++) {
                var n = w.get(m[e].id);
                if (n) n.forEach(function(e) {
                    e.walk(x);
                });
            }
            Object.keys(j).forEach(function(e) {
                var t = j[e];
                if (!t) {
                    delete j[e];
                    return;
                }
                t = t.reduce(function(n, e) {
                    e.forEach(function(e) {
                        Jn(n, e);
                    });
                    return n;
                }, []);
                var n = (y.get(e) || []).filter(function(n) {
                    return Ln(n instanceof On ? function(e) {
                        return e === n;
                    } : function(e) {
                        if (e === n) return true;
                        if (e instanceof On) return false;
                        return r(e) === r(n);
                    }, t);
                });
                if (t.length == n.length) {
                    j[e] = n;
                } else {
                    delete j[e];
                }
            });
            var B = [];
            var L = [];
            var U = new Xr(function(r) {
                if (r instanceof kn) return D(U, r);
                if (r instanceof Fn && r.rest) r.rest = r.rest.transform(U);
                if (r instanceof mr) {
                    var e = !r.rest;
                    for (var n = r.elements.length; --n >= 0; ) {
                        var t = r.elements[n].transform(U);
                        if (t) {
                            r.elements[n] = t;
                            e = false;
                        } else if (e) {
                            r.elements.pop();
                        } else {
                            r.elements[n] = Ce(Ur, r.elements[n]);
                        }
                    }
                    return r;
                }
                if (r instanceof gr) {
                    var i = [];
                    r.properties.forEach(function(e) {
                        var n = false;
                        if (e.key instanceof vn) {
                            e.key = e.key.transform(V);
                            n = e.key.has_side_effects(q);
                        }
                        if ((n || r.rest) && a(e.value)) {
                            e.value = e.value.transform(V);
                            i.push(e);
                        } else {
                            var t = e.value.transform(U);
                            if (!t && r.rest) {
                                if (e.value instanceof mr) {
                                    t = Ce(mr, e.value, {
                                        elements: []
                                    });
                                } else {
                                    t = Ce(gr, e.value, {
                                        properties: []
                                    });
                                }
                            }
                            if (t) {
                                e.value = t;
                                i.push(e);
                            }
                        }
                    });
                    r.properties = i;
                    return r;
                }
                if (r instanceof Sr) return r.definition().id in I ? r : null;
            });
            var V = new Xr(function(_, n, e) {
                var g = V.parent();
                if (F) {
                    var t = [], r = P(_, t);
                    if (r) {
                        var i;
                        if (Z(r, _)) {
                            if (_ instanceof Cn) {
                                i = ee(_);
                                if (_.write_only === true) i = i.drop_side_effect_free(q);
                            }
                            if (!i) i = Ce(Yn, _, {
                                value: 0
                            });
                        }
                        if (i) {
                            if (t.assign) {
                                var a = t.assign.drop_side_effect_free(q);
                                if (a) {
                                    a.write_only = true;
                                    t.unshift(a);
                                }
                            }
                            if (!(g instanceof Sn) || g.tail_node() === _ || i.has_side_effects(q)) {
                                t.push(i);
                            }
                            switch (t.length) {
                              case 0:
                                return Gn.skip;

                              case 1:
                                return Fe(q, g, _, t[0].transform(V));

                              default:
                                return Me(_, t.map(function(e) {
                                    return e.transform(V);
                                }));
                            }
                        }
                    } else if (_ instanceof dr && _.expression instanceof Nn && K(_.expression.definition(), _) < 0) {
                        return Ce($n, _, {
                            operator: "+",
                            expression: _.expression
                        });
                    }
                }
                if (_ instanceof zn && _.operator == "instanceof") {
                    var r = _.right;
                    if (!(r instanceof Nn)) return;
                    if (r.definition().id in I) return;
                    var o = _.left.drop_side_effect_free(q);
                    var i = Ce(Gr, _).optimize(q);
                    return o ? Me(_, [ o, i ]) : i;
                }
                if (_ instanceof En) {
                    B.push(_);
                    _.args = _.args.map(function(e) {
                        return e.transform(V);
                    });
                    _.expression = _.expression.transform(V);
                    return _;
                }
                if (Y !== C) return;
                if (M && _ !== C && _ instanceof jt) {
                    var s = _.name.definition();
                    if (!(s.id in I)) {
                        W(_.name, "Dropping unused class {name}");
                        s.eliminated++;
                        n(_, V);
                        var f = ie(_, true);
                        if (g instanceof sr) return f;
                        f = f.drop_side_effect_free(q, true);
                        if (f) return Ce(mn, _, {
                            body: f
                        });
                        return e ? Gn.skip : Ce(hn, _);
                    }
                }
                if (_ instanceof Nt && _.name && R(_.name.definition())) {
                    _.name = null;
                }
                if (_ instanceof bn) {
                    if (M && _ !== C && _ instanceof zt) {
                        var s = _.name.definition();
                        if (!(s.id in I)) {
                            W(_.name, "Dropping unused function {name}");
                            s.eliminated++;
                            if (g instanceof sr) {
                                z();
                                return we(_, true);
                            }
                            return e ? Gn.skip : Ce(hn, _);
                        }
                    }
                    if (_ instanceof yt && _.name && R(_.name.definition())) {
                        _.name = null;
                    }
                    if (!(_ instanceof bt)) {
                        var u, c, l = q.drop_fargs(_, g);
                        if (l && g instanceof En && g.expression === _) {
                            u = g.args;
                            for (c = 0; c < u.length; c++) {
                                if (u[c] instanceof Dn) break;
                            }
                        }
                        var p = _.argnames;
                        var d = _.rest;
                        var v = false, h = false;
                        if (d) {
                            h = true;
                            if (!u || c < p.length || d instanceof jn) {
                                d = d.transform(U);
                            } else {
                                var f = Q(d, Ce(Mn, g, {
                                    elements: u.slice(p.length)
                                }), function(e) {
                                    return e.definition().id in I ? e : null;
                                }, !_.uses_arguments, d);
                                d = f.name;
                                u.length = p.length;
                                if (f.value.elements.length) [].push.apply(u, f.value.elements);
                            }
                            if (d instanceof Fn && !d.rest) {
                                if (d instanceof mr) {
                                    if (d.elements.length == 0) d = null;
                                } else if (d.properties.length == 0) {
                                    d = null;
                                }
                            }
                            _.rest = d;
                            if (d) {
                                l = false;
                                v = true;
                            }
                        }
                        var m = l ? -1 : _.length();
                        var b = u && !_.uses_arguments && g !== q.parent();
                        for (var y = p.length; --y >= 0; ) {
                            var r = p[y];
                            if (r instanceof jn) {
                                var s = r.definition();
                                if (s.id in I) {
                                    l = false;
                                    if (K(s, r) < 0) r.unused = null;
                                } else if (l) {
                                    W(r, "Dropping unused function argument {name}");
                                    p.pop();
                                } else {
                                    r.unused = true;
                                }
                            } else {
                                h = true;
                                var w;
                                if (!u || c < y) {
                                    w = r.transform(U);
                                } else {
                                    var f = Q(r, u[y], function(e) {
                                        return e.definition().id in I ? e : null;
                                    }, b, r);
                                    w = f.name;
                                    if (f.value) u[y] = f.value;
                                }
                                if (w) {
                                    l = false;
                                    p[y] = w;
                                    if (!v) v = !(w instanceof jn);
                                } else if (l) {
                                    G(r, "Dropping unused default argument {name}");
                                    p.pop();
                                } else if (y > m) {
                                    G(r, "Dropping unused default argument assignment {name}");
                                    if (r.name instanceof jn) {
                                        r.name.unused = true;
                                    } else {
                                        v = true;
                                    }
                                    p[y] = r.name;
                                } else {
                                    G(r, "Dropping unused default argument value {name}");
                                    p[y] = r = r.clone();
                                    r.value = Ce(Yn, r, {
                                        value: 0
                                    });
                                    v = true;
                                }
                            }
                        }
                        if (h && !v && _.uses_arguments && !V.has_directive("use strict")) {
                            _.rest = Ce(mr, _, {
                                elements: []
                            });
                        }
                        L.push(_);
                    }
                }
                if (_ instanceof er && _.argname instanceof Fn) {
                    _.argname.transform(U);
                }
                if (_ instanceof tr && !(g instanceof dt && g.init === _)) {
                    var x = [], k = [], E = [];
                    var S = [];
                    var T = 0;
                    var A = _ instanceof ar;
                    _.definitions.forEach(function(t) {
                        if (t.value) t.value = t.value.transform(V);
                        var e = t.value;
                        if (t.name instanceof Fn) {
                            var n = Q(t.name, e, function(e) {
                                if (!F) return e;
                                if (e.definition().id in I) return e;
                                if (h(e)) return e;
                                if (A && !ze(e)) return e;
                                return null;
                            }, true);
                            if (n.name) {
                                t = Ce(xn, t, {
                                    name: n.name,
                                    value: e = n.value
                                });
                                m();
                            } else if (n.value) {
                                S.push(n.value);
                            }
                            return;
                        }
                        var a = t.name.definition();
                        var r = A ? ze(t.name) : ne(a);
                        if (!r || !F || a.id in I) {
                            var i;
                            if (e && ((i = K(a, t)) < 0 || l(e.tail_node()))) {
                                t = t.clone();
                                e = e.drop_side_effect_free(q);
                                if (e) vn.warn("Side effects in definition of variable {name} [{file}:{line},{col}]", J(t.name));
                                if (_ instanceof rr) {
                                    t.value = e || Ce(Yn, t, {
                                        value: 0
                                    });
                                } else {
                                    t.value = null;
                                    if (e) S.push(e);
                                }
                                e = null;
                                if (i >= 0) j[a.id][i] = t;
                            }
                            var o, s;
                            if (!e && !(_ instanceof ir)) {
                                if (g instanceof or) {
                                    m();
                                } else if (r && H[a.id] > 1) {
                                    vn.info("Dropping declaration of variable {name} [{file}:{line},{col}]", J(t.name));
                                    H[a.id]--;
                                    a.eliminated++;
                                } else {
                                    k.push(t);
                                }
                            } else if (q.option("functions") && !q.option("ie") && r && e && H[a.id] == 1 && a.assignments == 0 && (s = e.tail_node()) instanceof yt && !$e(a) && !wt(s) && p(s, a.references) && d(s) && (o = v(s, t.name.name)) !== false) {
                                vn.warn("Declaring {name} as function [{file}:{line},{col}]", J(t.name));
                                var f;
                                switch (s.CTOR) {
                                  case At:
                                    f = qt;
                                    break;

                                  case Dt:
                                    f = Ct;
                                    break;

                                  case Ot:
                                    f = Mt;
                                    break;

                                  case $t:
                                    f = Ft;
                                    break;
                                }
                                var u = Ce(f, t, s);
                                u.name = Ce($r, t.name, t.name);
                                var c = t.name.scope.resolve().def_function(u.name);
                                if (o) o.forEach(function(e) {
                                    e.name = c.name;
                                    e.thedef = c;
                                    e.reference();
                                });
                                x.push(u);
                                if (e !== s) [].push.apply(S, e.expressions.slice(0, -1));
                            } else {
                                if (r && H[a.id] > 1 && !(g instanceof or) && a.orig.indexOf(t.name) > a.eliminated) {
                                    H[a.id]--;
                                    T++;
                                }
                                m();
                            }
                        } else if (h(t.name)) {
                            e = e && e.drop_side_effect_free(q);
                            if (e) S.push(e);
                            if (H[a.id] > 1) {
                                vn.warn("Dropping duplicated declaration of variable {name} [{file}:{line},{col}]", J(t.name));
                                H[a.id]--;
                                a.eliminated++;
                            } else {
                                t.value = null;
                                k.push(t);
                            }
                        } else {
                            e = e && e.drop_side_effect_free(q);
                            if (e) {
                                vn.warn("Side effects in initialization of unused variable {name} [{file}:{line},{col}]", J(t.name));
                                S.push(e);
                            } else {
                                W(t.name, "Dropping unused variable {name}");
                            }
                            a.eliminated++;
                        }
                        function l(e) {
                            return e instanceof Nn && e.definition() === a;
                        }
                        function p(n, e) {
                            if (e.length == 0) return n === t.name.fixed_value();
                            return pn(e, function(e) {
                                return n === e.fixed_value();
                            });
                        }
                        function d(e) {
                            if (!A || q.has_directive("use strict") || !(e instanceof Ot)) {
                                return g instanceof gn;
                            }
                            return g instanceof ot || g instanceof pt && g.init === _ || g instanceof wn;
                        }
                        function v(t, r) {
                            if (!t.name) return null;
                            var e = t.name.definition();
                            if (e.orig.length > 1) return null;
                            if (e.assignments > 0) return false;
                            if (e.name == r) return e;
                            if (q.option("keep_fnames")) return false;
                            var i;
                            switch (r) {
                              case "await":
                                i = xt;
                                break;

                              case "yield":
                                i = kt;
                                break;
                            }
                            return pn(e.references, function(e) {
                                var n = e.scope;
                                if (n.find_variable(r) !== a) return false;
                                if (i) do {
                                    n = n.resolve();
                                    if (i(n)) return false;
                                } while (n !== t && (n = n.parent_scope));
                                return true;
                            }) && e;
                        }
                        function h(e) {
                            var n = e.definition();
                            return n.orig[0] instanceof Cr && n.scope.resolve() === e.scope.resolve();
                        }
                        function m() {
                            if (S.length > 0) {
                                if (E.length == 0) {
                                    x.push(Ce(mn, _, {
                                        body: Me(_, S)
                                    }));
                                } else if (e) {
                                    S.push(e);
                                    t.value = Me(e, S);
                                } else {
                                    t.value = Ce($n, t, {
                                        operator: "void",
                                        expression: Me(t, S)
                                    });
                                }
                                S = [];
                            }
                            E.push(t);
                        }
                    });
                    switch (k.length) {
                      case 0:
                        if (E.length == 0) break;
                        if (E.length == T) {
                            [].unshift.apply(S, E.map(function(e) {
                                vn.info("Dropping duplicated definition of variable {name} [{file}:{line},{col}]", J(e.name));
                                var n = e.name.definition();
                                var t = Ce(Nn, e.name, e.name);
                                n.references.push(t);
                                var r = Ce(Cn, e, {
                                    operator: "=",
                                    left: t,
                                    right: e.value
                                });
                                var i = K(n, e);
                                if (i >= 0) j[n.id][i] = r;
                                n.assignments++;
                                n.eliminated++;
                                return r;
                            }));
                            break;
                        }

                      case 1:
                        if (E.length == 0) {
                            var D = k[0].name.definition().id;
                            if (D in N) {
                                _.definitions = k;
                                N[D].init = _;
                                break;
                            }
                        }

                      default:
                        var O;
                        if (E.length > 0 && (O = E[0].value) instanceof Sn) {
                            E[0].value = O.tail_node();
                            x.push(Ce(mn, _, {
                                body: Me(O, O.expressions.slice(0, -1))
                            }));
                        }
                        _.definitions = k.concat(E);
                        x.push(_);
                    }
                    if (S.length > 0) {
                        x.push(Ce(mn, _, {
                            body: Me(_, S)
                        }));
                    }
                    return X(x, _, e);
                }
                if (_ instanceof Cn) {
                    n(_, V);
                    if (!(_.left instanceof Fn)) return _;
                    var f = Q(_.left, _.right, function(e) {
                        return e;
                    }, _.write_only === true);
                    if (f.name) return Ce(Cn, _, {
                        operator: _.operator,
                        left: f.name,
                        right: f.value
                    });
                    if (f.value) return f.value;
                    if (g instanceof Sn && g.tail_node() !== _) return Gn.skip;
                    return Ce(Yn, _, {
                        value: 0
                    });
                }
                if (_ instanceof st && _.body instanceof pt) {
                    n(_, V);
                    if (_.body instanceof _n) {
                        var $ = _.body;
                        _.body = $.body.pop();
                        $.body.push(_);
                        return e ? Gn.splice($.body) : $;
                    }
                    return _;
                }
                if (_ instanceof gn) {
                    z();
                    return _;
                }
                if (_ instanceof Ar) {
                    if (!q.option("imports") || _.definition().id in I) return _;
                    return e ? Gn.skip : null;
                }
                function z() {
                    var e = Y;
                    Y = _;
                    n(_, V);
                    Y = e;
                }
            }, function(e, n) {
                if (e instanceof _n) return O(e, V.parent(), n);
                if (e instanceof or) {
                    var t = e.body;
                    if (!(t instanceof _n)) return;
                    e.body = t.body.pop();
                    t.body.push(e);
                    return n ? Gn.splice(t.body) : t;
                }
                if (e instanceof pt) return Ue(e, n);
                if (e instanceof vt) {
                    if (!F || !q.option("loops")) return;
                    if (!ue(e.body)) return;
                    var r = A(e);
                    if (!r) return;
                    var i = r.definition();
                    if (i.id in I) return;
                    W(r, "Dropping unused loop variable {name}");
                    if (N[i.id] === e) delete N[i.id];
                    var a = [];
                    var o = e.object.drop_side_effect_free(q);
                    if (o) {
                        vn.warn("Side effects in object of for-in loop [{file}:{line},{col}]", o.start);
                        a.push(Ce(mn, e, {
                            body: o
                        }));
                    }
                    if (e.init instanceof tr && i.orig[0] instanceof Cr) {
                        a.push(e.init);
                    }
                    return X(a, e, n);
                }
                if (e instanceof ur) {
                    if (e.properties && e.properties.length == 0) e.properties = null;
                    return e;
                }
                if (e instanceof Sn) {
                    if (e.expressions.length > 1) return;
                    return Fe(q, V.parent(), e, e.expressions[0]);
                }
            });
            V.push(q.parent());
            V.directives = Object.create(q.directives);
            C.transform(V);
            if (C instanceof bn && C.body.length == 1 && C.body[0] instanceof tt && C.body[0].value == "use strict") {
                C.body.length = 0;
            }
            B.forEach(function(e) {
                Ee(e, q, L);
            });
            function W(e, n) {
                vn[e.definition().references.length > 0 ? "info" : "warn"](n + " [{file}:{line},{col}]", J(e));
            }
            function G(e, n) {
                if (e.name instanceof jn) {
                    W(e.name, n);
                } else {
                    vn.info(n + " [{file}:{line},{col}]", {
                        name: e,
                        file: e.start.file,
                        line: e.start.line,
                        col: e.start.col
                    });
                }
            }
            function J(e) {
                return {
                    name: e.name,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                };
            }
            function r(e) {
                return e[e instanceof Cn ? "right" : "value"];
            }
            function X(e, n, t) {
                switch (e.length) {
                  case 0:
                    return t ? Gn.skip : Ce(hn, n);

                  case 1:
                    return e[0];

                  default:
                    return t ? Gn.splice(e) : Ce(_n, n, {
                        body: e
                    });
                }
            }
            function k(e, n) {
                if (e.scope.resolve() !== C) return false;
                if (!e.fixed || !n.fixed) j[e.id] = false;
                return j[e.id] !== false;
            }
            function E(e, n) {
                if (!j[e.id]) j[e.id] = [];
                if (n.fixed.assigns) Jn(j[e.id], n.fixed.assigns);
            }
            function K(e, n) {
                var t = j[e.id];
                return t && t.indexOf(n);
            }
            function T(e) {
                if (_[e.id] > 1 && !(e.id in I)) {
                    I[e.id] = true;
                    m.push(e);
                }
                _[e.id] = 0;
            }
            function S(e, n, t) {
                if (e.id in I) return;
                if (n && t) {
                    I[e.id] = n;
                    m.push(e);
                } else {
                    g[e.id] = n;
                    b[e.id] = t;
                }
            }
            function Z(e, n) {
                var t = e.definition();
                var r = I[t.id];
                if (!r) return true;
                if (n[n instanceof Cn ? "left" : "expression"] !== e) return false;
                return r === e && t.references.length - t.replaced == 1 || K(t, n) < 0;
            }
            function ee(e) {
                var n = e.right;
                if (!e.write_only) return n;
                if (!(n instanceof zn && Ne[n.operator])) return n;
                if (!(n.left instanceof Nn)) return n;
                if (!(e.left instanceof Nn)) return n;
                var t = e.left.definition();
                if (n.left.definition() !== t) return n;
                if (n.right.has_side_effects(q)) return n;
                if (k(t, n.left)) E(t, n.left);
                return n.right;
            }
            function A(e) {
                var n = e.init;
                if (n instanceof tr) {
                    n = n.definitions[0].name;
                    return n instanceof Sr && n;
                }
                while (n instanceof Tn) n = n.expression.tail_node();
                if (n instanceof Nn) return n;
            }
            function f(e, n, t) {
                if (e instanceof Cn && e.left instanceof Nn) {
                    var r = e.left.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                if (e instanceof On && e.expression instanceof Nn) {
                    var r = e.expression.definition();
                    if (r.scope.resolve() === C) y.add(r.id, e);
                }
                var i = [], a = P(e, i);
                if (a) {
                    var o = a.definition();
                    if (o.scope.resolve() !== C && C.variables.get(a.name) !== o) return;
                    if ($e(o) && !pn(C.argnames, function(e) {
                        return !e.match_symbol(function(e) {
                            if (e instanceof jn) {
                                var n = e.definition();
                                return n.references.length > n.replaced;
                            }
                        }, true);
                    })) return;
                    if (e.write_only === "p" && e.right.may_throw_on_access(q, true)) return;
                    var s = i.assign;
                    if (s) {
                        s.write_only = true;
                        s.walk(x);
                    }
                    i.forEach(function(e) {
                        e.walk(x);
                    });
                    if (e instanceof Cn) {
                        var f = ee(e), u = false;
                        if (t && e.write_only === true && !f.has_side_effects(q)) {
                            w.add(o.id, f);
                        } else {
                            f.walk(x);
                            u = f.tail_node().operator == "=";
                        }
                        if (e.left === a) {
                            if (!e.write_only || u) {
                                S(o, a, b[o.id]);
                            }
                        } else {
                            var c = a.fixed_value();
                            if (!c || !c.is_constant()) {
                                S(o, g[o.id], true);
                            }
                        }
                    }
                    if (k(o, a) && ai(a, e) !== a) E(o, a);
                    T(o);
                    return true;
                }
                if (e instanceof zn) {
                    if (e.operator != "instanceof") return;
                    var a = e.right;
                    if (!(a instanceof Nn)) return;
                    var l = a.definition().id;
                    if (!_[l]) return;
                    e.left.walk(x);
                    _[l]++;
                    return true;
                }
                if (e instanceof vt) {
                    if (e.init instanceof Nn && Y === C) {
                        var l = e.init.definition().id;
                        if (!(l in N)) N[l] = e;
                    }
                    if (!F || !q.option("loops")) return;
                    if (!ue(e.body)) return;
                    if (e.init.has_side_effects(q)) return;
                    var a = A(e);
                    if (!a) return;
                    var r = a.definition();
                    if (r.scope.resolve() !== C) {
                        var p = h(a.name);
                        if (p === r || p && p.redefined() === r) return;
                    }
                    e.object.walk(x);
                    return true;
                }
                if (e instanceof Nn) {
                    var o = e.definition();
                    if (!(o.id in I)) {
                        I[o.id] = true;
                        m.push(o);
                    }
                    if (te(o.scope, e.scope)) {
                        var d = o.redefined();
                        if (d && !(d.id in I)) {
                            I[d.id] = true;
                            m.push(d);
                        }
                    }
                    if (k(o, e)) E(o, e);
                    return true;
                }
                if (e instanceof gn) {
                    var v = Y;
                    Y = e;
                    n();
                    Y = v;
                    return true;
                }
            }
            function a(e) {
                return (e instanceof kn ? e.name : e) instanceof Sr;
            }
            function D(e, n) {
                n.value = n.value.transform(V);
                var t = n.name.transform(e);
                if (!t) {
                    if (n.name instanceof Fn) return null;
                    var r = n.value.drop_side_effect_free(q);
                    if (!r) return null;
                    W(n.name, "Side effects in default value of unused variable {name}");
                    n = n.clone();
                    n.name.unused = null;
                    n.value = r;
                }
                return n;
            }
            function Q(e, m, _, g, b) {
                var y = new Xr(function(a) {
                    if (a instanceof kn) {
                        if (!(q.option("default_values") && m && m.is_defined(q))) {
                            var e = g;
                            g = false;
                            var n = D(y, a);
                            g = e;
                            if (!n && g && m) m = m.drop_side_effect_free(q);
                            return n;
                        } else if (a === b) {
                            b = a = a.name;
                        } else {
                            a = a.name;
                        }
                    }
                    if (a instanceof mr) {
                        var e = g;
                        var t = m;
                        if (m instanceof Nn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var r = m instanceof Mn && m.elements;
                        var i = [], o = g && [], s = 0;
                        a.elements.forEach(function(e, n) {
                            m = r && r[n];
                            if (m instanceof Ur) {
                                m = null;
                            } else if (m instanceof Dn) {
                                if (g) {
                                    o.length = s;
                                    ye(t, o);
                                    [].push.apply(o, r.slice(n));
                                    t.elements = o;
                                }
                                m = r = false;
                            }
                            e = e.transform(y);
                            if (e) i[s] = e;
                            if (g && m) o[s] = m;
                            if (e || m || !g || !r) s++;
                        });
                        m = r && Ce(Mn, t, {
                            elements: r.slice(a.elements.length)
                        });
                        if (a.rest) {
                            var f = g;
                            g = false;
                            a.rest = a.rest.transform(q.option("rests") ? y : V);
                            g = f;
                            if (a.rest) i.length = s;
                        }
                        if (g) {
                            if (m && !a.rest) m = m.drop_side_effect_free(q);
                            if (m instanceof Mn) {
                                m = m.elements;
                            } else if (m instanceof Sn) {
                                m = m.expressions;
                            } else if (m) {
                                m = [ m ];
                            }
                            if (m && m.length) {
                                o.length = s;
                                [].push.apply(o, m);
                            }
                        }
                        m = t;
                        g = e;
                        if (r && o) {
                            ye(m, o);
                            m = m.clone();
                            m.elements = o;
                        }
                        if (!a.rest && (m instanceof Mn || m && m.is_string(q))) switch (i.length) {
                          case 0:
                            if (a === b) break;
                            if (g) m = m.drop_side_effect_free(q);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var u = i[0];
                            if (u.has_side_effects(q)) break;
                            if (m.has_side_effects(q) && u.match_symbol(function(e) {
                                return e instanceof Tn;
                            })) break;
                            m = Ce(pr, a, {
                                expression: m,
                                property: Ce(Yn, a, {
                                    value: 0
                                })
                            });
                            return u;
                        }
                        ye(a, i);
                        a.elements = i;
                        return a;
                    }
                    if (a instanceof gr) {
                        var e = g;
                        var t = m;
                        if (m instanceof Nn) {
                            g = false;
                            m = m.fixed_value();
                        }
                        var c, l, r;
                        if (m instanceof Pn) {
                            c = [];
                            l = new dn();
                            r = m.properties.map(function(e, n) {
                                e = e.clone();
                                if (e instanceof Dn) {
                                    l = false;
                                } else {
                                    var t = e.key;
                                    if (t instanceof vn) t = t.evaluate(q, true);
                                    if (t instanceof vn) {
                                        l = false;
                                    } else if (l && !(e instanceof xr)) {
                                        l.set(t, e);
                                    }
                                    c[n] = t;
                                }
                                return e;
                            });
                        }
                        if (a.rest) {
                            m = false;
                            a.rest = a.rest.transform(q.option("rests") ? y : V);
                        }
                        var p = new dn();
                        var d = g && new dn();
                        var v = [];
                        a.properties.map(function(e) {
                            var n = e.key;
                            if (n instanceof vn) {
                                e.key = n = n.transform(V);
                                n = n.evaluate(q, true);
                            }
                            if (n instanceof vn) {
                                d = false;
                            } else {
                                p.set(n, !p.has(n));
                            }
                            return n;
                        }).forEach(function(e, n) {
                            var t = a.properties[n], r;
                            if (e instanceof vn) {
                                g = false;
                                m = false;
                                r = t.value.transform(y) || x(t.value);
                            } else {
                                g = d && p.get(e);
                                var i = l && l.get(e);
                                if (i) {
                                    m = i.value;
                                    if (m instanceof bt) m = false;
                                } else {
                                    m = false;
                                }
                                r = t.value.transform(y);
                                if (!r) {
                                    if (a.rest || w(t)) r = x(t.value);
                                    if (d && !d.has(e)) {
                                        if (i) {
                                            d.set(e, i);
                                            if (m === null) {
                                                l.set(e, w(i) && Ce(yr, i, {
                                                    key: i.key,
                                                    value: Ce(Yn, i, {
                                                        value: 0
                                                    })
                                                }));
                                            }
                                        } else {
                                            d.set(e, true);
                                        }
                                    }
                                } else if (d) {
                                    d.set(e, false);
                                }
                                if (m) i.value = m;
                            }
                            if (r) {
                                t.value = r;
                                v.push(t);
                            }
                        });
                        m = t;
                        g = e;
                        if (d && c) {
                            m = m.clone();
                            m.properties = Gn(r, function(e, n) {
                                if (e instanceof Dn) return e;
                                var t = c[n];
                                if (t instanceof vn) return e;
                                if (d.has(t)) {
                                    var r = d.get(t);
                                    if (!r) return e;
                                    if (r === e) return l.get(t) || Gn.skip;
                                } else if (a.rest) {
                                    return e;
                                }
                                var i = e.value.drop_side_effect_free(q);
                                if (i) {
                                    e.value = i;
                                    return e;
                                }
                                return w(e) ? Ce(yr, e, {
                                    key: e.key,
                                    value: Ce(Yn, e, {
                                        value: 0
                                    })
                                }) : Gn.skip;
                            });
                        }
                        if (m && !a.rest) switch (v.length) {
                          case 0:
                            if (a === b) break;
                            if (m.may_throw_on_access(q, true)) break;
                            if (g) m = m.drop_side_effect_free(q);
                            return null;

                          case 1:
                            if (!g) break;
                            if (a === b) break;
                            var h = v[0];
                            if (h.key instanceof vn) break;
                            if (h.value.has_side_effects(q)) break;
                            if (m.has_side_effects(q) && h.value.match_symbol(function(e) {
                                return e instanceof Tn;
                            })) break;
                            m = Ce(pr, a, {
                                expression: m,
                                property: fe(h.key, h)
                            });
                            return h.value;
                        }
                        a.properties = v;
                        return a;
                    }
                    if (a instanceof Ur) {
                        a = null;
                    } else {
                        a = _(a);
                    }
                    if (!a && g && m) m = m.drop_side_effect_free(q);
                    return a;
                });
                return {
                    name: e.transform(y),
                    value: m
                };
                function w(e) {
                    return e.key instanceof vn && e.key.has_side_effects(q);
                }
                function n(e) {
                    if (e instanceof Cn) {
                        e.write_only = false;
                        n(e.right);
                    } else if (e instanceof zn) {
                        if (!Ne[e.operator]) return;
                        n(e.left);
                        n(e.right);
                    } else if (e instanceof qn) {
                        n(e.consequent);
                        n(e.alternative);
                    } else if (e instanceof Sn) {
                        n(e.tail_node());
                    } else if (e instanceof On) {
                        e.write_only = false;
                    }
                }
                function x(e) {
                    if (e instanceof kn) return x(e.name);
                    if (e instanceof Fn) {
                        if (m === null) {
                            m = Ce(Yn, e, {
                                value: 0
                            });
                        } else if (m) {
                            if (m.may_throw_on_access(q, true)) {
                                m = Ce(Mn, e, {
                                    elements: m instanceof Sn ? m.expressions : [ m ]
                                });
                            } else {
                                n(m);
                            }
                        }
                        return Ce(gr, e, {
                            properties: []
                        });
                    }
                    e.unused = null;
                    return e;
                }
            }
        });
        gn.DEFMETHOD("hoist_declarations", function(o) {
            if (o.has_directive("use asm")) return;
            var s = o.option("hoist_funs");
            var f = o.option("hoist_vars");
            var u = this;
            if (f) {
                var n = 0;
                u.walk(new Rn(function(e) {
                    if (n > 1) return true;
                    if (e instanceof or) return true;
                    if (e instanceof gn && e !== u) return true;
                    if (e instanceof ar) {
                        n++;
                        return true;
                    }
                }));
                if (n <= 1) f = false;
            }
            if (!s && !f) return;
            var c = new dn();
            var l = [];
            var p = [];
            var d = new dn();
            var v = new Xr(function(e, n, t) {
                if (e === u) return;
                if (e instanceof tt) {
                    l.push(e);
                    return t ? Gn.skip : Ce(hn, e);
                }
                if (e instanceof zt) {
                    if (!s) return e;
                    var r = v.parent();
                    if (r instanceof or) return e;
                    if (r instanceof sr) return e;
                    if (r !== u && o.has_directive("use strict")) return e;
                    p.push(e);
                    return t ? Gn.skip : Ce(hn, e);
                }
                if (e instanceof ar) {
                    if (!f) return e;
                    var r = v.parent();
                    if (r instanceof or) return e;
                    if (!pn(e.definitions, function(e) {
                        var n = e.name;
                        return n instanceof Or && !c.has(n.name) && u.find_variable(n.name) === n.definition();
                    })) return e;
                    e.definitions.forEach(function(e) {
                        d.set(e.name.name, e);
                    });
                    var i = e.to_assignments();
                    if (r instanceof dt && r.init === e) {
                        if (i) return i;
                        var a = e.definitions[0].name;
                        return Ce(Nn, a, a);
                    }
                    if (r instanceof pt && r.init === e) return i;
                    if (!i) return t ? Gn.skip : Ce(hn, e);
                    return Ce(mn, e, {
                        body: i
                    });
                }
                if (e instanceof gn) return e;
                if (e instanceof Tr) {
                    c.set(e.name, true);
                    return e;
                }
            });
            u.transform(v);
            if (d.size() > 0) {
                var h = [];
                if (u instanceof bn) u.each_argname(function(e) {
                    d.del(e.name);
                });
                d.each(function(e, n) {
                    e = e.clone();
                    e.name = e.name.clone();
                    e.value = null;
                    h.push(e);
                    d.set(n, e);
                    e.name.definition().orig.unshift(e.name);
                });
                if (h.length > 0) {
                    m(u.body);
                    p.push(Ce(ar, u, {
                        definitions: h
                    }));
                }
            }
            u.body = l.concat(p, u.body);
            function m(e) {
                while (e.length) {
                    var n = e[0];
                    if (n instanceof mn) {
                        var t = n.body, r, i;
                        if (t instanceof Cn && t.operator == "=" && (r = t.left) instanceof Er && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            var o = t.right;
                            if (o instanceof Sn) o = o.clone();
                            a.value = o;
                            Kn(h, a);
                            h.push(a);
                            e.shift();
                            continue;
                        }
                        if (t instanceof Sn && (i = t.expressions[0]) instanceof Cn && i.operator == "=" && (r = i.left) instanceof Er && d.has(r.name)) {
                            var a = d.get(r.name);
                            if (a.value) break;
                            a.value = i.right;
                            Kn(h, a);
                            h.push(a);
                            n.body = Me(t, t.expressions.slice(1));
                            continue;
                        }
                    }
                    if (n instanceof hn) {
                        e.shift();
                        continue;
                    }
                    if (n instanceof _n && !m(n.body)) {
                        e.shift();
                        continue;
                    }
                    break;
                }
                return e.length;
            }
        });
        function _(n, t) {
            n.walk(new Rn(function(e) {
                if (e instanceof yn) {
                    t(e);
                    return true;
                }
                if (e instanceof gn && e !== n) return true;
            }));
        }
        function w(e) {
            var r = Object.create(null);
            _(e, function(e) {
                var n = e.value;
                if (n) n = n.tail_node();
                if (n instanceof Nn) {
                    var t = n.definition().id;
                    r[t] = (r[t] || 0) + 1;
                }
            });
            return r;
        }
        function B(e, n, t) {
            if (t.exposed(e)) return false;
            switch (e.references.length - e.replaced - (n[e.id] || 0)) {
              case e.drop_return:
                return "d";

              case e.bool_return:
                return true;
            }
        }
        function L(e, r) {
            _(e, function(e) {
                e.in_bool = true;
                var n = e.value;
                if (n) {
                    var t = q(r, n);
                    if (!t) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Me(e.value, [ n, Ce(Yn, e.value, {
                            value: 0
                        }) ]) : null;
                    } else if (!(t instanceof vn)) {
                        n = n.drop_side_effect_free(r);
                        e.value = n ? Me(e.value, [ n, Ce(Yn, e.value, {
                            value: 1
                        }) ]) : Ce(Yn, e.value, {
                            value: 1
                        });
                    }
                }
            });
        }
        gn.DEFMETHOD("process_returns", Un);
        Mt.DEFMETHOD("process_returns", function(e) {
            if (!e.option("booleans")) return;
            if (e.parent() instanceof sr) return;
            switch (B(this.name.definition(), w(this), e)) {
              case "d":
                U(e, this, true);
                break;

              case true:
                L(this, e);
                break;
            }
        });
        Ot.DEFMETHOD("process_returns", function(n) {
            if (!n.option("booleans")) return;
            var t = true;
            var r = w(this);
            if (this.name && !c(this.name.definition())) return;
            var e = n.parent();
            if (e instanceof Cn) {
                if (e.operator != "=") return;
                var i = e.left;
                if (!(i instanceof Nn)) return;
                if (!c(i.definition())) return;
            } else if (e instanceof En && e.expression !== this) {
                var a = e.expression;
                if (a instanceof Nn) a = a.fixed_value();
                if (!(a instanceof bn)) return;
                if (a.uses_arguments || a.pinned()) return;
                var o = e.args, i;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f === this) {
                        i = a.argnames[s];
                        if (!i && a.rest) return;
                        break;
                    }
                    if (f instanceof Dn) return;
                }
                if (i instanceof kn) i = i.name;
                if (i instanceof jn && !c(i.definition())) return;
            } else if (e.TYPE == "Call") {
                n.pop();
                var u = n.in_boolean_context();
                n.push(this);
                switch (u) {
                  case true:
                    t = false;

                  case "d":
                    break;

                  default:
                    return;
                }
            } else return;
            if (t) {
                U(n, this, true);
            } else {
                L(this, n);
            }
            function c(e) {
                switch (B(e, r, n)) {
                  case true:
                    t = false;

                  case "d":
                    return true;
                }
            }
        });
        it.DEFMETHOD("var_names", function() {
            var t = this._var_names;
            if (!t) {
                this._var_names = t = new dn();
                this.enclosed.forEach(function(e) {
                    t.set(e.name, true);
                });
                this.variables.each(function(e, n) {
                    t.set(n, true);
                });
            }
            return t;
        });
        gn.DEFMETHOD("make_var", function(e, n, t) {
            var r = [ this ];
            if (n instanceof Sr) n.definition().references.forEach(function(e) {
                var n = e.scope;
                if (Bn(n, r)) return;
                do {
                    Jn(r, n);
                    n = n.parent_scope;
                } while (n && n !== this);
            });
            t = t.replace(/^[^a-z_$]|[^a-z0-9_$]/gi, "_");
            var i = t;
            for (var a = 0; !pn(r, function(e) {
                return !e.var_names().has(i);
            }); a++) i = t + "$" + a;
            var o = Ce(e, n, {
                name: i,
                scope: this
            });
            var s = this.def_variable(o);
            r.forEach(function(e) {
                e.enclosed.push(s);
                e.var_names().set(i, true);
            });
            return o;
        });
        gn.DEFMETHOD("hoist_properties", function(a) {
            if (!a.option("hoist_props") || a.has_directive("use asm")) return;
            var u = this;
            var o = u instanceof _t && a.top_retain || un;
            var c = Object.create(null);
            var l = new Xr(function(r, e) {
                if (r instanceof Cn) {
                    if (r.operator != "=") return;
                    if (!r.write_only) return;
                    if (!p(r.left, r.right, 1)) return;
                    e(r, l);
                    var i = new dn();
                    var a = [];
                    var o = [];
                    r.right.properties.forEach(function(e) {
                        var n = f(Or, r.left, e.key);
                        o.push(Ce(xn, r, {
                            name: n,
                            value: null
                        }));
                        var t = Ce(Nn, r, {
                            name: n.name,
                            scope: u,
                            thedef: n.definition()
                        });
                        t.reference();
                        a.push(Ce(Cn, r, {
                            operator: "=",
                            left: t,
                            right: e.value
                        }));
                    });
                    i.value = r.right;
                    c[r.left.definition().id] = i;
                    u.body.splice(u.body.indexOf(l.stack[1]) + 1, 0, Ce(ar, r, {
                        definitions: o
                    }));
                    return Me(r, a);
                }
                if (r instanceof gn) {
                    if (r === u) return;
                    var n = l.parent();
                    if (n.TYPE == "Call" && n.expression === r) return;
                    return r;
                }
                if (r instanceof xn) {
                    if (!p(r.name, r.value, 0)) return;
                    e(r, l);
                    var i = new dn();
                    var t = [];
                    var s = r.clone();
                    s.value = r.name instanceof Tr ? Ce(Yn, r, {
                        value: 0
                    }) : null;
                    t.push(s);
                    r.value.properties.forEach(function(e) {
                        t.push(Ce(xn, r, {
                            name: f(r.name.CTOR, r.name, e.key),
                            value: e.value
                        }));
                    });
                    i.value = r.value;
                    c[r.name.definition().id] = i;
                    return Gn.splice(t);
                }
                function f(e, n, t) {
                    var r = u.make_var(e, n, n.name + "_" + t);
                    i.set(t, r.definition());
                    return r;
                }
            });
            u.transform(l);
            u.transform(new Xr(function(e, n) {
                if (e instanceof Tn) {
                    if (!(e.expression instanceof Nn)) return;
                    var t = c[e.expression.definition().id];
                    if (!t) return;
                    if (e.expression.fixed_value() !== t.value) return;
                    var r = t.get(e.get_property());
                    var i = Ce(Nn, e, {
                        name: r.name,
                        scope: e.expression.scope,
                        thedef: r
                    });
                    i.reference();
                    return i;
                }
                if (e instanceof Nn) {
                    var t = c[e.definition().id];
                    if (!t) return;
                    if (e.fixed_value() !== t.value) return;
                    return Ce(Pn, e, {
                        properties: []
                    });
                }
            }));
            function p(e, n, t) {
                if (!(e instanceof Er)) return;
                var r = e.definition();
                if (r.assignments != t) return;
                if (r.references.length - r.replaced == t) return;
                if (r.single_use) return;
                if (u.find_variable(e.name) !== r) return;
                if (o(r)) return;
                if (e.fixed_value() !== n) return;
                var i = e.fixed || r.fixed;
                if (i.direct_access) return;
                if (i.escaped && i.escaped.depth == 1) return;
                return n instanceof Pn && n.properties.length > 0 && ze(e, a) && pn(n.properties, function(e) {
                    return an(e) && e.key !== "__proto__";
                });
            }
        });
        function xe(e, n) {
            if (!e.name || !n.option("ie")) return true;
            var t = e.name.definition();
            if (n.exposed(t)) return false;
            return pn(t.references, function(e) {
                return !(e instanceof Nn);
            });
        }
        function U(o, n, e) {
            if (!(n instanceof bn)) return;
            var t = wt(n);
            var r = xt(n);
            var s = false;
            var i = false;
            if (t && o.option("arrows")) {
                if (!n.value) {
                    i = true;
                } else if (!r || x(o, n.value)) {
                    var a = n.value.drop_side_effect_free(o);
                    if (a !== n.value) {
                        s = true;
                        n.value = a;
                    }
                }
            } else if (!kt(n)) {
                if (!e && n.name) {
                    var f = n.name.definition();
                    i = f.references.length == f.replaced;
                } else {
                    i = true;
                }
            }
            if (i) {
                n.process_expression(false, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return e;
                        n = n.drop_side_effect_free(o, true);
                    }
                    s = true;
                    if (!n) return Ce(hn, e);
                    return Ce(mn, e, {
                        body: n
                    });
                });
                _(n, function(e) {
                    var n = e.value;
                    if (n) {
                        if (r && !x(o, n)) return;
                        var t = n.drop_side_effect_free(o);
                        if (t !== n) {
                            s = true;
                            if (t && r && !x(o, t)) {
                                t = t.negate(o);
                            }
                            e.value = t;
                        }
                    }
                });
            }
            if (r && o.option("awaits")) {
                if (i) n.process_expression("awaits", function(e) {
                    var n = e.body;
                    if (n instanceof vr) {
                        if (x(o, n.expression)) {
                            s = true;
                            n = n.expression.drop_side_effect_free(o, true);
                            if (!n) return Ce(hn, e);
                            e.body = n;
                        }
                    } else if (n instanceof Sn) {
                        var t = n.expressions;
                        for (var r = t.length; --r >= 0; ) {
                            var i = t[r];
                            if (!(i instanceof vr)) break;
                            var a = i.expression;
                            if (!x(o, a)) break;
                            s = true;
                            if (t[r] = a.drop_side_effect_free(o)) break;
                        }
                        switch (r) {
                          case -1:
                            return Ce(hn, e);

                          case 0:
                            e.body = t[0];
                            break;

                          default:
                            t.length = r + 1;
                            break;
                        }
                    }
                    return e;
                });
                var u = !i && n.name || t && n.value && !x(o, n.value);
                var c = new Rn(function(e) {
                    if (u) return true;
                    if (c.parent() === n && e.may_throw(o)) return u = true;
                    if (e instanceof vr) return u = true;
                    if (e instanceof ht) return u = true;
                    if (e instanceof yn) {
                        if (e.value && !x(o, e.value)) return u = true;
                        return;
                    }
                    if (e instanceof gn && e !== n) return true;
                });
                n.walk(c);
                if (!u) {
                    var l;
                    switch (n.CTOR) {
                      case Tt:
                        l = St;
                        break;

                      case At:
                        l = Ot;
                        break;

                      case Dt:
                        l = $t;
                        break;
                    }
                    return Ce(l, n, n);
                }
            }
            return s && n.clone();
        }
        (function(e) {
            function d(e, n, t, r) {
                var i = e.length;
                var a = [], o = false;
                for (var s = 0; s < i; s++) {
                    var f = e[s];
                    var u;
                    if (r && f instanceof Dn) {
                        u = r(f, n, t);
                    } else {
                        u = f.drop_side_effect_free(n, t);
                    }
                    if (u !== f) o = true;
                    if (u) {
                        a.push(u);
                        t = false;
                    }
                }
                return a.length ? o ? a : e : null;
            }
            function c(e, n, t) {
                var r = e.expression;
                if (!r.is_string(n)) return e;
                return r.drop_side_effect_free(n, t);
            }
            function l(e) {
                return e instanceof Dn ? Ce(Mn, e, {
                    elements: [ e ]
                }) : e;
            }
            e(vn, Vn);
            e(bt, Wn);
            e(Mn, function(e, n) {
                var t = d(this.elements, e, n, c);
                if (!t) return null;
                if (t === this.elements && pn(t, function(e) {
                    return e instanceof Dn;
                })) return this;
                return Me(this, t.map(l));
            });
            e(Cn, function(e) {
                var n = this.left;
                if (n instanceof Tn) {
                    var t = n.expression;
                    if (t.may_throw_on_access(e, true)) return this;
                    if (e.has_directive("use strict") && t.is_constant()) return this;
                }
                if (n.has_side_effects(e)) return this;
                if (Ne[this.operator.slice(0, -1)]) return this;
                this.write_only = true;
                if (!lr(n).is_constant_expression(e.find_parent(gn))) return this;
                return this.right.drop_side_effect_free(e);
            });
            e(vr, function(e) {
                if (!e.option("awaits")) return this;
                var n = this.expression;
                if (!x(e, n)) return this;
                if (n instanceof $n && n.operator == "!") n = n.expression;
                var t = n.drop_side_effect_free(e);
                if (t === n) return this;
                if (!t) {
                    t = Ce(Yn, n, {
                        value: 0
                    });
                } else if (!x(e, t)) {
                    t = t.negate(e);
                }
                var r = this.clone();
                r.expression = t;
                return r;
            });
            e(zn, function(e, n) {
                var t = this.left;
                var r = this.right;
                var i = this.operator;
                if (!We(i, r, e)) {
                    var a = t.drop_side_effect_free(e, n);
                    if (a === t) return this;
                    var o = this.clone();
                    o.left = a || Ce(Yn, t, {
                        value: 0
                    });
                    return o;
                }
                var s = r.drop_side_effect_free(e, n);
                if (!s) return t.drop_side_effect_free(e, n);
                if (Ne[i] && s.has_side_effects(e)) {
                    var o = this;
                    if (s !== r) {
                        o = o.clone();
                        o.right = s.drop_side_effect_free(e);
                    }
                    if (i == "??") return o;
                    var f = o.clone();
                    f.operator = i == "&&" ? "||" : "&&";
                    f.left = t.negate(e, n);
                    if (f.operator == f.right.operator) Je(f);
                    var u = n ? v : le;
                    return i == "&&" ? u(o, f) : u(f, o);
                }
                var a = t.drop_side_effect_free(e, n);
                if (!a) return s;
                s = s.drop_side_effect_free(e);
                if (!s) return a;
                return Me(this, [ a, s ]);
            });
            function p(e, n) {
                e.new = true;
                var t = pn(e.body, function(e) {
                    return !e.has_side_effects(n);
                }) && pn(e.argnames, function(e) {
                    return !e.match_symbol(un);
                }) && !(e.rest && e.rest.match_symbol(un));
                e.new = false;
                return t;
            }
            e(En, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    if (t.pure) vn.warn("Dropping __PURE__ call [{file}:{line},{col}]", t.start);
                    var r = d(t.args, e, n, c);
                    return r && Me(t, r.map(l));
                }
                var i = t.expression;
                if (t.is_call_pure(e)) {
                    var a = t.args.slice();
                    a.unshift(i.expression);
                    a = d(a, e, n, c);
                    return a && Me(t, a.map(l));
                }
                if (e.option("yields") && kt(i)) {
                    var o = t.clone();
                    o.expression = Ce(Ot, i, i);
                    o.expression.body = [];
                    var s = o.transform(e);
                    if (s !== o) return s.drop_side_effect_free(e, n);
                }
                var f = U(e, i);
                if (f) {
                    t = t.clone();
                    t.expression = f;
                    if (i._squeezed) t.expression._squeezed = true;
                }
                if (t instanceof cr) {
                    var u = i;
                    if (u instanceof Nn) u = u.fixed_value();
                    if (u instanceof bn) {
                        if (p(u, e)) {
                            var a = t.args.slice();
                            a.unshift(i);
                            a = d(a, e, n, c);
                            return a && Me(t, a.map(l));
                        }
                        if (!u.contains_this()) {
                            t = Ce(En, t, t);
                            t.expression = t.expression.clone();
                            t.args = t.args.slice();
                        }
                    }
                }
                t.call_only = true;
                return t;
            });
            e(Nt, function(e, n) {
                var t = this;
                var r = [], i = [], a = 0;
                var o = t.properties;
                for (var s = 0; s < o.length; s++) {
                    var f = o[s];
                    if (f.key instanceof vn) r.push(f.key);
                    if (!re(f)) continue;
                    var u = f.value;
                    if (!u.has_side_effects(e)) continue;
                    if (u.contains_this()) return t;
                    if (f instanceof Rt) {
                        a++;
                        i.push(f);
                    } else {
                        i.push(u);
                    }
                }
                var c = t.extends;
                if (c) {
                    if (c instanceof Nn) c = c.fixed_value();
                    c = !He(c);
                    if (!c) r.unshift(t.extends);
                }
                r = d(r, e, n);
                if (r) n = false;
                i = d(i, e, n);
                if (!r) {
                    if (!c && !i && !t.name) return null;
                    r = [];
                }
                if (c || t.name || !e.has_directive("use strict")) {
                    var l = ie(t);
                    if (!c) l.extends = null;
                    l.properties = [];
                    if (i) {
                        if (i.length == a) {
                            if (r.length) i.unshift(Ce(Ht, t, {
                                key: Me(t, r),
                                value: null
                            }));
                            l.properties = i;
                        } else l.properties.push(Ce(Ht, t, {
                            static: true,
                            key: r.length ? Me(t, r) : "c",
                            value: p()
                        }));
                    } else if (r.length) l.properties.push(Ce(Yt, t, {
                        key: Me(t, r),
                        value: Ce(Ot, t, {
                            argnames: [],
                            body: []
                        }).init_vars(l)
                    }));
                    return l;
                }
                if (i) r.push(Ce(En, t, {
                    expression: Ce(St, t, {
                        argnames: [],
                        body: [],
                        value: p()
                    }).init_vars(t.parent_scope),
                    args: []
                }));
                return Me(t, r);
                function p() {
                    return Me(t, i.map(function(e) {
                        if (!(e instanceof Rt)) return e;
                        var n = Ce(St, e, e.value);
                        n.argnames = [];
                        return Ce(En, e, {
                            expression: n,
                            args: []
                        });
                    }));
                }
            });
            e(qn, function(e) {
                var n = this.consequent.drop_side_effect_free(e);
                var t = this.alternative.drop_side_effect_free(e);
                if (n === this.consequent && t === this.alternative) return this;
                var r;
                if (e.option("ie")) {
                    r = [];
                    if (n instanceof Ot) {
                        r.push(n);
                        n = null;
                    }
                    if (t instanceof Ot) {
                        r.push(t);
                        t = null;
                    }
                }
                var i;
                if (!n) {
                    i = t ? Ce(zn, this, {
                        operator: "||",
                        left: this.condition,
                        right: t
                    }) : this.condition.drop_side_effect_free(e);
                } else if (!t) {
                    i = Ce(zn, this, {
                        operator: "&&",
                        left: this.condition,
                        right: n
                    });
                } else {
                    i = this.clone();
                    i.consequent = n;
                    i.alternative = t;
                }
                if (!r) return i;
                if (i) r.push(i);
                return r.length == 0 ? null : Me(this, r);
            });
            e(In, Wn);
            e(An, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                return t.drop_side_effect_free(e, n);
            });
            e(Ot, function(e) {
                return xe(this, e) ? null : this;
            });
            e(yt, Wn);
            e(Pn, function(e, n) {
                var t = [];
                this.properties.forEach(function(e) {
                    if (e instanceof Dn) {
                        t.push(e);
                    } else {
                        if (e.key instanceof vn) t.push(e.key);
                        t.push(e.value);
                    }
                });
                var r = d(t, e, n, function(e, n, t) {
                    var r = e.expression;
                    return r.safe_to_spread() ? r.drop_side_effect_free(n, t) : e;
                });
                if (!r) return null;
                if (r === t && !pn(r, function(e) {
                    return !(e instanceof Dn);
                })) return this;
                return Me(this, r.map(function(e) {
                    return e instanceof Dn ? Ce(Pn, e, {
                        properties: [ e ]
                    }) : e;
                }));
            });
            e(Fr, Wn);
            e(Sn, function(e, n) {
                var t = d(this.expressions, e, n);
                if (!t) return null;
                var r = t.length - 1;
                var i = t[r];
                if (e.option("awaits") && r > 0 && i instanceof vr && i.expression.is_constant()) {
                    t = t.slice(0, -1);
                    r--;
                    var a = t[r];
                    i.expression = x(e, a) ? a : a.negate(e);
                    t[r] = i;
                }
                var o, s, f;
                if (e.option("conditionals") && r > 0 && (o = t[r - 1]) instanceof Cn && o.operator == "=" && (f = o.left) instanceof Nn && (s = ee(e, f.definition(), o.right, i))) {
                    o = o.clone();
                    o.right = s;
                    t = t.slice(0, -2);
                    t.push(o.drop_side_effect_free(e, n));
                }
                return t === this.expressions ? this : Me(this, t);
            });
            e(pr, function(e, n) {
                var t = this.expression;
                if (t.may_throw_on_access(e)) return this;
                var r = this.property;
                t = t.drop_side_effect_free(e, n);
                if (!t) return r.drop_side_effect_free(e, n);
                r = r.drop_side_effect_free(e);
                if (!r) return t;
                return Me(this, [ t, r ]);
            });
            e(Nn, function(e) {
                return this.is_declared(e) && ze(this, e) ? null : this;
            });
            e(Ir, function(e, n) {
                var t = this;
                if (t.is_expr_pure(e)) {
                    var r = t.expressions;
                    if (r.length == 0) return null;
                    return Me(t, r).drop_side_effect_free(e, n);
                }
                var i = t.tag;
                var a = U(e, i);
                if (a) {
                    t = t.clone();
                    t.tag = a;
                    if (i._squeezed) t.tag._squeezed = true;
                }
                return t;
            });
            e(On, function(e, n) {
                var t = this.expression;
                if (ii[this.operator]) {
                    this.write_only = !t.has_side_effects(e);
                    return this;
                }
                if (this.operator == "typeof" && t instanceof Nn && ze(t, e)) {
                    return null;
                }
                var r = t.drop_side_effect_free(e, n);
                if (n && r && be(r)) {
                    if (r === t && this.operator == "!") return this;
                    return r.negate(e, n);
                }
                return r;
            });
        })(function(e, n) {
            e.DEFMETHOD("drop_side_effect_free", n);
        });
        e(mn, function(e, n) {
            if (n.option("side_effects")) {
                var t = e.body;
                var r = t.drop_side_effect_free(n, true);
                if (!r) {
                    vn.warn("Dropping side-effect-free statement [{file}:{line},{col}]", e.start);
                    return Ce(hn, e);
                }
                if (r !== t) {
                    return Ce(mn, e, {
                        body: r
                    });
                }
            }
            return e;
        });
        e(lt, function(e, n) {
            return n.option("loops") ? Ce(pt, e, e).optimize(n) : e;
        });
        function V(n, e, t) {
            if (!t) t = Vt;
            var r = false;
            var i = new Rn(function(e) {
                if (r || e instanceof gn) return true;
                if (e instanceof t && i.loopcontrol_target(e) === n) {
                    return r = true;
                }
            });
            if (e instanceof st) i.push(e);
            i.push(n);
            n.body.walk(i);
            return r;
        }
        e(ct, function(t, e) {
            if (!e.option("loops")) return t;
            var n = q(e, t.condition);
            if (!(n instanceof vn)) {
                if (n && !V(t, e.parent(), Gt)) return Ce(pt, t, {
                    body: Ce(_n, t.body, {
                        body: [ t.body, Ce(mn, t.condition, {
                            body: t.condition
                        }) ]
                    })
                }).optimize(e);
                if (!V(t, e.parent())) return Ce(_n, t.body, {
                    body: [ t.body, Ce(mn, t.condition, {
                        body: t.condition
                    }) ]
                }).optimize(e);
            }
            if (t.body instanceof _n && !V(t, e.parent(), Gt)) {
                var r = t.body.body;
                for (var i = r.length; --i >= 0; ) {
                    var a = r[i];
                    if (a instanceof wn && !a.alternative && a.body instanceof Wt && e.loopcontrol_target(a.body) === t) {
                        if (o(a.condition)) break;
                        t.condition = Ce(zn, t, {
                            operator: "&&",
                            left: a.condition.negate(e),
                            right: t.condition
                        });
                        r.splice(i, 1);
                    } else if (a instanceof mn) {
                        if (o(a.body)) break;
                        t.condition = Me(t, [ a.body, t.condition ]);
                        r.splice(i, 1);
                    } else if (!P(a, true)) {
                        break;
                    }
                }
                t.body = O(t.body, e.parent());
            }
            if (t.body instanceof hn) return Ce(pt, t, t).optimize(e);
            if (t.body instanceof mn) return Ce(pt, t, {
                condition: Me(t.condition, [ t.body.body, t.condition ]),
                body: Ce(hn, t)
            }).optimize(e);
            return t;
            function o(e) {
                var n = false;
                e.walk(new Rn(function(e) {
                    if (n) return true;
                    if (e instanceof Nn) {
                        if (!Bn(e.definition(), t.enclosed)) n = true;
                        return true;
                    }
                }));
                return n;
            }
        });
        function W(n, t) {
            var e = o(n.body);
            if (t.option("dead_code") && (e instanceof Wt || e instanceof Gt && s(e) || e instanceof Lt)) {
                var r = [];
                if (rt(n.init)) {
                    r.push(n.init);
                } else if (n.init) {
                    r.push(Ce(mn, n.init, {
                        body: n.init
                    }));
                }
                var i = s(e) || e instanceof Lt;
                if (n.condition && i) {
                    r.push(Ce(wn, n, {
                        condition: n.condition,
                        body: e,
                        alternative: null
                    }));
                } else if (n.condition) {
                    r.push(Ce(mn, n.condition, {
                        body: n.condition
                    }));
                } else if (i) {
                    r.push(e);
                }
                S(t, n.body, r);
                return Ce(_n, n, {
                    body: r
                });
            }
            if (e instanceof wn) {
                var a = o(e.body);
                if (a instanceof Wt && !s(a)) {
                    if (n.condition) {
                        n.condition = Ce(zn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition.negate(t)
                        });
                    } else {
                        n.condition = e.condition.negate(t);
                    }
                    var r = H(e.alternative);
                    S(t, e.body, r);
                    return f(r);
                }
                a = o(e.alternative);
                if (a instanceof Wt && !s(a)) {
                    if (n.condition) {
                        n.condition = Ce(zn, n.condition, {
                            left: n.condition,
                            operator: "&&",
                            right: e.condition
                        });
                    } else {
                        n.condition = e.condition;
                    }
                    var r = H(e.body);
                    S(t, e.alternative, r);
                    return f(r);
                }
            }
            return n;
            function o(e) {
                return e instanceof _n ? e.body[0] : e;
            }
            function s(e) {
                return t.loopcontrol_target(e) !== t.self();
            }
            function f(e) {
                if (n.body instanceof _n) {
                    n.body = n.body.clone();
                    n.body.body = e.concat(n.body.body.slice(1));
                    n.body = n.body.transform(t);
                } else {
                    n.body = Ce(_n, n.body, {
                        body: e
                    }).transform(t);
                }
                return W(n, t);
            }
        }
        e(pt, function(e, n) {
            if (!n.option("loops")) return e;
            if (n.option("side_effects")) {
                if (e.init) e.init = e.init.drop_side_effect_free(n);
                if (e.step) e.step = e.step.drop_side_effect_free(n);
            }
            if (e.condition) {
                var t = q(n, e.condition);
                if (!t) {
                    if (n.option("dead_code")) {
                        var r = [];
                        if (rt(e.init)) {
                            r.push(e.init);
                        } else if (e.init) {
                            r.push(Ce(mn, e.init, {
                                body: e.init
                            }));
                        }
                        r.push(Ce(mn, e.condition, {
                            body: e.condition
                        }));
                        S(n, e.body, r);
                        return Ce(_n, e, {
                            body: r
                        }).optimize(n);
                    }
                } else if (!(t instanceof vn)) {
                    e.body = Ce(_n, e.body, {
                        body: [ Ce(mn, e.condition, {
                            body: e.condition
                        }), e.body ]
                    });
                    e.condition = null;
                }
            }
            return W(e, n);
        });
        e(dt, function(e, t) {
            if (t.option("varify") && I(e.init)) {
                var n = e.init.definitions[0].name;
                if ((n instanceof Fn || n instanceof Dr) && !n.match_symbol(function(e) {
                    if (e instanceof Sr) {
                        var n = e.definition();
                        return !Ie(n) || X(t, n);
                    }
                }, true)) {
                    e.init = K(e.init);
                }
            }
            return e;
        });
        function N(e, n, t) {
            if (e instanceof Sn) e = e.tail_node();
            if (!(e instanceof zn)) return;
            if (!(e.left instanceof Hn)) {
                switch (e.operator) {
                  case "&&":
                    N(e.left, n);
                    N(e.right, n);
                    break;

                  case "||":
                    N(p(e.left), t);
                    N(p(e.right), t);
                    break;
                }
                return;
            }
            if (!(e.right instanceof $n)) return;
            if (e.right.operator != "typeof") return;
            var r = e.right.expression;
            if (!Pe(r)) return;
            var i;
            var a = e.left.value == "undefined";
            switch (e.operator) {
              case "==":
                i = a ? t : n;
                break;

              case "!=":
                i = a ? n : t;
                break;

              default:
                return;
            }
            if (!i) return;
            var o = false;
            var s = r.definition();
            var f;
            var u = [];
            var c = [];
            var l = new Rn(function(e, n) {
                if (o) return true;
                if (e instanceof Cn) {
                    var t = e.left;
                    if (!(t instanceof Nn && t.definition() === s)) return;
                    e.right.walk(l);
                    switch (e.operator) {
                      case "=":
                      case "&&=":
                        o = true;
                    }
                    return true;
                }
                if (e instanceof En) {
                    n();
                    f = e.expression.tail_node();
                    var r;
                    if (f instanceof Nn) {
                        f = f.fixed_value();
                        r = u.length;
                    }
                    if (!(f instanceof bn)) {
                        o = true;
                    } else if (Jn(c, f)) {
                        f.walk(l);
                    }
                    if (r >= 0) u.length = r;
                    return true;
                }
                if (e instanceof ut) {
                    var r = u.length;
                    n();
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof pt) {
                    if (e.init) e.init.walk(l);
                    var r = u.length;
                    if (e.condition) e.condition.walk(l);
                    e.body.walk(l);
                    if (e.step) e.step.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof dt) {
                    e.object.walk(l);
                    var r = u.length;
                    e.init.walk(l);
                    e.body.walk(l);
                    if (o) u.length = r;
                    return true;
                }
                if (e instanceof gn) {
                    if (e === f) return;
                    return true;
                }
                if (e instanceof Nn) {
                    if (e.definition() === s) u.push(e);
                    return true;
                }
            });
            i.walk(l);
            u.forEach(function(e) {
                e.defined = true;
            });
            function p(e) {
                if (!(e instanceof zn)) return;
                switch (e.operator) {
                  case "==":
                    e = e.clone();
                    e.operator = "!=";
                    return e;

                  case "!=":
                    e = e.clone();
                    e.operator = "==";
                    return e;
                }
            }
        }
        function q(e, n, t) {
            if (n.truthy) return true;
            if (je(n)) return undefined;
            if (n.falsy && !t) return false;
            if (n.is_truthy()) return true;
            return n.evaluate(e, true);
        }
        function G(e, n) {
            var t;
            var r = 0;
            var i = false;
            var a = e.self();
            if (!rt(a)) while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof zn) {
                    switch (t) {
                      case a.left:
                        if (Ne[a.operator]) continue;
                        break;

                      case a.right:
                        if (s(a.left)) switch (a.operator) {
                          case "&&":
                            n[i ? "falsy" : "truthy"] = true;
                            break;

                          case "||":
                          case "??":
                            n[i ? "truthy" : "falsy"] = true;
                            break;
                        }
                        break;
                    }
                } else if (a instanceof qn) {
                    var o = a.condition;
                    if (o === t) continue;
                    if (s(o)) switch (t) {
                      case a.consequent:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                } else if (a instanceof Lt) {
                    break;
                } else if (a instanceof wn) {
                    break;
                } else if (a instanceof Sn) {
                    if (a.expressions[0] === t) continue;
                } else if (a instanceof mn) {
                    break;
                }
                return;
            }
            while (true) {
                t = a;
                a = e.parent(r++);
                if (a instanceof _n) {
                    if (a.body[0] === t) continue;
                } else if (a instanceof wn) {
                    if (s(a.condition)) switch (t) {
                      case a.body:
                        n[i ? "falsy" : "truthy"] = true;
                        break;

                      case a.alternative:
                        n[i ? "truthy" : "falsy"] = true;
                        break;
                    }
                }
                return;
            }
            function s(e) {
                if (n.equivalent_to(e)) return true;
                if (!(e instanceof $n)) return false;
                if (e.operator != "!") return false;
                if (!n.equivalent_to(e.expression)) return false;
                i = true;
                return true;
            }
        }
        e(wn, function(e, u) {
            if (ue(e.alternative)) e.alternative = null;
            if (!u.option("conditionals")) return e;
            if (u.option("booleans") && !e.condition.has_side_effects(u)) {
                G(u, e.condition);
            }
            if (u.option("dead_code")) {
                var n = q(u, e.condition);
                if (!n) {
                    vn.warn("Condition always false [{file}:{line},{col}]", e.condition.start);
                    var t = [ Ce(mn, e.condition, {
                        body: e.condition
                    }).transform(u) ];
                    S(u, e.body, t);
                    if (e.alternative) t.push(e.alternative);
                    return Ce(_n, e, {
                        body: t
                    }).optimize(u);
                } else if (!(n instanceof vn)) {
                    vn.warn("Condition always true [{file}:{line},{col}]", e.condition.start);
                    var t = [ Ce(mn, e.condition, {
                        body: e.condition
                    }).transform(u), e.body ];
                    if (e.alternative) S(u, e.alternative, t);
                    return Ce(_n, e, {
                        body: t
                    }).optimize(u);
                }
            }
            var r = e.condition.negate(u);
            var i = e.condition.print_to_string().length;
            var a = r.print_to_string().length;
            var o = a < i;
            if (e.alternative && o) {
                o = false;
                e.condition = r;
                var s = e.body;
                e.body = e.alternative;
                e.alternative = ue(s) ? null : s;
            }
            var f = [];
            var c = [];
            var l = [];
            var p = y(e.body, f, c, l);
            var d = [];
            var v = [];
            var h = [];
            var m = y(e.alternative, d, v, h);
            if (p instanceof _n || m instanceof _n) {
                var t = [], _ = [];
                if (p) {
                    [].push.apply(t, f);
                    [].push.apply(_, c);
                    if (p instanceof _n) {
                        e.body = p;
                    } else if (p.length == 0) {
                        e.body = Ce(hn, e.body);
                    } else {
                        e.body = Ce(mn, e.body, {
                            body: Me(e.body, p)
                        });
                    }
                    l.forEach(F);
                }
                if (m) {
                    [].push.apply(t, d);
                    [].push.apply(_, v);
                    if (m instanceof _n) {
                        e.alternative = m;
                    } else if (m.length == 0) {
                        e.alternative = null;
                    } else {
                        e.alternative = Ce(mn, e.alternative, {
                            body: Me(e.alternative, m)
                        });
                    }
                    h.forEach(F);
                }
                if (_.length > 0) t.push(Ce(ar, e, {
                    definitions: _
                }));
                if (t.length > 0) {
                    t.push(e);
                    return Ce(_n, e, {
                        body: t
                    }).optimize(u);
                }
            } else if (p && m) {
                var t = f.concat(d);
                if (c.length > 0 || v.length > 0) t.push(Ce(ar, e, {
                    definitions: c.concat(v)
                }));
                if (p.length == 0) {
                    t.push(Ce(mn, e.condition, {
                        body: m.length > 0 ? Ce(zn, e, {
                            operator: "||",
                            left: e.condition,
                            right: Me(e.alternative, m)
                        }).transform(u) : e.condition.clone()
                    }).optimize(u));
                } else if (m.length == 0) {
                    if (i === a && !o && e.condition instanceof zn && e.condition.operator == "||") {
                        o = true;
                    }
                    t.push(Ce(mn, e, {
                        body: Ce(zn, e, {
                            operator: o ? "||" : "&&",
                            left: o ? r : e.condition,
                            right: Me(e.body, p)
                        }).transform(u)
                    }).optimize(u));
                } else {
                    t.push(Ce(mn, e, {
                        body: Ce(qn, e, {
                            condition: e.condition,
                            consequent: Me(e.body, p),
                            alternative: Me(e.alternative, m)
                        })
                    }).optimize(u));
                }
                l.forEach(F);
                h.forEach(F);
                return Ce(_n, e, {
                    body: t
                }).optimize(u);
            }
            if (ue(e.body)) e = Ce(wn, e, {
                condition: r,
                body: e.alternative,
                alternative: null
            });
            if (e.alternative instanceof Lt && e.body.TYPE == e.alternative.TYPE) {
                var g = Ce(e.body.CTOR, e, {
                    value: Ce(qn, e, {
                        condition: e.condition,
                        consequent: e.body.value || Ce(Lr, e.body).transform(u),
                        alternative: e.alternative.value || Ce(Lr, e.alternative).transform(u)
                    })
                });
                if (g instanceof yn) g.in_bool = e.body.in_bool || e.alternative.in_bool;
                return g;
            }
            if (e.body instanceof wn && !e.body.alternative && !e.alternative) {
                e = Ce(wn, e, {
                    condition: Ce(zn, e.condition, {
                        operator: "&&",
                        left: e.condition,
                        right: e.body.condition
                    }),
                    body: e.body.body,
                    alternative: null
                });
            }
            if (j(e.body) && e.alternative) {
                var b = e.alternative;
                e.alternative = null;
                return Ce(_n, e, {
                    body: [ e, b ]
                }).optimize(u);
            }
            if (j(e.alternative)) {
                var t = e.body;
                e.body = e.alternative;
                e.condition = o ? r : e.condition.negate(u);
                e.alternative = null;
                return Ce(_n, e, {
                    body: [ e, t ]
                }).optimize(u);
            }
            if (u.option("typeofs")) N(e.condition, e.body, e.alternative);
            return e;
            function y(e, n, t, r) {
                if (e == null) return [];
                if (e instanceof _n) {
                    var i = [];
                    for (var a = 0; a < e.body.length; a++) {
                        var o = e.body[a];
                        if (o instanceof hn) continue;
                        if (o instanceof Lt) {
                            if (a == 0) return;
                            if (i.length > 0) {
                                o = o.clone();
                                i.push(o.value || Ce(Lr, o).transform(u));
                                o.value = Me(e, i);
                            }
                            var s = e.clone();
                            s.body = s.body.slice(a + 1);
                            s.body.unshift(o);
                            return s;
                        }
                        if (o instanceof zt) {
                            n.push(o);
                        } else if (o instanceof mn) {
                            if (!u.option("sequences") && i.length > 0) return;
                            i.push(o.body);
                        } else if (o instanceof ar) {
                            if (!u.option("sequences") && i.length > 0) return;
                            o.remove_initializers(u, t);
                            o.definitions.forEach(f);
                        } else {
                            return;
                        }
                    }
                    return i;
                }
                if (e instanceof zt) {
                    n.push(e);
                    return [];
                }
                if (e instanceof hn) return [];
                if (e instanceof mn) return [ e.body ];
                if (e instanceof ar) {
                    var i = [];
                    e.remove_initializers(u, t);
                    e.definitions.forEach(f);
                    return i;
                }
                function f(e) {
                    if (!e.value) return;
                    i.push(Ce(Cn, e, {
                        operator: "=",
                        left: e.name.convert_symbol(Nn, function(e) {
                            r.push(e);
                        }),
                        right: e.value
                    }));
                }
            }
        });
        e(Jt, function(r, t) {
            if (!t.option("switches")) return r;
            if (!t.option("dead_code")) return r;
            var e = [];
            var n;
            var i = [];
            var a;
            var o;
            var s = [];
            for (var f = 0, u = r.body.length; f < u; f++) {
                n = r.body[f];
                if (n instanceof Kt) {
                    var c = e[e.length - 1];
                    if (a || w(n.body[0], t) && (!c || j(c))) {
                        k(n, c);
                        continue;
                    } else {
                        a = n;
                    }
                } else {
                    var l = n.expression;
                    var p = Ce(zn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }).evaluate(t, true);
                    if (!p) {
                        if (l.has_side_effects(t)) s.push(l);
                        k(n, e[e.length - 1]);
                        continue;
                    }
                    if (!(p instanceof vn)) {
                        if (a) {
                            var d = e.indexOf(a);
                            e.splice(d, 1);
                            k(a, e[d - 1]);
                            a = null;
                        }
                        if (l.has_side_effects(t)) {
                            o = n;
                        } else {
                            a = n = Ce(Kt, n, n);
                        }
                        while (++f < u) k(r.body[f], n);
                    }
                }
                if (f + 1 >= u || j(n)) {
                    var c = e[e.length - 1];
                    var v = n.body;
                    if (j(c)) switch (c.body.length - v.length) {
                      case 1:
                        var h = c.body[c.body.length - 1];
                        if (!w(h, t)) break;
                        v = v.concat(h);

                      case 0:
                        var m = Ce(_n, c, c);
                        var _ = Ce(_n, n, {
                            body: v
                        });
                        if (m.equivalent_to(_)) c.body = [];
                    }
                }
                if (s.length) {
                    if (n instanceof Kt) {
                        e.push(Ce(Qt, r, {
                            expression: Me(r, s),
                            body: []
                        }));
                    } else {
                        s.push(n.expression);
                        n.expression = Me(r, s);
                    }
                    s = [];
                }
                e.push(n);
            }
            if (s.length && !o) {
                e.push(Ce(Qt, r, {
                    expression: Me(r, s),
                    body: []
                }));
            }
            while (n = e[e.length - 1]) {
                var h = n.body[n.body.length - 1];
                if (w(h, t)) n.body.pop();
                if (n === a) {
                    if (!E(n)) break;
                } else if (n.expression.has_side_effects(t)) {
                    break;
                } else if (a) {
                    if (!E(a)) break;
                    if (e[e.length - 2] !== a) break;
                    a.body = a.body.concat(n.body);
                    n.body = [];
                } else if (!E(n)) break;
                k(n);
                if (e.pop() === a) a = null;
            }
            if (!n) {
                i.push(Ce(mn, r.expression, {
                    body: r.expression
                }));
                if (s.length) i.push(Ce(mn, r, {
                    body: Me(r, s)
                }));
                return Ce(_n, r, {
                    body: i
                }).optimize(t);
            }
            if (n === a) while (n = e[e.length - 2]) {
                if (n instanceof Kt) break;
                if (!E(n)) break;
                var l = n.expression;
                if (l.has_side_effects(t)) {
                    var c = e[e.length - 3];
                    if (c && !j(c)) break;
                    a.body.unshift(Ce(mn, r, {
                        body: l
                    }));
                }
                k(n);
                e.splice(-2, 1);
            }
            e[0].body = i.concat(e[0].body);
            r.body = e;
            if (t.option("conditionals")) switch (e.length) {
              case 1:
                if (!x(e[0])) break;
                var l = e[0].expression;
                var v = e[0].body.slice();
                if (e[0] !== a && e[0] !== o) return Ce(wn, r, {
                    condition: Ce(zn, r, {
                        operator: "===",
                        left: r.expression,
                        right: l
                    }),
                    body: Ce(_n, r, {
                        body: v
                    }),
                    alternative: null
                }).optimize(t);
                if (l) v.unshift(Ce(mn, l, {
                    body: l
                }));
                v.unshift(Ce(mn, r.expression, {
                    body: r.expression
                }));
                return Ce(_n, r, {
                    body: v
                }).optimize(t);

              case 2:
                if (!Bn(a, e) || !x(e[1])) break;
                var v = e[0].body.slice();
                var g = v.length && w(v[v.length - 1], t);
                if (g) v.pop();
                if (!pn(v, x)) break;
                var b = e[1].body.length && Ce(_n, e[1], e[1]);
                var y = Ce(wn, r, {
                    condition: Ce(zn, r, e[0] === a ? {
                        operator: "!==",
                        left: r.expression,
                        right: e[1].expression
                    } : {
                        operator: "===",
                        left: r.expression,
                        right: e[0].expression
                    }),
                    body: Ce(_n, e[0], {
                        body: v
                    }),
                    alternative: g && b || null
                });
                if (!g && b) y = Ce(_n, r, {
                    body: [ y, b ]
                });
                return y.optimize(t);
            }
            return r;
            function w(e, n) {
                return e instanceof Wt && n.loopcontrol_target(e) === r;
            }
            function x(e) {
                var n = false;
                var t = new Rn(function(e) {
                    if (n || e instanceof bn || e instanceof mn) return true;
                    if (w(e, t)) n = true;
                });
                t.push(r);
                e.walk(t);
                return !n;
            }
            function k(e, n) {
                if (n && !j(n)) {
                    n.body = n.body.concat(e.body);
                } else {
                    S(t, e, i);
                }
            }
        });
        e(Zt, function(e, n) {
            e.body = c(e.body, n);
            if (n.option("dead_code")) {
                if (E(e) && !(e.bcatch && e.bcatch.argname && e.bcatch.argname.match_symbol(function(e) {
                    return e instanceof Cr && !ze(e);
                }, true))) {
                    var t = [];
                    if (e.bcatch) {
                        S(n, e.bcatch, t);
                        t.forEach(function(e) {
                            if (!(e instanceof ar)) return;
                            e.definitions.forEach(function(e) {
                                var n = e.name.definition().redefined();
                                if (!n) return;
                                e.name = e.name.clone();
                                e.name.thedef = n;
                            });
                        });
                    }
                    t.unshift(Ce(_n, e, e).optimize(n));
                    if (e.bfinally) {
                        t.push(Ce(_n, e.bfinally, e.bfinally).optimize(n));
                    }
                    return Ce(_n, e, {
                        body: t
                    }).optimize(n);
                }
                if (e.bfinally && E(e.bfinally)) {
                    var t = Ce(_n, e.bfinally, e.bfinally).optimize(n);
                    t = e.body.concat(t);
                    if (!e.bcatch) return Ce(_n, e, {
                        body: t
                    }).optimize(n);
                    e.body = t;
                    e.bfinally = null;
                }
            }
            return e;
        });
        function J(i) {
            return function(n, t) {
                var r = false;
                this.definitions.forEach(function(e) {
                    if (e.value) r = true;
                    e.name.match_symbol(function(e) {
                        if (e instanceof Sr) t.push(Ce(xn, e, {
                            name: e,
                            value: i(n, e)
                        }));
                    }, true);
                });
                return r;
            };
        }
        rr.DEFMETHOD("remove_initializers", J(function(e, n) {
            return Ce(Lr, n).optimize(e);
        }));
        ir.DEFMETHOD("remove_initializers", J(Wn));
        ar.DEFMETHOD("remove_initializers", J(Wn));
        tr.DEFMETHOD("to_assignments", function() {
            var e = this.definitions.reduce(function(e, t) {
                var r = t.name.definition();
                var n = t.value;
                if (n) {
                    if (n instanceof Sn) n = n.clone();
                    var i = Ce(Nn, t.name, t.name);
                    var a = Ce(Cn, t, {
                        operator: "=",
                        left: i,
                        right: n
                    });
                    e.push(a);
                    var o = function() {
                        return a.right;
                    };
                    o.assigns = [ a ];
                    o.direct_access = r.direct_access;
                    o.escaped = r.escaped;
                    i.fixed = o;
                    r.references.forEach(function(e) {
                        if (!e.fixed) return;
                        var n = e.fixed.assigns;
                        if (!n) return;
                        if (n[0] !== t) return;
                        if (n.length > 1 || e.fixed.to_binary || e.fixed.to_prefix) {
                            n[0] = a;
                        } else {
                            e.fixed = o;
                            if (r.fixed === e.fixed) r.fixed = o;
                        }
                    });
                    r.references.push(i);
                }
                r.assignments++;
                r.eliminated++;
                r.single_use = false;
                return e;
            }, []);
            if (e.length == 0) return null;
            return Me(this, e);
        });
        function ne(e) {
            return e.name != "arguments" && e.orig.length < (e.orig[0] instanceof zr ? 3 : 2);
        }
        function X(e, n) {
            if (e.exposed(n)) return true;
            var t = n.scope.resolve();
            for (var r = n.scope; r !== t; ) {
                r = r.parent_scope;
                if (r.var_names().has(n.name)) return true;
            }
        }
        function K(e) {
            return Ce(ar, e, {
                definitions: e.definitions.map(function(e) {
                    return Ce(xn, e, {
                        name: e.name.convert_symbol(Or, function(e, n) {
                            var t = e.definition();
                            t.orig[t.orig.indexOf(n)] = e;
                            var r = t.scope.resolve();
                            if (t.scope === r) return;
                            t.scope = r;
                            r.variables.set(t.name, t);
                            r.enclosed.push(t);
                            r.var_names().set(t.name, true);
                        }),
                        value: e.value
                    });
                })
            });
        }
        function Q(e, n) {
            if (!n.fixed_value()) return false;
            var t = n.definition();
            return ne(t) && Ie(t) && !X(e, t);
        }
        function Z(e, n) {
            return n.option("varify") && pn(e.definitions, function(e) {
                return !e.name.match_symbol(function(e) {
                    if (e instanceof Sr) return !Q(n, e);
                }, true);
            }) ? K(e) : e;
        }
        e(rr, Z);
        e(ir, Z);
        function ke(e, n) {
            if (!n.option("optional_chains")) return;
            if (e.terminal) do {
                var t = e.expression;
                if (e.optional) {
                    var r = q(n, t, true);
                    if (r == null) return Ce($n, e, {
                        operator: "void",
                        expression: t
                    }).optimize(n);
                    if (!(r instanceof vn)) e.optional = false;
                }
                e = t;
            } while ((e.TYPE == "Call" || e instanceof Tn) && !e.terminal);
        }
        function ve(e, n) {
            var t = e.expression;
            if (!(t instanceof Sn)) return e;
            var r = t.expressions.slice();
            var i = e.clone();
            i.expression = r.pop();
            r.push(i);
            return Me(e, r);
        }
        function Ee(e, t, n) {
            var r = e.expression;
            var i = r instanceof Nn ? r.fixed_value() : r;
            if (!(i instanceof bn)) return;
            if (i.uses_arguments) return;
            if (i.pinned()) return;
            if (n && n.indexOf(i) < 0) return;
            var a = e.args;
            if (!pn(a, function(e) {
                return !(e instanceof Dn);
            })) return;
            var o = i.argnames;
            var s = i === r && !i.name;
            if (i.rest) {
                if (!(s && t.option("rests"))) return;
                var f = o.length;
                a = a.slice(0, f);
                while (a.length < f) a.push(Ce(Lr, e).optimize(t));
                a.push(Ce(Mn, e, {
                    elements: e.args.slice(f)
                }));
                o = o.concat(i.rest);
                i.rest = null;
            } else {
                a = a.slice();
                o = o.slice();
            }
            var u = 0, c = 0;
            var l = s && t.option("default_values");
            var p = s && t.drop_fargs(i, e) ? function(e, n) {
                if (!e) return true;
                if (e instanceof mr) {
                    return e.elements.length == 0 && !e.rest && n instanceof Mn;
                }
                if (e instanceof gr) {
                    return e.properties.length == 0 && !e.rest && n && !n.may_throw_on_access(t);
                }
                return e.unused;
            } : un;
            var d = [];
            for (var v = 0; v < a.length; v++) {
                var h = o[v];
                if (l && h instanceof kn && a[v].is_defined(t)) {
                    o[v] = h = h.name;
                }
                if (!h || h.unused !== undefined) {
                    var m = a[v].drop_side_effect_free(t);
                    if (p(h)) {
                        if (h) o.splice(v, 1);
                        a.splice(v, 1);
                        if (m) d.push(m);
                        v--;
                        continue;
                    } else if (m) {
                        d.push(m);
                        a[u++] = Me(e, d);
                        d = [];
                    } else if (h) {
                        if (d.length) {
                            a[u++] = Me(e, d);
                            d = [];
                        } else {
                            a[u++] = Ce(Yn, a[v], {
                                value: 0
                            });
                            continue;
                        }
                    }
                } else if (p(h, a[v])) {
                    var m = a[v].drop_side_effect_free(t);
                    o.splice(v, 1);
                    a.splice(v, 1);
                    if (m) d.push(m);
                    v--;
                    continue;
                } else {
                    d.push(a[v]);
                    a[u++] = Me(e, d);
                    d = [];
                }
                c = u;
            }
            for (;v < o.length; v++) {
                if (p(o[v])) o.splice(v--, 1);
            }
            i.argnames = o;
            a.length = c;
            e.args = a;
            if (!d.length) return;
            var _ = Me(e, d);
            a.push(a.length < o.length ? Ce($n, e, {
                operator: "void",
                expression: _
            }) : _);
        }
        function he(e, n) {
            if (!n) n = e.find_parent(gn);
            var t = [];
            if (xt(n) || n instanceof _t && e.option("module")) {
                t.push("await");
            }
            if (kt(n)) t.push("yield");
            return t.length && ln(t);
        }
        function Se(t, r) {
            if (!r) return true;
            var i = true;
            var a = new Rn(function(e) {
                if (!i) return true;
                if (e instanceof gn) {
                    if (e === t) return;
                    if (wt(e)) {
                        for (var n = 0; i && n < e.argnames.length; n++) e.argnames[n].walk(a);
                    } else if (e instanceof zt && r[e.name.name]) {
                        i = false;
                    }
                    return true;
                }
                if (e instanceof Er && r[e.name] && e !== t.name) i = false;
            });
            t.walk(a);
            return i;
        }
        function Te(e, n) {
            return e.in_strict_mode(n) || !n.has_directive("use strict");
        }
        e(En, function(p, u) {
            var a = p.expression;
            var P = ke(p, u);
            if (P) return P;
            if (u.option("sequences")) {
                if (a instanceof Tn) {
                    var e = ve(a, u);
                    if (e !== a) {
                        var j = p.clone();
                        j.expression = e.expressions.pop();
                        e.expressions.push(j);
                        return e.optimize(u);
                    }
                } else if (!ge(u, a.tail_node())) {
                    var e = ve(p, u);
                    if (e !== p) return e.optimize(u);
                }
            }
            if (u.option("unused")) Ee(p, u);
            if (u.option("unsafe")) {
                if (Pe(a)) switch (a.name) {
                  case "Array":
                    if (p.args.length == 1) {
                        var n = p.args[0];
                        if (n instanceof Yn) try {
                            var t = n.value;
                            if (t > 6) break;
                            var r = Array(t);
                            for (var i = 0; i < t; i++) r[i] = Ce(Ur, p);
                            return Ce(Mn, p, {
                                elements: r
                            });
                        } catch (e) {
                            vn.warn("Invalid array length: {length} [{file}:{line},{col}]", {
                                length: t,
                                file: p.start.file,
                                line: p.start.line,
                                col: p.start.col
                            });
                            break;
                        }
                        if (!n.is_boolean(u) && !n.is_string(u)) break;
                    }
                    return Ce(Mn, p, {
                        elements: p.args
                    });

                  case "Object":
                    if (p.args.length == 0) return Ce(Pn, p, {
                        properties: []
                    });
                    break;

                  case "String":
                    if (p.args.length == 0) return Ce(Hn, p, {
                        value: ""
                    });
                    if (p.args.length == 1) return Ce(zn, p, {
                        operator: "+",
                        left: Ce(Hn, p, {
                            value: ""
                        }),
                        right: p.args[0]
                    }).optimize(u);
                    break;

                  case "Number":
                    if (p.args.length == 0) return Ce(Yn, p, {
                        value: 0
                    });
                    if (p.args.length == 1) return Ce($n, p, {
                        operator: "+",
                        expression: Ce(zn, p, {
                            operator: "+",
                            left: Ce(Hn, p, {
                                value: ""
                            }),
                            right: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "Boolean":
                    if (p.args.length == 0) return Ce(Gr, p).optimize(u);
                    if (p.args.length == 1) return Ce($n, p, {
                        operator: "!",
                        expression: Ce($n, p, {
                            operator: "!",
                            expression: p.args[0]
                        })
                    }).optimize(u);
                    break;

                  case "RegExp":
                    var N = [];
                    if (pn(p.args, function(e) {
                        var n = e.evaluate(u);
                        N.unshift(n);
                        return e !== n;
                    })) try {
                        return pe(u, p, Ce(Yr, p, {
                            value: RegExp.apply(RegExp, N)
                        }));
                    } catch (e) {
                        vn.warn("Error converting {expr} [{file}:{line},{col}]", {
                            expr: p,
                            file: p.start.file,
                            line: p.start.line,
                            col: p.start.col
                        });
                    }
                    break;
                } else if (a instanceof An) switch (a.property) {
                  case "toString":
                    var o = a.expression;
                    if (p.args.length == 0 && !(o.may_throw_on_access(u) || o instanceof Pr)) {
                        return Ce(zn, p, {
                            operator: "+",
                            left: Ce(Hn, p, {
                                value: ""
                            }),
                            right: o
                        }).optimize(u);
                    }
                    break;

                  case "join":
                    if (a.expression instanceof Mn && p.args.length < 2) e: {
                        var s = p.args[0];
                        if (a.expression.elements.length == 0 && !(s instanceof Dn)) {
                            return s ? Me(p, [ s, Ce(Hn, p, {
                                value: ""
                            }) ]).optimize(u) : Ce(Hn, p, {
                                value: ""
                            });
                        }
                        if (s) {
                            s = s.evaluate(u);
                            if (s instanceof vn) break e;
                        }
                        var r = [];
                        var f = [];
                        for (var i = 0; i < a.expression.elements.length; i++) {
                            var c = a.expression.elements[i];
                            var l = c.evaluate(u);
                            if (l !== c) {
                                f.push(l);
                            } else if (c instanceof Dn) {
                                break e;
                            } else {
                                if (f.length > 0) {
                                    r.push(Ce(Hn, p, {
                                        value: f.join(s)
                                    }));
                                    f.length = 0;
                                }
                                r.push(c);
                            }
                        }
                        if (f.length > 0) r.push(Ce(Hn, p, {
                            value: f.join(s)
                        }));
                        if (r.length == 1) {
                            if (r[0].is_string(u)) return r[0];
                            return Ce(zn, r[0], {
                                operator: "+",
                                left: Ce(Hn, p, {
                                    value: ""
                                }),
                                right: r[0]
                            });
                        }
                        if (s == "") {
                            var n;
                            if (r[0].is_string(u) || r[1].is_string(u)) {
                                n = r.shift();
                            } else {
                                n = Ce(Hn, p, {
                                    value: ""
                                });
                            }
                            return r.reduce(function(e, n) {
                                return Ce(zn, n, {
                                    operator: "+",
                                    left: e,
                                    right: n
                                });
                            }, n).optimize(u);
                        }
                        var d = p.clone();
                        d.expression = d.expression.clone();
                        d.expression.expression = d.expression.expression.clone();
                        d.expression.expression.elements = r;
                        return pe(u, p, d);
                    }
                    break;

                  case "charAt":
                    if (p.args.length < 2) {
                        var d = Ce(zn, p, {
                            operator: "||",
                            left: Ce(pr, p, {
                                expression: a.expression,
                                property: p.args.length ? Ce(zn, p.args[0], {
                                    operator: "|",
                                    left: Ce(Yn, p, {
                                        value: 0
                                    }),
                                    right: p.args[0]
                                }) : Ce(Yn, p, {
                                    value: 0
                                })
                            }).optimize(u),
                            right: Ce(Hn, p, {
                                value: ""
                            })
                        });
                        d.is_string = cn;
                        return d.optimize(u);
                    }
                    break;

                  case "apply":
                    if (p.args.length == 2 && p.args[1] instanceof Mn) {
                        var v = p.args[1].elements.slice();
                        v.unshift(p.args[0]);
                        return Ce(En, p, {
                            expression: Ce(An, a, {
                                expression: a.expression,
                                property: "call"
                            }),
                            args: v
                        }).optimize(u);
                    }
                    break;

                  case "call":
                    var h = a.expression;
                    if (h instanceof Nn) {
                        h = h.fixed_value();
                    }
                    if (h instanceof bn && !h.contains_this()) {
                        return (p.args.length ? Me(this, [ p.args[0], Ce(En, p, {
                            expression: a.expression,
                            args: p.args.slice(1)
                        }) ]) : Ce(En, p, {
                            expression: a.expression,
                            args: []
                        })).optimize(u);
                    }
                    break;
                }
            }
            if (u.option("unsafe_Function") && Pe(a) && a.name == "Function") {
                if (p.args.length == 0) return Ce(Ot, p, {
                    argnames: [],
                    body: []
                }).init_vars(a.scope);
                if (pn(p.args, function(e) {
                    return e instanceof Hn;
                })) {
                    try {
                        var m = "n(function(" + p.args.slice(0, -1).map(function(e) {
                            return e.value;
                        }).join() + "){" + p.args[p.args.length - 1].value + "})";
                        var _ = ti(m);
                        var g = {
                            ie: u.option("ie")
                        };
                        _.figure_out_scope(g);
                        var I = new oi(u.options);
                        _ = _.transform(I);
                        _.figure_out_scope(g);
                        _.compute_char_frequency(g);
                        _.mangle_names(g);
                        var b;
                        _.walk(new Rn(function(e) {
                            if (b) return true;
                            if (e instanceof bn) {
                                b = e;
                                return true;
                            }
                        }));
                        var m = si();
                        _n.prototype._codegen.call(b, m);
                        p.args = [ Ce(Hn, p, {
                            value: b.argnames.map(function(e) {
                                return e.print_to_string();
                            }).join()
                        }), Ce(Hn, p.args[p.args.length - 1], {
                            value: m.get().replace(/^\{|\}$/g, "")
                        }) ];
                        return p;
                    } catch (e) {
                        if (e instanceof Zr) {
                            vn.warn("Error parsing code passed to new Function [{file}:{line},{col}]", p.args[p.args.length - 1].start);
                            vn.warn(e.toString());
                        } else {
                            throw e;
                        }
                    }
                }
            }
            var y = a instanceof Nn ? a.fixed_value() : a;
            var w = u.parent(), x = u.self();
            var k = y instanceof bn && (!xt(y) || u.option("awaits") && w instanceof vr) && (!kt(y) || u.option("yields") && x instanceof hr && x.nested);
            var E = k && y.first_statement();
            var S = 0, T = false;
            var A = !pn(p.args, function(e) {
                return !(e instanceof Dn);
            });
            var H = k && pn(y.argnames, function(e, n) {
                if (S == 1 && p.args[n] instanceof Dn) S = 2;
                if (e instanceof kn) {
                    if (!S) S = 1;
                    var t = S == 1 && p.args[n];
                    if (!je(t)) S = 2;
                    if (me(y, e.value)) return false;
                    e = e.name;
                }
                if (e instanceof Fn) {
                    T = true;
                    if (me(y, e)) return false;
                }
                return true;
            }) && !(y.rest instanceof Fn && me(y, y.rest));
            var Y = H && u.option("inline") && !p.is_expr_pure(u) && (a === y || Te(y, u));
            if (Y && E instanceof yn) {
                var l = E.value;
                if (a === y && !y.name && (!l || l.is_constant_expression()) && Se(y, he(u))) {
                    return Me(p, G(l)).optimize(u);
                }
            }
            if (k && !y.contains_this()) {
                var D, l, O = false;
                if (Y && !y.uses_arguments && !y.pinned() && !(y.name && y instanceof yt) && (a === y || !Xe(u, D = a.definition(), y) && y.is_constant_expression(qe(u))) && (l = K(E))) {
                    var $ = a === y || D.single_use && D.references.length - D.replaced == 1;
                    if (Z()) {
                        var v = p.args.slice();
                        var R = [];
                        var B = l.clone(true).transform(new Xr(function(e) {
                            if (e instanceof Nn) {
                                var n = e.definition();
                                if (y.variables.get(e.name) !== n) {
                                    R.push(e);
                                    return e;
                                }
                                var t = Q(n);
                                var r = v[t];
                                if (!r) return Ce(Lr, p);
                                v[t] = null;
                                var i = this.parent();
                                return i ? Fe(u, i, e, r) : r;
                            }
                        }));
                        var L = y.inlined;
                        if (a !== y) y.inlined = true;
                        var U = [];
                        v.forEach(function(e) {
                            if (!e) return;
                            e = e.clone(true);
                            e.walk(new Rn(function(e) {
                                if (e instanceof Nn) R.push(e);
                            }));
                            U.push(e);
                        }, []);
                        U.push(B);
                        var d = Me(p, U).optimize(u);
                        y.inlined = L;
                        d = Fe(u, w, x, d);
                        if ($ || le(d, p) === d) {
                            R.forEach(function(e) {
                                e.scope = a === y ? y.parent_scope : a.scope;
                                e.reference();
                                var n = e.definition();
                                if ($) n.replaced++;
                                n.single_use = false;
                            });
                            return d;
                        } else if (!d.has_side_effects(u)) {
                            p.drop_side_effect_free = function(e, n) {
                                var t = this;
                                var r = t.args.slice();
                                r.unshift(t.expression);
                                return Me(t, r).drop_side_effect_free(e, n);
                            };
                        }
                    }
                    var z, V, q, C;
                    if ($ && re()) {
                        y._squeezed = true;
                        if (a !== y) y.parent_scope = a.scope;
                        var d = Me(p, se()).optimize(u);
                        return Fe(u, w, x, d);
                    }
                }
                if (u.option("side_effects") && H && pn(y.body, ue) && (y === a ? xe(y, u) : !S && !T && !y.rest) && !(wt(y) && y.value) && Se(y, he(u))) {
                    return Me(p, G()).optimize(u);
                }
            }
            if (u.option("drop_console")) {
                if (a instanceof Tn) {
                    var M = a.expression;
                    while (M.expression) {
                        M = M.expression;
                    }
                    if (Pe(M) && M.name == "console") {
                        return Ce(Lr, p).optimize(u);
                    }
                }
            }
            if (u.option("negate_iife") && w instanceof mn && be(x)) {
                return p.negate(u, true);
            }
            return de(u, p);
            function W(e) {
                return Ce(An, e, {
                    expression: Ce(Mn, e, {
                        elements: []
                    }),
                    property: "e"
                });
            }
            function G(e) {
                var n = p.args.slice();
                var t = S > 1 || T || y.rest;
                if (t || A) n = [ Ce(Mn, p, {
                    elements: n
                }) ];
                if (t) {
                    var o = new Xr(function(r, e) {
                        if (r instanceof kn) return Ce(kn, r, {
                            name: r.name.transform(o) || W(r),
                            value: r.value
                        });
                        if (r instanceof mr) {
                            var t = [];
                            r.elements.forEach(function(e, n) {
                                e = e.transform(o);
                                if (e) t[n] = e;
                            });
                            ye(r, t);
                            return Ce(mr, r, {
                                elements: t
                            });
                        }
                        if (r instanceof gr) {
                            var i = [], a = [];
                            r.properties.forEach(function(e) {
                                var n = e.key;
                                var t = e.value.transform(o);
                                if (t) {
                                    if (a.length) {
                                        if (!(n instanceof vn)) n = fe(n, e);
                                        a.push(n);
                                        n = Me(r, a);
                                        a = [];
                                    }
                                    i.push(Ce(_r, e, {
                                        key: n,
                                        value: t
                                    }));
                                } else if (n instanceof vn) {
                                    a.push(n);
                                }
                            });
                            if (a.length) i.push(Ce(_r, r, {
                                key: Me(r, a),
                                value: W(r)
                            }));
                            return Ce(gr, r, {
                                properties: i
                            });
                        }
                        if (r instanceof jn) return null;
                    });
                    var r = [];
                    y.argnames.forEach(function(e, n) {
                        e = e.transform(o);
                        if (e) r[n] = e;
                    });
                    var i = y.rest && y.rest.transform(o);
                    if (i) r.length = y.argnames.length;
                    ye(y, r);
                    n[0] = Ce(Cn, p, {
                        operator: "=",
                        left: Ce(mr, y, {
                            elements: r,
                            rest: i
                        }),
                        right: n[0]
                    });
                } else y.argnames.forEach(function(e) {
                    if (e instanceof kn) n.push(e.value);
                });
                n.push(e || Ce(Lr, p));
                return n;
            }
            function J() {
                return p.call_only ? Ce(Yn, p, {
                    value: 0
                }) : Ce(Lr, p);
            }
            function X(e) {
                if (!e) return J();
                if (e instanceof yn) return e.value || J();
                if (e instanceof mn) {
                    return p.call_only ? e.body : Ce($n, e, {
                        operator: "void",
                        expression: e.body
                    });
                }
            }
            function K(e) {
                var n = y.body.length;
                if (n < 2) {
                    e = X(e);
                    if (e) return e;
                }
                if (u.option("inline") < 3) return false;
                e = null;
                for (var t = 0; t < n; t++) {
                    var r = y.body[t];
                    if (r instanceof ar) {
                        if (O) {
                            if (!e) continue;
                            if (!(e instanceof mn)) return false;
                            if (!ce(r)) e = null;
                        } else if (!ce(r)) {
                            if (e && !(e instanceof mn)) return false;
                            e = null;
                            O = true;
                        }
                    } else if (r instanceof qt || r instanceof Mt || r instanceof hn) {
                        continue;
                    } else if (e) {
                        return false;
                    } else {
                        e = r;
                    }
                }
                return X(e);
            }
            function Q(e) {
                for (var n = y.argnames.length; --n >= 0; ) {
                    if (y.argnames[n].definition() === e) return n;
                }
            }
            function Z() {
                if (S || T || A || O || y.rest) return;
                if (u.option("inline") < 2 && y.argnames.length) return;
                if (!y.variables.all(function(e) {
                    return e.references.length - e.replaced < 2 && e.orig[0] instanceof jn;
                })) return;
                var n = u.find_parent(gn);
                var i = false;
                var a = he(u, n);
                var o;
                var s = [];
                var f = false;
                l.walk(new Rn(function(e, n) {
                    if (i) return true;
                    if (e instanceof zn && Ne[e.operator] || e instanceof qn) {
                        s = null;
                        return;
                    }
                    if (e instanceof gn) return i = true;
                    if (a && e instanceof Er && a[e.name]) return i = true;
                    if (e instanceof Nn) {
                        var t = e.definition();
                        if (y.variables.get(e.name) !== t) {
                            s = null;
                            return;
                        }
                        if (t.init instanceof zt) return i = true;
                        if (ai(e, this.parent())) return i = true;
                        var r = Q(t);
                        if (!(o < r)) o = r;
                        if (!s) return;
                        if (f) {
                            s = null;
                        } else {
                            s.push(y.argnames[r]);
                        }
                        return;
                    }
                    if (e.has_side_effects(u)) {
                        n();
                        f = true;
                        return true;
                    }
                }));
                if (i) return;
                var e = p.args.length;
                if (s && y.argnames.length >= e) {
                    e = y.argnames.length;
                    while (e-- > o && y.argnames[e] === s.pop());
                    e++;
                }
                return e <= o || pn(p.args.slice(o, e), f && !s ? function(e) {
                    return e.is_constant_expression(n);
                } : function(e) {
                    return !e.has_side_effects(u);
                });
            }
            function ee(e, n) {
                return e.has(n) || _e[n] || C.var_names().has(n);
            }
            function ne(n, t) {
                var r = false;
                y.each_argname(function(e) {
                    if (r) return;
                    if (e.unused) return;
                    if (!t || ee(n, e.name)) return r = true;
                    z.set(e.name, true);
                    if (q) q.push(e.definition());
                });
                return !r;
            }
            function te(n, e) {
                for (var t = 0; t < y.body.length; t++) {
                    var r = y.body[t];
                    if (r instanceof zt) {
                        var i = r.name;
                        if (!e) return false;
                        if (z.has(i.name)) return false;
                        if (ee(n, i.name)) return false;
                        if (!pn(r.enclosed, function(e) {
                            return e.scope === C || e.scope === r || !n.has(e.name);
                        })) return false;
                        if (q) q.push(i.definition());
                        continue;
                    }
                    if (!(r instanceof ar)) continue;
                    if (!e) return false;
                    for (var a = r.definitions.length; --a >= 0; ) {
                        var i = r.definitions[a].name;
                        if (ee(n, i.name)) return false;
                        if (q) q.push(i.definition());
                    }
                }
                return true;
            }
            function re() {
                var n = new dn();
                var e = 0, t;
                C = x;
                do {
                    if (C.variables) C.variables.each(function(e) {
                        n.set(e.name, true);
                    });
                    t = C;
                    C = u.parent(e++);
                    if (C instanceof ut) {
                        q = [];
                    } else if (C instanceof pt) {
                        if (C.init === t) continue;
                        q = [];
                    } else if (C instanceof dt) {
                        if (C.init === t) continue;
                        if (C.object === t) continue;
                        q = [];
                    }
                } while (!(C instanceof gn));
                V = C.body.indexOf(t) + 1;
                if (!V) return false;
                if (!Se(y, he(u, C))) return false;
                var r = (a !== y || y.parent_scope.resolve() === C) && !C.pinned();
                if (C instanceof _t) {
                    if (u.toplevel.vars) {
                        n.set("arguments", true);
                    } else {
                        r = false;
                    }
                }
                z = new dn();
                var i = u.option("inline");
                if (!ne(n, i >= 2 && r)) return false;
                if (!te(n, i >= 3 && r)) return false;
                return !q || q.length == 0 || !en(y, q);
            }
            function F(e, n, t, r) {
                var i = t.definition();
                if (!C.var_names().has(t.name)) {
                    C.var_names().set(t.name, true);
                    e.push(Ce(xn, t, {
                        name: t,
                        value: null
                    }));
                }
                C.variables.set(t.name, i);
                C.enclosed.push(i);
                if (!r) return;
                var a = Ce(Nn, t, t);
                i.assignments++;
                i.references.push(a);
                n.push(Ce(Cn, p, {
                    operator: "=",
                    left: a,
                    right: r
                }));
            }
            function ie(e, n) {
                var t = y.argnames.length;
                for (var r = p.args.length; --r >= t; ) {
                    n.push(p.args[r]);
                }
                var i = [];
                for (r = t; --r >= 0; ) {
                    var a = y.argnames[r];
                    var o;
                    if (a instanceof kn) {
                        i.push(a);
                        o = a.name;
                    } else {
                        o = a;
                    }
                    var s = p.args[r];
                    if (o.unused || C.var_names().has(o.name)) {
                        if (s) n.push(s);
                    } else {
                        var f = Ce(Or, o, o);
                        var u = o.definition();
                        u.orig.push(f);
                        u.eliminated++;
                        if (o.unused !== undefined) {
                            F(e, n, f);
                            if (s) n.push(s);
                        } else {
                            if (!s && q && a === o) s = Ce(Lr, p);
                            F(e, n, f, s);
                        }
                    }
                }
                e.reverse();
                n.reverse();
                for (r = i.length; --r >= 0; ) {
                    var c = i[r];
                    if (c.name.unused !== undefined) {
                        n.push(c.value);
                    } else {
                        var l = Ce(Nn, c.name, c.name);
                        c.name.definition().references.push(l);
                        n.push(Ce(Cn, c, {
                            operator: "=",
                            left: l,
                            right: c.value
                        }));
                    }
                }
            }
            function ae(i, a) {
                a.push(Ce(Cn, p, {
                    operator: "=",
                    left: Ce(mr, p, {
                        elements: y.argnames.map(function(e) {
                            if (e.unused) return Ce(Ur, e);
                            return e.convert_symbol(Nn, n);
                        }),
                        rest: y.rest && y.rest.convert_symbol(Nn, n)
                    }),
                    right: Ce(Mn, p, {
                        elements: p.args.slice()
                    })
                }));
                function n(e, n) {
                    var t = n.definition();
                    t.assignments++;
                    t.references.push(e);
                    var r = Ce(Or, n, n);
                    t.orig.push(r);
                    t.eliminated++;
                    F(i, a, r);
                }
            }
            function oe(r, e) {
                var t = [ V, 0 ];
                var a = [], i = [], o = [], s = [], f = [];
                y.body.filter(q ? function(e) {
                    if (!(e instanceof zt)) return true;
                    var n = Ce(Or, e.name, on(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    F(r, i, n, we(e, true));
                    return false;
                } : function(e) {
                    if (!(e instanceof zt)) return true;
                    var n = e.name.definition();
                    C.functions.set(n.name, n);
                    C.variables.set(n.name, n);
                    C.enclosed.push(n);
                    C.var_names().set(n.name, true);
                    t.push(e);
                    return false;
                }).forEach(function(e) {
                    if (!(e instanceof ar)) {
                        if (e instanceof mn) f.push(e.body);
                        return;
                    }
                    for (var n = 0; n < e.definitions.length; n++) {
                        var t = e.definitions[n];
                        var r = on(t.name);
                        var i = t.value;
                        if (i && f.length > 0) {
                            f.push(i);
                            i = Me(t, f);
                            f = [];
                        }
                        F(a, o, r, i);
                        if (!q) continue;
                        if (z.has(r.name)) continue;
                        if (r.definition().orig.length == 1 && y.functions.has(r.name)) continue;
                        s.push(fn(u, r));
                    }
                });
                [].push.apply(r, a);
                [].push.apply(e, s);
                [].push.apply(e, i);
                [].push.apply(e, o);
                return t;
            }
            function se() {
                var e = [];
                var n = [];
                if (S > 1 || T || A || y.rest) {
                    ae(e, n);
                } else {
                    ie(e, n);
                }
                var t = oe(e, n);
                n.push(l);
                if (e.length) t.push(Ce(ar, y, {
                    definitions: e
                }));
                [].splice.apply(C.body, t);
                y.enclosed.forEach(function(e) {
                    if (C.var_names().has(e.name)) return;
                    C.enclosed.push(e);
                    C.var_names().set(e.name, true);
                });
                return n;
            }
        });
        e(cr, function(e, n) {
            if (n.option("sequences")) {
                var t = ve(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("unused")) Ee(e, n);
            if (n.option("unsafe")) {
                var r = e.expression;
                if (Pe(r)) {
                    switch (r.name) {
                      case "Object":
                      case "RegExp":
                      case "Function":
                      case "Error":
                      case "Array":
                        return Ce(En, e, e).transform(n);
                    }
                }
            }
            return e;
        });
        function ee(t, r, e, n) {
            if (!(n instanceof zn)) return;
            if (!(n.operator == "&&" || n.operator == "||")) return;
            if (!(n.right instanceof Cn)) return;
            if (n.right.operator != "=") return;
            if (!(n.right.left instanceof Nn)) return;
            if (n.right.left.definition() !== r) return;
            if (e.has_side_effects(t)) return;
            if (!i(n.left)) return;
            if (!i(n.right.right)) return;
            r.replaced++;
            return n.operator == "&&" ? Ce(qn, n, {
                condition: n.left,
                consequent: n.right.right,
                alternative: e
            }) : Ce(qn, n, {
                condition: n.left,
                consequent: e,
                alternative: n.right.right
            });
            function i(e) {
                if (e.has_side_effects(t)) return;
                var n = false;
                e.walk(new Rn(function(e) {
                    if (n) return true;
                    if (e instanceof Nn && e.definition() === r) return n = true;
                }));
                return !n;
            }
        }
        e(Sn, function(e, a) {
            var o = n();
            var s = o.length - 1;
            r();
            t();
            if (s == 0) {
                e = Fe(a, a.parent(), a.self(), o[0]);
                if (!(e instanceof Sn)) e = e.optimize(a);
                return e;
            }
            e.expressions = o;
            return e;
            function n() {
                if (!a.option("side_effects")) return e.expressions;
                var t = [];
                var r = Zn(a);
                var i = e.expressions.length - 1;
                e.expressions.forEach(function(e, n) {
                    if (n < i) e = e.drop_side_effect_free(a, r);
                    if (e) {
                        T(t, e);
                        r = false;
                    }
                });
                return t;
            }
            function t() {
                if (!a.option("side_effects")) return;
                while (s > 0 && je(o[s], a)) s--;
                if (s < o.length - 1) {
                    o[s] = Ce($n, e, {
                        operator: "void",
                        expression: o[s]
                    });
                    o.length = s + 1;
                }
            }
            function f(e) {
                return e instanceof Cn && e.operator == "=" && e.left instanceof Nn && e.left.definition();
            }
            function r() {
                for (var e = 1; e < s; e++) {
                    var n = o[e - 1];
                    var t = f(n);
                    if (!t) continue;
                    var r = o[e];
                    if (a.option("conditionals")) {
                        var i = ee(a, t, n.right, r);
                        if (i) {
                            n.right = i;
                            o.splice(e--, 1);
                            s--;
                            continue;
                        }
                    }
                    if (a.option("dead_code") && f(r) === t && r.right.is_constant_expression(t.scope.resolve())) {
                        o[--e] = n.right;
                    }
                }
            }
        });
        e(dr, function(e, n) {
            if (n.option("sequences")) {
                var t = ve(e, n);
                if (t !== e) return t.optimize(n);
            }
            return de(n, e);
        });
        var ae = ln("+ -");
        var oe = ln("* / %");
        e($n, function(e, n) {
            var t = e.operator;
            var r = e.expression;
            if (n.option("sequences") && f()) {
                var i = ve(e, n);
                if (i !== e) return i.optimize(n);
            }
            switch (t) {
              case "+":
                if (!n.option("evaluate")) break;
                if (!r.is_number(n, true)) break;
                var a = n.parent();
                if (a instanceof $n && a.operator == "delete") break;
                return r;

              case "-":
                if (r instanceof Vr) r = r.transform(n);
                if (r instanceof Yn || r instanceof Vr) return e;
                break;

              case "!":
                if (!n.option("booleans")) break;
                if (r.is_truthy()) return Me(e, [ r, Ce(Gr, e) ]).optimize(n);
                if (n.in_boolean_context()) {
                    if (r instanceof $n && r.operator == "!") return r.expression;
                    if (r instanceof zn) {
                        e = pe(n, e, r.negate(n, Zn(n)));
                    }
                }
                break;

              case "delete":
                if (!n.option("evaluate")) break;
                if (s(r)) break;
                return Me(e, [ r, Ce(Jr, e) ]).optimize(n);

              case "typeof":
                if (!n.option("booleans")) break;
                if (!n.in_boolean_context()) break;
                vn.warn("Boolean expression always true [{file}:{line},{col}]", e.start);
                var o = [ Ce(Jr, e) ];
                if (!(r instanceof Nn && ze(r, n))) o.unshift(r);
                return Me(e, o).optimize(n);

              case "void":
                if (!n.option("side_effects")) break;
                r = r.drop_side_effect_free(n);
                if (!r) return Ce(Lr, e).optimize(n);
                e.expression = r;
                return e;
            }
            if (n.option("evaluate") && r instanceof zn && ae[t] && oe[r.operator] && (r.left.is_constant() || !r.right.has_side_effects(n))) {
                return Ce(zn, e, {
                    operator: r.operator,
                    left: Ce($n, r.left, {
                        operator: t,
                        expression: r.left
                    }),
                    right: r.right
                });
            }
            return de(n, e);
            function s(e) {
                return e instanceof Vr || e instanceof Br || e instanceof Nr || e instanceof Tn || e instanceof Nn || e instanceof Lr;
            }
            function f() {
                switch (t) {
                  case "delete":
                    return !s(r.tail_node());

                  case "typeof":
                    return !Pe(r.tail_node());

                  default:
                    return true;
                }
            }
        });
        e(vr, function(e, n) {
            if (!n.option("awaits")) return e;
            if (n.option("sequences")) {
                var t = ve(e, n);
                if (t !== e) return t.optimize(n);
            }
            if (n.option("side_effects")) {
                var r = e.expression;
                if (r instanceof vr) return r.optimize(n);
                if (r instanceof $n && r.expression instanceof vr) return r.optimize(n);
                for (var i = 0, a = e, o; o = n.parent(i++); a = o) {
                    if (wt(o)) {
                        if (o.value === a) return r.optimize(n);
                    } else if (o instanceof yn) {
                        var s = true;
                        do {
                            a = o;
                            o = n.parent(i++);
                            if (o instanceof Zt && (o.bfinally || o.bcatch) !== a) {
                                s = false;
                                break;
                            }
                        } while (o && !(o instanceof gn));
                        if (s) return r.optimize(n);
                    } else if (o instanceof Sn) {
                        if (o.tail_node() === a) continue;
                    }
                    break;
                }
            }
            return e;
        });
        e(hr, function(e, n) {
            if (!n.option("yields")) return e;
            if (n.option("sequences")) {
                var t = ve(e, n);
                if (t !== e) return t.optimize(n);
            }
            var r = e.expression;
            if (e.nested && r.TYPE == "Call") {
                var i = r.clone().optimize(n);
                if (i.TYPE != "Call") return i;
            }
            return e;
        });
        zn.DEFMETHOD("lift_sequences", function(e) {
            if (this.left instanceof Tn) {
                if (!(this.left.expression instanceof Sn)) return this;
                var n = this.left.expression.expressions.slice();
                var t = this.clone();
                t.left = t.left.clone();
                t.left.expression = n.pop();
                n.push(t);
                return Me(this, n);
            }
            if (this.left instanceof Sn) {
                var n = this.left.expressions.slice();
                var t = this.clone();
                t.left = n.pop();
                n.push(t);
                return Me(this, n);
            }
            if (this.right instanceof Sn) {
                if (this.left.has_side_effects(e)) return this;
                var r = this.operator == "=" && this.left instanceof Nn;
                var n = this.right.expressions;
                var i = n.length - 1;
                for (var a = 0; a < i; a++) {
                    if (!r && n[a].has_side_effects(e)) break;
                }
                if (a == i) {
                    n = n.slice();
                    var t = this.clone();
                    t.right = n.pop();
                    n.push(t);
                    return Me(this, n);
                }
                if (a > 0) {
                    var t = this.clone();
                    t.right = Me(this.right, n.slice(a));
                    n = n.slice(0, a);
                    n.push(t);
                    return Me(this, n);
                }
            }
            return this;
        });
        var se = ln("indexOf lastIndexOf");
        var Ae = ln("== === != !== * & | ^");
        function De(e) {
            if (e instanceof Cn) return e.operator == "=" && De(e.right);
            if (e instanceof Sn) return De(e.tail_node());
            if (e instanceof Nn) return De(e.fixed_value());
            return e instanceof Mn || e instanceof Pt || e instanceof bn || e instanceof cr || e instanceof Pn;
        }
        function We(e, n, t) {
            switch (e) {
              case "in":
                return De(n) || t && t.option("unsafe_comps");

              case "instanceof":
                if (n instanceof Nn) n = n.fixed_value();
                return $(n) || t && t.option("unsafe_comps");

              default:
                return true;
            }
        }
        function x(e, n) {
            if (n.is_constant()) return true;
            if (n instanceof Cn) return n.operator != "=" || x(e, n.right);
            if (n instanceof zn) {
                return !Ne[n.operator] || x(e, n.left) && x(e, n.right);
            }
            if (n instanceof qn) {
                return x(e, n.consequent) && x(e, n.alternative);
            }
            if (n instanceof Sn) return x(e, n.tail_node());
            if (n instanceof Nn) {
                var t = n.fixed_value();
                return t && x(e, t);
            }
            if (n instanceof Ir) return !n.tag || Ke(e, n.tag);
            if (n instanceof On) return true;
        }
        function Ge(e, n) {
            if (n instanceof An) return Ge(e, n.expression);
            if (n instanceof pr) {
                return Ge(e, n.expression) && Ge(e, n.property);
            }
            if (n instanceof Er) return true;
            return !n.has_side_effects(e);
        }
        function Je(e, n) {
            var t = e.right;
            e.left = Ce(zn, e, {
                operator: e.operator,
                left: e.left,
                right: t.left,
                start: e.left.start,
                end: t.left.end
            });
            e.right = t.right;
            if (n) {
                e.left = e.left.transform(n);
            } else if (e.operator == t.left.operator) {
                Je(e.left);
            }
        }
        e(zn, function(r, o) {
            if (Ae[r.operator] && r.right.is_constant() && !r.left.is_constant() && !(r.left instanceof zn && ni[r.left.operator] >= ni[r.operator])) {
                O();
            }
            if (o.option("sequences")) {
                var e = r.lift_sequences(o);
                if (e !== r) return e.optimize(o);
            }
            if (o.option("assignments") && Ne[r.operator]) {
                var n = r.right;
                if (r.left instanceof Nn && n instanceof Cn && n.operator == "=" && r.left.equivalent_to(n.left)) {
                    return Ce(Cn, r, {
                        operator: "=",
                        left: n.left,
                        right: Ce(zn, r, {
                            operator: r.operator,
                            left: r.left,
                            right: n.right
                        })
                    }).optimize(o);
                }
            }
            if (o.option("comparisons")) switch (r.operator) {
              case "===":
              case "!==":
                if (je(r.left, o) && r.right.is_defined(o)) {
                    vn.warn("Expression always defined [{file}:{line},{col}]", r.start);
                    return Me(r, [ r.right, Ce(r.operator == "===" ? Gr : Jr, r) ]).optimize(o);
                }
                var t = true;
                if (r.left.is_string(o) && r.right.is_string(o) || r.left.is_number(o) && r.right.is_number(o) || r.left.is_boolean(o) && r.right.is_boolean(o) || Ge(o, r.left) && r.left.equivalent_to(r.right)) {
                    r.operator = r.operator.slice(0, 2);
                }

              case "==":
              case "!=":
                if (!t && je(r.left, o)) {
                    r.left = Ce(Rr, r.left);
                } else if (o.option("typeofs") && r.left instanceof Hn && r.left.value == "undefined" && r.right instanceof $n && r.right.operator == "typeof") {
                    var i = r.right.expression;
                    if (i instanceof Nn ? i.is_declared(o) : !(i instanceof Tn && o.option("ie"))) {
                        r.right = i;
                        r.left = Ce(Lr, r.left).optimize(o);
                        if (r.operator.length == 2) r.operator += "=";
                    }
                } else if (r.left instanceof Nn && r.right instanceof Nn && r.left.definition() === r.right.definition() && De(r.left)) {
                    return Ce(r.operator[0] == "=" ? Jr : Gr, r).optimize(o);
                }
                break;

              case "&&":
              case "||":
                var a = r.left;
                if (a.operator == r.operator) a = a.right;
                var i = a.right;
                if (i instanceof Cn && i.operator == "=") i = i.left;
                if (a instanceof zn && a.operator == (r.operator == "&&" ? "!==" : "===") && r.right instanceof zn && a.operator == r.right.operator && (je(a.left, o) && r.right.left instanceof Rr || a.left instanceof Rr && je(r.right.left, o)) && !i.has_side_effects(o) && i.equivalent_to(r.right.right)) {
                    a.operator = a.operator.slice(0, -1);
                    a.left = Ce(Rr, r);
                    return r.left;
                }
                break;
            }
            var s = false;
            var f = o.parent();
            if (o.option("booleans")) {
                var a = r.left;
                if (Ne[r.operator] && !a.has_side_effects(o)) {
                    if (a.equivalent_to(r.right)) {
                        return Fe(o, f, o.self(), a).optimize(o);
                    }
                    G(o, a);
                }
                s = o.in_boolean_context();
            }
            if (s) switch (r.operator) {
              case "+":
                var u = r.left.evaluate(o, true);
                if (u && typeof u == "string" || (u = r.right.evaluate(o, true)) && typeof u == "string") {
                    vn.warn("+ in boolean context always true [{file}:{line},{col}]", r.start);
                    var c = [];
                    if (r.left.evaluate(o) instanceof vn) c.push(r.left);
                    if (r.right.evaluate(o) instanceof vn) c.push(r.right);
                    if (c.length < 2) {
                        c.push(Ce(Jr, r));
                        return Me(r, c).optimize(o);
                    }
                    r.truthy = true;
                }
                break;

              case "==":
                if (r.left instanceof Hn && r.left.value == "" && r.right.is_string(o)) {
                    return Ce($n, r, {
                        operator: "!",
                        expression: r.right
                    }).optimize(o);
                }
                break;

              case "!=":
                if (r.left instanceof Hn && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                break;
            }
            if (o.option("comparisons") && r.is_boolean(o)) {
                if (!(f instanceof zn) || f instanceof Cn) {
                    var l = pe(o, r, Ce($n, r, {
                        operator: "!",
                        expression: r.negate(o, Zn(o))
                    }));
                    if (l !== r) return l;
                }
                switch (r.operator) {
                  case ">":
                    O("<");
                    break;

                  case ">=":
                    O("<=");
                    break;
                }
            }
            if (o.option("conditionals") && Ne[r.operator] && r.right instanceof zn && r.operator == r.right.operator) {
                Je(r, o);
            }
            if (o.option("strings") && r.operator == "+") {
                if (r.right instanceof Hn && r.right.value == "" && r.left.is_string(o)) {
                    return r.left.optimize(o);
                }
                if (r.left instanceof Hn && r.left.value == "" && r.right.is_string(o)) {
                    return r.right.optimize(o);
                }
                if (r.left instanceof zn && r.left.operator == "+" && r.left.left instanceof Hn && r.left.left.value == "" && r.right.is_string(o) && (r.left.right.is_constant() || !r.right.has_side_effects(o))) {
                    r.left = r.left.right;
                    return r.optimize(o);
                }
                if (r.right instanceof zn && r.operator == r.right.operator && (r.left.is_string(o) && r.right.is_string(o) || r.right.left.is_string(o) && (r.left.is_constant() || !r.right.right.has_side_effects(o)))) {
                    Je(r, o);
                }
            }
            if (o.option("evaluate")) {
                var p = true;
                switch (r.operator) {
                  case "&&":
                    var d = q(o, r.left);
                    if (!d) {
                        vn.warn("Condition left of && always false [{file}:{line},{col}]", r.start);
                        return Fe(o, f, o.self(), r.left).optimize(o);
                    } else if (!(d instanceof vn)) {
                        vn.warn("Condition left of && always true [{file}:{line},{col}]", r.start);
                        return Me(r, [ r.left, r.right ]).optimize(o);
                    }
                    if (!r.right.evaluate(o, true)) {
                        if (s && !(r.right.evaluate(o) instanceof vn)) {
                            vn.warn("Boolean && always false [{file}:{line},{col}]", r.start);
                            return Me(r, [ r.left, Ce(Gr, r) ]).optimize(o);
                        } else r.falsy = true;
                    } else if ((s || f.operator == "&&" && f.left === o.self()) && !(r.right.evaluate(o) instanceof vn)) {
                        vn.warn("Dropping side-effect-free && [{file}:{line},{col}]", r.start);
                        return r.left.optimize(o);
                    }
                    if (r.left.operator == "||") {
                        var v = q(o, r.left.right);
                        if (!v) return Ce(qn, r, {
                            condition: r.left.left,
                            consequent: r.right,
                            alternative: r.left.right
                        }).optimize(o);
                    }
                    break;

                  case "??":
                    var h = true;

                  case "||":
                    var d = q(o, r.left, h);
                    if (h ? d == null : !d) {
                        vn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: h ? "nulish" : "false",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Me(r, [ r.left, r.right ]).optimize(o);
                    } else if (!(d instanceof vn)) {
                        vn.warn("Condition left of {operator} always {value} [{file}:{line},{col}]", {
                            operator: r.operator,
                            value: h ? "defined" : "true",
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return Fe(o, f, o.self(), r.left).optimize(o);
                    }
                    var m;
                    if (!h && (m = r.right.evaluate(o, true)) && !(m instanceof vn)) {
                        if (s && !(r.right.evaluate(o) instanceof vn)) {
                            vn.warn("Boolean || always true [{file}:{line},{col}]", r.start);
                            return Me(r, [ r.left, Ce(Jr, r) ]).optimize(o);
                        } else r.truthy = true;
                    } else if ((s || f.operator == "||" && f.left === o.self()) && !r.right.evaluate(o)) {
                        vn.warn("Dropping side-effect-free {operator} [{file}:{line},{col}]", {
                            operator: r.operator,
                            file: r.start.file,
                            line: r.start.line,
                            col: r.start.col
                        });
                        return r.left.optimize(o);
                    }
                    if (!h && r.left.operator == "&&") {
                        var v = q(o, r.left.right);
                        if (v && !(v instanceof vn)) return Ce(qn, r, {
                            condition: r.left.left,
                            consequent: r.left.right,
                            alternative: r.right
                        }).optimize(o);
                    }
                    break;

                  case "+":
                    if (r.left instanceof In && r.right instanceof zn && r.right.operator == "+" && r.right.left instanceof In && r.right.is_string(o)) {
                        r = Ce(zn, r, {
                            operator: "+",
                            left: Ce(Hn, r.left, {
                                value: "" + r.left.value + r.right.left.value,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                    }
                    if (r.right instanceof In && r.left instanceof zn && r.left.operator == "+" && r.left.right instanceof In && r.left.is_string(o)) {
                        r = Ce(zn, r, {
                            operator: "+",
                            left: r.left.left,
                            right: Ce(Hn, r.right, {
                                value: "" + r.left.right.value + r.right.value,
                                start: r.left.right.start,
                                end: r.right.end
                            })
                        });
                    }
                    if (r.right instanceof $n && r.right.operator == "-" && r.left.is_number(o)) {
                        r = Ce(zn, r, {
                            operator: "-",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }
                    if (r.left instanceof $n && r.left.operator == "-" && D() && r.right.is_number(o)) {
                        r = Ce(zn, r, {
                            operator: "-",
                            left: r.right,
                            right: r.left.expression
                        });
                        break;
                    }
                    if (o.option("unsafe_math") && r.left instanceof zn && ni[r.left.operator] == ni[r.operator] && r.right.is_constant() && (r.right.is_boolean(o) || r.right.is_number(o)) && r.left.is_number(o) && !r.left.right.is_constant() && (r.left.left.is_boolean(o) || r.left.left.is_number(o))) {
                        r = Ce(zn, r, {
                            operator: r.left.operator,
                            left: Ce(zn, r, {
                                operator: r.operator,
                                left: r.right,
                                right: r.left.left
                            }),
                            right: r.left.right
                        });
                        break;
                    }

                  case "-":
                    if (r.right instanceof $n && r.right.operator == "-" && r.left.is_number(o) && r.right.expression.is_number(o)) {
                        r = Ce(zn, r, {
                            operator: "+",
                            left: r.left,
                            right: r.right.expression
                        });
                        break;
                    }

                  case "*":
                  case "/":
                    p = o.option("unsafe_math");
                    if (r.operator != "+") [ "left", "right" ].forEach(function(e) {
                        var n = r[e];
                        if (n instanceof $n && n.operator == "+") {
                            var t = n.expression;
                            if (t.is_boolean(o) || t.is_number(o) || t.is_string(o)) {
                                r[e] = t;
                            }
                        }
                    });

                  case "&":
                  case "|":
                  case "^":
                    if (r.operator != "-" && r.operator != "/" && (r.left.is_boolean(o) || r.left.is_number(o)) && (r.right.is_boolean(o) || r.right.is_number(o)) && D() && !(r.left instanceof zn && r.left.operator != r.operator && ni[r.left.operator] >= ni[r.operator])) {
                        var _ = Ce(zn, r, {
                            operator: r.operator,
                            left: r.right,
                            right: r.left
                        });
                        if (r.right instanceof In && !(r.left instanceof In)) {
                            r = pe(o, _, r);
                        } else {
                            r = pe(o, r, _);
                        }
                    }
                    if (!p || !r.is_number(o)) break;
                    if (r.right instanceof zn && r.right.operator != "%" && ni[r.right.operator] == ni[r.operator] && r.right.is_number(o) && (r.operator != "+" || r.right.left.is_boolean(o) || r.right.left.is_number(o)) && (r.operator != "-" || !r.left.is_negative_zero()) && (r.right.left.is_constant_expression() || !r.right.right.has_side_effects(o)) && !k(r.right.right)) {
                        r = Ce(zn, r, {
                            operator: E(r.operator, r.right.operator),
                            left: Ce(zn, r.left, {
                                operator: r.operator,
                                left: r.left,
                                right: r.right.left,
                                start: r.left.start,
                                end: r.right.left.end
                            }),
                            right: r.right.right
                        });
                        if (r.operator == "+" && !r.right.is_boolean(o) && !r.right.is_number(o)) {
                            r.right = Ce($n, r.right, {
                                operator: "+",
                                expression: r.right
                            });
                        }
                    }
                    if (r.right instanceof In && r.left instanceof zn && r.left.operator != "%" && ni[r.left.operator] == ni[r.operator] && r.left.is_number(o)) {
                        if (r.left.left instanceof In) {
                            var a = S(r.left, r.operator, r.left.left, r.right, r.left.left.start, r.right.end);
                            r = S(r, r.left.operator, de(o, a), r.left.right);
                        } else if (r.left.right instanceof In) {
                            var g = E(r.left.operator, r.operator);
                            var b = de(o, S(r.left, g, r.left.right, r.right));
                            if (b.is_constant() && !(r.left.operator == "-" && r.right.value != 0 && +b.value == 0 && r.left.left.is_negative_zero())) {
                                r = S(r, r.left.operator, r.left.left, b);
                            }
                        }
                    }
                    break;

                  case "instanceof":
                    if ($(r.right)) return Me(r, [ r, Ce(Gr, r) ]).optimize(o);
                    break;
                }
                if (!(f instanceof $n && f.operator == "delete")) {
                    if (r.left instanceof Yn && !r.right.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.left.value == 0) {
                            if (r.right.is_boolean(o)) return Ce($n, r, {
                                operator: "+",
                                expression: r.right
                            }).optimize(o);
                            if (r.right.is_number(o) && !r.right.is_negative_zero()) return r.right;
                        }
                        break;

                      case "*":
                        if (r.left.value == 1) return Ce($n, r, {
                            operator: "+",
                            expression: r.right
                        }).optimize(o);
                        break;
                    }
                    if (r.right instanceof Yn && !r.left.is_constant()) switch (r.operator) {
                      case "+":
                        if (r.right.value == 0) {
                            if (r.left.is_boolean(o)) return Ce($n, r, {
                                operator: "+",
                                expression: r.left
                            }).optimize(o);
                            if (r.left.is_number(o) && !r.left.is_negative_zero()) return r.left;
                        }
                        break;

                      case "-":
                        if (r.right.value == 0) return Ce($n, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(o);
                        break;

                      case "/":
                        if (r.right.value == 1) return Ce($n, r, {
                            operator: "+",
                            expression: r.left
                        }).optimize(o);
                        break;
                    }
                }
            }
            if (o.option("typeofs")) switch (r.operator) {
              case "&&":
                N(r.left, r.right, null);
                break;

              case "||":
                N(r.left, null, r.right);
                break;
            }
            if (o.option("unsafe")) {
                var y = T(r.right);
                if (s && y && (r.operator == "==" || r.operator == "!=") && r.left instanceof Yn && r.left.value == 0) {
                    return (r.operator == "==" ? Ce($n, r, {
                        operator: "!",
                        expression: r.right
                    }) : r.right).optimize(o);
                }
                var w = T(r.left);
                if (o.option("comparisons") && A()) {
                    var x = Ce($n, r, {
                        operator: "!",
                        expression: Ce($n, r, {
                            operator: "~",
                            expression: w ? r.left : r.right
                        })
                    });
                    switch (r.operator) {
                      case "<":
                        if (w) break;

                      case "<=":
                      case "!=":
                        x = Ce($n, r, {
                            operator: "!",
                            expression: x
                        });
                        break;
                    }
                    return x.optimize(o);
                }
            }
            return de(o, r);
            function k(e) {
                var n = false;
                e.walk(new Rn(function(e) {
                    if (n) return true;
                    if (e instanceof Cn) {
                        if (e.left instanceof Tn) return n = true;
                    } else if (e instanceof On) {
                        if (ii[e.operator] && e.expression instanceof Tn) {
                            return n = true;
                        }
                    }
                }));
                return n;
            }
            function E(e, n) {
                switch (e) {
                  case "-":
                    return n == "+" ? "-" : "+";

                  case "/":
                    return n == "*" ? "/" : "*";

                  default:
                    return n;
                }
            }
            function S(e, n, t, r, i, a) {
                if (n == "+") {
                    if (!t.is_boolean(o) && !t.is_number(o)) {
                        t = Ce($n, t, {
                            operator: "+",
                            expression: t
                        });
                    }
                    if (!r.is_boolean(o) && !r.is_number(o)) {
                        r = Ce($n, r, {
                            operator: "+",
                            expression: r
                        });
                    }
                }
                return Ce(zn, e, {
                    operator: n,
                    left: t,
                    right: r,
                    start: i,
                    end: a
                });
            }
            function T(e) {
                return e.TYPE == "Call" && e.expression instanceof An && se[e.expression.property];
            }
            function A() {
                switch (r.operator) {
                  case "<=":
                    return y && r.left instanceof Yn && r.left.value == 0;

                  case "<":
                    if (w && r.right instanceof Yn && r.right.value == 0) return true;

                  case "==":
                  case "!=":
                    if (!y) return false;
                    return r.left instanceof Yn && r.left.value == -1 || r.left instanceof $n && r.left.operator == "-" && r.left.expression instanceof Yn && r.left.expression.value == 1;
                }
            }
            function D() {
                return r.left.is_constant() || r.right.is_constant() || !r.left.has_side_effects(o) && !r.right.has_side_effects(o);
            }
            function O(e) {
                if (D()) {
                    if (e) r.operator = e;
                    var n = r.left;
                    r.left = r.right;
                    r.right = n;
                }
            }
        });
        e(Mr, function(e) {
            return e;
        });
        function Xe(e, n, t) {
            var r = 0, i = e.self();
            do {
                if (i === t) return i;
                if ($(i) && i.name && i.name.definition() === n) return i;
            } while (i = e.parent(r++));
        }
        function Ie(e) {
            var n = e.scope.resolve();
            return pn(e.references, function(e) {
                return n === e.scope.resolve();
            });
        }
        e(Nn, function(t, e) {
            if (!e.option("ie") && Pe(t) && !(t.scope.resolve().uses_with && e.find_parent(mt))) {
                switch (t.name) {
                  case "undefined":
                    return Ce(Lr, t).optimize(e);

                  case "NaN":
                    return Ce(Br, t).optimize(e);

                  case "Infinity":
                    return Ce(Vr, t).optimize(e);
                }
            }
            var n = e.parent();
            if (e.option("reduce_vars") && ai(e.self(), n) !== e.self()) {
                var r = t.definition();
                var i = t.fixed_value();
                var a = r.single_use && !(n instanceof En && n.is_expr_pure(e));
                if (a) {
                    if ($(i)) {
                        if ((r.scope !== t.scope.resolve() || r.in_loop) && (!e.option("reduce_funcs") || r.escaped.depth == 1 || i.inlined)) {
                            a = false;
                        } else if (Xe(e, r, i)) {
                            a = false;
                        } else if (i.name && i.name.definition() !== r) {
                            a = false;
                        } else if (i.parent_scope !== t.scope || ri(r)) {
                            if (!Te(i, e)) {
                                a = false;
                            } else if ((a = i.is_constant_expression(t.scope)) == "f") {
                                var o = t.scope;
                                do {
                                    if (o instanceof zt || o instanceof yt) {
                                        o.inlined = true;
                                    }
                                } while (o = o.parent_scope);
                            }
                        } else if (i.name && (i.name.name == "await" && xt(i) || i.name.name == "yield" && kt(i))) {
                            a = false;
                        } else if (i.has_side_effects(e)) {
                            a = false;
                        } else if (e.option("ie") && i instanceof Pt) {
                            a = false;
                        }
                        if (a) i.parent_scope = t.scope;
                    } else if (!i || r.recursive_refs > 0 || !i.is_constant_expression() || i.drop_side_effect_free(e)) {
                        a = false;
                    }
                }
                if (a) {
                    r.single_use = false;
                    i._squeezed = true;
                    i.single_use = true;
                    if (i instanceof jt) i = ie(i);
                    if (i instanceof zt) i = we(i);
                    if ($(i)) {
                        var o = t.scope.resolve();
                        i.enclosed.forEach(function(e) {
                            if (i.variables.has(e.name)) return;
                            if (o.var_names().has(e.name)) return;
                            o.enclosed.push(e);
                            o.var_names().set(e.name, true);
                        });
                    }
                    var s;
                    if (r.recursive_refs > 0) {
                        s = i.clone(true);
                        var f = s.name.definition();
                        var u = s.variables.get(s.name.name);
                        var c = u && u.orig[0];
                        var l, p;
                        if (s instanceof Pt) {
                            l = "def_function";
                            p = qr;
                        } else {
                            l = "def_variable";
                            p = zr;
                        }
                        if (!(c instanceof p)) {
                            c = Ce(p, s.name, s.name);
                            c.scope = s;
                            s.name = c;
                            u = s[l](c);
                            u.recursive_refs = r.recursive_refs;
                        }
                        s.walk(new Rn(function(e) {
                            if (e instanceof Sr) {
                                if (e !== c) {
                                    var n = e.definition();
                                    n.orig.push(e);
                                    n.eliminated++;
                                }
                                return;
                            }
                            if (!(e instanceof Nn)) return;
                            var n = e.definition();
                            if (n === f) {
                                e.thedef = n = u;
                            } else {
                                n.single_use = false;
                                var t = e.fixed_value();
                                if ($(t) && t.name && t.name.definition() === n && n.scope === t.name.scope && i.variables.get(t.name.name) === n) {
                                    t.name = t.name.clone();
                                    e.thedef = n = s.variables.get(t.name.name) || s[l](t.name);
                                }
                            }
                            n.references.push(e);
                        }));
                    } else {
                        if (i instanceof gn) {
                            e.push(i);
                            s = i.optimize(e);
                            e.pop();
                        } else {
                            s = i.optimize(e);
                        }
                        s = s.transform(new Xr(function(e, n) {
                            if (e instanceof gn) return e;
                            e = e.clone();
                            n(e, this);
                            return e;
                        }));
                    }
                    r.replaced++;
                    return s;
                }
                var d;
                if (i && (d = t.fixed || r.fixed).should_replace !== false) {
                    var v, h;
                    if (i instanceof jr) {
                        if (!ri(r) && Ie(r) && !b(r)) h = i;
                    } else if ((v = i.evaluate(e, true)) !== i && typeof v != "function" && (v === null || typeof v != "object" || e.option("unsafe_regexp") && v instanceof RegExp && !r.cross_loop && Ie(r))) {
                        h = fe(v, i);
                    }
                    if (h) {
                        if (d.should_replace === undefined) {
                            var m = h.optimize(e).print_to_string().length;
                            if (!y(i)) {
                                m = Math.min(m, i.print_to_string().length);
                            }
                            var _ = r.name.length;
                            if (e.option("unused") && !e.exposed(r)) {
                                var g = r.references.length - r.replaced - r.assignments;
                                g = Math.min(g, r.references.filter(function(e) {
                                    return e.fixed === d;
                                }).length);
                                _ += (_ + 2 + m) / Math.max(1, g);
                            }
                            d.should_replace = m - Math.floor(_) < e.eval_threshold;
                        }
                        if (d.should_replace) {
                            var s;
                            if (y(i)) {
                                s = h.optimize(e);
                                if (s === h) s = s.clone(true);
                            } else {
                                s = le(h.optimize(e), i);
                                if (s === h || s === i) s = s.clone(true);
                            }
                            r.replaced++;
                            return s;
                        }
                    }
                }
            }
            return t;
            function b(e) {
                var n = t.scope;
                while (n !== e.scope) {
                    if (n instanceof Pt) return true;
                    n = n.parent_scope;
                }
            }
            function y(e) {
                var n;
                e.walk(new Rn(function(e) {
                    if (e instanceof Nn) n = true;
                    if (n) return true;
                }));
                return n;
            }
        });
        function Ke(e, n) {
            return e.option("unsafe") && n instanceof An && n.property == "raw" && Pe(n.expression) && n.expression.name == "String";
        }
        function Qe(e) {
            var r = false;
            e = e.replace(/\\(u\{[^{}]*\}?|u[\s\S]{0,4}|x[\s\S]{0,2}|[0-9]+|[\s\S])/g, function(e, n) {
                var t = Qr(n);
                if (typeof t == "string") return t;
                r = true;
            });
            if (!r) return e;
        }
        e(Ir, function(e, t) {
            if (!t.option("templates")) return e;
            var r = e.tag;
            if (!r || Ke(t, r)) {
                var n = [];
                var i = [];
                for (var a = 0, o; a < e.strings.length; a++) {
                    var s = e.strings[a];
                    if (!r) {
                        var f = Qe(s);
                        if (f) s = h(f);
                    }
                    if (a > 0) {
                        var u = e.expressions[a - 1];
                        var c = m(u);
                        if (c) {
                            var l = i[i.length - 1];
                            var p = l + c + s;
                            var d;
                            if (r || typeof (d = Qe(p)) == o) {
                                i[i.length - 1] = d ? h(d) : p;
                                continue;
                            }
                        }
                        n.push(u);
                    }
                    i.push(s);
                    if (!r) o = typeof f;
                }
                if (!r && i.length > 1) {
                    if (i[i.length - 1] == "") return Ce(zn, e, {
                        operator: "+",
                        left: Ce(Ir, e, {
                            expressions: n.slice(0, -1),
                            strings: i.slice(0, -1),
                            tag: r
                        }).transform(t),
                        right: n[n.length - 1]
                    }).optimize(t);
                    if (i[0] == "") {
                        var v = Ce(zn, e, {
                            operator: "+",
                            left: Ce(Hn, e, {
                                value: ""
                            }),
                            right: n[0]
                        });
                        for (var a = 1; i[a] == "" && a < n.length; a++) {
                            v = Ce(zn, e, {
                                operator: "+",
                                left: v,
                                right: n[a]
                            });
                        }
                        return pe(t, e, Ce(zn, e, {
                            operator: "+",
                            left: v.transform(t),
                            right: Ce(Ir, e, {
                                expressions: n.slice(a),
                                strings: i.slice(a),
                                tag: r
                            }).transform(t)
                        }).optimize(t));
                    }
                }
                e.expressions = n;
                e.strings = i;
            }
            return de(t, e);
            function h(e) {
                return e.replace(/\r|\\|`|\${/g, function(e) {
                    return "\\" + (e == "\r" ? "r" : e);
                });
            }
            function m(e) {
                var n = e.evaluate(t);
                if (n === e) return;
                if (r && /\r|\\|`/.test(n)) return;
                n = h("" + n);
                if (n.length > e.print_to_string().length + "${}".length) return;
                return n;
            }
        });
        function Ze(e, n) {
            return e instanceof Nn || e.TYPE === n.TYPE;
        }
        e(Lr, function(e, n) {
            if (n.option("unsafe_undefined")) {
                var t = qe(n).find_variable("undefined");
                if (t) {
                    var r = Ce(Nn, e, {
                        name: "undefined",
                        scope: t.scope,
                        thedef: t
                    });
                    r.is_undefined = true;
                    return r;
                }
            }
            var i = ai(n.self(), n.parent());
            if (i && Ze(i, e)) return e;
            return Ce($n, e, {
                operator: "void",
                expression: Ce(Yn, e, {
                    value: 0
                })
            });
        });
        e(Vr, function(e, n) {
            var t = ai(n.self(), n.parent());
            if (t && Ze(t, e)) return e;
            if (n.option("keep_infinity") && !t && !qe(n).find_variable("Infinity")) {
                return e;
            }
            return Ce(zn, e, {
                operator: "/",
                left: Ce(Yn, e, {
                    value: 1
                }),
                right: Ce(Yn, e, {
                    value: 0
                })
            });
        });
        e(Br, function(e, n) {
            var t = ai(n.self(), n.parent());
            if (t && Ze(t, e)) return e;
            if (!t && !qe(n).find_variable("NaN")) return e;
            return Ce(zn, e, {
                operator: "/",
                left: Ce(Yn, e, {
                    value: 0
                }),
                right: Ce(Yn, e, {
                    value: 0
                })
            });
        });
        function en(t, n) {
            var r = false;
            var i = new Rn(function(e) {
                if (r) return true;
                if (e instanceof Nn && Bn(e.definition(), n)) return r = true;
            });
            var a = new Rn(function(e) {
                if (r) return true;
                if (e instanceof bn && e !== t) {
                    if (!(e.name || xt(e) || kt(e))) {
                        var n = a.parent();
                        if (n instanceof En && n.expression === e) return;
                    }
                    e.walk(i);
                    return true;
                }
            });
            t.walk(a);
            return r;
        }
        var nn = ln("+ - * / % >> << >>> | ^ &");
        var tn = ln("* | ^ &");
        e(Cn, function(o, s) {
            if (s.option("dead_code")) {
                if (o.left instanceof Tn) {
                    if (o.operator == "=") {
                        if (o.redundant) {
                            var e = [ o.left.expression ];
                            if (o.left instanceof pr) e.push(o.left.property);
                            e.push(o.right);
                            return Me(o, e).optimize(s);
                        }
                        if (o.left.equivalent_to(o.right) && !o.left.has_side_effects(s)) {
                            return o.right;
                        }
                        var n = o.left.expression;
                        if (n instanceof bn || !s.has_directive("use strict") && n instanceof In && !n.may_throw_on_access(s)) {
                            return o.left instanceof An ? o.right : Me(o, [ o.left.property, o.right ]).optimize(s);
                        }
                    }
                } else if (o.left instanceof Nn && ze(o.left, s)) {
                    var t;
                    if (o.operator == "=" && o.left.equivalent_to(o.right) && !((t = s.parent()) instanceof $n && t.operator == "delete")) {
                        return o.right;
                    }
                    if (o.left.is_immutable()) return _();
                    var r = o.left.definition();
                    var f = r.scope.resolve();
                    var i = f === s.find_parent(bn);
                    var a = 0, u;
                    t = s.self();
                    if (!(f.uses_arguments && ri(r)) || s.has_directive("use strict")) do {
                        u = t;
                        t = s.parent(a++);
                        if (t instanceof Cn) {
                            if (t.left instanceof Nn && t.left.definition() === r) {
                                if (m(a, t, !i)) break;
                                return _(r);
                            }
                            if (t.left.match_symbol(function(e) {
                                if (e instanceof Tn) return true;
                            })) break;
                            continue;
                        }
                        if (t instanceof Lt) {
                            if (!i) break;
                            if (m(a, t)) break;
                            if (en(f, [ r ])) break;
                            return _(r);
                        }
                        if (t instanceof mn) {
                            if (!i) break;
                            if (en(f, [ r ])) break;
                            var c;
                            do {
                                c = t;
                                t = s.parent(a++);
                                if (t === f && D(t.body, c)) return _(r);
                            } while (h(c, t));
                            break;
                        }
                        if (t instanceof xn) {
                            if (!(t.name instanceof Sr)) continue;
                            if (t.name.definition() !== r) continue;
                            if (m(a, t)) break;
                            return _(r);
                        }
                    } while (v(u, t));
                }
            }
            if (s.option("sequences")) {
                var l = o.lift_sequences(s);
                if (l !== o) return l.optimize(s);
            }
            if (s.option("assignments")) {
                if (o.operator == "=" && o.left instanceof Nn && o.right instanceof zn) {
                    var p;
                    if ((p = o.right.left) instanceof Nn && p.name == o.left.name && nn[o.right.operator]) {
                        if (o.left.fixed) o.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Ce(Cn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.right
                        });
                    }
                    if ((p = o.right.right) instanceof Nn && p.name == o.left.name && tn[o.right.operator] && !o.right.left.has_side_effects(s)) {
                        if (o.left.fixed) o.left.fixed.to_binary = function() {
                            return p;
                        };
                        return Ce(Cn, o, {
                            operator: o.right.operator + "=",
                            left: o.left,
                            right: o.right.left
                        });
                    }
                }
                if ((o.operator == "-=" || o.operator == "+=" && (o.left.is_boolean(s) || o.left.is_number(s))) && o.right instanceof Yn && o.right.value == 1) {
                    var d = o.operator.slice(0, -1);
                    return Ce($n, o, {
                        operator: d + d,
                        expression: o.left
                    });
                }
            }
            return de(s, o);
            function v(e, n) {
                if (n instanceof zn) {
                    return n.right === e || n.right.is_constant_expression(f);
                }
                if (n instanceof qn) {
                    return n.condition !== e || n.consequent.is_constant_expression(f) && n.alternative.is_constant_expression(f);
                }
                if (n instanceof Sn) {
                    var t = n.expressions;
                    var r = t.indexOf(e);
                    if (r < 0) return false;
                    for (var i = t.length; --i > r; ) {
                        if (!t[i].is_constant_expression(f)) return false;
                    }
                    return true;
                }
                if (n instanceof $n) return true;
            }
            function h(e, n) {
                if (n instanceof _n) return D(n.body, e);
                if (n instanceof er) return D(n.body, e);
                if (n instanceof nr) return D(n.body, e);
                if (n instanceof wn) return n.body === e || n.alternative === e;
                if (n instanceof Zt) return n.bfinally ? n.bfinally === e : n.bcatch === e;
            }
            function m(e, n, t) {
                var r = o.right;
                o.right = Ce(Rr, r);
                var i = n.may_throw(s);
                o.right = r;
                for (var a; a = s.parent(e++); n = a) {
                    if (a === f) return false;
                    if (t && a instanceof bn) {
                        if (a.name || xt(a) || kt(a)) return true;
                    } else if (a instanceof Zt) {
                        if (a.bfinally && a.bfinally !== n) return true;
                        if (i && a.bcatch && a.bcatch !== n) return true;
                    }
                }
            }
            function _(e) {
                if (e) e.fixed = false;
                return (o.operator != "=" ? Ce(zn, o, {
                    operator: o.operator.slice(0, -1),
                    left: o.left,
                    right: o.right
                }) : Fe(s, s.parent(), o, o.right)).optimize(s);
            }
        });
        e(qn, function(i, n) {
            if (n.option("sequences") && i.condition instanceof Sn) {
                var e = i.condition.expressions.slice();
                i.condition = e.pop();
                e.push(i);
                return Me(i, e);
            }
            if (!n.option("conditionals")) return i;
            var a = i.condition;
            if (n.option("booleans") && !a.has_side_effects(n)) {
                G(n, a);
            }
            a = q(n, a);
            if (!a) {
                vn.warn("Condition always false [{file}:{line},{col}]", i.start);
                return Me(i, [ i.condition, i.alternative ]).optimize(n);
            } else if (!(a instanceof vn)) {
                vn.warn("Condition always true [{file}:{line},{col}]", i.start);
                return Me(i, [ i.condition, i.consequent ]).optimize(n);
            }
            var t = a.negate(n, Zn(n));
            if (pe(n, a, t) === t) {
                i = Ce(qn, i, {
                    condition: t,
                    consequent: i.alternative,
                    alternative: i.consequent
                });
                t = a;
                a = i.condition;
            }
            var r = i.consequent;
            var o = i.alternative;
            if (Ge(n, a)) {
                if (a.equivalent_to(r)) return Ce(zn, i, {
                    operator: "||",
                    left: a,
                    right: o
                }).optimize(n);
                if (a.equivalent_to(o)) return Ce(zn, i, {
                    operator: "&&",
                    left: a,
                    right: r
                }).optimize(n);
            }
            var s = r.tail_node();
            if (s instanceof Cn) {
                var f = s.operator == "=";
                var u = f ? o.tail_node() : o;
                if ((f || r === s) && u instanceof Cn && s.operator == u.operator && s.left.equivalent_to(u.left) && (f && s.left instanceof Nn || !a.has_side_effects(n) && w(r) && w(o))) {
                    return Ce(Cn, i, {
                        operator: s.operator,
                        left: s.left,
                        right: Ce(qn, i, {
                            condition: a,
                            consequent: x(r),
                            alternative: x(o)
                        })
                    });
                }
            }
            if (r.equivalent_to(o)) return Me(i, [ a, r ]).optimize(n);
            var c = y(r, o, true);
            if (c) return c;
            var l;
            if (r instanceof En && o.TYPE == r.TYPE && (l = g(r, o)) >= 0 && r.expression.equivalent_to(o.expression) && !a.has_side_effects(n) && !r.expression.has_side_effects(n)) {
                var p = r.clone();
                var d = r.args[l];
                p.args[l] = d instanceof Dn ? Ce(Dn, i, {
                    expression: Ce(qn, i, {
                        condition: a,
                        consequent: d.expression,
                        alternative: o.args[l].expression
                    })
                }) : Ce(qn, i, {
                    condition: a,
                    consequent: d,
                    alternative: o.args[l]
                });
                return p;
            }
            if (r instanceof qn && r.alternative.equivalent_to(o)) {
                return Ce(qn, i, {
                    condition: Ce(zn, i, {
                        left: a,
                        operator: "&&",
                        right: r.condition
                    }),
                    consequent: r.consequent,
                    alternative: o
                });
            }
            if (r instanceof qn && r.consequent.equivalent_to(o)) {
                return Ce(qn, i, {
                    condition: Ce(zn, i, {
                        left: t,
                        operator: "||",
                        right: r.condition
                    }),
                    consequent: o,
                    alternative: r.alternative
                });
            }
            if (o instanceof qn && r.equivalent_to(o.consequent)) {
                return Ce(qn, i, {
                    condition: Ce(zn, i, {
                        left: a,
                        operator: "||",
                        right: o.condition
                    }),
                    consequent: r,
                    alternative: o.alternative
                });
            }
            if (o instanceof qn && r.equivalent_to(o.alternative)) {
                return Ce(qn, i, {
                    condition: Ce(zn, i, {
                        left: t,
                        operator: "&&",
                        right: o.condition
                    }),
                    consequent: o.consequent,
                    alternative: r
                });
            }
            if ((r instanceof Sn || o instanceof Sn) && r.tail_node().equivalent_to(o.tail_node())) {
                return Me(i, [ Ce(qn, i, {
                    condition: a,
                    consequent: k(r),
                    alternative: k(o)
                }), r.tail_node() ]).optimize(n);
            }
            if (r instanceof zn && r.operator == "&&" && r.right.equivalent_to(o)) {
                return Ce(zn, i, {
                    operator: "&&",
                    left: Ce(zn, i, {
                        operator: "||",
                        left: t,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (r instanceof zn && r.operator == "||" && r.right.equivalent_to(o)) {
                return Ce(zn, i, {
                    operator: "||",
                    left: Ce(zn, i, {
                        operator: "&&",
                        left: a,
                        right: r.left
                    }),
                    right: o
                }).optimize(n);
            }
            if (o instanceof zn && o.operator == "&&" && o.right.equivalent_to(r)) {
                return Ce(zn, i, {
                    operator: "&&",
                    left: Ce(zn, i, {
                        operator: "||",
                        left: a,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            if (o instanceof zn && o.operator == "||" && o.right.equivalent_to(r)) {
                return Ce(zn, i, {
                    operator: "||",
                    left: Ce(zn, i, {
                        operator: "&&",
                        left: t,
                        right: o.left
                    }),
                    right: r
                }).optimize(n);
            }
            var v = n.option("booleans") && n.in_boolean_context();
            if (m(r)) {
                if (_(o)) {
                    return h(a);
                }
                return Ce(zn, i, {
                    operator: "||",
                    left: h(a),
                    right: o
                });
            }
            if (_(r)) {
                if (m(o)) {
                    return h(a.negate(n));
                }
                return Ce(zn, i, {
                    operator: "&&",
                    left: h(a.negate(n)),
                    right: o
                });
            }
            if (m(o)) {
                return Ce(zn, i, {
                    operator: "||",
                    left: h(a.negate(n)),
                    right: r
                });
            }
            if (_(o)) {
                return Ce(zn, i, {
                    operator: "&&",
                    left: h(a),
                    right: r
                });
            }
            if (n.option("typeofs")) N(a, r, o);
            return i;
            function h(e) {
                if (e.is_boolean(n)) return e;
                return Ce($n, e, {
                    operator: "!",
                    expression: e.negate(n)
                });
            }
            function m(e) {
                return e instanceof Jr || v && e instanceof In && e.value || e instanceof $n && e.operator == "!" && e.expression instanceof In && !e.expression.value;
            }
            function _(e) {
                return e instanceof Gr || v && (e instanceof In && !e.value || e instanceof $n && e.operator == "void" && !e.expression.has_side_effects(n)) || e instanceof $n && e.operator == "!" && e.expression instanceof In && e.expression.value;
            }
            function g(e, n) {
                var t = e.args;
                var r = n.args;
                var i = t.length;
                if (i != r.length) return -2;
                for (var a = 0; a < i; a++) {
                    if (!t[a].equivalent_to(r[a])) {
                        if (t[a] instanceof Dn !== r[a] instanceof Dn) return -3;
                        for (var o = a + 1; o < i; o++) {
                            if (!t[o].equivalent_to(r[o])) return -2;
                        }
                        return a;
                    }
                }
                return -1;
            }
            function b(e, n) {
                if (e.TYPE != n.TYPE) return;
                if (e.optional != n.optional) return;
                if (e instanceof En) {
                    if (g(e, n) != -1) return;
                    return e.TYPE != "Call" || !(e.expression instanceof Tn || n.expression instanceof Tn) || b(e.expression, n.expression);
                }
                if (!(e instanceof Tn)) return;
                var t = e.property;
                var r = n.property;
                return (t instanceof vn ? t.equivalent_to(r) : t == r) && !(e.expression instanceof Pr || n.expression instanceof Pr);
            }
            function y(e, n, t) {
                if (!b(e, n)) return !t && Ce(qn, i, {
                    condition: a,
                    consequent: e,
                    alternative: n
                });
                var r = e.clone();
                r.expression = y(e.expression, n.expression);
                return r;
            }
            function w(e) {
                return e === e.tail_node() || pn(e.expressions.slice(0, -1), function(e) {
                    return !e.has_side_effects(n);
                });
            }
            function x(e) {
                if (!(e instanceof Sn)) return e.right;
                var n = e.expressions.slice();
                n.push(n.pop().right);
                return Me(e, n);
            }
            function k(e) {
                if (!(e instanceof Sn)) return Ce(Yn, e, {
                    value: 0
                });
                return Me(e, e.expressions.slice(0, -1));
            }
        });
        e(Wr, function(e, n) {
            if (!n.option("booleans")) return e;
            if (n.in_boolean_context()) return Ce(Yn, e, {
                value: +e.value
            });
            var t = n.parent();
            if (t instanceof zn && (t.operator == "==" || t.operator == "!=")) {
                vn.warn("Non-strict equality against boolean: {operator} {value} [{file}:{line},{col}]", {
                    operator: t.operator,
                    value: e.value,
                    file: t.start.file,
                    line: t.start.line,
                    col: t.start.col
                });
                return Ce(Yn, e, {
                    value: +e.value
                });
            }
            return Ce($n, e, {
                operator: "!",
                expression: Ce(Yn, e, {
                    value: 1 - e.value
                })
            });
        });
        e(Dn, function(e, n) {
            var t = e.expression;
            if (n.option("spreads") && t instanceof Mn && !(n.parent() instanceof Pn)) {
                return Gn.splice(t.elements.map(function(e) {
                    return e instanceof Ur ? Ce(Lr, e).optimize(n) : e;
                }));
            }
            return e;
        });
        function rn(e, n) {
            if (!e) return false;
            var t = n.parent();
            if (t.TYPE != "Call") return true;
            if (t.expression !== n.self()) return true;
            if (e instanceof Nn) {
                e = e.fixed_value();
                if (!e) return false;
            }
            return e instanceof bn && !e.contains_this();
        }
        e(pr, function(e, t) {
            var n = e.expression;
            var r = e.property;
            var i = ke(e, t);
            if (i) return i;
            if (t.option("properties")) {
                var a = r.evaluate(t);
                if (a !== r) {
                    if (typeof a == "string") {
                        if (a == "undefined") {
                            a = undefined;
                        } else {
                            var o = parseFloat(a);
                            if (o.toString() == a) {
                                a = o;
                            }
                        }
                    }
                    r = e.property = le(r, fe(a, r).transform(t));
                    var s = "" + a;
                    if (Kr(s) && s.length <= r.print_to_string().length + 1) {
                        return Ce(An, e, {
                            optional: e.optional,
                            expression: n,
                            property: s
                        }).optimize(t);
                    }
                }
            }
            var f = t.parent();
            var u = ai(t.self(), f);
            var c, l, p, d;
            if (t.option("arguments") && n instanceof Nn && $e(c = n.definition()) && !n.in_arg && r instanceof Yn && Math.floor(d = r.value) == d && (l = c.scope) === S() && l.uses_arguments < (u ? 2 : 3)) {
                if (f instanceof $n && f.operator == "delete") {
                    if (!c.deleted) c.deleted = [];
                    c.deleted[d] = true;
                }
                var v = l.argnames[d];
                if (c.deleted && c.deleted[d]) {
                    v = null;
                } else if (v) {
                    var h;
                    if (!(v instanceof jn) || v.name == "await" || n.scope.find_variable(v.name) !== (h = v.definition())) {
                        v = null;
                    } else if (t.has_directive("use strict") || l.name || l.rest || !(p instanceof En && d < p.args.length && pn(p.args.slice(0, d + 1), function(e) {
                        return !(e instanceof Dn);
                    })) || !pn(l.argnames, function(e) {
                        return e instanceof jn;
                    })) {
                        if (T() || h.assignments || h.orig.length > 1) v = null;
                    }
                } else if ((u || !T()) && d < l.argnames.length + 5 && t.drop_fargs(l, p) && !l.rest) {
                    while (d >= l.argnames.length) {
                        v = l.make_var(jn, l, "argument_" + l.argnames.length);
                        l.argnames.push(v);
                    }
                }
                if (v && Ln(function(e) {
                    return e.name === v.name;
                }, l.argnames) === v) {
                    if (u) c.reassigned--;
                    var m = Ce(Nn, e, v);
                    m.reference();
                    v.unused = undefined;
                    return m;
                }
            }
            if (u) return e;
            if (t.option("sequences") && f.TYPE != "Call" && !(f instanceof dt && f.init === e)) {
                var _ = ve(e, t);
                if (_ !== e) return _.optimize(t);
            }
            if (a !== r) {
                var g = e.flatten_object(s, t);
                if (g) {
                    n = e.expression = g.expression;
                    r = e.property = g.property;
                }
            }
            var b;
            if (t.option("properties") && t.option("side_effects") && r instanceof Yn && n instanceof Mn && pn(b = n.elements, function(e) {
                return !(e instanceof Dn);
            })) {
                var d = r.value;
                var y = b[d];
                if (rn(y, t)) {
                    var w = y instanceof Ur;
                    var x = !w;
                    var k = [];
                    for (var E = b.length; --E > d; ) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                            if (x && o.has_side_effects(t)) x = false;
                        }
                    }
                    if (!x) k.unshift(y);
                    while (--E >= 0) {
                        var o = b[E].drop_side_effect_free(t);
                        if (o) {
                            k.unshift(o);
                        } else if (w) {
                            k.unshift(Ce(Ur, b[E]));
                        } else {
                            d--;
                        }
                    }
                    if (x) {
                        k.push(y);
                        return Me(e, k).optimize(t);
                    }
                    return Ce(pr, e, {
                        expression: Ce(Mn, n, {
                            elements: k
                        }),
                        property: Ce(Yn, r, {
                            value: d
                        })
                    });
                }
            }
            return de(t, e);
            function S() {
                var e = 0, n;
                while (n = t.parent(e++)) {
                    if (n instanceof bn) {
                        if (n instanceof bt) return;
                        if (wt(n)) continue;
                        p = t.parent(e);
                        return n;
                    }
                }
            }
            function T() {
                return !t.option("reduce_vars") || c.reassigned;
            }
        });
        yt.DEFMETHOD("contains_super", function() {
            var n = false;
            var t = this;
            t.walk(new Rn(function(e) {
                if (n) return true;
                if (e instanceof Pr) return n = true;
                if (e !== t && e instanceof gn && !wt(e)) return true;
            }));
            return n;
        });
        (function(e) {
            e(St, un);
            e(Tt, un);
            e(vn, function() {
                var n = false;
                var t = this;
                t.walk(new Rn(function(e) {
                    if (n) return true;
                    if (e instanceof jr) return n = true;
                    if (e !== t && e instanceof gn && !wt(e)) return true;
                }));
                return n;
            });
        })(function(e, n) {
            e.DEFMETHOD("contains_this", n);
        });
        function an(e) {
            return e instanceof yr && typeof e.key == "string" && !(e instanceof wr && e.value.contains_super());
        }
        Tn.DEFMETHOD("flatten_object", function(e, n) {
            if (!n.option("properties")) return;
            if (e === "__proto__") return;
            var t = this;
            var r = t.expression;
            if (!(r instanceof Pn)) return;
            var i = r.properties;
            for (var a = i.length; --a >= 0; ) {
                var o = i[a];
                if (o.key !== e) continue;
                if (!pn(i, an)) return;
                if (!rn(o.value, n)) return;
                var s, f, u = [];
                for (var c = 0; c < i.length; c++) {
                    var l = i[c].value;
                    if (i[c] instanceof wr) {
                        var p = !(l.uses_arguments || kt(l) || l.contains_this());
                        if (p) {
                            if (!f) f = n.find_parent(gn);
                            var d = he(n, f);
                            l.each_argname(function(e) {
                                if (d[e.name]) p = false;
                            });
                        }
                        var v;
                        if (p) {
                            v = xt(l) ? Tt : St;
                        } else if (a != c || (s = n.parent()) instanceof En && s.expression === t) {
                            v = l.CTOR;
                        } else {
                            return;
                        }
                        l = Ce(v, l, l);
                    }
                    u.push(l);
                }
                return Ce(pr, t, {
                    expression: Ce(Mn, r, {
                        elements: u
                    }),
                    property: Ce(Yn, t, {
                        value: a
                    })
                });
            }
        });
        e(An, function(e, n) {
            if (e.property == "arguments" || e.property == "caller") {
                vn.warn("Function.prototype.{prop} not supported [{file}:{line},{col}]", {
                    prop: e.property,
                    file: e.start.file,
                    line: e.start.line,
                    col: e.start.col
                });
            }
            var t = n.parent();
            if (ai(n.self(), t)) return e;
            var r = ke(e, n);
            if (r) return r;
            if (n.option("sequences") && t.TYPE != "Call" && !(t instanceof dt && t.init === e)) {
                var i = ve(e, n);
                if (i !== e) return i.optimize(n);
            }
            if (n.option("unsafe_proto") && e.expression instanceof An && e.expression.property == "prototype") {
                var a = e.expression.expression;
                if (Pe(a)) switch (a.name) {
                  case "Array":
                    e.expression = Ce(Mn, e.expression, {
                        elements: []
                    });
                    break;

                  case "Function":
                    e.expression = Ce(Ot, e.expression, {
                        argnames: [],
                        body: []
                    }).init_vars(a.scope);
                    break;

                  case "Number":
                    e.expression = Ce(Yn, e.expression, {
                        value: 0
                    });
                    break;

                  case "Object":
                    e.expression = Ce(Pn, e.expression, {
                        properties: []
                    });
                    break;

                  case "RegExp":
                    e.expression = Ce(Yr, e.expression, {
                        value: /t/
                    });
                    break;

                  case "String":
                    e.expression = Ce(Hn, e.expression, {
                        value: ""
                    });
                    break;
                }
            }
            var o = e.flatten_object(e.property, n);
            if (o) return o.optimize(n);
            return de(n, e);
        });
        e(mr, function(e, n) {
            if (n.option("rests") && e.rest instanceof mr) {
                return Ce(mr, e, {
                    elements: e.elements.concat(e.rest.elements),
                    rest: e.rest.rest
                });
            }
            return e;
        });
        e(_r, function(e, n) {
            if (n.option("objects")) {
                var t = e.key;
                if (t instanceof vn) {
                    t = t.evaluate(n);
                    if (t !== e.key) e.key = "" + t;
                }
            }
            return e;
        });
        e(Pn, function(r, i) {
            if (!i.option("objects")) return r;
            var a = false;
            var t = false;
            var o = false;
            var s = i.has_directive("use strict");
            var f = [];
            var u = new dn();
            var c = [];
            r.properties.forEach(function(e) {
                if (!(e instanceof Dn)) return p(e);
                t = true;
                var n = e.expression;
                if (i.option("spreads") && n instanceof Pn && pn(n.properties, function(e) {
                    if (e instanceof kr) return false;
                    if (e instanceof Dn) return false;
                    if (e.key !== "__proto__") return true;
                    if (e instanceof xr) return true;
                    return !e.value.has_side_effects(i);
                })) {
                    a = true;
                    n.properties.forEach(function(e) {
                        var n = e.key;
                        var t = e instanceof xr;
                        if (n === "__proto__") {
                            if (!t) return;
                            n = fe(n, e);
                        }
                        p(t ? Ce(yr, e, {
                            key: n,
                            value: Ce(Lr, e).optimize(i)
                        }) : e);
                    });
                } else {
                    o = true;
                    l();
                    c.push(e);
                }
            });
            l();
            if (!a) return r;
            if (t && o && c.length == 1) {
                var e = c[0];
                if (e instanceof br && e.key instanceof Yn) {
                    e.key = "" + e.key.value;
                }
            }
            return Ce(Pn, r, {
                properties: c
            });
            function l() {
                f.forEach(function(e) {
                    var n = u.get(e);
                    switch (n.length) {
                      case 0:
                        return;

                      case 1:
                        return c.push(n[0]);
                    }
                    a = true;
                    var t = s && !o && n.pop();
                    c.push(n.length == 1 ? n[0] : Ce(yr, r, {
                        key: n[0].key,
                        value: Me(r, n.map(function(e) {
                            return e.value;
                        }))
                    }));
                    if (t) c.push(t);
                    n.length = 0;
                });
                f = [];
                u = new dn();
            }
            function p(e) {
                var n = e.key;
                if (n instanceof vn) {
                    t = true;
                    n = n.evaluate(i);
                    if (n === e.key || n === "__proto__") {
                        o = true;
                    } else {
                        n = e.key = "" + n;
                    }
                }
                if (an(e)) {
                    if (e.value.has_side_effects(i)) l();
                    f.push(n);
                    u.add(n, e);
                } else {
                    l();
                    c.push(e);
                }
                if (t && !o && typeof n == "string" && M.test(n)) {
                    o = true;
                    if (u.has(n)) e = u.get(n)[0];
                    e.key = Ce(Yn, e, {
                        value: +n
                    });
                }
            }
        });
        function on(e) {
            var n = e.definition().redefined();
            if (n) {
                e = e.clone();
                e.thedef = n;
            }
            return e;
        }
        function me(n, e) {
            var t = false;
            e.walk(new Rn(function(e) {
                if (t) return true;
                if (e instanceof Nn && n.variables.get(e.name) === e.definition()) {
                    return t = true;
                }
            }));
            return t;
        }
        function sn(e, t) {
            var r = [];
            e.references.forEach(function(e) {
                var n = e.fixed;
                if (!n || !Jn(r, n)) return;
                if (n.assigns) {
                    n.assigns.unshift(t);
                } else {
                    n.assigns = [ t ];
                }
            });
        }
        function fn(e, n) {
            var t = Ce(Nn, n, n);
            var r = Ce(Cn, n, {
                operator: "=",
                left: t,
                right: Ce(Lr, n).transform(e)
            });
            var i = n.definition();
            if (i.fixed) {
                t.fixed = function() {
                    return r.right;
                };
                t.fixed.assigns = [ r ];
                sn(i, r);
            }
            i.assignments++;
            i.references.push(t);
            return r;
        }
        (function(e) {
            e(vn, Un);
            e(Cn, Un);
            e(vr, function(t, e, r, n) {
                var i = this;
                var a = o(i.expression).try_inline(t, e, r, n);
                if (!a) return;
                if (!r) _(a, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (n instanceof vr) return;
                    e.value = Ce(vr, i, {
                        expression: n || Ce(Lr, e).transform(t)
                    });
                });
                return j(a) ? a : Ce(_n, i, {
                    body: [ a, Ce(mn, i, {
                        body: Ce(vr, i, {
                            expression: Ce(Yn, i, {
                                value: 0
                            })
                        })
                    }) ]
                });
                function o(e) {
                    if (!r) return e;
                    if (e.TYPE != "Call") return e;
                    var n = e.expression;
                    switch (n.CTOR) {
                      case Tt:
                        n = Ce(St, n, n);
                        break;

                      case At:
                        n = Ce(Ot, n, n);
                        break;

                      case Dt:
                        n = Ce($t, n, n);
                        break;

                      default:
                        return e;
                    }
                    e = e.clone();
                    e.expression = n;
                    return e;
                }
            });
            e(zn, function(n, e, t, r) {
                if (t === undefined) return;
                var i = this;
                var a = i.operator;
                if (!Ne[a]) return;
                var o = i.right.try_inline(n, e, t, r);
                if (!o) return;
                return Ce(wn, i, {
                    condition: s(i.left),
                    body: o,
                    alternative: t ? null : Ce(yn, i, {
                        value: null
                    })
                });
                function s(e) {
                    switch (a) {
                      case "&&":
                        return e;

                      case "||":
                        return e.negate(n);

                      case "??":
                        return Ce(zn, i, {
                            operator: "==",
                            left: Ce(Rr, i),
                            right: e
                        });
                    }
                }
            });
            e(_n, function(e, n, t, r) {
                if (t) return;
                if (!this.variables) return;
                var i = this.body;
                var a = i.length - 1;
                if (a < 0) return;
                var o = i[a].try_inline(e, this, t, r);
                if (!o) return;
                i[a] = o;
                return this;
            });
            e(En, function(r, i, e, a) {
                if (r.option("inline") < 4) return;
                var o = this;
                if (o.is_expr_pure(r)) return;
                var s = o.expression;
                if (!(s instanceof yt)) return;
                if (s.name) return;
                if (s.uses_arguments) return;
                if (s.pinned()) return;
                if (kt(s)) return;
                var f = wt(s);
                if (f && s.value) return;
                if (s.body[0] instanceof tt) return;
                if (s.contains_this()) return;
                if (!i) i = qe(r);
                if (k(i)) return;
                var t = new dn();
                t.set("NaN", true);
                while (!(i instanceof gn)) {
                    i.variables.each(function(e) {
                        t.set(e.name, true);
                    });
                    i = i.parent_scope;
                }
                if (!Bn(i, r.stack)) return;
                if (i.pinned() && s.variables.size() > (f ? 0 : 1)) return;
                if (i instanceof _t) {
                    if (s.variables.size() > (f ? 0 : 1)) {
                        if (!r.toplevel.vars) return;
                        if (s.functions.size() > 0 && !r.toplevel.funcs) return;
                    }
                    t.set("arguments", true);
                }
                var u = xt(s);
                if (u) {
                    if (!r.option("awaits")) return;
                    if (!xt(i)) return;
                    if (o.may_throw(r)) return;
                }
                var c = i.var_names();
                if (a) a = [];
                if (!s.variables.all(function(e, n) {
                    if (a) a.push(e);
                    if (!t.has(n) && !c.has(n)) return true;
                    return !f && n == "arguments" && e.orig.length == 1;
                })) return;
                if (a && a.length > 0 && en(s, a)) return;
                var l = true;
                if (!pn(s.argnames, function(e) {
                    var n = false;
                    var t = new Rn(function(e) {
                        if (n) return true;
                        if (e instanceof kn) {
                            if (me(s, e.value)) return n = true;
                            e.name.walk(t);
                            return true;
                        }
                        if (e instanceof _r) {
                            if (e.key instanceof vn && me(s, e.key)) return n = true;
                            e.value.walk(t);
                            return true;
                        }
                        if (e instanceof jn && !pn(e.definition().orig, function(e) {
                            return !(e instanceof $r);
                        })) return n = true;
                    });
                    e.walk(t);
                    if (n) return false;
                    if (!(e instanceof jn)) l = false;
                    return true;
                })) return;
                if (s.rest) {
                    if (me(s, s.rest)) return;
                    l = false;
                }
                if (e && !pn(s.body, function(e) {
                    var n = false;
                    e.walk(new Rn(function(e) {
                        if (n) return true;
                        if (u && e instanceof vr || e instanceof yn) return n = true;
                        if (e instanceof gn && e !== s) return true;
                    }));
                    return !n;
                })) return;
                if (!Se(s, he(r, i))) return;
                s.functions.each(function(e, n) {
                    i.functions.set(n, e);
                });
                var p = [];
                s.variables.each(function(n, e) {
                    if (!f && e == "arguments" && n.orig.length == 1) return;
                    c.set(e, true);
                    i.enclosed.push(n);
                    i.variables.set(e, n);
                    n.single_use = false;
                    if (!a) return;
                    if (n.references.length == n.replaced) return;
                    if (n.orig.length == n.eliminated) return;
                    if (n.orig.length == 1 && s.functions.has(e)) return;
                    if (!pn(n.orig, function(e) {
                        if (e instanceof Tr) return false;
                        if (e instanceof jn) return n.scope.resolve() !== s;
                        if (e instanceof Dr) return false;
                        return true;
                    })) return;
                    var t = n.orig[0];
                    if (t instanceof Cr) return;
                    p.push(Ce(mn, t, {
                        body: fn(r, on(t))
                    }));
                });
                var d = Object.create(null), v = new dn();
                if (l && pn(o.args, function(e) {
                    return !(e instanceof Dn);
                })) {
                    var h = o.args.slice();
                    s.argnames.forEach(function(e) {
                        var n = h.shift();
                        if (e.unused) {
                            if (n) p.push(Ce(mn, o, {
                                body: n
                            }));
                            return;
                        }
                        var t = Ce(xn, o, {
                            name: e.convert_symbol(Or, m),
                            value: n || Ce(Lr, o).transform(r)
                        });
                        if (e instanceof jn) sn(e.definition(), t);
                        p.push(Ce(ar, o, {
                            definitions: [ t ]
                        }));
                    });
                    if (h.length) p.push(Ce(mn, o, {
                        body: Me(o, h)
                    }));
                } else {
                    p.push(Ce(ar, o, {
                        definitions: [ Ce(xn, o, {
                            name: Ce(mr, o, {
                                elements: s.argnames.map(function(e) {
                                    if (e.unused) return Ce(Ur, e);
                                    return e.convert_symbol(Or, m);
                                }),
                                rest: s.rest && s.rest.convert_symbol(Or, m)
                            }),
                            value: Ce(Mn, o, {
                                elements: o.args.slice()
                            })
                        }) ]
                    }));
                }
                v.each(function(e, n) {
                    var t = d[n];
                    [].unshift.apply(t.orig, e);
                    t.eliminated += e.length;
                });
                [].push.apply(p, a ? s.body.filter(function(e) {
                    if (!(e instanceof zt)) return true;
                    var n = Ce(Or, e.name, on(e.name));
                    var t = n.definition();
                    t.fixed = false;
                    t.orig.push(n);
                    t.eliminated++;
                    p.push(Ce(ar, e, {
                        definitions: [ Ce(xn, e, {
                            name: n,
                            value: we(e, true)
                        }) ]
                    }));
                    return false;
                }) : s.body);
                var n = Ce(_n, o, {
                    body: p
                });
                if (!e) {
                    if (u) _(n, function(e) {
                        var n = e.value;
                        if (je(n)) return;
                        e.value = Ce(vr, o, {
                            expression: n
                        });
                    });
                    p.push(Ce(yn, o, {
                        value: null
                    }));
                }
                return n;
                function m(e, n) {
                    var t = n.definition();
                    d[t.id] = t;
                    v.add(t.id, e);
                }
            });
            e(qn, function(e, n, t, r) {
                var i = this;
                var a = i.consequent.try_inline(e, n, t, r);
                var o = i.alternative.try_inline(e, n, t, r);
                if (!a && !o) return;
                return Ce(wn, i, {
                    condition: i.condition,
                    body: a || s(i.consequent),
                    alternative: o || s(i.alternative)
                });
                function s(e) {
                    if (t) return Ce(mn, e, {
                        body: e
                    });
                    return Ce(yn, e, {
                        value: e
                    });
                }
            });
            e(pt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.init;
                if (a) {
                    a = a.try_inline(e, n, true, r);
                    if (a) {
                        this.init = null;
                        if (a instanceof _n) {
                            a.body.push(this);
                            return a;
                        }
                        return Ce(_n, a, {
                            body: [ a, this ]
                        });
                    }
                }
                return i && this;
            });
            e(dt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (i) this.body = i;
                var a = this.object;
                if (a instanceof Sn) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.object = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(wn, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.alternative;
                if (a) {
                    a = a.try_inline(e, n, t, r);
                    if (a) this.alternative = a;
                }
                var o = this.condition;
                if (o instanceof Sn) {
                    var s = f(e, n, true, r, o, 1);
                    if (s) {
                        this.condition = o.tail_node();
                        s.body.push(this);
                        return s;
                    }
                }
                return (i || a) && this;
            });
            e(ft, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, true, true);
                if (!i) return;
                this.body = i;
                return this;
            });
            e(st, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (!i) return;
                if (this.body instanceof ft && i instanceof _n) {
                    var a = i.body.pop();
                    this.body = a;
                    i.body.push(this);
                    return i;
                }
                this.body = i;
                return this;
            });
            e(cr, Un);
            e(yn, function(e, n, t, r) {
                var i = this.value;
                return i && i.try_inline(e, n, undefined, r === "try");
            });
            function f(e, n, t, r, i, a) {
                var o = [], s = i.expressions, f = t;
                for (var u = s.length - (a || 0), c = u; --u >= 0; f = true) {
                    var l = s[u].try_inline(e, n, f, r);
                    if (!l) continue;
                    p();
                    o.push(l);
                }
                if (o.length == 0) return;
                p();
                if (!t && o[0] instanceof mn) {
                    o[0] = Ce(yn, i, {
                        value: o[0].body
                    });
                }
                return Ce(_n, i, {
                    body: o.reverse()
                });
                function p() {
                    if (c > u + 1) o.push(Ce(mn, i, {
                        body: Me(i, s.slice(u + 1, c))
                    }));
                    c = u;
                }
            }
            e(Sn, function(e, n, t, r) {
                return f(e, n, t, r, this);
            });
            e(mn, function(e, n, t, r) {
                var i = this.body;
                while (i instanceof $n) {
                    var a = i.operator;
                    if (ii[a]) break;
                    if (a == "void") break;
                    i = i.expression;
                }
                if (!t && !je(i)) i = Ce($n, this, {
                    operator: "void",
                    expression: i
                });
                return i.try_inline(e, n, t || false, r);
            });
            e($n, function(t, e, n, r) {
                var i = this;
                var a = i.operator;
                if (ii[a]) return;
                if (!n && a == "void") n = false;
                var o = i.expression.try_inline(t, e, n, r);
                if (!o) return;
                if (!n) _(o, function(e) {
                    e.in_bool = false;
                    var n = e.value;
                    if (a == "void" && je(n)) return;
                    e.value = Ce($n, i, {
                        operator: a,
                        expression: n || Ce(Lr, e).transform(t)
                    });
                });
                return o;
            });
            e(mt, function(e, n, t, r) {
                var i = this.body.try_inline(e, n, t, r);
                if (i) this.body = i;
                var a = this.expression;
                if (a instanceof Sn) {
                    var o = f(e, n, true, r, a, 1);
                    if (o) {
                        this.expression = a.tail_node();
                        o.body.push(this);
                        return o;
                    }
                }
                return i && this;
            });
            e(hr, function(e, n, t, r) {
                if (!e.option("yields")) return;
                if (!this.nested) return;
                var i = this.expression;
                if (i.TYPE != "Call") return;
                var a = i.expression;
                switch (a.CTOR) {
                  case Dt:
                    a = Ce(At, a, a);
                    break;

                  case $t:
                    a = Ce(Ot, a, a);
                    break;

                  default:
                    return;
                }
                i = i.clone();
                i.expression = a;
                return i.try_inline(e, n, t, r);
            });
        })(function(e, n) {
            e.DEFMETHOD("try_inline", n);
        });
        e(yn, function(e, n) {
            var t = e.value;
            if (t && n.option("side_effects") && je(t, n) && !k(n.find_parent(gn))) {
                e.value = null;
            }
            return e;
        });
    })(function(e, r) {
        e.DEFMETHOD("optimize", function(e) {
            var n = this;
            if (n._optimized) return n;
            if (e.has_directive("use asm")) return n;
            var t = r(n, e);
            t._optimized = true;
            return t;
        });
    });
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    function oe(e) {
        return e.type == "comment2" && /@preserve|@license|@cc_on/i.test(e.value);
    }
    function si(f) {
        f = be(f, {
            annotations: false,
            ascii_only: false,
            beautify: false,
            braces: false,
            comments: false,
            galio: false,
            ie: false,
            indent_level: 4,
            indent_start: 0,
            inline_script: true,
            keep_quoted_props: false,
            max_line_len: false,
            preamble: null,
            preserve_line: false,
            quote_keys: false,
            quote_style: 0,
            semicolons: true,
            shebang: true,
            source_map: null,
            v8: false,
            webkit: false,
            width: 80,
            wrap_iife: false
        }, true);
        var u = un;
        if (f.comments) {
            var n = f.comments;
            if (typeof f.comments === "string" && /^\/.*\/[a-zA-Z]*$/.test(f.comments)) {
                var e = f.comments.lastIndexOf("/");
                n = new RegExp(f.comments.substr(1, e - 1), f.comments.substr(e + 1));
            }
            if (n instanceof RegExp) {
                u = function(e) {
                    return e.type != "comment5" && n.test(e.value);
                };
            } else if (typeof n === "function") {
                u = function(e) {
                    return e.type != "comment5" && n(this, e);
                };
            } else if (n === "some") {
                u = oe;
            } else {
                u = cn;
            }
        }
        function t(e) {
            if (typeof e == "number") return new Array(e + 1).join(" ");
            if (!e) return "";
            if (!/^\s*$/.test(e)) throw new Error("unsupported indentation: " + JSON.stringify("" + e));
            return e;
        }
        var c = 0;
        var l = 1;
        var r = t(f.indent_start);
        var i = t(f.indent_level);
        var P = i.length + 1 >> 1;
        var o;
        var s = 0;
        var p = true;
        var d = f.source_map && [];
        var v;
        var h;
        var m;
        var _;
        var g = false;
        var b = false;
        var y;
        var a;
        var w = "";
        function x() {
            o = "";
            m = false;
            _ = false;
            a = [];
            var e = y;
            y = "";
            return e;
        }
        x();
        var k = f.ascii_only ? function(e, t) {
            if (t) e = e.replace(/[\ud800-\udbff][\udc00-\udfff]/g, function(e) {
                return "\\u{" + (e.charCodeAt(0) - 55232 << 10 | e.charCodeAt(1) - 56320).toString(16) + "}";
            });
            return e.replace(/[\u0000-\u001f\u007f-\uffff]/g, function(e) {
                var n = e.charCodeAt(0).toString(16);
                if (n.length <= 2 && !t) {
                    while (n.length < 2) n = "0" + n;
                    return "\\x" + n;
                } else {
                    while (n.length < 4) n = "0" + n;
                    return "\\u" + n;
                }
            });
        } : function(e) {
            var n = "";
            for (var t = 0, r = 0; t < e.length; t++) {
                var i = e.charCodeAt(t);
                if (re(i)) {
                    if (ie(e.charCodeAt(t + 1))) {
                        t++;
                        continue;
                    }
                } else if (!ie(i)) {
                    continue;
                }
                n += e.slice(r, t) + "\\u" + i.toString(16);
                r = t + 1;
            }
            return r == 0 ? e : n + e.slice(r);
        };
        function E(e) {
            return "'" + e.replace(/\x27/g, "\\'") + "'";
        }
        function S(e) {
            return '"' + e.replace(/\x22/g, '\\"') + '"';
        }
        var j = [ null, E, S, function(e, n) {
            return n == "'" ? E(e) : S(e);
        } ][f.quote_style] || function(e, n, t, r) {
            return t > r ? E(e) : S(e);
        };
        function T(t, e) {
            var r = 0, i = 0;
            t = t.replace(/[\\\b\f\n\r\v\t\x22\x27\u2028\u2029\0\ufeff]/g, function(e, n) {
                switch (e) {
                  case '"':
                    ++r;
                    return '"';

                  case "'":
                    ++i;
                    return "'";

                  case "\\":
                    return "\\\\";

                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\\t";

                  case "\b":
                    return "\\b";

                  case "\f":
                    return "\\f";

                  case "\v":
                    return f.ie ? "\\x0B" : "\\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  case "\ufeff":
                    return "\\ufeff";

                  case "\0":
                    return /[0-9]/.test(t.charAt(n + 1)) ? "\\x00" : "\\0";
                }
                return e;
            });
            return j(k(t), e, r, i);
        }
        var N = d ? function(n, t) {
            d.forEach(function(e) {
                e.line += n;
                e.col += t;
            });
        } : Un;
        var A = d ? function() {
            d.forEach(function(e) {
                f.source_map.add(e.token.file, e.line, e.col, e.token.line, e.token.col, !e.name && e.token.type == "name" ? e.token.value : e.name);
            });
            d = [];
        } : Un;
        function D(e) {
            w += y.slice(0, s);
            y = y.slice(s);
            var n = y.length;
            N(e, n - c);
            l += e;
            c = n;
            while (e--) w += "\n";
        }
        var O = f.max_line_len ? function(e) {
            if (p) {
                if (c > f.max_line_len) {
                    vn.warn("Output exceeds {max_line_len} characters", f);
                }
                return;
            }
            if (c > f.max_line_len) {
                D(1);
                p = true;
            }
            if (p || e) A();
        } : Un;
        var I = ln("( [ + * / - , .");
        function $(e, n, t) {
            return ae(e) && (ae(n) || n == "\\") || n == "/" && n == e || (n == "+" || n == "-") && n == o || o == "--" && n == ">" || o == "!" && t == "--" || e == "/" && (t == "in" || t == "instanceof");
        }
        var z = f.beautify || f.comments || f.max_line_len || f.preserve_line || f.shebang || !f.semicolons || f.source_map || f.width ? function(e) {
            var n = e.charAt(0);
            if (g && n) {
                g = false;
                if (n != "\n") {
                    z("\n");
                    C();
                }
            }
            if (b && n) {
                b = false;
                if (!/[\s;})]/.test(n)) {
                    q();
                }
            }
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || t != ";" && (!n || ";}".indexOf(n) < 0)) {
                    var r = I[n];
                    if (r || f.semicolons) {
                        y += ";";
                        c++;
                        if (!p) {
                            O();
                            if (p && !r && y == ";") {
                                y = "";
                                c = 0;
                            }
                        }
                        if (s == y.length - 1) s++;
                    } else {
                        O();
                        y += "\n";
                        l++;
                        c = 0;
                        if (/^\s+$/.test(e)) _ = true;
                    }
                    if (!f.beautify) m = false;
                }
            }
            if (m) {
                if ($(t, n, e)) {
                    y += " ";
                    c++;
                }
                if (t != "<" || e != "!") m = false;
            }
            if (h) {
                d.push({
                    token: h,
                    name: v,
                    line: l,
                    col: c
                });
                h = false;
                if (p) A();
            }
            y += e;
            var i = e.split(/\r?\n/), a = i.length - 1;
            l += a;
            c += i[0].length;
            if (a > 0) {
                O();
                c = i[a].length;
            }
            o = e;
        } : function(e) {
            var n = e.charAt(0);
            var t = o.slice(-1);
            if (_) {
                _ = false;
                if (t == ":" && n == "}" || (!n || ";}".indexOf(n) < 0) && t != ";") {
                    y += ";";
                    m = false;
                }
            }
            if (m) {
                if ($(t, n, e)) y += " ";
                if (t != "<" || e != "!") m = false;
            }
            y += e;
            o = e;
        };
        var q = f.beautify ? function() {
            z(" ");
        } : function() {
            m = true;
        };
        var C = f.beautify ? function(e) {
            if (g) z("\n");
            z(e ? r.slice(0, -P) : r);
        } : Un;
        var H = f.beautify ? function(e) {
            var n = r;
            r += i;
            e();
            r = n;
        } : function(e) {
            e();
        };
        var M = f.max_line_len || f.preserve_line ? function() {
            O();
            s = y.length;
            p = false;
        } : Un;
        var Y = f.beautify ? function() {
            z("\n");
            s = y.length;
        } : M;
        var R = f.beautify ? function() {
            z(";");
        } : function() {
            _ = true;
        };
        function B() {
            if (_) z(";");
            z(";");
        }
        function L(e) {
            z("{");
            Y();
            H(e);
            C();
            z("}");
        }
        function U(e) {
            z("(");
            M();
            e();
            M();
            z(")");
        }
        function V(e) {
            z("[");
            M();
            e();
            M();
            z("]");
        }
        function W() {
            M();
            z(",");
            M();
            q();
        }
        function G() {
            z(":");
            q();
        }
        var J = d ? function(e, n) {
            h = e;
            v = n;
        } : Un;
        function X() {
            if (!p) O(true);
            return w + y;
        }
        function K() {
            return /(^|\n) *$/.test(y);
        }
        function F(e, n) {
            if (g) return;
            if (e.nlb && (n || !K())) {
                g = true;
            } else if (n) {
                b = true;
            }
        }
        function Q(e) {
            var n = e.value.replace(/[@#]__PURE__/g, " ");
            if (/^\s*$/.test(n) && !/^\s*$/.test(e.value)) return false;
            if (/comment[134]/.test(e.type)) {
                z("//" + n);
                g = true;
            } else if (e.type == "comment2") {
                z("/*" + n + "*/");
            }
            return true;
        }
        function Z(e, n) {
            if (n instanceof zn) return n.left === e;
            if (n.TYPE == "Call") return n.expression === e;
            if (n instanceof qn) return n.condition === e;
            if (n instanceof An) return n.expression === e;
            if (n instanceof Lt) return true;
            if (n instanceof Sn) return n.expressions[0] === e;
            if (n instanceof pr) return n.expression === e;
            if (n instanceof dr) return true;
            if (n instanceof hr) return true;
        }
        function ee(e) {
            var r = this;
            var i;
            if (e instanceof Lt) {
                i = e.value;
            } else if (e instanceof hr) {
                i = e.expression;
            }
            var t = s(e);
            if (!t) t = [];
            if (i) {
                var a = new Rn(function(e) {
                    if (!Z(e, a.parent())) return true;
                    var n = s(e);
                    if (n) t = t.concat(n);
                });
                a.push(e);
                i.walk(a);
            }
            if (l == 1 && c == 0) {
                if (t.length > 0 && f.shebang && t[0].type == "comment5") {
                    z("#!" + t.shift().value + "\n");
                    C();
                }
                var n = f.preamble;
                if (n) z(n.replace(/\r\n?|\u2028|\u2029|(^|\S)\s*$/g, "$1\n"));
            }
            t = t.filter(u, e);
            var o = false;
            t.forEach(function(e, n) {
                F(e, n);
                if (Q(e)) o = true;
            });
            if (o) F(e.start, true);
            function s(e) {
                var n = e.start;
                if (!n) {
                    if (!i) return;
                    e.start = n = new te();
                }
                var t = n.comments_before;
                if (!t) {
                    if (!i) return;
                    n.comments_before = t = [];
                }
                if (t._dumped === r) return;
                t._dumped = r;
                return t;
            }
        }
        function ne(e, t) {
            var n = this;
            var r = e.end;
            if (!r) return;
            var i = r[t ? "comments_before" : "comments_after"];
            if (!i || i._dumped === n) return;
            if (!(e instanceof et || pn(i, function(e) {
                return !/comment[134]/.test(e.type);
            }))) return;
            i._dumped = n;
            i.filter(u, e).forEach(function(e, n) {
                F(e, n || !t);
                Q(e);
            });
        }
        return {
            get: X,
            reset: x,
            indent: C,
            should_break: f.beautify && f.width ? function() {
                return c >= f.width;
            } : un,
            has_parens: function() {
                return o.slice(-1) == "(";
            },
            newline: Y,
            print: z,
            space: q,
            comma: W,
            colon: G,
            last: function() {
                return o;
            },
            semicolon: R,
            force_semicolon: B,
            to_utf8: k,
            print_name: function(e) {
                z(k(e.toString(), true));
            },
            print_string: f.inline_script ? function(e, n) {
                e = T(e, n).replace(/<\x2f(script)([>\/\t\n\f\r ])/gi, "<\\/$1$2");
                z(e.replace(/\x3c!--/g, "\\x3c!--").replace(/--\x3e/g, "--\\x3e"));
            } : function(e, n) {
                z(T(e, n));
            },
            with_indent: H,
            with_block: L,
            with_parens: U,
            with_square: V,
            add_mapping: J,
            option: function(e) {
                return f[e];
            },
            prepend_comments: f.comments || f.shebang ? ee : Un,
            append_comments: f.comments ? ne : Un,
            push_node: function(e) {
                a.push(e);
            },
            pop_node: f.preserve_line ? function() {
                var e = a.pop();
                if (e.start && e.start.line > l) {
                    D(e.start.line - l);
                }
            } : function() {
                a.pop();
            },
            parent: function(e) {
                return a[a.length - 2 - (e || 0)];
            }
        };
    }
    (function() {
        function e(e, n) {
            e.DEFMETHOD("_codegen", n);
        }
        var s = false;
        vn.DEFMETHOD("print", function(e, n) {
            var t = this;
            e.push_node(t);
            if (n || t.needs_parens(e)) {
                e.with_parens(r);
            } else {
                r();
            }
            e.pop_node();
            function r() {
                e.prepend_comments(t);
                t.add_source_map(e);
                t._codegen(e);
                e.append_comments(t);
            }
        });
        var t = si({
            inline_script: false,
            shebang: false,
            width: false
        });
        vn.DEFMETHOD("print_to_string", function(e) {
            if (e) {
                var n = si(e);
                this.print(n);
                return n.get();
            }
            this.print(t);
            return t.reset();
        });
        function n(e, n) {
            e.DEFMETHOD("needs_parens", n);
        }
        n(vn, un);
        function r(e) {
            var n = e.parent();
            if (!e.has_parens() && Zn(e, false, true)) {
                return this.name || !(n instanceof sr);
            }
            if (e.option("webkit") && n instanceof Tn && n.expression === this) return true;
            if (e.option("wrap_iife") && n instanceof En && n.expression === this) return true;
        }
        n(At, r);
        n(Dt, r);
        n(Nt, r);
        n(Ot, r);
        n($t, r);
        function i(e) {
            return !e.has_parens() && Zn(e, true);
        }
        n(Pn, i);
        function a(e) {
            var n = e.parent();
            if (n instanceof zn) return n.operator == "**" && n.left === this;
            if (n instanceof En) return n.expression === this;
            if (n instanceof Pt) return true;
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof Ir) return n.tag === this;
        }
        n(vr, a);
        n(On, a);
        n(Sn, function(e) {
            var n = e.parent();
            return n instanceof Mn || wt(n) && n.value === this || n instanceof vr || n instanceof zn || n instanceof En || n instanceof Pt || n instanceof It || n instanceof qn || n instanceof kn || n instanceof _r || n instanceof sr || n instanceof ye || n instanceof br || n instanceof Tn && n.expression === this || n instanceof Dn || n instanceof Ir && n.tag === this || n instanceof On || n instanceof xn || n instanceof hr;
        });
        n(zn, function(e) {
            var n = e.parent();
            if (n instanceof vr) return true;
            if (n instanceof zn) {
                var t = n.operator, r = ni[t];
                var i = this.operator, a = ni[i];
                return r > a || t == "??" && (i == "&&" || i == "||") || r == a && this === n[t == "**" ? "left" : "right"];
            }
            if (n instanceof En) return n.expression === this;
            if (n instanceof Pt) return true;
            if (n instanceof Tn) return n.expression === this;
            if (n instanceof Ir) return n.tag === this;
            if (n instanceof On) return true;
        });
        function o(e, n) {
            if (!e.terminal) return false;
            if (!(n instanceof En || n instanceof Tn)) return false;
            return n.expression === e;
        }
        n(Tn, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof cr && t.expression === n && lr(n).TYPE == "Call") return true;
            return o(n, t);
        });
        n(En, function(e) {
            var n = this;
            var t = e.parent();
            if (t instanceof cr) return t.expression === n;
            if (e.option("webkit") && n.expression instanceof Ot && t instanceof Tn && t.expression === n) {
                var r = e.parent(1);
                if (r instanceof Cn && r.left === t) return true;
            }
            return o(n, t);
        });
        n(cr, function(e) {
            if (q(this, e)) return false;
            var n = e.parent();
            if (n instanceof En) return n.expression === this;
            if (n instanceof Tn) return true;
            if (n instanceof Ir) return n.tag === this;
        });
        n(Yn, function(e) {
            if (!e.option("galio")) return false;
            var n = e.parent();
            return n instanceof Tn && n.expression === this && /^0/.test(C(this.value));
        });
        function f(e, n) {
            var t = n.parent();
            if (t instanceof vr) return true;
            if (t instanceof zn) return !(t instanceof Cn);
            if (t instanceof En) return t.expression === e;
            if (t instanceof Pt) return true;
            if (t instanceof qn) return t.condition === e;
            if (t instanceof Tn) return t.expression === e;
            if (t instanceof Ir) return t.tag === e;
            if (t instanceof On) return true;
        }
        n(St, function(e) {
            return f(this, e);
        });
        n(Cn, function(e) {
            if (f(this, e)) return true;
            if (e.option("v8")) return this.left instanceof Fn;
            if (this.left instanceof gr) return i(e);
        });
        n(Tt, function(e) {
            return f(this, e);
        });
        n(qn, function(e) {
            return f(this, e);
        });
        n(hr, function(e) {
            return f(this, e);
        });
        e(tt, function(e) {
            var n = this.quote;
            var t = this.value;
            switch (e.option("quote_style")) {
              case 0:
              case 2:
                if (t.indexOf('"') == -1) n = '"';
                break;

              case 1:
                if (t.indexOf("'") == -1) n = "'";
                break;
            }
            e.print(n + t + n);
            e.semicolon();
        });
        e(nt, function(e) {
            e.print("debugger");
            e.semicolon();
        });
        function u(e, t, r, n) {
            var i = e.length - 1;
            var a = n;
            var o = s;
            e.forEach(function(e, n) {
                if (a) {
                    if (e instanceof tt) {
                        if (e.value == "use asm") s = true;
                    } else if (!(e instanceof hn)) {
                        if (e instanceof mn && e.body instanceof Hn) {
                            r.force_semicolon();
                        }
                        a = false;
                    }
                }
                if (e instanceof hn) return;
                r.indent();
                e.print(r);
                if (n == i && t) return;
                r.newline();
                if (t) r.newline();
            });
            s = o;
        }
        e(_t, function(e) {
            u(this.body, true, e, true);
            e.print("");
        });
        e(st, function(e) {
            this.label.print(e);
            e.colon();
            this.body.print(e);
        });
        e(mn, function(e) {
            this.body.print(e);
            e.semicolon();
        });
        function c(e, n) {
            n.print("{");
            n.with_indent(function() {
                n.append_comments(e, true);
            });
            n.print("}");
        }
        function l(e, n, t) {
            if (e.body.length > 0) {
                n.with_block(function() {
                    u(e.body, false, n, t);
                });
            } else c(e, n);
        }
        e(_n, function(e) {
            l(this, e);
        });
        e(hn, function(e) {
            e.semicolon();
        });
        e(ct, function(e) {
            var n = this;
            e.print("do");
            M(n.body, e);
            e.space();
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            e.semicolon();
        });
        e(lt, function(e) {
            var n = this;
            e.print("while");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            z(n.body, e);
        });
        e(pt, function(e) {
            var n = this;
            e.print("for");
            e.space();
            e.with_parens(function() {
                if (n.init) {
                    if (n.init instanceof tr) {
                        n.init.print(e);
                    } else {
                        E(n.init, e, true);
                    }
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.condition) {
                    n.condition.print(e);
                    e.print(";");
                    e.space();
                } else {
                    e.print(";");
                }
                if (n.step) {
                    n.step.print(e);
                }
            });
            z(n.body, e);
        });
        function p(t, r) {
            return function(e) {
                var n = this;
                e.print(t);
                e.space();
                e.with_parens(function() {
                    n.init.print(e);
                    e.space();
                    e.print(r);
                    e.space();
                    n.object.print(e);
                });
                z(n.body, e);
            };
        }
        e(ht, p("for await", "of"));
        e(vt, p("for", "in"));
        e(ye, p("for", "of"));
        e(mt, function(e) {
            var n = this;
            e.print("with");
            e.space();
            e.with_parens(function() {
                n.expression.print(e);
            });
            z(n.body, e);
        });
        e(or, function(e) {
            e.print("export");
            e.space();
            this.body.print(e);
        });
        e(sr, function(e) {
            e.print("export");
            e.space();
            e.print("default");
            e.space();
            var n = this.body;
            n.print(e);
            if (n instanceof Nt) {
                if (!n.name) return;
            }
            if (n instanceof jt) return;
            if (n instanceof zt) return;
            if (n instanceof yt) {
                if (!n.name && !wt(n)) return;
            }
            e.semicolon();
        });
        e(ke, function(r) {
            var i = this;
            r.print("export");
            r.space();
            var n = i.keys.length;
            if (n == 0) {
                c(i, r);
            } else if (i.keys[0] == "*") {
                t(0);
            } else r.with_block(function() {
                r.indent();
                t(0);
                for (var e = 1; e < n; e++) {
                    r.print(",");
                    r.newline();
                    r.indent();
                    t(e);
                }
                r.newline();
            });
            r.space();
            r.print("from");
            r.space();
            r.print_string(i.path, i.quote);
            r.semicolon();
            function t(e) {
                var n = i.aliases[e];
                var t = i.keys[e];
                r.print_name(t);
                if (n != t) {
                    r.space();
                    r.print("as");
                    r.space();
                    r.print_name(n);
                }
            }
        });
        e(fr, function(e) {
            var n = this;
            e.print("export");
            e.space();
            A(n, e);
            e.semicolon();
        });
        e(ur, function(e) {
            var n = this;
            e.print("import");
            e.space();
            if (n.default) n.default.print(e);
            if (n.all) {
                if (n.default) e.comma();
                n.all.print(e);
            }
            if (n.properties) {
                if (n.default) e.comma();
                A(n, e);
            }
            if (n.all || n.default || n.properties) {
                e.space();
                e.print("from");
                e.space();
            }
            e.print_string(n.path, n.quote);
            e.semicolon();
        });
        function d(e, t) {
            t.with_parens(function() {
                e.argnames.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (e.rest) {
                    if (e.argnames.length) t.comma();
                    t.print("...");
                    e.rest.print(t);
                }
            });
        }
        function v(e, n) {
            var t = e.argnames.length == 1 && !e.rest && e.argnames[0];
            if (t instanceof jn && t.name != "yield") {
                t.print(n);
            } else {
                d(e, n);
            }
            n.space();
            n.print("=>");
            n.space();
            if (e.value) {
                e.value.print(n);
            } else {
                l(e, n, true);
            }
        }
        e(St, function(e) {
            v(this, e);
        });
        e(Tt, function(e) {
            e.print("async");
            e.space();
            v(this, e);
        });
        function h(e, n) {
            if (e.name) {
                n.space();
                e.name.print(n);
            }
            d(e, n);
            n.space();
            l(e, n, true);
        }
        e(bn, function(e) {
            e.print("function");
            h(this, e);
        });
        function m(e) {
            e.print("async");
            e.space();
            e.print("function");
            h(this, e);
        }
        e(qt, m);
        e(At, m);
        function _(e) {
            e.print("async");
            e.space();
            e.print("function*");
            h(this, e);
        }
        e(Ct, _);
        e(Dt, _);
        function g(e) {
            e.print("function*");
            h(this, e);
        }
        e(Ft, g);
        e($t, g);
        e(Pt, function(e) {
            var n = this;
            e.print("class");
            if (n.name) {
                e.space();
                n.name.print(e);
            }
            if (n.extends) {
                e.space();
                e.print("extends");
                e.space();
                n.extends.print(e);
            }
            e.space();
            A(n, e, true);
        });
        e(Ht, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            D(n, e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                n.value.print(e);
            }
            e.semicolon();
        });
        e(we, O("get"));
        e(xe, O("set"));
        function b(e, n) {
            var t = e.value;
            if (xt(t)) {
                n.print("async");
                n.space();
            }
            if (kt(t)) n.print("*");
            D(e, n);
            h(e.value, n);
        }
        e(Yt, function(e) {
            var n = this;
            if (n.static) {
                e.print("static");
                e.space();
            }
            b(n, e);
        });
        e(Rt, function(e) {
            e.print("static");
            e.space();
            l(this.value, e);
        });
        function y(t, r) {
            return function(e) {
                e.print(t);
                var n = this[r];
                if (n) {
                    e.space();
                    n.print(e);
                }
                e.semicolon();
            };
        }
        e(yn, y("return", "value"));
        e(Ut, y("throw", "value"));
        e(Wt, y("break", "label"));
        e(Gt, y("continue", "label"));
        function w(e, n) {
            var t = e.body;
            if (n.option("braces") && !(t instanceof rr || t instanceof ir) || n.option("ie") && t instanceof ct) return M(t, n);
            if (!t) return n.force_semicolon();
            while (true) {
                if (t instanceof wn) {
                    if (!t.alternative) {
                        M(e.body, n);
                        return;
                    }
                    t = t.alternative;
                } else if (t instanceof j) {
                    t = t.body;
                } else break;
            }
            z(e.body, n);
        }
        e(wn, function(e) {
            var n = this;
            e.print("if");
            e.space();
            e.with_parens(function() {
                n.condition.print(e);
            });
            if (n.alternative) {
                w(n, e);
                e.space();
                e.print("else");
                if (n.alternative instanceof wn) {
                    e.space();
                    n.alternative.print(e);
                } else {
                    z(n.alternative, e);
                }
            } else {
                z(n.body, e);
            }
        });
        e(Jt, function(t) {
            var e = this;
            t.print("switch");
            t.space();
            t.with_parens(function() {
                e.expression.print(t);
            });
            t.space();
            var r = e.body.length - 1;
            if (r < 0) c(e, t); else t.with_block(function() {
                e.body.forEach(function(e, n) {
                    t.indent(true);
                    e.print(t);
                    if (n < r && e.body.length > 0) t.newline();
                });
            });
        });
        function x(e, n) {
            n.newline();
            e.body.forEach(function(e) {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        e(Kt, function(e) {
            e.print("default:");
            x(this, e);
        });
        e(Qt, function(e) {
            var n = this;
            e.print("case");
            e.space();
            n.expression.print(e);
            e.print(":");
            x(n, e);
        });
        e(Zt, function(e) {
            var n = this;
            e.print("try");
            e.space();
            l(n, e);
            if (n.bcatch) {
                e.space();
                n.bcatch.print(e);
            }
            if (n.bfinally) {
                e.space();
                n.bfinally.print(e);
            }
        });
        e(er, function(e) {
            var n = this;
            e.print("catch");
            if (n.argname) {
                e.space();
                e.with_parens(function() {
                    n.argname.print(e);
                });
            }
            e.space();
            l(n, e);
        });
        e(nr, function(e) {
            e.print("finally");
            e.space();
            l(this, e);
        });
        function k(r) {
            return function(t) {
                var e = this;
                t.print(r);
                t.space();
                e.definitions.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                var n = t.parent();
                if (!(n instanceof ft && n.init === e)) t.semicolon();
            };
        }
        e(rr, k("const"));
        e(ir, k("let"));
        e(ar, k("var"));
        function E(e, n, t) {
            var r = false;
            if (t) e.walk(new Rn(function(e) {
                if (r) return true;
                if (e instanceof zn && e.operator == "in") return r = true;
                if (e instanceof gn && !(wt(e) && e.value)) return true;
            }));
            e.print(n, r);
        }
        e(xn, function(e) {
            var n = this;
            n.name.print(e);
            if (n.value) {
                e.space();
                e.print("=");
                e.space();
                var t = e.parent(1);
                var r = t instanceof pt || t instanceof dt;
                E(n.value, e, r);
            }
        });
        e(kn, function(e) {
            var n = this;
            n.name.print(e);
            e.space();
            e.print("=");
            e.space();
            n.value.print(e);
        });
        function S(e, n) {
            if (!n.option("annotations")) return;
            if (!e.pure) return;
            var t = 0, r = e, i;
            do {
                i = r;
                r = n.parent(t++);
                if (r instanceof En && r.expression === i) return;
            } while (r instanceof Tn && r.expression === i);
            n.print("/*@__PURE__*/");
        }
        function T(e, t) {
            if (e.expression instanceof En || e.expression instanceof bn) {
                t.add_mapping(e.start);
            }
            t.with_parens(function() {
                e.args.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
            });
        }
        e(En, function(e) {
            var n = this;
            S(n, e);
            n.expression.print(e);
            if (n.optional) e.print("?.");
            T(n, e);
        });
        e(cr, function(e) {
            var n = this;
            S(n, e);
            e.print("new");
            e.space();
            n.expression.print(e);
            if (q(n, e)) T(n, e);
        });
        e(Sn, function(t) {
            this.expressions.forEach(function(e, n) {
                if (n > 0) {
                    t.comma();
                    if (t.should_break()) {
                        t.newline();
                        t.indent();
                    }
                }
                e.print(t);
            });
        });
        e(An, function(e) {
            var n = this;
            var t = n.expression;
            t.print(e);
            var r = n.property;
            if (e.option("ie") && N[r]) {
                e.print(n.optional ? "?.[" : "[");
                e.add_mapping(n.end);
                e.print_string(r);
                e.print("]");
            } else {
                if (t instanceof Yn && !/[ex.)]/i.test(e.last())) e.print(".");
                e.print(n.optional ? "?." : ".");
                e.add_mapping(n.end);
                e.print_name(r);
            }
        });
        e(pr, function(e) {
            var n = this;
            n.expression.print(e);
            e.print(n.optional ? "?.[" : "[");
            n.property.print(e);
            e.print("]");
        });
        e(Dn, function(e) {
            e.print("...");
            this.expression.print(e);
        });
        e($n, function(e) {
            var n = this.operator;
            var t = this.expression;
            e.print(n);
            if (/^[a-z]/i.test(n) || /[+-]$/.test(n) && t instanceof $n && /^[+-]/.test(t.operator)) {
                e.space();
            }
            t.print(e);
        });
        e(dr, function(e) {
            this.expression.print(e);
            e.print(this.operator);
        });
        e(zn, function(e) {
            var n = this;
            n.left.print(e);
            e.space();
            e.print(n.operator);
            e.space();
            n.right.print(e);
        });
        e(qn, function(e) {
            var n = this;
            n.condition.print(e);
            e.space();
            e.print("?");
            e.space();
            n.consequent.print(e);
            e.space();
            e.colon();
            n.alternative.print(e);
        });
        e(vr, function(e) {
            e.print("await");
            e.space();
            this.expression.print(e);
        });
        e(hr, function(e) {
            e.print(this.nested ? "yield*" : "yield");
            if (this.expression) {
                e.space();
                this.expression.print(e);
            }
        });
        e(Mn, function(t) {
            var e = this.elements, r = e.length;
            t.with_square(r > 0 ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                    if (n === r - 1 && e instanceof Ur) t.comma();
                });
                t.space();
            } : Un);
        });
        e(mr, function(t) {
            var e = this.elements, n = e.length, r = this.rest;
            t.with_square(n || r ? function() {
                t.space();
                e.forEach(function(e, n) {
                    if (n) t.comma();
                    e.print(t);
                });
                if (r) {
                    if (n) t.comma();
                    t.print("...");
                    r.print(t);
                } else if (e[n - 1] instanceof Ur) {
                    t.comma();
                }
                t.space();
            } : Un);
        });
        e(_r, function(e) {
            var n = this;
            var t = D(n, e);
            var r = n.value;
            if (t) {
                if (r instanceof kn) {
                    if (r.name instanceof Er && t == $(r.name)) {
                        e.space();
                        e.print("=");
                        e.space();
                        r.value.print(e);
                        return;
                    }
                } else if (r instanceof Er) {
                    if (t == $(r)) return;
                }
            }
            e.colon();
            r.print(e);
        });
        e(gr, function(t) {
            var e = this.properties, n = e.length, r = this.rest;
            if (n || r) t.with_block(function() {
                e.forEach(function(e, n) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                if (r) {
                    if (n) {
                        t.print(",");
                        t.newline();
                    }
                    t.indent();
                    t.print("...");
                    r.print(t);
                }
                t.newline();
            }); else c(this, t);
        });
        function A(e, t, r) {
            var n = e.properties;
            if (n.length > 0) t.with_block(function() {
                n.forEach(function(e, n) {
                    if (n) {
                        if (!r) t.print(",");
                        t.newline();
                    }
                    t.indent();
                    e.print(t);
                });
                t.newline();
            }); else c(e, t);
        }
        e(Pn, function(e) {
            A(this, e);
        });
        function D(e, n) {
            var t = e.key;
            if (t instanceof vn) return n.with_square(function() {
                t.print(n);
            });
            var r = e.start && e.start.quote;
            if (n.option("quote_keys") || r && n.option("keep_quoted_props")) {
                n.print_string(t, r);
            } else if ("" + +t == t && t >= 0) {
                n.print(C(t));
            } else if (e.private) {
                n.print_name(t);
            } else if (N[t] ? !n.option("ie") : Kr(t)) {
                n.print_name(t);
                return t;
            } else {
                n.print_string(t, r);
            }
        }
        e(yr, function(e) {
            var n = this;
            D(n, e);
            e.colon();
            n.value.print(e);
        });
        e(wr, function(e) {
            b(this, e);
        });
        function O(t) {
            return function(e) {
                var n = this;
                if (n.static) {
                    e.print("static");
                    e.space();
                }
                e.print(t);
                e.space();
                D(n, e);
                h(n.value, e);
            };
        }
        e(kr, O("get"));
        e(xr, O("set"));
        function $(e) {
            var n = e.definition();
            return n && n.mangled_name || e.name;
        }
        e(Er, function(e) {
            e.print_name($(this));
        });
        e(Mr, function(e) {
            var n = this;
            var t = $(n);
            e.print_name(t);
            var r = n.alias;
            if (r != t) {
                e.space();
                e.print("as");
                e.space();
                e.print_name(r);
            }
        });
        e(Ar, function(e) {
            var n = this;
            var t = $(n);
            var r = n.key;
            if (r && r != t) {
                e.print_name(r);
                e.space();
                e.print("as");
                e.space();
            }
            e.print_name(t);
        });
        e(Ur, Un);
        e(Ir, function(e) {
            var n = this;
            if (n.tag) n.tag.print(e);
            e.print("`");
            for (var t = 0; t < n.expressions.length; t++) {
                e.print(n.strings[t]);
                e.print("${");
                n.expressions[t].print(e);
                e.print("}");
            }
            e.print(n.strings[t]);
            e.print("`");
        });
        e(In, function(e) {
            e.print("" + this.value);
        });
        e(Hn, function(e) {
            e.print_string(this.value, this.quote);
        });
        e(Yn, function(e) {
            var n = this.start;
            if (s && n && n.raw != null) {
                e.print(n.raw);
            } else {
                e.print(C(this.value));
            }
        });
        e(Yr, function(e) {
            var n = this.value;
            var t = n.toString();
            var r = t.lastIndexOf("/");
            if (n.raw_source) {
                t = "/" + n.raw_source + t.slice(r);
            } else if (r == 1) {
                t = "/(?:)" + t.slice(r);
            } else if (t.indexOf("/", 1) < r) {
                t = "/" + t.slice(1, r).replace(/\\\\|[^/]?\//g, function(e) {
                    return e[0] == "\\" ? e : e.slice(0, -1) + "\\/";
                }) + t.slice(r);
            }
            e.print(e.to_utf8(t).replace(/\\(?:\0(?![0-9])|[^\0])/g, function(e) {
                switch (e[1]) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\t":
                    return "\t";

                  case "\b":
                    return "\b";

                  case "\f":
                    return "\f";

                  case "\0":
                    return "\0";

                  case "\v":
                    return "\v";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";

                  default:
                    return e;
                }
            }).replace(/[\n\r\u2028\u2029]/g, function(e) {
                switch (e) {
                  case "\n":
                    return "\\n";

                  case "\r":
                    return "\\r";

                  case "\u2028":
                    return "\\u2028";

                  case "\u2029":
                    return "\\u2029";
                }
            }));
        });
        function z(e, n) {
            if (n.option("braces") && !(e instanceof rr || e instanceof ir)) {
                M(e, n);
            } else if (e instanceof hn) {
                n.force_semicolon();
            } else {
                n.space();
                e.print(n);
            }
        }
        function q(e, n) {
            if (e.args.length > 0) return true;
            return n.option("beautify");
        }
        function P(e) {
            var n = e[0], t = n.length;
            for (var r = 1; r < e.length; ++r) {
                if (e[r].length < t) {
                    n = e[r];
                    t = n.length;
                }
            }
            return n;
        }
        function C(e) {
            var n = e.toString(10).replace(/^0\./, ".").replace("e+", "e");
            var t = [ n ];
            if (Math.floor(e) === e) {
                if (e < 0) {
                    t.push("-0x" + (-e).toString(16).toLowerCase());
                } else {
                    t.push("0x" + e.toString(16).toLowerCase());
                }
            }
            var r, i, a;
            if (r = /^\.0+/.exec(n)) {
                i = r[0].length;
                a = n.slice(i);
                t.push(a + "e-" + (a.length + i - 1));
            } else if (r = /[^0]0+$/.exec(n)) {
                i = r[0].length - 1;
                t.push(n.slice(0, -i) + "e" + i);
            } else if (r = /^(\d)\.(\d+)e(-?\d+)$/.exec(n)) {
                t.push(r[1] + r[2] + "e" + (r[3] - r[2].length));
            }
            return P(t);
        }
        function M(e, n) {
            n.space();
            if (e instanceof hn) {
                c(e, n);
            } else if (e instanceof _n) {
                e.print(n);
            } else n.with_block(function() {
                n.indent();
                e.print(n);
                n.newline();
            });
        }
        function F(e, n) {
            e.forEach(function(e) {
                e.DEFMETHOD("add_source_map", n);
            });
        }
        F([ vn, st ], Un);
        F([ Mn, _n, er, In, nt, tr, Fn, nr, Bt, bn, cr, Pn, j, Er, Jt, Xt, Zt ], function(e) {
            e.add_mapping(this.start);
        });
        F([ It, _r, br ], function(e) {
            if (typeof this.key == "string") e.add_mapping(this.start, this.key);
        });
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var S = t("ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/");
    var T = S.reduce(function(e, n, t) {
        e[n] = t;
        return e;
    }, Object.create(null));
    function A(e, n) {
        var t = 0;
        var r = 0;
        for (var i = 0, a = 0; i < n.length; i++) {
            var o = T[n[i]];
            t += (o & 31) << r;
            if (o & 32) {
                r += 5;
            } else {
                e[a++] += t & 1 ? 2147483648 | -(t >> 1) : t >> 1;
                t = r = 0;
            }
        }
        return a;
    }
    function D(e) {
        var n = "";
        e = Math.abs(e) << 1 | e >>> 31;
        do {
            var t = e & 31;
            if (e >>>= 5) t |= 32;
            n += S[t];
        } while (e);
        return n;
    }
    function O() {
        var t = new dn();
        var r = [];
        r.index = function(e) {
            var n = t.get(e);
            if (!(n >= 0)) {
                n = r.length;
                r.push(e);
                t.set(e, n);
            }
            return n;
        };
        return r;
    }
    function $(l) {
        var f = O();
        var a = l.includeSources && new dn();
        var u = O();
        var c = "";
        if (l.orig) Object.keys(l.orig).forEach(function(e) {
            var n = l.orig[e];
            var t = [ 0, 0, 1, 0, 0 ];
            l.orig[e] = {
                names: n.names,
                mappings: n.mappings.split(/;/).map(function(e) {
                    t[0] = 0;
                    return e.split(/,/).map(function(e) {
                        return t.slice(0, A(t, e));
                    });
                }),
                sources: n.sources
            };
            if (!a || !n.sourcesContent) return;
            for (var r = 0; r < n.sources.length; r++) {
                var i = n.sourcesContent[r];
                if (i) a.set(n.sources[r], i);
            }
        });
        var p;
        var d = 1;
        var v = 0;
        var h = 0;
        var m = 1;
        var _ = 0;
        var g = 0;
        return {
            add: l.orig ? function(e, n, t, r, i, a) {
                var o = l.orig[e];
                if (o) {
                    var s = o.mappings[r - 1];
                    if (!s) return;
                    var f;
                    for (var u = 0; u < s.length; u++) {
                        var c = s[u][0];
                        if (i >= c) f = s[u];
                        if (i <= c) break;
                    }
                    if (!f || f.length < 4) {
                        e = null;
                    } else {
                        e = o.sources[f[1]];
                        r = f[2];
                        i = f[3];
                        if (f.length > 4) a = o.names[f[4]];
                    }
                }
                b(e, n, t, r, i, a);
            } : b,
            setSourceContent: a ? function(e, n) {
                if (!a.has(e)) {
                    a.set(e, n);
                }
            } : Un,
            toString: function() {
                return JSON.stringify({
                    version: 3,
                    file: l.filename || undefined,
                    sourceRoot: l.root || undefined,
                    sources: f,
                    sourcesContent: a ? f.map(function(e) {
                        return a.get(e) || null;
                    }) : undefined,
                    names: u,
                    mappings: c
                });
            }
        };
        function b(e, n, t, r, i, a) {
            if (p == null && e == null) return;
            p = e;
            if (d < n) {
                v = 0;
                do {
                    c += ";";
                } while (++d < n);
            } else if (c) {
                c += ",";
            }
            c += D(t - v);
            v = t;
            if (e == null) return;
            var o = f.index(e);
            c += D(o - h);
            h = o;
            c += D(r - m);
            m = r;
            c += D(i - _);
            _ = i;
            if (l.names && a != null) {
                var s = u.index(a);
                c += D(s - g);
                g = s;
            }
        }
    }
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    (function() {
        var r = {
            Program: function(e) {
                return new _t({
                    start: s(e),
                    end: f(e),
                    body: a(e.body.map(l))
                });
            },
            ArrowFunctionExpression: function(e) {
                var n = [], t = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                var r = new (e.async ? Tt : St)({
                    start: s(e),
                    end: f(e),
                    argnames: n,
                    rest: t
                });
                var i = l(e.body);
                if (i instanceof _n) {
                    r.body = a(i.body);
                    r.value = null;
                } else {
                    r.body = [];
                    r.value = i;
                }
                return r;
            },
            FunctionDeclaration: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Ct : qt;
                } else {
                    n = e.generator ? Ft : Mt;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            FunctionExpression: function(e) {
                var n;
                if (e.async) {
                    n = e.generator ? Dt : At;
                } else {
                    n = e.generator ? $t : Ot;
                }
                var t = [], r = null;
                e.params.forEach(function(e) {
                    if (e.type == "RestElement") {
                        r = l(e.argument);
                    } else {
                        t.push(l(e));
                    }
                });
                return new n({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    argnames: t,
                    rest: r,
                    body: a(l(e.body).body)
                });
            },
            ClassDeclaration: function(e) {
                return new jt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            ClassExpression: function(e) {
                return new Nt({
                    start: s(e),
                    end: f(e),
                    name: l(e.id),
                    extends: l(e.superClass),
                    properties: e.body.body.map(l)
                });
            },
            MethodDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                var r = Yt, i = l(e.value);
                switch (e.kind) {
                  case "get":
                    r = we;
                    i = new bt(i);
                    break;

                  case "set":
                    r = xe;
                    i = new bt(i);
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: i
                });
            },
            PropertyDefinition: function(e) {
                var n = e.key, t = false;
                if (e.computed) {
                    n = l(n);
                } else if (n.type == "PrivateIdentifier") {
                    t = true;
                    n = "#" + n.name;
                } else {
                    n = o(n);
                }
                return new Ht({
                    start: s(e),
                    end: f(e),
                    key: n,
                    private: t,
                    static: e.static,
                    value: l(e.value)
                });
            },
            ForOfStatement: function(e) {
                return new (e.await ? ht : ye)({
                    start: s(e),
                    end: f(e),
                    init: l(e.left),
                    object: l(e.right),
                    body: l(e.body)
                });
            },
            TryStatement: function(e) {
                var n = e.handlers || [ e.handler ];
                if (n.length > 1 || e.guardedHandlers && e.guardedHandlers.length) {
                    throw new Error("Multiple catch clauses are not supported.");
                }
                return new Zt({
                    start: s(e),
                    end: f(e),
                    body: l(e.block).body,
                    bcatch: l(n[0]),
                    bfinally: e.finalizer ? new nr(l(e.finalizer)) : null
                });
            },
            Property: function(e) {
                var n = e.computed ? l(e.key) : o(e.key);
                var t = {
                    start: s(e),
                    end: f(e),
                    key: n,
                    value: l(e.value)
                };
                if (e.kind == "init") return new (e.method ? wr : yr)(t);
                t.value = new bt(t.value);
                if (e.kind == "get") return new kr(t);
                if (e.kind == "set") return new xr(t);
            },
            ArrayExpression: function(e) {
                return new Mn({
                    start: s(e),
                    end: f(e),
                    elements: e.elements.map(function(e) {
                        return e === null ? new Ur() : l(e);
                    })
                });
            },
            ArrayPattern: function(e) {
                var n = [], t = null;
                e.elements.forEach(function(e) {
                    if (e === null) {
                        n.push(new Ur());
                    } else if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(l(e));
                    }
                });
                return new mr({
                    start: s(e),
                    end: f(e),
                    elements: n,
                    rest: t
                });
            },
            ObjectPattern: function(e) {
                var n = [], t = null;
                e.properties.forEach(function(e) {
                    if (e.type == "RestElement") {
                        t = l(e.argument);
                    } else {
                        n.push(new _r(l(e)));
                    }
                });
                return new gr({
                    start: s(e),
                    end: f(e),
                    properties: n,
                    rest: t
                });
            },
            MemberExpression: function(e) {
                return new (e.computed ? pr : An)({
                    start: s(e),
                    end: f(e),
                    optional: e.optional,
                    expression: l(e.object),
                    property: e.computed ? l(e.property) : e.property.name
                });
            },
            MetaProperty: function(e) {
                var n = l(e.meta);
                var t = o(e.property);
                if (n.name == "new" && t == "target") return new Nr({
                    start: s(e),
                    end: f(e),
                    name: "new.target"
                });
                return new An({
                    start: s(e),
                    end: f(e),
                    expression: n,
                    property: t
                });
            },
            SwitchCase: function(e) {
                return new (e.test ? Qt : Kt)({
                    start: s(e),
                    end: f(e),
                    expression: l(e.test),
                    body: e.consequent.map(l)
                });
            },
            ExportAllDeclaration: function(e) {
                var n = e.exported ? o(e.exported) : "*";
                return new ke({
                    start: s(e),
                    end: f(e),
                    aliases: [ n ],
                    keys: [ "*" ],
                    path: e.source.value
                });
            },
            ExportDefaultDeclaration: function(e) {
                var n = l(e.declaration);
                if (!n.name) switch (n.CTOR) {
                  case qt:
                    n = new At(n);
                    break;

                  case Ct:
                    n = new Dt(n);
                    break;

                  case jt:
                    n = new Nt(n);
                    break;

                  case Mt:
                    n = new Ot(n);
                    break;

                  case Ft:
                    n = new $t(n);
                    break;
                }
                return new sr({
                    start: s(e),
                    end: f(e),
                    body: n
                });
            },
            ExportNamedDeclaration: function(e) {
                if (e.declaration) return new or({
                    start: s(e),
                    end: f(e),
                    body: l(e.declaration)
                });
                if (e.source) {
                    var n = [], t = [];
                    e.specifiers.forEach(function(e) {
                        n.push(o(e.exported));
                        t.push(o(e.local));
                    });
                    return new ke({
                        start: s(e),
                        end: f(e),
                        aliases: n,
                        keys: t,
                        path: e.source.value
                    });
                }
                return new fr({
                    start: s(e),
                    end: f(e),
                    properties: e.specifiers.map(function(e) {
                        var n = new Mr(l(e.local));
                        n.alias = o(e.exported);
                        return n;
                    })
                });
            },
            ImportDeclaration: function(e) {
                var t = null, r = null, i = null;
                e.specifiers.forEach(function(e) {
                    var n = new Ar(l(e.local));
                    switch (e.type) {
                      case "ImportDefaultSpecifier":
                        r = n;
                        r.key = "";
                        break;

                      case "ImportNamespaceSpecifier":
                        t = n;
                        t.key = "*";
                        break;

                      default:
                        n.key = e.imported.name || syn.name;
                        if (!i) i = [];
                        i.push(n);
                        break;
                    }
                });
                return new ur({
                    start: s(e),
                    end: f(e),
                    all: t,
                    default: r,
                    properties: i,
                    path: e.source.value
                });
            },
            ImportExpression: function(e) {
                var n = s(e);
                var t = l(e.source);
                return new En({
                    start: n,
                    end: f(e),
                    expression: new Nn({
                        start: n,
                        end: t.start,
                        name: "import"
                    }),
                    args: [ t ]
                });
            },
            VariableDeclaration: function(e) {
                return new ({
                    const: rr,
                    let: ir
                }[e.kind] || ar)({
                    start: s(e),
                    end: f(e),
                    definitions: e.declarations.map(l)
                });
            },
            Literal: function(e) {
                var n = {
                    start: s(e),
                    end: f(e)
                };
                if (e.bigint) {
                    n.value = e.bigint.toLowerCase() + "n";
                    return new Hr(n);
                }
                var t = e.value;
                if (t === null) return new Rr(n);
                var r = e.regex;
                if (r && r.pattern) {
                    n.value = new RegExp(r.pattern, r.flags);
                    n.value.raw_source = r.pattern;
                    return new Yr(n);
                } else if (r) {
                    n.value = e.regex && e.raw ? e.raw : t;
                    return new Yr(n);
                }
                switch (typeof t) {
                  case "string":
                    n.value = t;
                    return new Hn(n);

                  case "number":
                    if (isNaN(t)) return new Br(n);
                    var i, a;
                    if (isFinite(t)) {
                        i = 1 / t < 0;
                        n.value = i ? -t : t;
                        a = new Yn(n);
                    } else {
                        i = t < 0;
                        a = new Vr(n);
                    }
                    return i ? new $n({
                        start: n.start,
                        end: n.end,
                        operator: "-",
                        expression: a
                    }) : a;

                  case "boolean":
                    return new (t ? Jr : Gr)(n);
                }
            },
            TemplateLiteral: function(e) {
                return new Ir({
                    start: s(e),
                    end: f(e),
                    expressions: e.expressions.map(l),
                    strings: e.quasis.map(function(e) {
                        return e.value.raw;
                    })
                });
            },
            TaggedTemplateExpression: function(e) {
                var n = l(e.quasi);
                n.start = s(e);
                n.end = f(e);
                n.tag = l(e.tag);
                return n;
            },
            Identifier: function(e) {
                var n, t = c.length - 1;
                do {
                    n = c[--t];
                } while (n.type == "ArrayPattern" || n.type == "AssignmentPattern" && n.left === c[t + 1] || n.type == "ObjectPattern" || n.type == "Property" && n.value === c[t + 1] || n.type == "VariableDeclarator" && n.id === c[t + 1]);
                var r = Nn;
                switch (n.type) {
                  case "ArrowFunctionExpression":
                    if (n.body !== c[t + 1]) r = jn;
                    break;

                  case "BreakStatement":
                  case "ContinueStatement":
                    r = Te;
                    break;

                  case "CatchClause":
                    r = Cr;
                    break;

                  case "ClassDeclaration":
                    if (n.id === c[t + 1]) r = Ee;
                    break;

                  case "ClassExpression":
                    if (n.id === c[t + 1]) r = qr;
                    break;

                  case "FunctionDeclaration":
                    r = n.id === c[t + 1] ? $r : jn;
                    break;

                  case "FunctionExpression":
                    r = n.id === c[t + 1] ? zr : jn;
                    break;

                  case "LabeledStatement":
                    r = Se;
                    break;

                  case "VariableDeclaration":
                    r = {
                        const: Tr,
                        let: Dr
                    }[n.kind] || Or;
                    break;
                }
                return new r({
                    start: s(e),
                    end: f(e),
                    name: e.name
                });
            },
            Super: function(e) {
                return new Pr({
                    start: s(e),
                    end: f(e),
                    name: "super"
                });
            },
            ThisExpression: function(e) {
                return new jr({
                    start: s(e),
                    end: f(e),
                    name: "this"
                });
            },
            ParenthesizedExpression: function(e) {
                var n = l(e.expression);
                if (!n.start.parens) n.start.parens = [];
                n.start.parens.push(s(e));
                if (!n.end.parens) n.end.parens = [];
                n.end.parens.push(f(e));
                return n;
            },
            ChainExpression: function(e) {
                var n = l(e.expression);
                n.terminal = true;
                return n;
            }
        };
        r.UpdateExpression = r.UnaryExpression = function e(n) {
            var t = "prefix" in n ? n.prefix : n.type == "UnaryExpression" ? true : false;
            return new (t ? $n : dr)({
                start: s(n),
                end: f(n),
                operator: n.operator,
                expression: l(n.argument)
            });
        };
        u("EmptyStatement", hn);
        u("ExpressionStatement", mn, "expression>body");
        u("BlockStatement", _n, "body@body");
        u("IfStatement", wn, "test>condition, consequent>body, alternate>alternative");
        u("LabeledStatement", st, "label>label, body>body");
        u("BreakStatement", Wt, "label>label");
        u("ContinueStatement", Gt, "label>label");
        u("WithStatement", mt, "object>expression, body>body");
        u("SwitchStatement", Jt, "discriminant>expression, cases@body");
        u("ReturnStatement", yn, "argument>value");
        u("ThrowStatement", Ut, "argument>value");
        u("WhileStatement", lt, "test>condition, body>body");
        u("DoWhileStatement", ct, "test>condition, body>body");
        u("ForStatement", pt, "init>init, test>condition, update>step, body>body");
        u("ForInStatement", vt, "left>init, right>object, body>body");
        u("DebuggerStatement", nt);
        u("VariableDeclarator", xn, "id>name, init>value");
        u("CatchClause", er, "param>argname, body%body");
        u("BinaryExpression", zn, "operator=operator, left>left, right>right");
        u("LogicalExpression", zn, "operator=operator, left>left, right>right");
        u("AssignmentExpression", Cn, "operator=operator, left>left, right>right");
        u("AssignmentPattern", kn, "left>name, right>value");
        u("ConditionalExpression", qn, "test>condition, consequent>consequent, alternate>alternative");
        u("NewExpression", cr, "callee>expression, arguments@args, pure=pure");
        u("CallExpression", En, "callee>expression, arguments@args, optional=optional, pure=pure");
        u("SequenceExpression", Sn, "expressions@expressions");
        u("SpreadElement", Dn, "argument>expression");
        u("ObjectExpression", Pn, "properties@properties");
        u("AwaitExpression", vr, "argument>expression");
        u("YieldExpression", hr, "argument>expression, delegate=nested");
        d(_t, function e(n) {
            return m("Program", n);
        });
        d(zt, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "FunctionDeclaration",
                id: v(n.name),
                async: xt(n),
                generator: kt(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(bn, function e(n) {
            var t = n.argnames.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            if (wt(n)) return {
                type: "ArrowFunctionExpression",
                async: xt(n),
                params: t,
                body: n.value ? v(n.value) : m("BlockStatement", n)
            };
            return {
                type: "FunctionExpression",
                id: v(n.name),
                async: xt(n),
                generator: kt(n),
                params: t,
                body: m("BlockStatement", n)
            };
        });
        d(jt, function e(n) {
            return {
                type: "ClassDeclaration",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        d(Nt, function e(n) {
            return {
                type: "ClassExpression",
                id: v(n.name),
                superClass: v(n.extends),
                body: {
                    type: "ClassBody",
                    body: n.properties.map(v)
                }
            };
        });
        function e(r) {
            return function(e) {
                var n = e.key instanceof vn;
                var t = n ? v(e.key) : e.private ? {
                    type: "PrivateIdentifier",
                    name: e.key.slice(1)
                } : {
                    type: "Literal",
                    value: e.key
                };
                return {
                    type: "MethodDefinition",
                    kind: r,
                    computed: n,
                    key: t,
                    static: e.static,
                    value: v(e.value)
                };
            };
        }
        d(we, e("get"));
        d(xe, e("set"));
        d(Yt, e("method"));
        d(Ht, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : n.private ? {
                type: "PrivateIdentifier",
                name: n.key.slice(1)
            } : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "PropertyDefinition",
                computed: t,
                key: r,
                static: n.static,
                value: v(n.value)
            };
        });
        function n(n) {
            return function(e) {
                return {
                    type: "ForOfStatement",
                    await: n,
                    left: v(e.init),
                    right: v(e.object),
                    body: v(e.body)
                };
            };
        }
        d(ht, n(true));
        d(ye, n(false));
        d(tt, function e(n) {
            return {
                type: "ExpressionStatement",
                expression: p(n, {
                    type: "Literal",
                    value: n.value
                })
            };
        });
        d(Xt, function e(n) {
            return {
                type: "SwitchCase",
                test: v(n.expression),
                consequent: n.body.map(v)
            };
        });
        d(Zt, function e(n) {
            return {
                type: "TryStatement",
                block: h(n),
                handler: v(n.bcatch),
                guardedHandlers: [],
                finalizer: v(n.bfinally)
            };
        });
        d(er, function e(n) {
            return {
                type: "CatchClause",
                param: v(n.argname),
                guard: null,
                body: h(n)
            };
        });
        d(or, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                declaration: v(n.body)
            };
        });
        d(sr, function e(n) {
            return {
                type: "ExportDefaultDeclaration",
                declaration: v(n.body)
            };
        });
        d(ke, function e(n) {
            if (n.keys[0] == "*") return {
                type: "ExportAllDeclaration",
                exported: n.aliases[0] == "*" ? null : {
                    type: "Identifier",
                    name: n.aliases[0]
                },
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
            var t = [];
            for (var r = 0; r < n.aliases.length; r++) {
                t.push({
                    type: "ExportSpecifier",
                    exported: {
                        type: "Identifier",
                        name: n.aliases[r]
                    },
                    local: {
                        type: "Identifier",
                        name: n.keys[r]
                    }
                });
            }
            return {
                type: "ExportNamedDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(fr, function e(n) {
            return {
                type: "ExportNamedDeclaration",
                specifiers: n.properties.map(function(e) {
                    return {
                        type: "ExportSpecifier",
                        local: v(e),
                        exported: {
                            type: "Identifier",
                            name: e.alias
                        }
                    };
                })
            };
        });
        d(ur, function e(n) {
            var t = n.properties ? n.properties.map(function(e) {
                return {
                    type: "ImportSpecifier",
                    local: v(e),
                    imported: {
                        type: "Identifier",
                        name: e.key
                    }
                };
            }) : [];
            if (n.all) t.unshift({
                type: "ImportNamespaceSpecifier",
                local: v(n.all)
            });
            if (n.default) t.unshift({
                type: "ImportDefaultSpecifier",
                local: v(n.default)
            });
            return {
                type: "ImportDeclaration",
                specifiers: t,
                source: {
                    type: "Literal",
                    value: n.path
                }
            };
        });
        d(tr, function e(n) {
            return {
                type: "VariableDeclaration",
                kind: n.TYPE.toLowerCase(),
                declarations: n.definitions.map(v)
            };
        });
        d(Tn, function e(n) {
            var t = n instanceof pr;
            var r = {
                type: "MemberExpression",
                object: v(n.expression),
                computed: t,
                optional: n.optional,
                property: t ? v(n.property) : {
                    type: "Identifier",
                    name: n.property
                }
            };
            return n.terminal ? {
                type: "ChainExpression",
                expression: r
            } : r;
        });
        d(On, function e(n) {
            return {
                type: n.operator == "++" || n.operator == "--" ? "UpdateExpression" : "UnaryExpression",
                operator: n.operator,
                prefix: n instanceof $n,
                argument: v(n.expression)
            };
        });
        d(zn, function e(n) {
            return {
                type: n.operator == "&&" || n.operator == "||" ? "LogicalExpression" : "BinaryExpression",
                left: v(n.left),
                operator: n.operator,
                right: v(n.right)
            };
        });
        d(Mn, function e(n) {
            return {
                type: "ArrayExpression",
                elements: n.elements.map(v)
            };
        });
        d(mr, function e(n) {
            var t = n.elements.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ArrayPattern",
                elements: t
            };
        });
        d(_r, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            return {
                type: "Property",
                kind: "init",
                computed: t,
                key: r,
                value: v(n.value)
            };
        });
        d(gr, function e(n) {
            var t = n.properties.map(v);
            if (n.rest) t.push({
                type: "RestElement",
                argument: v(n.rest)
            });
            return {
                type: "ObjectPattern",
                properties: t
            };
        });
        d(br, function e(n) {
            var t = n.key instanceof vn;
            var r = t ? v(n.key) : {
                type: "Literal",
                value: n.key
            };
            var i;
            if (n instanceof yr) {
                i = "init";
            } else if (n instanceof kr) {
                i = "get";
            } else if (n instanceof xr) {
                i = "set";
            }
            return {
                type: "Property",
                kind: i,
                computed: t,
                method: n instanceof wr,
                key: r,
                value: v(n.value)
            };
        });
        d(Er, function e(n) {
            var t = n.definition();
            return {
                type: "Identifier",
                name: t && t.mangled_name || n.name
            };
        });
        d(Pr, function e() {
            return {
                type: "Super"
            };
        });
        d(jr, function e() {
            return {
                type: "ThisExpression"
            };
        });
        d(Nr, function e() {
            return {
                type: "MetaProperty",
                meta: {
                    type: "Identifier",
                    name: "new"
                },
                property: {
                    type: "Identifier",
                    name: "target"
                }
            };
        });
        d(Yr, function e(n) {
            var t = n.value.toString().match(/\/([gimuy]*)$/)[1];
            var r = "/" + n.value.raw_source + "/" + t;
            return {
                type: "Literal",
                value: r,
                raw: r,
                regex: {
                    pattern: n.value.raw_source,
                    flags: t
                }
            };
        });
        d(Hr, function e(n) {
            var t = n.value;
            return {
                type: "Literal",
                bigint: t.slice(0, -1),
                raw: t
            };
        });
        function t(e) {
            var n = e.value;
            if (typeof n === "number" && (n < 0 || n === 0 && 1 / n < 0)) {
                return {
                    type: "UnaryExpression",
                    operator: "-",
                    prefix: true,
                    argument: {
                        type: "Literal",
                        value: -n,
                        raw: e.start.raw
                    }
                };
            }
            return {
                type: "Literal",
                value: n,
                raw: e.start.raw
            };
        }
        d(Wr, t);
        d(In, t);
        d(Rr, t);
        d(g, function e(n) {
            return {
                type: "Identifier",
                name: String(n.value)
            };
        });
        d(Ir, function e(n) {
            var t = n.strings.length - 1;
            var r = {
                type: "TemplateLiteral",
                expressions: n.expressions.map(v),
                quasis: n.strings.map(function(e, n) {
                    return {
                        type: "TemplateElement",
                        tail: n == t,
                        value: {
                            raw: e
                        }
                    };
                })
            };
            if (!n.tag) return r;
            return {
                type: "TaggedTemplateExpression",
                tag: v(n.tag),
                quasi: r
            };
        });
        ot.DEFMETHOD("to_mozilla_ast", _n.prototype.to_mozilla_ast);
        Ur.DEFMETHOD("to_mozilla_ast", Wn);
        vn.DEFMETHOD("to_mozilla_ast", function() {
            throw new Error("Cannot convert AST_" + this.TYPE);
        });
        function a(e) {
            for (var n = 0; n < e.length; n++) {
                var t = e[n];
                if (!(t instanceof mn)) break;
                var r = t.body;
                if (!(r instanceof Hn)) break;
                if (t.start.pos !== r.start.pos) break;
                e[n] = new tt(r);
            }
            return e;
        }
        function i(e) {
            if (e.type == "Literal") {
                return e.raw != null ? e.raw : e.value + "";
            }
        }
        function s(e) {
            var n = e.loc, t = n && n.start;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[0] : e.start,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[0] : e.start,
                raw: i(e)
            });
        }
        function f(e) {
            var n = e.loc, t = n && n.end;
            var r = e.range;
            return new te({
                file: n && n.source,
                line: t && t.line,
                col: t && t.column,
                pos: r ? r[1] : e.end,
                endline: t && t.line,
                endcol: t && t.column,
                endpos: r ? r[1] : e.end,
                raw: i(e)
            });
        }
        function o(e) {
            return "" + e[e.type == "Identifier" ? "name" : "value"];
        }
        function u(e, n, t) {
            var a = [ "start: my_start_token(M)", "end: my_end_token(M)" ];
            var o = [ "type: " + JSON.stringify(e) ];
            if (t) t.split(/\s*,\s*/).forEach(function(e) {
                var n = /([a-z0-9$_]+)(=|@|>|%)([a-z0-9$_]+)/i.exec(e);
                if (!n) throw new Error("Can't understand property map: " + e);
                var t = n[1], r = n[2], i = n[3];
                switch (r) {
                  case "@":
                    a.push(i + ": M." + t + ".map(from_moz)");
                    o.push(t + ": M." + i + ".map(to_moz)");
                    break;

                  case ">":
                    a.push(i + ": from_moz(M." + t + ")");
                    o.push(t + ": to_moz(M." + i + ")");
                    break;

                  case "=":
                    a.push(i + ": M." + t);
                    o.push(t + ": M." + i);
                    break;

                  case "%":
                    a.push(i + ": from_moz(M." + t + ").body");
                    o.push(t + ": to_moz_block(M)");
                    break;

                  default:
                    throw new Error("Can't understand operator in propmap: " + e);
                }
            });
            r[e] = new Function("U2", "my_start_token", "my_end_token", "from_moz", [ "return function From_Moz_" + e + "(M) {", "    return new U2.AST_" + n.TYPE + "({", a.join(",\n"), "    });", "};" ].join("\n"))(_, s, f, l);
            d(n, new Function("to_moz", "to_moz_block", "to_moz_scope", [ "return function To_Moz_" + e + "(M) {", "    return {", o.join(",\n"), "    };", "};" ].join("\n"))(v, h, m));
        }
        var c = null;
        function l(e) {
            c.push(e);
            var n = null;
            if (e) {
                if (!Qn(r, e.type)) throw new Error("Unsupported type: " + e.type);
                n = r[e.type](e);
            }
            c.pop();
            return n;
        }
        vn.from_mozilla_ast = function(e) {
            var n = c;
            c = [];
            var t = l(e);
            c = n;
            t.walk(new Rn(function(e) {
                if (e instanceof Te) {
                    for (var n = 0, t; t = this.parent(n); n++) {
                        if (t instanceof gn) break;
                        if (t instanceof st && t.label.name == e.name) {
                            e.thedef = t.label;
                            break;
                        }
                    }
                    if (!e.thedef) {
                        var r = e.start;
                        Oe("Undefined label " + e.name, r.file, r.line, r.col, r.pos);
                    }
                }
            }));
            return t;
        };
        function p(e, n) {
            var t = e.start;
            var r = e.end;
            if (t.pos != null && r.endpos != null) {
                n.range = [ t.pos, r.endpos ];
            }
            if (t.line) {
                n.loc = {
                    start: {
                        line: t.line,
                        column: t.col
                    },
                    end: r.endline ? {
                        line: r.endline,
                        column: r.endcol
                    } : null
                };
                if (t.file) {
                    n.loc.source = t.file;
                }
            }
            return n;
        }
        function d(e, n) {
            e.DEFMETHOD("to_mozilla_ast", function() {
                return p(this, n(this));
            });
        }
        function v(e) {
            return e != null ? e.to_mozilla_ast() : null;
        }
        function h(e) {
            return {
                type: "BlockStatement",
                body: e.body.map(v)
            };
        }
        function m(e, n) {
            var t = n.body.map(v);
            if (n.body[0] instanceof mn && n.body[0].body instanceof Hn) {
                t.unshift(v(new hn(n.body[0])));
            }
            return {
                type: e,
                body: t
            };
        }
    })();
    /***********************************************************************

  A JavaScript tokenizer / parser / beautifier / compressor.
  https://github.com/mishoo/UglifyJS

  -------------------------------- (C) ---------------------------------

                           Author: Mihai Bazon
                         <mihai.bazon@gmail.com>
                       http://mihai.bazon.net/blog

  Distributed under the BSD license:

    Copyright 2012 (c) Mihai Bazon <mihai.bazon@gmail.com>

    Redistribution and use in source and binary forms, with or without
    modification, are permitted provided that the following conditions
    are met:

        * Redistributions of source code must retain the above
          copyright notice, this list of conditions and the following
          disclaimer.

        * Redistributions in binary form must reproduce the above
          copyright notice, this list of conditions and the following
          disclaimer in the documentation and/or other materials
          provided with the distribution.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER “AS IS” AND ANY
    EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
    IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
    PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
    PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
    THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
    SUCH DAMAGE.

 ***********************************************************************/
    "use strict";
    var z = function() {
        var n = new dn();
        [ "null", "true", "false", "Infinity", "-Infinity", "undefined" ].forEach(t);
        [ Array, Boolean, Date, Error, Function, Math, Number, Object, RegExp, String ].forEach(function(e) {
            Object.getOwnPropertyNames(e).map(t);
            if (e.prototype) {
                Object.getOwnPropertyNames(new e()).map(t);
                Object.getOwnPropertyNames(e.prototype).map(t);
            }
        });
        return n;
        function t(e) {
            n.set(e, true);
        }
    }();
    function q(e, n) {
        e.walk(new Rn(function(e) {
            if (e instanceof It) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof br) {
                if (e.start && e.start.quote) t(e.key);
            } else if (e instanceof pr) {
                W(e.property, t);
            }
        }));
        function t(e) {
            Jn(n, e);
        }
    }
    function W(e, n) {
        if (e instanceof qn) {
            W(e.consequent, n);
            W(e.alternative, n);
        } else if (e instanceof Sn) {
            W(e.tail_node(), n);
        } else if (e instanceof Hn) {
            n(e.value);
        }
    }
    function G(e, t) {
        t = be(t, {
            builtins: false,
            cache: null,
            debug: false,
            keep_quoted: false,
            regex: null,
            reserved: null
        }, true);
        var n = t.builtins ? new dn() : z.clone();
        if (Array.isArray(t.reserved)) t.reserved.forEach(function(e) {
            n.set(e, true);
        });
        var r = -1;
        var i;
        if (t.cache) {
            i = t.cache.props;
            i.each(function(e) {
                n.set(e, true);
            });
        } else {
            i = new dn();
        }
        var a = t.regex;
        var o = t.debug !== false;
        var s;
        if (o) s = t.debug === true ? "" : t.debug;
        var f = new dn();
        var u = n.clone();
        e.walk(new Rn(function(e) {
            if (e instanceof zn) {
                if (e.operator == "in") W(e.left, p);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof An) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Nn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    W(e.args[1], p);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    W(e.args[0], p);
                    break;
                }
            } else if (e instanceof It) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof An) {
                p(e.property);
            } else if (e instanceof br) {
                if (typeof e.key == "string") p(e.key);
            } else if (e instanceof pr) {
                W(e.property, p);
            }
        }));
        e.walk(new Rn(function(e) {
            if (e instanceof zn) {
                if (e.operator == "in") v(e.left);
            } else if (e.TYPE == "Call") {
                var n = e.expression;
                if (n instanceof An) switch (n.property) {
                  case "defineProperty":
                  case "getOwnPropertyDescriptor":
                    if (e.args.length < 2) break;
                    n = n.expression;
                    if (!(n instanceof Nn)) break;
                    if (n.name != "Object") break;
                    if (!n.definition().undeclared) break;
                    v(e.args[1]);
                    break;

                  case "hasOwnProperty":
                    if (e.args.length < 1) break;
                    v(e.args[0]);
                    break;
                }
            } else if (e instanceof It) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof An) {
                e.property = d(e.property);
            } else if (e instanceof br) {
                if (typeof e.key == "string") e.key = d(e.key);
            } else if (e instanceof pr) {
                if (!t.keep_quoted) v(e.property);
            }
        }));
        function c(e) {
            if (u.has(e)) return false;
            if (/^-?[0-9]+(\.[0-9]+)?(e[+-][0-9]+)?$/.test(e)) return false;
            return true;
        }
        function l(e) {
            if (n.has(e)) return false;
            if (a && !a.test(e)) return false;
            return i.has(e) || f.has(e);
        }
        function p(e) {
            if (c(e)) f.set(e, true);
            if (!l(e)) u.set(e, true);
        }
        function d(e) {
            if (!l(e)) return e;
            var n = i.get(e);
            if (!n) {
                if (o) {
                    var t = "_$" + e + "$" + s + "_";
                    if (c(t)) n = t;
                }
                if (!n) do {
                    n = E(++r);
                } while (!c(n));
                if (/^#/.test(e)) n = "#" + n;
                i.set(e, n);
            }
            return n;
        }
        function v(e) {
            if (e instanceof Sn) {
                v(e.expressions.tail_node());
            } else if (e instanceof Hn) {
                e.value = d(e.value);
            } else if (e instanceof qn) {
                v(e.consequent);
                v(e.alternative);
            }
        }
    }
    "use strict";
    var J, X;
    if (typeof Buffer == "undefined") {
        J = atob;
        X = btoa;
    } else if (typeof Buffer.alloc == "undefined") {
        J = function(e) {
            return new Buffer(e, "base64").toString();
        };
        X = function(e) {
            return new Buffer(e).toString("base64");
        };
    } else {
        J = function(e) {
            return Buffer.from(e, "base64").toString();
        };
        X = function(e) {
            return Buffer.from(e).toString("base64");
        };
    }
    function K(e, n) {
        var t = n.end.comments_after;
        for (var r = t.length; --r >= 0; ) {
            var i = t[r];
            if (i.type != "comment1") break;
            var a = /^# ([^\s=]+)=(\S+)\s*$/.exec(i.value);
            if (!a) break;
            if (a[1] == "sourceMappingURL") {
                a = /^data:application\/json(;.*?)?;base64,([^,]+)$/.exec(a[2]);
                if (!a) break;
                return J(a[2]);
            }
        }
        vn.warn("inline source map not found: {name}", {
            name: e
        });
    }
    function Q(n) {
        try {
            return JSON.parse(n);
        } catch (e) {
            throw new Error("invalid input source map: " + n);
        }
    }
    function Z(n, t, e) {
        e.forEach(function(e) {
            if (t[e]) {
                if (typeof t[e] != "object") t[e] = {};
                if (!(n in t[e])) t[e][n] = t[n];
            }
        });
    }
    function ee(e) {
        if (!e) return;
        if (!("props" in e)) {
            e.props = new dn();
        } else if (!(e.props instanceof dn)) {
            e.props = dn.fromObject(e.props);
        }
    }
    function ne(e) {
        return {
            props: e.props.toObject()
        };
    }
    function se(r, i) {
        try {
            i = be(i, {
                annotations: undefined,
                compress: {},
                enclose: false,
                ie: false,
                ie8: false,
                keep_fargs: false,
                keep_fnames: false,
                mangle: {},
                module: false,
                nameCache: null,
                output: {},
                parse: {},
                rename: undefined,
                sourceMap: false,
                timings: false,
                toplevel: !!(i && i["module"]),
                v8: false,
                validate: false,
                warnings: false,
                webkit: false,
                wrap: false
            }, true);
            if (i.validate) vn.enable_validation();
            var e = i.timings && {
                start: Date.now()
            };
            if (i.annotations !== undefined) Z("annotations", i, [ "compress", "output" ]);
            if (i.ie8) i.ie = i.ie || i.ie8;
            if (i.ie) Z("ie", i, [ "compress", "mangle", "output", "rename" ]);
            if (i.keep_fargs) Z("keep_fargs", i, [ "compress", "mangle", "rename" ]);
            if (i.keep_fnames) Z("keep_fnames", i, [ "compress", "mangle", "rename" ]);
            if (i.module) Z("module", i, [ "compress", "parse" ]);
            if (i.toplevel) Z("toplevel", i, [ "compress", "mangle", "rename" ]);
            if (i.v8) Z("v8", i, [ "mangle", "output", "rename" ]);
            if (i.webkit) Z("webkit", i, [ "compress", "mangle", "output", "rename" ]);
            var n;
            if (i.mangle) {
                i.mangle = be(i.mangle, {
                    cache: i.nameCache && (i.nameCache.vars || {}),
                    eval: false,
                    ie: false,
                    keep_fargs: false,
                    keep_fnames: false,
                    properties: false,
                    reserved: [],
                    toplevel: false,
                    v8: false,
                    webkit: false
                }, true);
                if (i.mangle.properties) {
                    if (typeof i.mangle.properties != "object") {
                        i.mangle.properties = {};
                    }
                    if (i.mangle.properties.keep_quoted) {
                        n = i.mangle.properties.reserved;
                        if (!Array.isArray(n)) n = [];
                        i.mangle.properties.reserved = n;
                    }
                    if (i.nameCache && !("cache" in i.mangle.properties)) {
                        i.mangle.properties.cache = i.nameCache.props || {};
                    }
                }
                ee(i.mangle.cache);
                ee(i.mangle.properties.cache);
            }
            if (i.rename === undefined) i.rename = i.compress && i.mangle;
            if (i.sourceMap) {
                i.sourceMap = be(i.sourceMap, {
                    content: null,
                    filename: null,
                    includeSources: false,
                    names: true,
                    root: null,
                    url: null
                }, true);
            }
            var t = [];
            if (i.warnings) vn.log_function(function(e) {
                t.push(e);
            }, i.warnings == "verbose");
            if (e) e.parse = Date.now();
            var a;
            if (r instanceof _t) {
                a = r;
            } else {
                if (typeof r == "string") {
                    r = [ r ];
                }
                i.parse = i.parse || {};
                i.parse.toplevel = null;
                var o = i.sourceMap && i.sourceMap.content;
                if (typeof o == "string" && o != "inline") {
                    o = Q(o);
                }
                if (o) i.sourceMap.orig = Object.create(null);
                for (var s in r) if (Qn(r, s)) {
                    i.parse.filename = s;
                    i.parse.toplevel = a = ti(r[s], i.parse);
                    if (o == "inline") {
                        var f = K(s, a);
                        if (f) {
                            i.sourceMap.orig[s] = Q(f);
                        }
                    } else if (o) {
                        i.sourceMap.orig[s] = o;
                    }
                }
            }
            if (n) {
                q(a, n);
            }
            [ "enclose", "wrap" ].forEach(function(e) {
                var n = i[e];
                if (!n) return;
                var t = a.print_to_string().slice(0, -1);
                a = a[e](n);
                r[a.start.file] = a.print_to_string().replace(t, "");
            });
            if (i.validate) a.validate_ast();
            if (e) e.rename = Date.now();
            if (i.rename) {
                a.figure_out_scope(i.rename);
                a.expand_names(i.rename);
            }
            if (e) e.compress = Date.now();
            if (i.compress) {
                a = new oi(i.compress).compress(a);
                if (i.validate) a.validate_ast();
            }
            if (e) e.scope = Date.now();
            if (i.mangle) a.figure_out_scope(i.mangle);
            if (e) e.mangle = Date.now();
            if (i.mangle) {
                a.compute_char_frequency(i.mangle);
                a.mangle_names(i.mangle);
            }
            if (e) e.properties = Date.now();
            if (i.mangle && i.mangle.properties) G(a, i.mangle.properties);
            if (e) e.output = Date.now();
            var u = {};
            var c = be(i.output, {
                ast: false,
                code: true
            });
            if (c.ast) u.ast = a;
            if (c.code) {
                if (i.sourceMap) {
                    c.source_map = $(i.sourceMap);
                    if (i.sourceMap.includeSources) {
                        if (r instanceof _t) {
                            throw new Error("original source content unavailable");
                        } else for (var s in r) if (Qn(r, s)) {
                            c.source_map.setSourceContent(s, r[s]);
                        }
                    }
                }
                delete c.ast;
                delete c.code;
                var l = si(c);
                a.print(l);
                u.code = l.get();
                if (i.sourceMap) {
                    u.map = c.source_map.toString();
                    var p = i.sourceMap.url;
                    if (p) {
                        u.code = u.code.replace(/\n\/\/# sourceMappingURL=\S+\s*$/, "");
                        if (p == "inline") {
                            u.code += "\n//# sourceMappingURL=data:application/json;charset=utf-8;base64," + X(u.map);
                        } else {
                            u.code += "\n//# sourceMappingURL=" + p;
                        }
                    }
                }
            }
            if (i.nameCache && i.mangle) {
                if (i.mangle.cache) i.nameCache.vars = ne(i.mangle.cache);
                if (i.mangle.properties && i.mangle.properties.cache) {
                    i.nameCache.props = ne(i.mangle.properties.cache);
                }
            }
            if (e) {
                e.end = Date.now();
                u.timings = {
                    parse: .001 * (e.rename - e.parse),
                    rename: .001 * (e.compress - e.rename),
                    compress: .001 * (e.scope - e.compress),
                    scope: .001 * (e.mangle - e.scope),
                    mangle: .001 * (e.properties - e.mangle),
                    properties: .001 * (e.output - e.properties),
                    output: .001 * (e.end - e.output),
                    total: .001 * (e.end - e.start)
                };
            }
            if (t.length) {
                u.warnings = t;
            }
            return u;
        } catch (e) {
            return {
                error: e
            };
        } finally {
            vn.log_function();
            vn.disable_validation();
        }
    }
    _["Dictionary"] = dn;
    _["is_statement"] = rt;
    _["List"] = Gn;
    _["minify"] = se;
    _["parse"] = ti;
    _["push_uniq"] = Jn;
    _["TreeTransformer"] = Xr;
    _["TreeWalker"] = Rn;
})(typeof UglifyJS == "undefined" ? UglifyJS = {} : UglifyJS);
// @license-end
